// root stuff
#include <stdio.h>
#include <stdlib.h>
#include <TROOT.h>
#include "TH1.h"
#include "TF1.h"
#include "TCanvas.h"
#include "TApplication.h"
#include "TFile.h"
#include "TRint.h"
#include "TStyle.h"
#include "TPaveText.h"
#include "TSystem.h"
#include <TTree.h>
#include <TChain.h>

int main() { 
                 // definition of HEPEVT 
                 const int hepevt_local_max =4000;
                 int NEVHEP;
                 int NHEP;
                 int ISTHEP[hepevt_local_max];
                 int IDHEP[hepevt_local_max];
                 int CHA3[hepevt_local_max]; // charge times 3
                 int JMOHEP1[hepevt_local_max];
                 int JMOHEP2[hepevt_local_max];
                 int JDAHEP1[hepevt_local_max];
                 int JDAHEP2[hepevt_local_max];
                 double PX[hepevt_local_max];
                 double PY[hepevt_local_max];
                 double PZ[hepevt_local_max];
                 double E[hepevt_local_max];
                 double M[hepevt_local_max];
                 double VX[hepevt_local_max];
                 double VY[hepevt_local_max];
                 double VZ[hepevt_local_max];
                 double VT[hepevt_local_max];
  

  TChain *chain = new TChain("thepevt");
  chain->Add("analmc.htup");    
  chain->SetBranchAddress("NEVHEP",&NEVHEP);
  chain->SetBranchAddress("NHEP",&NHEP);
  chain->SetBranchAddress("ISTHEP",&ISTHEP);
  chain->SetBranchAddress("IDHEP",&IDHEP);
  chain->SetBranchAddress("CHA3",&CHA3);
  chain->SetBranchAddress("JMOHEP1",&JMOHEP1);
  chain->SetBranchAddress("JMOHEP2",&JMOHEP2);
  chain->SetBranchAddress("JDAHEP1",&JDAHEP1);
  chain->SetBranchAddress("JDAHEP2",&JDAHEP2);
  chain->SetBranchAddress("PX",&PX);
  chain->SetBranchAddress("PY",&PY);
  chain->SetBranchAddress("PZ",&PZ);
  chain->SetBranchAddress("E",&E);
  chain->SetBranchAddress("M",&M);
  chain->SetBranchAddress("VX",&VX);
  chain->SetBranchAddress("VY",&VY);
  chain->SetBranchAddress("VZ",&VZ);
  chain->SetBranchAddress("VT",&VT);


  int nentries = (long int)chain->GetEntries();
  printf("Total number of events %d \n", nentries);
  int nbytes = 0;

//----------------------------- Loop over events -----------------------------

  for ( int i=0; i<nentries;i++) {

    if (i%100==0 && i>0 ) {printf("%d events processed\n ",i);}
    nbytes += chain->GetEntry(i);
    
    printf("NHEP = %d (particles in event), and  NEVHEP= %d \n ",NHEP, NEVHEP); 
    
// loop over all particles !
    for (int j=0; j<NHEP;j++) {
    printf("%4d ISTHEP=%5d  IDHEP=%5d JMOHEP[0]=%5d JMOHEP[1]=%5d JDAHEP[0]=%5d JDAHEP[1]=%5d \n",
    j,ISTHEP[j],IDHEP[j],JMOHEP1[j],JMOHEP2[j],JDAHEP1[j],JDAHEP2[j] );
    printf("     Px=%6.3f  Py=%6.3f  Pz=%6.3f  E=%6.3f Mass=%6.3f  CHA3=%2d  \n",
    PX[j], PY[j], PZ[j], E[j], M[j], CHA3[j] );
    printf("     V1=%6.3f  V2=%6.3f  V3=%6.3f  V4=%6.3f \n",
    VX[j], VY[j], VZ[j], VT[j]  );

    } // end loop over particles  

    } // end loop over events 

//   printf(" ok \n",nentries);
 
 return 0;
}
