// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <SetIni.h> // include class containing initializations for MC
#include <SetHisto.h> // initialization of histograms
#include <WSClist.h>

extern WSClist* newlist_000;
extern void ep_getpipe();


using namespace std;
extern int MaxHisto;


// write settings
int MCwrite ( char * names) {

   extern SetIni inival;
   extern SetHisto inihis;

// get name of the pipe file: inival.PipeName
   ep_getpipe();  
 
// get time
  time_t t=time(NULL);

//  inihis.HistoN = newlist_000->getNum(); // get total number of items
   WSCstring item("undefined", WS_EN_ISO8859_1);

   ofstream myout(names, ios::out | ios::trunc);
   if (!myout) { return 1; } 


   if (inival.MOutput == "" ) { inival.MOutput = "undefined";}
   myout << "# RunMC v3.3:  Feb  2005" << endl;
   myout << "# project file was created on" << ctime(&t); 
   myout << "# input file for RunMC. Use # to put your comments in any place" << endl;
   myout << "# I-, R-, S- mean integer, real and string values" << endl; 
   myout << "# H- means histogram info, O-mean options" << endl; 
   myout << "# " << endl;
   myout << "# Name of the project:" << endl; 
   myout << "S-PROJECT " << inival.MOutput << endl; 
   myout << "# " << endl;
   myout << "# Number of Monte Carlo events requested:" << endl;
   myout << "I-EVENTS " << inival.Nevents << endl;  
   myout << "# " << endl;
   myout << "# Select Monte Carlo model:" << endl; 
   myout << "I-MCTYPE " << inival.MCtype << endl; 
   myout << "# " << endl;
   myout << "# Select Monte Carlo process:" << endl;
   myout << "I-PROCESS " << inival.MCprocess << endl;
   myout << "# " << endl;
   myout << "# Type of first particle (1):" << endl; 
   myout << "I-ID1 "  << inival.IDparticle1 << endl;
   myout << "# " << endl;
   myout << "# Type of second  particle (2):" << endl;
   myout << "I-ID2 " << inival.IDparticle2 << endl;
   myout << "# " << endl;
   myout << "# Beam energy of first particle (1):" << endl;
   myout << "R-ENERGY1 " << inival.Energy1  << endl;
   myout << "# " << endl;
   myout << "# Beam energy of second particle (2):" << endl;
   myout << "R-ENERGY2 " << inival.Energy2  << endl;
   myout << "# " << endl;
   myout << "# PDF of first particle (1):" << endl;
   myout << "I-PDF1 " << inival.PDFparticle1  << endl;
   myout << "# " << endl;
   myout << "# PDF of second particle (2):" << endl;
   myout << "I-PDF2 " << inival.PDFparticle2  << endl;
   myout << "# " << endl;
   myout << "# Which type of ntuple to read ?:" << endl;
   myout << "I-NTTYPE " << inival.NTwhat  << endl;
   myout << "# " << endl;
   myout << "# Read only this file (0) or all files in this directory (1)?:" << endl;
   myout << "I-NTREAD " << inival.NTread  << endl;
   myout << "# " << endl;
   myout << "# Ntuple name  :" << endl;
   myout << "S-NTNAME " << inival.NTname  << endl;
   myout << "# " << endl;
   myout << "# Ntuple directory  :" << endl;
   myout << "S-NTDIR " << inival.NTdir  << endl;
   myout << "# " << endl;
   myout << "# Luminosity for this ntuple(s) in pb-1  :" << endl;
   myout << "R-NTlumi " << inival.NTlumi  << endl;
   myout << "# " << endl;
   myout << "# --- Type of final state (partons or stable final state):" << endl;
   myout << "I-FSTYPE " << inival.FStype   << endl;
   myout << "# " << endl;
   myout << "# --- Type of calculations (particles or jets):" << endl;
   myout << "I-JETTYPE " << inival.JetType   << endl;
   myout << "# " << endl;
   myout << "# --- Ycut for jet definitions :" << endl;
   myout << "R-YCUT " << inival.JetYcut   << endl;
   myout << "# " << endl;
   myout << "# --- Number of jets for this jet definition:" << endl;
   myout << "I-NJETS " << inival.JetNfixed   << endl;
   myout << "# " << endl;
   myout << "# --- Angle for the jet definition (only for KT algorithm):" << endl;
   myout << "I-ANGLE " << inival.JetAngle   << endl;
   myout << "# " << endl;
   myout << "# --- Recombination scheme for the jet definition (only for KT algorithm):" << endl;
   myout << "I-RECOMB " << inival.JetRecomb   << endl;
   myout << "# " << endl;
   myout << "# --- Frame type: 1-Lab;   2-HCM;   3-Breit:" << endl;
   myout << "I-FRAME " << inival.Frame   << endl;
   myout << "# " << endl;
   myout << "# --------- Q2_min for DIS:" << endl;
   myout << "R-Q2MIN " << inival.Q2min   << endl;
   myout << "# " << endl;
   myout << "# --------- Q2_max for DIS:" << endl;
   myout << "R-Q2MAX " << inival.Q2max   << endl;
   myout << "# " << endl;
   myout << "# --------- X_min (minimum Bjorken x) for DIS:" << endl;
   myout << "R-XMIN " << inival.Xmin   << endl;
   myout << "# " << endl;
   myout << "# --------- X_max for DIS:" << endl;
   myout << "R-XMAX " << inival.Xmax   << endl;
   myout << "# " << endl;
   myout << "# --------- Y_min:" << endl;
   myout << "R-YMIN " << inival.Ymin   << endl;
   myout << "# " << endl;
   myout << "# --------- Y_max:" << endl;
   myout << "R-YMAX " << inival.Ymax   << endl;
   myout << "# " << endl;
   myout << "# --------- W_min:" << endl;
   myout << "R-WMIN " << inival.Wmin   << endl;
   myout << "# " << endl;
   myout << "# --------- W_max:" << endl;
   myout << "R-WMAX " << inival.Wmax   << endl;
   myout << "# " << endl;
   myout << "# --------- ET_min:" << endl;
   myout << "R-ETMIN " << inival.ETmin   << endl;
   myout << "# " << endl;
   myout << "# --------- ET_max:" << endl;
   myout << "R-ETMAX " <<  inival.ETmax   << endl;
   myout << "# " << endl;
   myout << "# --------- ETA_min (minimum pseudorapidy) :" << endl;
   myout << "R-ETAMIN " << inival.ETAmin   << endl;
   myout << "# " << endl;
   myout << "# --------- ETA_max:" << endl;
   myout << "R-ETAMAX " << inival.ETAmax   << endl;
   myout << "# " << endl;
   myout << "# RUNMC options:" << endl; 
   myout << "# ---------Stop, (do not modify!):" << endl;
   myout << "I-STOP " << inival.Stop << endl;
   myout << "# ---------Renice RUNMC (do not modify!):" << endl;
   myout << "I-RENICE  " << inival.Renice << endl;
   myout << "# " << endl;
   myout << "# RUNMC option; use user-defined steering card? (0-no, 1-yes):" << endl;
   myout << "I-STEER " << inival.Steering << endl;
   myout << "# " << endl;
   myout << "# RUNMC option; Name of the pipe file in $RUNMC/pipes directory:" << endl;
   myout << "# " << endl;
   myout << "S-PIPE " << inival.PipeName << endl;
   myout << "# " << endl;
   myout << "# ----------------Options to display histogrsms-------" << endl; 
   myout << "OPTIONS " << inihis.HistoOptions[0] << " ";
   myout << inihis.HistoOptions[1] << " ";
   myout << inihis.HistoOptions[2] << " ";
   myout << inihis.HistoOptions[3] << " ";
   myout << inihis.HistoOptions[4] << " ";
   myout << inihis.HistoOptions[5] << " ";
   myout << inihis.HistoOptions[6] << " ";
   myout << inihis.HistoOptions[7] << " ";
   myout << inihis.HistoOptions[8] << " ";
   myout << inihis.HistoOptions[9] << " ";
   myout << inihis.HistoOptions[10] << " ";
   myout << inihis.HistoOptions[11] << " ";
   myout << inihis.HistoOptions[12] << " "; // rest not used so far ..  
   myout << inihis.HistoOptions[13] << " ";
   myout << inihis.HistoOptions[14] << " ";
   myout << inihis.HistoOptions[15] << " ";
   myout << inihis.HistoOptions[16] << " ";
   myout << inihis.HistoOptions[17] << " ";
   myout << inihis.HistoOptions[18] << " ";
   myout << inihis.HistoOptions[19] << endl;
   myout << "# " << endl;
   myout << "# ---------------- Output histograms --------------------" << endl;
   myout << "# No____Type_______Min________Max______NoBins___Weight" << endl;




    WSCstring empty=" ";
    WSCstring str;
    long nss=0; 
    int sspace=1;
    inihis.HistoNcurrent=0;

// comment
/*
   cout << "MCWrite says=" << inihis.HistoN << endl;
   for(int i=1; i<inihis.HistoN; i++){
    cout << i << " " << inihis.HistoName[i] << endl;
   }
*/

    for  (int i=1; i<=inihis.HistoN; i++ ) {
    if (inihis.HistoType[i]  > 0 ) {  
      inihis.HistoNcurrent++; 
      myout << "# new histogram No=" << inihis.HistoNcurrent << endl;
      myout << "H-NAME " << inihis.HistoName[inihis.HistoNcurrent]; 
// make nice space ibefore commenys
      str=inihis.HistoName[inihis.HistoNcurrent];
      nss=str.getChars();
      sspace=25-str.getChars();
      if (sspace<1) empty="      "; 
      for  (int j=0; j<sspace; j++ ) empty.addString(" "); 
      myout << empty; 
      myout << inihis.HistoComm[inihis.HistoNcurrent] << endl; 
      myout << "H-INFO " << " ";
      myout << inihis.Histo2D[i] << " ";  
      myout << inihis.HistoMin[i] <<" "; 
      myout << inihis.HistoMax[i] <<" ";
      myout << inihis.HistoBins[i] <<" "; 
      myout << inihis.HistoWeight[i] << endl;
      empty.clear(); 
    }; 

  };  


     myout.close();
     return 0;

     }
