// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCoption.h>
#include <WSCstring.h>
#include <WSCfileSelect.h>
#include <WSCmessageDialog.h> //(B) 
#include <WSCradioGroup.h>
#include <WSCvbtn.h>


#include <stdlib.h>
#include <math.h>
#include <stdio.h>

#include <SetIni.h> // include class containing initializations for M 
using namespace std;
#include <iostream>
#include<sys/stat.h> 

#include <WSCoption.h>
#include <WSCvifield.h>
#include <WSCvlabel.h>
 
extern int get_ntnames();
extern void remove_DIS_on_GUI();
extern void show_DIS_on_GUI(); 

// installation directory
extern char * RUNDIR;
extern char * PXMDIR;
extern int  CheckWIN32;
extern char * MC[];

extern WSCoption* newopti_000; 
extern WSCoption* newopti_030;
extern WSCoption* newopti_032;
extern WSCvlabel* newvlab_043;
extern WSCvlabel* newvlab_044;
extern WSCvifield* newvifi_032;
extern WSCvifield* newvifi_030;
extern WSCvifield* newvifi_003;
// ntuple staff
extern WSCradioGroup* newradi_046;
extern WSCvlabel* newvlab_045;
extern WSCvifield* newvifi_041;
extern WSCvbtn* newvbtn_111;
extern WSCvbtn* newvbtn_112;
extern WSCvbtn* newvbtn_113;
extern WSCvbtn* newvbtn_201;

extern WSCmessageDialog* newmess_000;
extern WSCoption* newopti_000;
extern WSCfileSelect* newfile_000; 

WSCstring NTUPLEname; 

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_MCselect(WSCbase* object){
  //do something...

     extern SetIni inival;

     long  val = object->getProperty(WSNvalue);
//   printf("ep_MCselect =%d\n",val);


     inival.MCtype = val;
//   printf("ep_MCselect =%d\n", inival.MCtype);



  //Access to the global instance of the WSCmessageDialog class.
  WSCmessageDialog* msg = WSGIappMessageDialog(); //(G)
  msg->setPropertyV(WSNtitleString,"Message:");
  msg->setPropertyV(WSNx,(short)168);
  msg->setPropertyV(WSNy,(short)114);
  msg->setPropertyV(WSNwidth,(unsigned short)335);
  msg->setPropertyV(WSNheight,(unsigned short)122);
  msg->setPropertyV(WSNtopShadowColor,"DEF1");
  msg->setPropertyV(WSNbottomShadowColor,"DEF1");


    if (inival.MCtype > 0) {

    show_DIS_on_GUI();
    newopti_000->setPropertyV(WSNlabelString, MC[inival.MCtype] );
    newopti_030->setVisible(True);
    newopti_032->setVisible(True);
    newvifi_032->setVisible(True);
    newvifi_030->setVisible(True);
    newvlab_043->setVisible(True);
    newvlab_044->setVisible(True);
    newvbtn_201->setPropertyV(WSNvis,(WSCbool)1); // MC settings visible 
// for PHOJET - no MC settings bottom
    if (inival.MCtype == 7) newvbtn_201->setPropertyV(WSNvis,(WSCbool)0); 

// remove Ntuple staff
    newradi_046->setPropertyV(WSNvis,(WSCbool)0);
    newvlab_045->setPropertyV(WSNvis,(WSCbool)0);
    newvifi_041->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_111->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_112->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_113->setPropertyV(WSNvis,(WSCbool)0);
    }



  if (inival.MCtype < 0) {

// no MC settings bottom 
    newvbtn_201->setPropertyV(WSNvis,(WSCbool)0);

// removee DIS 
    remove_DIS_on_GUI();

    newopti_030->setVisible(False);
    newopti_032->setVisible(False);
    newvifi_032->setVisible(False);
    newvifi_030->setVisible(False);
    newvlab_043->setVisible(False);
    newvlab_044->setVisible(False);

// add  Ntuple staff
    newradi_046->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_045->setPropertyV(WSNvis,(WSCbool)1);
    newvifi_041->setPropertyV(WSNvis,(WSCbool)1);
    newvbtn_111->setPropertyV(WSNvis,(WSCbool)1);
    newvbtn_112->setPropertyV(WSNvis,(WSCbool)1);
    newvbtn_113->setPropertyV(WSNvis,(WSCbool)1);

//   char * RUNDIR;
//   RUNDIR=getenv("RUNMC");
   char   mypathf[700];

// set mask
  if (inival.MCtype == -1) {newfile_000->setProperty(WSNmaskFileName,"rtup"); inival.NTwhat=1;} 
  if (inival.MCtype == -2) {newfile_000->setProperty(WSNmaskFileName,"htup"); inival.NTwhat=2;}  
  if (CheckWIN32 == 0) strcpy(mypathf,RUNDIR);
  if (CheckWIN32 == 1) strcpy(mypathf,PXMDIR);
  strncat(mypathf, "/proj", strlen("/proj"));
  newfile_000->setPropertyV(WSNdirName,mypathf);
 
//  fs->setProperty(WSNdefaultPosition,True);
  long ret = newfile_000->popup();


// if cancel 
  if (ret == WS_DIALOG_CANCEL){
    inival.MCtype=1; 
    newvbtn_201->setPropertyV(WSNvis,(WSCbool)1); // MC settings
    newopti_000->setPropertyV(WSNuserValue,(long)1); 
    newopti_000->setPropertyV(WSNvalue,(long)1); 
    newopti_000->update();  
    newopti_030->setVisible(True);
    newopti_032->setVisible(True);
    newvifi_032->setVisible(True);
    newvifi_030->setVisible(True);
    newvlab_043->setVisible(True);
    newvlab_044->setVisible(True);
// remove Ntuple staff
    newradi_046->setPropertyV(WSNvis,(WSCbool)0);
    newvlab_045->setPropertyV(WSNvis,(WSCbool)0);
    newvifi_041->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_111->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_112->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_113->setPropertyV(WSNvis,(WSCbool)0);
  }


  if (ret == WS_DIALOG_OK){
// open dialog
    WSCstring  str, str1,str2="...",str3;

//  str << fs->getFileName() << " is selected.";
    str << newfile_000->getFileName();


    WSCstring dirname= WSGFgetDirName(str); 
    WSCstring filename= WSGFgetFileName(str);  
    str1 << str << " is selected.";
    long word = str1.getChars();
    NTUPLEname=str;
//    cout << words << endl;
//    cout << str01 << endl;
    if (word>50) str1.deleteChars(0, word-45 );
    str3=str2+str1;
    msg->setProperty(WSNwidth,500);                 //(H)
    msg->setProperty(WSNheight,120);                //(I)
    msg->setPropertyV(WSNx,(short)168);
    msg->setPropertyV(WSNy,(short)168);
    msg->setProperty(WSNlabelString,str3);
    msg->update();
    long valmesg = msg->popup();
    if  (valmesg == WS_DIALOG_CANCEL) { 
    return;}
    if  (valmesg == WS_DIALOG_OK) { 

// load 
    inival.NTname = new char[strlen( (char*)filename )+1]; // empty
    strcpy(inival.NTname,(char*)filename );
    inival.NTdir = new char[strlen( (char*)dirname )+1]; // empty
    strcpy(inival.NTdir,(char*)dirname );


// get link to .analmc.tup
     static int icc=0;
     icc=get_ntnames();
//     if (icc !=0) cout << "Error in get_ntnames() .. " << endl;


// crete info fils

     WSCstring  myv1("$RUNMC/bin/ntupview ");
     WSCstring  myv2=NTUPLEname;
     WSCstring  myv3("> .analmc_ntuple.info &"); 
     myv1.addString(myv2);  
     if (inival.MCtype == -1) myv1.addString( " trunmc " );
     if (inival.MCtype == -2) myv1.addString( " thepevt " );
     myv1.addString(myv3);
//     cout << myv1 << endl;

// check/remove file
  struct stat buf1;
  int ile1= stat ( ".analmc_ntuple.info", &buf1 );
  if (ile1 == 0) remove(".analmc_ntuple.info");

  int irun=0;
  irun=system(myv1);      
//  cout << myv1 << endl;

  if (irun != 0) cout << "Error in ntupview" << endl;  
 
  };
 
  } // end of OK dialog
  } // end read of the file




}
static WSCfunctionRegister  op("ep_MCselect",(void*)ep_MCselect);
