// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSClist.h>
#include <WSCsheet.h>
#include <SetHisto.h> // initialization of histograms     
#include <WSCvbtn.h>
#include <WSCstring.h>

using namespace std;
#include <iostream>

extern WSCsheet* newshee_002;
extern WSClist* newlist_000;
extern void set_histo_spreadsheet( long number, long position );

extern WSCvbtn* newvbtn_001;
extern WSCvbtn* newvbtn_002;
extern WSCvbtn* newvbtn_003;
extern WSCvbtn* newvbtn_004;
extern WSCvbtn* newvbtn_005;
extern WSCvbtn* newvbtn_006;
extern WSCvbtn* newvbtn_008;
extern WSCvbtn* newvbtn_009;

// for input histograms
extern int InputCurrent;
extern WSCstring InputTitle[501];
extern WSCstring InputComme[501];

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_Select_histo(WSCbase* object){

// get histograms
  extern SetHisto inihis;

   long pos = newlist_000->getSelectedPos();  
//   cout << pos << endl;
   if (pos < 0 || pos > InputCurrent ) return;
 
//   cout << pos << endl;
//  WSCstring  item = newlist_000->getSelectedItem(); 
  static WSCstring  xnone("none"); 


//  long pos = newlist_000->getSelectedPos();
//  printf("selected item = %d\n",pos);
// determin the current position
// take into accont that 1 raw is definition    
     long nx=newshee_002->getRowCount()-1;
     long posi=nx+1;
      
//    cout << "Item=" << sna << " Spreadsheet pos= " << tpos << endl;

     inihis.HistoType[nx]=nx;
     inihis.HistoName[nx] = new char[strlen((char*)InputTitle[pos])];
     strcpy(inihis.HistoName[nx],(char*)InputTitle[pos]);
     inihis.HistoComm[nx] = new char[strlen((char*)InputComme[pos])];
     strcpy(inihis.HistoComm[nx],(char*)InputComme[pos]);
     inihis.HistoMin[nx]=0.0;
     inihis.HistoMax[nx]=0.0;
     inihis.Histo2D[nx]=1;
     inihis.HistoBins[nx]=0;
     inihis.HistoWeight[nx]=1.0;
// if nothing
     if ( strcmp((char*)InputTitle[pos], (char*)xnone) == 0 ) inihis.HistoType[nx]=0;

// set in the spreadsheet, take into accont that 1 line is the definition
//     cout << nx << " " << inihis.HistoName[nx] << endl;

//       cout << " call to set_histo_spreadsheet with " <<  nx << " " << tpos << endl;
     set_histo_spreadsheet( nx, posi ); 
     newshee_002->update();
     newshee_002->redraw();



     inihis.HistoNcurrent=nx;
     inihis.HistoN=nx+1;


// put on RunMC GUI 
  WSCstring tmp1;
  for(int i=2; i<newshee_002->getRowCount(); i++){
  tmp1=newshee_002->getText(1, i);
  nx=i-1;
     if (nx == 1) newvbtn_001->setPropertyV(WSNlabelString, (char*)tmp1); 
     if (nx == 2) newvbtn_002->setPropertyV(WSNlabelString, (char*)tmp1);
     if (nx == 3) newvbtn_003->setPropertyV(WSNlabelString, (char*)tmp1);
     if (nx == 4) newvbtn_004->setPropertyV(WSNlabelString, (char*)tmp1);
     if (nx == 5) newvbtn_005->setPropertyV(WSNlabelString, (char*)tmp1);
     if (nx == 6) newvbtn_006->setPropertyV(WSNlabelString, (char*)tmp1);
     if (nx == 7) newvbtn_008->setPropertyV(WSNlabelString, (char*)tmp1);
     if (nx == 8) newvbtn_009->setPropertyV(WSNlabelString, (char*)tmp1);
  }

  //do something...
}
static WSCfunctionRegister  op("ep_Select_histo",(void*)ep_Select_histo);
