// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------

#include <iostream>
#include <fstream>
using namespace std;
#include <WSCvtimer.h>
#include <WSCvbtn.h>
#include <WSCvbtn.h>
#include <WSCvlabel.h>
#include <SetIni.h> // include class containing initializations for MC
#include <SetHisto.h> // initialization of histograms
#include <SysRUNMC.h>
#include <WSCvarc.h>
#include <WSCvline.h>
#include <WSCvmeter.h>
extern WSCvmeter* newvmet_001;
extern WSCvbtn* newvbtn_204;
extern WSCvline* newvlin_001;
extern WSCvline* newvlin_002;
extern WSCvline* newvlin_063;
extern WSCvline* newvlin_064;
extern WSCvarc* newvarc_065;


extern WSCvbtn* newvbtn_000;
extern WSCvlabel* newvlab_017;
extern WSCvbtn* newvbtn_030;
extern WSCvtimer* newvtim_000;
extern WSCvlabel* newvlab_024;
extern SysRUNMC analmc; // system files for this run
extern char PipeEvents[500];
extern char PipeStop[500];
extern int timecounter;


void ep_Stop(WSCbase* object){
  //do something...

  extern SetHisto inihis;
  extern SetIni inival;
  inival.Stop=1;

    newvlab_017->setProperty(WSNlabelString,"Run is terminated");
    newvlab_017->setPropertyV(WSNbackColor,"DEF13");
    newvlab_017->setPropertyV(WSNtopShadowColor,"DEF15");
    newvlab_017->setPropertyV(WSNbottomShadowColor,"DEF16");
    newvbtn_000->setVisible(True); // put back  bottom run
    newvarc_065->setPropertyV(WSNvis,(WSCbool)0); // red dot unvisible 

// set default colors for arrows
    newvlin_001->setPropertyV(WSNforeColor,"#505050");
    newvlin_002->setPropertyV(WSNforeColor,"#505050");
    newvlin_064->setPropertyV(WSNforeColor,"#505050");
    newvlin_063->setPropertyV(WSNforeColor,"#505050");

// define Stop
    inival.Stop=0;
    // open system file for monitoring
    ofstream myoutsys(PipeStop, ios::out | ios::trunc);
    myoutsys << "1"; // termintae signal 
    myoutsys.close();


     int hhh = (int) analmc.runtime;  // integer now
     int  xhour= hhh / 60;
     int  xmin = hhh % 60;  // rest of the division
// show time passed
     char  szHOUR[3], szMINS[2];
     sprintf(szHOUR,"%3d", xhour );
     sprintf(szMINS,"%2d", xmin );

     char   xtime[31];
     strncpy(xtime,"", 30);
     strncat(xtime, "Time for this run ", 18);
     strncat(xtime, szHOUR, strlen(szHOUR));
     strncat(xtime, "h : ", 4 );
     strncat(xtime, szMINS, strlen(szMINS));
     strncat(xtime, "min", 3 );
     newvlab_017->setProperty(WSNlabelString,(char*)xtime);


// stop timer  
    newvtim_000->setProperty(WSNrunning,False);
    timecounter=0; // reset time !
    newvmet_001->setProperty(WSNvalue1,0); // do not show status bar
    newvmet_001->update();

// show histogram viewers (if histograms are wanted)
     if (inihis.HistoOptions[9] == 1)  newvbtn_204->setPropertyV(WSNvis,(WSCbool)1);


// remove pipes
//     remove (PipeEvents);
//     remove (PipeStop);

//   newvlab_024->setPropertyV(WSNlabelString,"Run is stopped");

}
static WSCfunctionRegister  op("ep_Stop",(void*)ep_Stop);
