// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
using namespace std;
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvtimer.h>
#include <WSCmessageDialog.h>
#include <WSCvlabel.h>
#include <WSCvmeter.h>
#include <WSCvbtn.h>
#include <WSCstring.h>
#include <WSCmainWindow.h>
#include <iostream>
#include <fstream>
#include <SetIni.h> // include class containing initializations for MC 
#include <SetHisto.h> // initialization of histograms 
#include <SysRUNMC.h>
#include <WSCvarc.h>
#include <WSCvline.h>
#include <sys/stat.h>

extern WSCvline* newvlin_001;
extern WSCvline* newvlin_002;
extern WSCvline* newvlin_063;
extern WSCvline* newvlin_064;
extern WSCvarc* newvarc_065;
extern SetIni inival;
extern WSCvbtn* newvbtn_000;
extern WSCvbtn* newvbtn_204;
extern SysRUNMC analmc; // system files for this run  
extern WSCmainWindow* newwin000; 
extern WSCmessageDialog* newmess_000;
extern WSCstring PROJlog;
extern WSCstring PROJerr;
extern char * RUNDIR;


int timecounter; // count time 

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
extern WSCvtimer* newvtim_000;
extern WSCmessageDialog* newmess_000;
extern WSCvmeter* newvmet_001;

// for pipe of events 
extern char  PipeEvents[500];
extern char  PipeStop[500];

extern WSCvlabel* newvlab_024;
extern WSCvlabel* newvlab_017;

void ep_Timer(WSCbase* object){
//do something...

  extern SetHisto inihis;

  static int  thisrun=0; 
  static long cnt = 0;
  static long val=0;
  static long vax=0;
  

    cnt++;
//  cout << cnt << endl;

   ifstream myout(PipeEvents, ios::in);
   if (!myout) {
   newmess_000->setPropertyV(WSNlabelString,"Cannot open pipe file \n for events");
   newmess_000->popup(); }
   myout >> val >> analmc.runpid ;
   myout.close();

// show number of events   
   newvlab_024->setProperty(WSNlabelString,val);

// show number of events in % 
    vax = (100* val / inival.Nevents);
//   cout << vax << endl;

   
     newvarc_065->setPropertyV(WSNvis,(WSCbool)1);
     newvarc_065->setPropertyV(WSNforeColor,"#c00040");

// change colors for arrows and red dot 
     newvlin_001->setPropertyV(WSNforeColor,"#804040");
     newvlin_002->setPropertyV(WSNforeColor,"#804040");
     newvlin_063->setPropertyV(WSNforeColor,"#804040");
     newvlin_064->setPropertyV(WSNforeColor,"#804040");
     if ( (cnt % 2) == 0 ) { newvarc_065->setPropertyV(WSNforeColor,"#ff8000"); } 


// check error file 
    struct stat buf;
    int file_size=0; 
    int icc=0;
    if ( (cnt % 2) == 0 ) {
    icc = stat ( (char*)PROJerr , &buf);  
    file_size=buf.st_size;
// if error was found 
    if (file_size>0) {
     timecounter=0;  
     newvarc_065->setPropertyV(WSNvis,(WSCbool)0);
     newvarc_065->setPropertyV(WSNforeColor,"#804040");
// change colors for arrows and red dot
     newvlin_001->setPropertyV(WSNforeColor,"#505050");
     newvlin_002->setPropertyV(WSNforeColor,"#505050");
     newvlin_063->setPropertyV(WSNforeColor,"#505050");
     newvlin_064->setPropertyV(WSNforeColor,"#505050");
     newvbtn_000->setVisible(True); // put it back
     newvmet_001->setProperty(WSNvalue1,0); // do not show status bar
     newvmet_001->update();
     newvtim_000->setProperty(WSNrunning,False); // stop timer
     newvlab_017->setProperty(WSNlabelString,"Error - check error file");
     newvlab_017->setPropertyV(WSNbackColor,"#ff8000");
//     newvlab_017->setPropertyV(WSNbackColor,"DEF13");
     newvlab_017->setPropertyV(WSNtopShadowColor,"DEF15");
     newvlab_017->setPropertyV(WSNbottomShadowColor,"DEF16");

// start message
  WSCstring  geterror="tail -n15 ";
  geterror.addString(PROJerr);
  geterror.addString(" > ");
  WSCstring ErrShort(RUNDIR);
  ErrShort.addString("/pipes/");
  ErrShort.addString(inival.PipeName);
  ErrShort.addString(".err");
  geterror.addString(ErrShort);
  int irun1=system( geterror );
  if (irun1 != 0) {
  newmess_000->setPropertyV(WSNlabelString,"Cannot make error file");
  newmess_000->popup(); }

// message dialog
  WSCmessageDialog* errormess = WSGIappMessageDialog(); //(G)
  errormess->setPropertyV(WSNworkBackColor,"#ffc0c0");
  errormess->setPropertyV(WSNok,(WSCbool)0);
  errormess->setPropertyV(WSNno,(WSCbool)0);
  errormess->setPropertyV(WSNname,"errormess");
  errormess->setPropertyV(WSNtitleString,"Error message");
  errormess->setPropertyV(WSNx,(short)224);
  errormess->setPropertyV(WSNy,(short)112);
  errormess->setPropertyV(WSNwidth,(unsigned short)581);
  errormess->setPropertyV(WSNheight,(unsigned short)264);
  errormess->setPropertyV(WSNtopShadowColor,"DEF1");
  errormess->setPropertyV(WSNbottomShadowColor,"DEF1"); 
  WSCstring* str = WSGFreadTextFile(ErrShort);
  errormess->setProperty(WSNlabelString,str->getString());
  long valmesg = errormess->popup();
  if  (valmesg == WS_DIALOG_CANCEL) { 
     newvbtn_000->setVisible(True); // put it back
     newvmet_001->setProperty(WSNvalue1,0); // do not show status bar
     newvmet_001->update();
     newvtim_000->setProperty(WSNrunning,False); // stop timer
     newvlab_017->setProperty(WSNlabelString,"");
     newvlab_017->setPropertyV(WSNbackColor,"DEF13");
     newvlab_017->setPropertyV(WSNtopShadowColor,"DEF15");
     newvlab_017->setPropertyV(WSNbottomShadowColor,"DEF16");
   return;}
   }
   }


// put all  pid values (history of jobs executed)
   if (thisrun == 0 && timecounter == 0 ) { analmc.allpid[thisrun]=analmc.runpid; thisrun++; };
   if (thisrun > 0 &&
       timecounter == 0 &&
       analmc.allpid[thisrun-1] != analmc.runpid && 
       thisrun < 100  ) {   
       thisrun++;
       analmc.allpid[thisrun]=analmc.runpid;  }; 
//       cout << analmc.allpid[thisrun] << endl; }    

// calculate how many minutes is run is going on
// one tic - 2 sec  (2000 msec)
    timecounter++;
    analmc.runtime=2*timecounter/60.; 

//    cout << analmc.runtime << " " << analmc.runpid << endl;
 

// show number of events in % to the total    
   newvmet_001->setProperty(WSNvalue1,vax);

// show START buttom when we have finished 

    if ( val == inival.Nevents && inival.Nevents > 0) {
     timecounter=0;

     int hhh = (int) analmc.runtime;  // integer now
     int  xhour= hhh / 60; 
     int  xmin = hhh % 60;  // rest of the division   
// show time passed
     char  szHOUR[3], szMINS[2];
     sprintf(szHOUR,"%3d", xhour );
     sprintf(szMINS,"%2d", xmin );

     char   xtime[31]; 
     strncpy(xtime,"", 30);
     strncat(xtime, "Time for this run ", 18);
     strncat(xtime, szHOUR, strlen(szHOUR));
     strncat(xtime, "h : ", 4 );
     strncat(xtime, szMINS, strlen(szMINS));
     strncat(xtime, "min", 3 );

//     cout << analmc.runtime << "  " << hhh << " " << xhour << " " << xmin << endl;
//     cout << xtime << endl;

// show histogram viewers (if histograms are wanted)
     if (inihis.HistoOptions[9] == 1)  newvbtn_204->setPropertyV(WSNvis,(WSCbool)1);


     newvarc_065->setPropertyV(WSNvis,(WSCbool)0);
     newvarc_065->setPropertyV(WSNforeColor,"#804040");

// change colors for arrows and red dot
     newvlin_001->setPropertyV(WSNforeColor,"#505050");
     newvlin_002->setPropertyV(WSNforeColor,"#505050");
     newvlin_063->setPropertyV(WSNforeColor,"#505050");
     newvlin_064->setPropertyV(WSNforeColor,"#505050");
       
 
     newvbtn_000->setVisible(True); // put it back 
     newvmet_001->setProperty(WSNvalue1,0); // do not show status bar 
     newvmet_001->update();
     newvtim_000->setProperty(WSNrunning,False); // stop timer 
     newvlab_017->setProperty(WSNlabelString,(char*)xtime);
     newvlab_017->setPropertyV(WSNbackColor,"DEF13");
     newvlab_017->setPropertyV(WSNtopShadowColor,"DEF15");
     newvlab_017->setPropertyV(WSNbottomShadowColor,"DEF16");

    }
}
static WSCfunctionRegister  op("ep_Timer",(void*)ep_Timer);
