// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCmessageDialog.h>
#include <WSCtextField.h>
#include <WSCdialog.h>

// loading initial file
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <WSCmainWindow.h>
#include <WSCvtimer.h> 
#include <WSCvbtn.h>

using namespace std;

extern WSCvbtn* newvbtn_112;
WSCvtimer* newvtim_013; 
WSCdialog* newdial_205;
WSCtextField* newtext_206;
extern WSCmainWindow* newwin000;
extern WSCmessageDialog* newmess_000;

extern char * RUNDIR;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_look(WSCbase* object){
  //do something...
static long cnt = 0;
 
  cnt++;
//  cout << cnt << endl;
//  cout << cnt << endl; 

// check file
  static struct stat buf;
// check file
  int inifile = stat ( ".analmc_ntuple.info", &buf );
  if (inifile == 0 )  {
      newvbtn_112->setPropertyV(WSNuserString,"check ntuple info"); 
      newvbtn_112->setPropertyV(WSNlabelString,"check ntuple info");
      newvbtn_112->setPropertyV(WSNbackColor,"DEF1");
      newvbtn_112->setPropertyV(WSNtopShadowColor,"DEF3");
      newvbtn_112->setPropertyV(WSNbottomShadowColor,"DEF4");

      WSCstring* str = WSGFreadTextFile(".analmc_ntuple.info");
      newtext_206->setProperty(WSNlabelString,str->getString());
      newtext_206->setPropertyV(WSNfont,(unsigned char)0);
      newdial_205->popup();
      newtext_206->update();
      newvtim_013->setProperty(WSNrunning,False);
   }

 
}





//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_checkinfo(WSCbase* object){
  //do something...


// show window
  newvbtn_112->setPropertyV(WSNuserString,"Loading info .. wait!");
  newvbtn_112->setPropertyV(WSNlabelString,"Loading info .. wait!");
  newvbtn_112->setPropertyV(WSNbackColor,"#c0ffc0");
  newvbtn_112->setPropertyV(WSNtopShadowColor,"#ffffff");
  newvbtn_112->setPropertyV(WSNbottomShadowColor,"#80c080");


  newdial_205 = new  WSCdialog(newwin000,"newdial_205");
      newdial_205->initialize();
  newdial_205->setPropertyV(WSNworkBackColor,"DEF1");
  newdial_205->setPropertyV(WSNok,(WSCbool)0);
  newdial_205->setPropertyV(WSNno,(WSCbool)0);
  newdial_205->setPropertyV(WSNname,"newdial_205");
  newdial_205->setPropertyV(WSNtitleString,"Ntuple files");
  newdial_205->setPropertyV(WSNx,(short)224);
  newdial_205->setPropertyV(WSNy,(short)112);
  newdial_205->setPropertyV(WSNwidth,(unsigned short)581);
  newdial_205->setPropertyV(WSNheight,(unsigned short)464);
  newdial_205->setPropertyV(WSNtopShadowColor,"DEF1");
  newdial_205->setPropertyV(WSNbottomShadowColor,"DEF1");
  
  newtext_206 = new  WSCtextField(newdial_205,"newtext_206");
      newtext_206->initialize();
  newtext_206->setPropertyV(WSNname,"newtext_206");
  newtext_206->setPropertyV(WSNuserString,"ntuples");
  newtext_206->setPropertyV(WSNx,(short)1);
  newtext_206->setPropertyV(WSNy,(short)1);
  newtext_206->setPropertyV(WSNwidth,(unsigned short)579);
  newtext_206->setPropertyV(WSNheight,(unsigned short)462);
  newtext_206->setPropertyV(WSNvis,(WSCbool)1);
  newtext_206->setPropertyV(WSNanchorTop,(unsigned short)1);
  newtext_206->setPropertyV(WSNanchorBottom,(unsigned short)40);
  newtext_206->setPropertyV(WSNanchorLeft,(unsigned short)1);
  newtext_206->setPropertyV(WSNanchorRight,(unsigned short)1);
  newtext_206->setPropertyV(WSNanchorTopFlag,(WSCbool)1);
  newtext_206->setPropertyV(WSNanchorBottomFlag,(WSCbool)1);
  newtext_206->setPropertyV(WSNanchorLeftFlag,(WSCbool)1);
  newtext_206->setPropertyV(WSNanchorRightFlag,(WSCbool)1);


// set timer at the very star of the gui
  newvtim_013 = new  WSCvtimer(newdial_205,"newvtim_013");
  newvtim_013->initialize();
  newvtim_013->setPropertyV(WSNinterval,(unsigned long)500);
  newvtim_013->setPropertyV(WSNcont,(WSCbool)1);
  newvtim_013->setProperty(WSNrunning,True);
  newvtim_013->setPropertyV(WSNname,"newvtim_013");
  WSCprocedure* op_newvtim_013_5 = new WSCprocedure("ep_look",2);
  extern void ep_look(WSCbase*);
  op_newvtim_013_5->setFunction(ep_look,"ep_look");
  newvtim_013->addProcedure(op_newvtim_013_5);

// show window
//  newtext_206->setProperty(WSNlabelString,"Loading info ... wait!");
//  newtext_206->setPropertyV(WSNfont,(unsigned char)6);
//  newdial_205->popup();



}
static WSCfunctionRegister  op("ep_checkinfo",(void*)ep_checkinfo);
