// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCmessageDialog.h>
#include <WSCtextField.h>
#include <WSCdialog.h>

// loading initial file
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <WSCmainWindow.h>
#include <WSCvtimer.h>
#include <WSCvbtn.h>

using namespace std;


WSCdialog* newdial_105;
WSCtextField* newtext_006;
extern WSCmainWindow* newwin000;
extern WSCvbtn* newvbtn_111;
extern WSCmessageDialog* newmess_000;
WSCvtimer* newvtim_015; 


//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_look2(WSCbase* object){
  //do something...
static long cnt = 0;
 
  cnt++;
//  cout << cnt << endl;
//  cout << cnt << endl;
 
// check file
  static struct stat buf;
// check file
  int inifile = stat ( ".analmc.tup", &buf );
  if (inifile == 0 )  {
      newvbtn_111->setPropertyV(WSNuserString,"check ntuple files");
      newvbtn_111->setPropertyV(WSNlabelString,"check ntuple files");
      newvbtn_111->setPropertyV(WSNbackColor,"DEF1");
      newvbtn_111->setPropertyV(WSNtopShadowColor,"DEF3");
      newvbtn_111->setPropertyV(WSNbottomShadowColor,"DEF4");


      WSCstring* str = WSGFreadTextFile(".analmc.tup");
      long lines=str->getLines(); // get number of lines
      newtext_006->setProperty(WSNlabelString,str->getString());
      newtext_006->setBottomLine(lines+1);
      newtext_006->update();
      newvtim_015->setProperty(WSNrunning,False);
      newdial_105->popup(); 

   }
 
 
}




//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_checkntuple(WSCbase* object){
  //do something...


// show window
  newvbtn_111->setPropertyV(WSNuserString,"Loading file .. wait!");
  newvbtn_111->setPropertyV(WSNlabelString,"Loading file .. wait!");
  newvbtn_111->setPropertyV(WSNbackColor,"#c0ffc0");
  newvbtn_111->setPropertyV(WSNtopShadowColor,"#ffffff");
  newvbtn_111->setPropertyV(WSNbottomShadowColor,"#80c080"); 






  newdial_105 = new  WSCdialog(newwin000,"newdial_105");
      newdial_105->initialize();
  newdial_105->setPropertyV(WSNworkBackColor,"DEF1");
  newdial_105->setPropertyV(WSNok,(WSCbool)0);
  newdial_105->setPropertyV(WSNno,(WSCbool)0);
  newdial_105->setPropertyV(WSNname,"newdial_105");
  newdial_105->setPropertyV(WSNtitleString,"Ntuple files");
  newdial_105->setPropertyV(WSNx,(short)224);
  newdial_105->setPropertyV(WSNy,(short)112);
  newdial_105->setPropertyV(WSNwidth,(unsigned short)581);
  newdial_105->setPropertyV(WSNheight,(unsigned short)264);
  newdial_105->setPropertyV(WSNtopShadowColor,"DEF1");
  newdial_105->setPropertyV(WSNbottomShadowColor,"DEF1");
  
  newtext_006 = new  WSCtextField(newdial_105,"newtext_006");
      newtext_006->initialize();
  newtext_006->setPropertyV(WSNname,"newtext_006");
  newtext_006->setPropertyV(WSNuserString,"ntuples");
  newtext_006->setPropertyV(WSNx,(short)1);
  newtext_006->setPropertyV(WSNy,(short)1);
  newtext_006->setPropertyV(WSNwidth,(unsigned short)579);
  newtext_006->setPropertyV(WSNheight,(unsigned short)262);
  newtext_006->setPropertyV(WSNvis,(WSCbool)1);
  newtext_006->setPropertyV(WSNanchorTop,(unsigned short)1);
  newtext_006->setPropertyV(WSNanchorBottom,(unsigned short)40);
  newtext_006->setPropertyV(WSNanchorLeft,(unsigned short)1);
  newtext_006->setPropertyV(WSNanchorRight,(unsigned short)1);
  newtext_006->setPropertyV(WSNanchorTopFlag,(WSCbool)1);
  newtext_006->setPropertyV(WSNanchorBottomFlag,(WSCbool)1);
  newtext_006->setPropertyV(WSNanchorLeftFlag,(WSCbool)1);
  newtext_006->setPropertyV(WSNanchorRightFlag,(WSCbool)1);


// set timer at the very star of the gui
  newvtim_015 = new  WSCvtimer(newdial_105,"newvtim_015");
  newvtim_015->initialize();
  newvtim_015->setPropertyV(WSNinterval,(unsigned long)500);
  newvtim_015->setPropertyV(WSNcont,(WSCbool)1);
  newvtim_015->setProperty(WSNrunning,True);
  newvtim_015->setPropertyV(WSNname,"newvtim_015");
  WSCprocedure* op_newvtim_015_5 = new WSCprocedure("ep_look2",2);
  extern void ep_look2(WSCbase*);
  op_newvtim_015_5->setFunction(ep_look2,"ep_look2");
  newvtim_015->addProcedure(op_newvtim_015_5);



}
static WSCfunctionRegister  op("ep_checkntuple",(void*)ep_checkntuple);
