// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCmessageDialog.h>
#include <WSCtextField.h>
#include <WSCdialog.h>
#include <WSCstring.h>

// loading initial file
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <WSCmainWindow.h>
#include <WSCvtimer.h>
#include <WSCvbtn.h>
#include <SetIni.h> //


using namespace std;

extern WSCstring NTUPLEname; 
extern WSCmainWindow* newwin000;
extern WSCmessageDialog* newmess_000;
extern WSCvbtn* newvbtn_113;

WSCvtimer* newvtim_014;





//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_look1(WSCbase* object){
  //do something...
static long cnt = 0;
 
   cnt++;
// check file
  if (cnt > 0 )  {
      newvbtn_113->setPropertyV(WSNuserString,"start ntuple viwer");
      newvbtn_113->setPropertyV(WSNlabelString,"start ntuple viwer");
      newvbtn_113->setPropertyV(WSNbackColor,"DEF1");
      newvbtn_113->setPropertyV(WSNtopShadowColor,"DEF3");
      newvbtn_113->setPropertyV(WSNbottomShadowColor,"DEF4");
      newvtim_014->setProperty(WSNrunning,False); 
   }

}










//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_checkview(WSCbase* object){
  //do something...

   extern SetIni inival;

// show window
  newvbtn_113->setPropertyV(WSNuserString,"Loading ROOT .. wait!");
  newvbtn_113->setPropertyV(WSNlabelString,"Loading ROOT .. wait!");
  newvbtn_113->setPropertyV(WSNbackColor,"#c0ffc0");
  newvbtn_113->setPropertyV(WSNtopShadowColor,"#ffffff");
  newvbtn_113->setPropertyV(WSNbottomShadowColor,"#80c080");



// start viwer  
  WSCstring  myv1("$RUNMC/bin/ntupview ");
  WSCstring  myv2=NTUPLEname;
  WSCstring  myv3(" ok &");
  myv1.addString(myv2);
  if (inival.MCtype == -1) myv1.addString( " trunmc" );
  if (inival.MCtype == -2) myv1.addString( " thepevt" );
  myv1.addString(myv3);
  int irun=0;
  irun=system(myv1);
  if (irun != 0) cout << "Error in ntupview" << endl;


// set timer at the very star of the gui
  newvtim_014 = new  WSCvtimer(newwin000,"newvtim_014");
  newvtim_014->initialize();
  newvtim_014->setPropertyV(WSNinterval,(unsigned long)1000);
  newvtim_014->setPropertyV(WSNcont,(WSCbool)0);
  newvtim_014->setProperty(WSNrunning,True);
  newvtim_014->setPropertyV(WSNname,"newvtim_014");
  WSCprocedure* op_newvtim_014_5 = new WSCprocedure("ep_look1",2);
  extern void ep_look1(WSCbase*);
  op_newvtim_014_5->setFunction(ep_look1,"ep_look1");
  newvtim_014->addProcedure(op_newvtim_014_5);




}
static WSCfunctionRegister  op("ep_checkview",(void*)ep_checkview);
