// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCmessageDialog.h> //(B)
#include <WSCstring.h>
#include <WSCmainWindow.h> 
#include <SetHisto.h> // initialization of histograms
#include <WSCsheet.h>
#include <WSCoption.h>
#include <WSCvbtn.h>
#include <WSCdialog.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <fstream>
#include <sys/stat.h>
#include <WSClist.h>
#include <WSCmessageDialog.h>
using namespace std;

 
extern WSClist* newlist_000;
// installation directory
extern char * RUNDIR;
extern char * PXMDIR;
extern int  CheckWIN32;
extern WSCdialog* newdial_220; 
extern WSCsheet* newshee_002;
extern WSCmessageDialog* newmess_002;

extern WSCdialog* newdial_004;
extern WSClist* newlist_000;

extern void ep_update_histo(); // update files

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_clear_histo(WSCbase* object){

   extern SetHisto inihis;

  //do something...
  newmess_002->setPropertyV(WSNwidth,(unsigned short)350);
  newmess_002->setPropertyV(WSNlabelString,"Do you want to clear all histograms?");
  long result = newmess_002->popup();

  if (result == WS_DIALOG_OK){


   char tt[2]=" ";
// set to zero
   for (int i=0; i<=500; i++) {
       inihis.HistoType[i]=0;
       inihis.HistoMax[i]=0.;
       inihis.HistoMin[i]=0.;
       inihis.HistoBins[i]=0;
       inihis.Histo2D[i]=1;
       inihis.HistoWeight[i]=1.;
       inihis.HistoName[i] = new char[strlen(tt)+1]; // empty
       strcpy(inihis.HistoName[i],tt);
       inihis.HistoComm[i] = new char[strlen(tt)+1]; // empty
       strcpy(inihis.HistoComm[i],tt);


      };
   inihis.HistoN=1;

// clear spreadsheet
  newshee_002->setPropertyV(WSNrows,1 );
  newshee_002->setColumnWidth(0, 30);
  newshee_002->setColumnWidth(1, 150);
  newshee_002->setColumnWidth(2, 30);
  newshee_002->setColumnWidth(3, 80);
  newshee_002->setColumnWidth(4, 80);
  newshee_002->setColumnWidth(5, 60);
  newshee_002->setColumnWidth(6, 60);
  newshee_002->setColumnWidth(7, 300);
  newshee_002->setText(1, 1, "Title");
  newshee_002->setText(2, 1, "D");
  newshee_002->setText(3, 1, "Min");
  newshee_002->setText(4, 1, "Max");
  newshee_002->setText(5, 1, "Bins");
  newshee_002->setText(6, 1, "W");
  newshee_002->setText(7, 1, "Comment");
 
  for (int i=1; i<=7; i++) {
   newshee_002->setCellLock(i,1,(WSCbool)1);
   newshee_002->setCellAlignemnt(i,1,WS_CENTER);
   newshee_002->setCellBkColor(i, 1, "DEF1");
  };


  newshee_002->update();
  newshee_002->redraw();





// write into file
   ep_update_histo();

  };


}
static WSCfunctionRegister  op("ep_clear_histo",(void*)ep_clear_histo);
