// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <SysRUNMC.h> // system 

#include <unistd.h>
#include <sys/types.h>
#include <signal.h> // kill comand
// #include <stdio.h>
// #include <stdlib.h>
#include <WSCmessageDialog.h> 
#include <iostream>
using namespace std;
extern WSCmessageDialog* newmess_002;

extern int  CheckWIN32;
extern SysRUNMC analmc; // system files for this run

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_exit(WSCbase* object){
  //do something...


//pop the dialog up.
  //wait until the dialog is done.
  newmess_002->setPropertyV(WSNwidth,(unsigned short)350);
  newmess_002->setPropertyV(WSNlabelString,"Do you want to exit? \n Note: all programs will be terminated");
  long result = newmess_002->popup();  

  if (result == WS_DIALOG_OK){
    // cout <<"OK" << endl; 
    //OK button is pressed.

// clean all jobs left - for linux
      if (CheckWIN32 == 0) {
      for (int i=0; i<100; i++) {
      if ( analmc.allpid[i] > 0 ) {
      pid_t jj = (pid_t) analmc.allpid[i];
      kill( jj, SIGKILL);
      }; };
      }

// clean all jobs left - for CYGWIN 
      if (CheckWIN32 == 1) {
      int irun=0;
      irun=system("pkill analmc.pythia6");
      irun=system("pkill analmc.ariadne");
      irun=system("pkill analmc.lepto");
      irun=system("pkill analmc.herwig");
      irun=system("pkill analmc.aroma");  
      irun=system("pkill analmc.cascade");
      irun=system("pkill analmc.rapgap3");
      irun=system("pkill analmc.lepto-ariadne");
      irun=system("pkill analmc.phojet");
      irun=system("pkill ntupview");
      irun=system("pkill histoview");
      }

      exit(0);


  }else
  if (result == WS_DIALOG_NO){
    //NO button is pressed.
  }else
  if (result == WS_DIALOG_CANCEL){
    //CANCEL button is pressed.
  //   cout <<"CANCEL" << endl;
  }



}
static WSCfunctionRegister  op("ep_exit",(void*)ep_exit);
