// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvtimer.h>
#include <WSCdialog.h>
#include <WSCtextField.h>
#include <WSCpulldownMenu.h>
#include <iostream>
#include <WSCmessageDialog.h>
#include <SetIni.h> // include class containing initializations 

using namespace std;

extern WSCvtimer* newvtim_003;
extern WSCdialog* newdial_003;
extern WSCdialog* newdial_015;
extern WSCpulldownMenu* newpull_003;
extern WSCmessageDialog* newmess_002;
extern WSCmessageDialog* newmess_000;  

extern char * RUNDIR;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------


void ep_help(WSCbase* object){
  //do something...
   extern SetIni inival;

   char  MCnameMan[2]; sprintf(MCnameMan,"%2d", inival.MCtype);
   char * MCname = new char[strlen(MCnameMan)+1];
   strcpy(MCname,MCnameMan);



  long val = newpull_003->getValue();
//   cout << val << endl;
   char starthelp[700]; 

 
  if (val == 1 ) { 

  newvtim_003->setProperty(WSNrunning,True);
  strcpy(starthelp,RUNDIR);
  strncat(starthelp, "/main/runmc/show_paper.sh &", strlen("/main/runmc/show_paper.sh &"));
  int irun1=system( starthelp );
    if (irun1 != 0) {
    newmess_000->setPropertyV(WSNlabelString,"Cannot start help");
    newmess_000->popup(); } 
  newmess_002->setPropertyV(WSNlabelString,"Please wait..  starting acroread"); 
  newmess_002->popup( ); 

  } else if (val == 2 ) {
 
  newvtim_003->setProperty(WSNrunning,True);
  strcpy(starthelp,RUNDIR);
  strncat(starthelp, "/main/runmc/show_manual.sh &", strlen("/main/runmc/show_manual.sh &"));
  int irun1=system( starthelp );
    if (irun1 != 0) {
    newmess_000->setPropertyV(WSNlabelString,"Cannot start help");
    newmess_000->popup(); }
  newmess_002->setPropertyV(WSNlabelString,"Please wait..  starting acroread");
  newmess_002->popup( );


  } else if (val == 3 ) {  

  newvtim_003->setProperty(WSNrunning,True);
  strcpy(starthelp,RUNDIR);
  strncat(starthelp, "/main/runmc/show_manual_mc.sh ", strlen("/main/runmc/show_manual_mc.sh "));
  strncat(starthelp, MCname, strlen(MCname));
  strncat(starthelp, " &", 2);

  int irun1=system( starthelp );
    if (irun1 != 0) {
    newmess_000->setPropertyV(WSNlabelString,"Cannot start MC help");
    newmess_000->popup(); }
  newmess_002->setPropertyV(WSNlabelString,"Please wait..  starting acroread");
  newmess_002->popup( );


 } else if (val == 4 ) { 
    newdial_003->popup();


 } else if (val == 5 ) {
     newdial_015->popup(); 
  } // pop up windows 

}
static WSCfunctionRegister  op("ep_help",(void*)ep_help);
