// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCstring.h>
#include <iostream> 
#include <sys/stat.h>
#include <SetIni.h> // include class containing initializations for M
#include <WSCmessageDialog.h> 

extern WSCmessageDialog* newmess_000;
using namespace std;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_histoview(WSCbase* object){
  //do something...

    extern SetIni inival;

    WSCstring  myv1("$RUNMC/bin/histoview  ");
    WSCstring PROJhisto=inival.MOutput;
    WSCstring myv2=inival.MOutput;

    PROJhisto.addString(".root &");
    myv1.addString(PROJhisto);
    myv2.addString(".root");

    struct stat buf;
    int ic = stat ( (char*)myv2, &buf);

    int ierr=0;
    if (ic != 0) ierr=1; 
    if (ic == 0 && buf.st_size < 100) ierr=1;


     if (ierr == 1) { 
     newmess_000->setPropertyV(WSNlabelString,"Root output file is not found  \n or has some problems");
     newmess_000->popup();
     return ;
     }

    if (ierr == 0) {
      int irun=0;
      irun=system(myv1);
      if (irun != 0) cout << "Error in histoview" << endl;
    }



}
static WSCfunctionRegister  op("ep_histoview",(void*)ep_histoview);
