// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------

#include <iostream>
#include <fstream>
#include <WSCmessageDialog.h>
#include <WSCvtimer.h>
#include <WSCvbtn.h>
#include <WSCvbtn.h>
#include <WSCvlabel.h>
#include <SetIni.h> // include class containing initializations for MC
#include <SysRUNMC.h>
#include <WSCvarc.h>
#include <WSCvline.h>
#include <WSCvmeter.h>
extern WSCvmeter* newvmet_001;

extern WSCvline* newvlin_001;
extern WSCvline* newvlin_002;
extern WSCvline* newvlin_063;
extern WSCvline* newvlin_064;
extern WSCvarc* newvarc_065;


extern WSCvbtn* newvbtn_000;
extern WSCvlabel* newvlab_017;
extern WSCvbtn* newvbtn_030;
extern WSCvtimer* newvtim_000;
extern WSCvlabel* newvlab_024;

extern SysRUNMC analmc; // system files for this run
extern WSCmessageDialog* newmess_002;

using namespace std;

extern WSCmessageDialog* newmess_002;
extern int timecounter;

extern WSCvtimer* newvtim_000;
extern WSCvmeter* newvmet_001;

extern char PipeEvents[500];
extern char PipeStop[500];

//--------------------------------------------------------n
//----------------------------------------------------------
void ep_kill(WSCbase* object){
  //do something...

//pop the dialog up.
  //wait until the dialog is done.
  newmess_002->setPropertyV(WSNcancelString,"No");
  newmess_002->setPropertyV(WSNlabelString,"This will kill all processes \n associated with RunMC. \n Do you want to kill all of them ?");
  long result = newmess_002->popup();

  if (result == WS_DIALOG_OK){

// clean all jobs left - for linux
      int irun=0;
      irun=system("pkill analmc.pythia6");
      if (irun  == 0) cout << "analmc.pythia6 killed" << endl;   
      irun=system("pkill analmc.ariadne");
      if (irun  == 0) cout << "analmc.ariadne killed" << endl;
      irun=system("pkill analmc.lepto");
      if (irun  == 0) cout << "analmc.lepto killed" << endl;
      irun=system("pkill analmc.herwig");
      if (irun  == 0) cout << "analmc.herwig killed" << endl;
      irun=system("pkill analmc.aroma");
      if (irun  == 0) cout << "analmc.aroma killed" << endl;
      irun=system("pkill analmc.cascade");
      if (irun  == 0) cout << "analmc.cascade killed" << endl;
      irun=system("pkill analmc.lepto-ariadne");
      if (irun  == 0) cout << "analmc.lepto-ariadne killed" << endl;
      irun=system("pkill analmc.phojet");
      if (irun  == 0) cout << "analmc.phojet killed" << endl;
      irun=system("pkill analmc.rapgap");
      if (irun  == 0) cout << "analmc.rapgap killed" << endl;
      irun=system("pkill notepad_runmc");
      if (irun  == 0) cout << "notepad_runmc killed" << endl;
      irun=system("pkill ntupview");
      if (irun  == 0) cout << "ntupview  killed" << endl;
      irun=system("pkill histoview");
      if (irun  == 0) cout << "histoview  killed" << endl;

 
   
// change GUI
    extern SetIni inival;
    inival.Stop=1;

    newvlab_017->setProperty(WSNlabelString,"jobs killed");
    newvlab_017->setPropertyV(WSNbackColor,"DEF13");
    newvlab_017->setPropertyV(WSNtopShadowColor,"DEF15");
    newvlab_017->setPropertyV(WSNbottomShadowColor,"DEF16");
    newvbtn_000->setVisible(True); // put back  bottom run
    newvarc_065->setPropertyV(WSNvis,(WSCbool)0); // red dot unvisible
// set default colors for arrows
    newvlin_001->setPropertyV(WSNforeColor,"#505050");
    newvlin_002->setPropertyV(WSNforeColor,"#505050");
    newvlin_064->setPropertyV(WSNforeColor,"#505050");
    newvlin_063->setPropertyV(WSNforeColor,"#505050");

// define Stop
    inival.Stop=0;
    // open system file for monitoring
    ofstream myoutsys(PipeStop, ios::out | ios::trunc);
    myoutsys << "1"; // termintae signal
    myoutsys.close();



// no timer 
    newvtim_000->setProperty(WSNrunning,False);
    timecounter=0; // reset time !
    newvmet_001->setProperty(WSNvalue1,0); // do not show status bar
    newvmet_001->update();


  }else
  if (result == WS_DIALOG_NO){
    //NO button is pressed.
  }else
  if (result == WS_DIALOG_CANCEL){
    //CANCEL button is pressed.
  //   cout <<"CANCEL" << endl;
  }


}
static WSCfunctionRegister  op("ep_kill",(void*)ep_kill);
