// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
// loading initial file 
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>

#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvlabel.h>
extern WSCvlabel* newvlab_017;
extern void ep_updategui();
extern int MCread( char * nn );

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_loadfile(WSCbase* object){
  //do something...
static long cnt = 0;

  cnt++;
  if (cnt == 1) {
  newvlab_017->setProperty(WSNlabelString,"Monte Carlo settings"); 

// read intial settings if exists
   struct stat buf;
   int inifile = stat ( ".runmc.mc", &buf );

   if (inifile == 0) {
    int wrr=MCread( ".runmc.mc"  );
    if (wrr  == 0 ) {
    newvlab_017->setProperty(WSNlabelString,"Project was loaded"); 
    ep_updategui(); // update gui  
    remove(".runmc.mc"); // remove unnecessary link  
    } else {  
    printf ("input file found, but cannot read it!"); };
    };  
    };
 
}
static WSCfunctionRegister  op("ep_loadfile",(void*)ep_loadfile);
