// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
// loading initial file 
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

#include <WSCvmeter.h>
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvlabel.h>
#include <WSCmessageDialog.h>  
#include <WSClist.h>
#include <WSCvtimer.h> 
#include <WSCdialog.h>
#include <WSCtform.h>
using namespace std; 

extern int MCread( char * nn );
extern void ep_updategui();
extern void ep_showcomment();

extern char * RUNDIR;
extern char * PXMDIR;
extern int   CheckWIN32;
extern void titels_to_win32();


extern WSCvtimer* newvtim_001;
extern WSClist* newlist_000;  
extern WSCmessageDialog* newmess_000;
extern WSCmessageDialog* newmess_001;
extern WSCvlabel* newvlab_017;
extern WSCvlabel* newvlab_049;
extern WSCvmeter* newvmet_001;
extern WSCdialog* newdial_005;
extern WSCtform* newtfor_002;
extern WSCvlabel* newvlab_040;
extern WSCvlabel* newvlab_041;
extern WSCvlabel* newvlab_035;
extern WSCdialog* newdial_004;

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_loadrmc(WSCbase* object){
  //do something...
static long cnt = 0;
static long cntfile = 0;
static float vax=0;
static float NumMC=9.0; // number of MC models
static char namef[700];    
static char getprojmc[700];
static int Jcheckmake=0; 


//    cout <<  cnt << endl;
    strcpy(namef,RUNDIR);
    strncat(namef, "/main/tmp/checkmake.tmp", strlen("/main/tmp/checkmake.tmp"));

     cnt++;

// check make file  
//     ifstream myin(namef, ios::in);
//     myin >> cntfile; myin.close();

// check make file
/*
     ifstream myin(namef, ios::in);
    if (!myin) // Always test file open
    {
        cout << "Error opening output file" << endl;
        return;
    }
     myin >> cntfile; myin.close();
*/

     FILE *ls5 = fopen(namef,"r");
     if (ls5  == NULL ){ cout << "Cannot find /main/tmp/checkmake.tmp" << endl; return; }
     int iu=0;
     while ( !feof(ls5) ) { 
     fscanf(ls5,"%d\n", &Jcheckmake); iu++; };
     fclose(ls5);
     cntfile=Jcheckmake;
//     cout << "   cntfile=" << Jcheckmake << endl;


    if ( cntfile < NumMC) {
    newvmet_001->setPropertyV(WSNforeColor,"#ffc000");
    newvmet_001->setPropertyV(WSNhatchColor,"#ffc000");
    vax=100* (float)cntfile/NumMC;
    newvmet_001->setProperty(WSNvalue1,vax);
    };



// all done -- do now 
    if ( cntfile > NumMC-1) { 
        titels_to_win32(); // conver to windows format
        newlist_000 = new  WSClist(newdial_004,"newlist_000");
        newlist_000->initialize();
        newlist_000->setPropertyV(WSNitemHeight,(unsigned char)21);
        newlist_000->setPropertyV(WSNuseIcon,(WSCbool)1);
        newlist_000->setPropertyV(WSNselectForeColor,"#ffffff");
        newlist_000->setPropertyV(WSNtitleString,"");
//      newlist_000->setPropertyV(WSNworkHeight,(unsigned short)5000);
        newlist_000->setPropertyV(WSNhbarVisible,(WSCbool)1);
        newlist_000->setPropertyV(WSNworkBackColor,"#ffffff");
        newlist_000->setPropertyV(WSNname,"newlist_000");
        newlist_000->setPropertyV(WSNuserString,"Select_Variable");
        newlist_000->setPropertyV(WSNx,(short)10);
        newlist_000->setPropertyV(WSNy,(short)8);
        newlist_000->setPropertyV(WSNwidth,(unsigned short)535);
        newlist_000->setPropertyV(WSNheight,(unsigned short)622);
        newlist_000->setPropertyV(WSNvis,(WSCbool)1);
        newlist_000->setPropertyV(WSNanchorTop,(unsigned short)3);
        newlist_000->setPropertyV(WSNanchorBottom,(unsigned short)40);
        newlist_000->setPropertyV(WSNanchorLeft,(unsigned short)3);
        newlist_000->setPropertyV(WSNanchorRight,(unsigned short)3);
        newlist_000->setPropertyV(WSNanchorTopFlag,(WSCbool)1);
        newlist_000->setPropertyV(WSNanchorBottomFlag,(WSCbool)1);
        newlist_000->setPropertyV(WSNanchorLeftFlag,(WSCbool)1);
        newlist_000->setPropertyV(WSNanchorRightFlag,(WSCbool)1);
// use option single click selected
        WSCprocedure* op_newlist_000_5 = new WSCprocedure("ep_Select_histo",35);
        extern void ep_Select_histo(WSCbase*);
        op_newlist_000_5->setFunction(ep_Select_histo,"ep_Select_histo");
        newlist_000->addProcedure(op_newlist_000_5);
// stop timer
   cntfile=0;
   Jcheckmake=0; 
   cnt=0;
   newvtim_001->setProperty(WSNrunning,False); // start timer

    newvlab_017->setProperty(WSNlabelString,"RMC project loaded");
    newvlab_017->setPropertyV(WSNbackColor,"DEF13");
    newvlab_017->setPropertyV(WSNtopShadowColor,"DEF15");
    newvlab_017->setPropertyV(WSNbottomShadowColor,"DEF16");
    newvmet_001->setProperty(WSNvalue1,0); // do not show status bar
    newvmet_001->update();
    newvlab_049->setPropertyV(WSNlabelString,"EVENTS PROCESSED (%)");
    newvlab_049->setPropertyV(WSNforeColor,"#8000ff");

// default meter colors
    newvmet_001->setPropertyV(WSNforeColor,"#0000c0");
    newvmet_001->setPropertyV(WSNhatchColor,"#0000c0");

   strcpy(getprojmc,RUNDIR);
   strncat(getprojmc, "/main/tmp/tmp.mc", strlen("/main/tmp/tmp.mc"));
   int wrr=MCread( getprojmc  );
   if (wrr  == 1 ){
    newmess_000->setPropertyV(WSNlabelString,"cannot read input file!");
    newmess_000->popup();
    };
// errors
    if (wrr == 2 ){
    newmess_000->setPropertyV(WSNlabelString,"error in reading \n input file!");
    newmess_000->popup();
    };
// display all of this on GUI
   ep_updategui();
 
// show message dialog
   ep_showcomment();



  };



}
static WSCfunctionRegister  op("ep_loadrmc",(void*)ep_loadrmc);
