// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCstring.h>
#include <WSCvtimer.h>

// #include <string.h>
// #include <iostream.h>
// #include <fstream.h>

#include <stdio.h>
#include <stdlib.h>
// #include <string.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>


#include <WSCvlabel.h>
#include <WSCdialog.h>
// #include <WSCverbList.h>
#include <WSClist.h>
#include <WSCmessageDialog.h> 

#include <SetIni.h> // include class containing initializations for MC
#include <SetHisto.h> // initialization of histograms
#include <WSCvbtn.h>
#include <time.h> 

extern char * RUNDIR;
using namespace std;


WSCstring PROJlog;
WSCstring PROJerr;
 

// to write the file 
extern int MCwrite(char * nn);
extern void ep_getpipe(); // get pipe name  

extern WSCvtimer* newvtim_000;
extern WSCdialog* newdial_001;
extern WSCvlabel* newvlab_017;

// labels on pop-up dialog 
extern WSCvlabel* newvlab_000;
extern WSCvlabel* newvlab_051;
extern WSCvlabel* newvlab_052;
extern WSCvlabel* newvlab_053;
extern WSCvlabel* newvlab_055;
extern WSCvlabel* newvlab_056;
extern WSCvlabel* newvlab_057;
extern WSCvlabel* newvlab_070;
extern WSCvlabel* newvlab_071;
extern WSCvlabel* newvlab_072;

extern WSCvbtn* newvbtn_000;
extern WSCvbtn* newvbtn_204;
// extern WSCverbList* newverb_000;
extern WSClist* newlist_000;
extern WSCmessageDialog* newmess_000;
extern WSCmessageDialog* newmess_001;

// set labels 
char * PDF[] = {"not set","CTEQ","MRST","GRV"};
char * MC[] = {"not set","PYTHIA","HERWIG","ARIADNE","LEPTO","AROMA","CASCADE","PHOJET","RAPGAP"};
char * NTUPLES[] = {"not set", "Ntuple RUNMC","Ntuple HEPEVT"}; 

char * FS[] = {"not set","for all stable","for partons", " for all", "for stable charged", "for stable+all","for user defined"};
char * JET[] = {"not set","separate particles","hadronic jets"};
char * OPT1[] = {"not set","Show every 2 sec","Show every 5 sec",
                  "Show every 10 sec","Show every 30 sec","Show every 1 min"};
char * OPT2[] = {"not set","Show all plots ","Show 1 plot",
                  "Show 2 plots","Show 4 plots","No Canvas","Only main Canvas"};
char * OPT3[] = {"not set","Show statistics","Do not show statistics"};

char * OPT4[] = {"not set","Color style (lines)","Plane style (lines)",
                  "Plane style (markers)","Color style (markers)","Color style (1)", "Color style (2)"};
char * OPT4D[] = {"not set","2D Lego color","2D Lego plane","2D Surface","2D Color surface","2D Color box style",
                  "2D Color box Z","2D Contour style","2D Arrow mode","2D Box style"};

char * OPT5[] = {"not set","lin","log"};

char * OPT6[] = {"not set","events No","norm to 1", "X-sections (pb)", "X-sections (nb)"};

char * MFrame[] = {"not set","laboratory frame","HCM frame", "Breit frame (ep)"};


char * Jangle[] = {"not set"," 1. angle"," 2. delta R", " angle QCD emission"};
char * Jrecom[] = {"not set","  1. recombination E"," 2. recombination Pt", "  3. recombination Pt2", " 4. recombination Et"," 5. recombination Et2"};
char * JNfixed[] = {"not set","not set","2 jets","3 jets","4 jets","5 jets","6 jets","7 jets","8 jets","9 jets","10 jets"};

char PipeEvents[500];
char PipeStop[500]; 

extern char * getname( int ii );


//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_run(WSCbase* object){

    extern SetIni inival;
    extern SetHisto inihis;


// reove histogram viewer bottom
     newvbtn_204->setPropertyV(WSNvis,(WSCbool)0);



//  put info on current file name
       WSCstring  maindir=RUNDIR; 
       WSCstring  mainproj=maindir+"/main/tmp/project.tmp";
       ofstream myproject(mainproj, ios::out);
       myproject << inival.MOutput;
       myproject.close();

// steering card name
    char  steer[401];
    struct stat buf1;
    struct stat buf2; 
    struct stat buf3;
    struct stat buf4;
    struct stat buf5;
    struct stat buf6;
    struct stat buf7;
    struct stat buf8;
    struct stat buf9;
    struct stat buf10;
    int iccfm = stat ( "ccfm.dat", &buf1 );

    int iuser_cascade=-99; iuser_cascade = stat ( "cascade.cards", &buf2 ); 
    int iuser_pythia=-99;  iuser_pythia  = stat ( "pythia6.cards", &buf3 ); 
    int iuser_herwig=-99;  iuser_herwig  = stat ( "herwig6.cards", &buf4 ); 
    int iuser_ariadne=-99; iuser_ariadne = stat ( "ariadne.cards", &buf5 );  
    int iuser_lepto=-99;   iuser_lepto   = stat ( "lepto65.cards", &buf6 ); 
    int iuser_arlepto=-99; iuser_arlepto = stat ( "arlepto.cards", &buf7 ); 
    int iuser_aroma=-99;   iuser_aroma   = stat ( "aroma22.cards", &buf8 ); 
    int iuser_phojet=-99;  iuser_phojet   = stat ( "phojet.cards", &buf9 ); 
    int iuser_rapgap=-99;  iuser_rapgap   = stat ( "rapgap3.cards", &buf10 );

//  cout << inival.MOutput << endl;

// for settings
  char   foutfile[50];
  strncpy(foutfile,"", 50);
  strncat(foutfile, inival.MOutput, strlen(inival.MOutput));
  strncat(foutfile, ".mc", 3 );


// fix particle IP for deafult settings
   if (inival.IDparticle1 == 1) inival.IDparticle1=11;
   if (inival.IDparticle2 == 1) inival.IDparticle2=-11; 


// write the file
  int wrr=MCwrite( foutfile  );
  if (wrr != 0) {
    newmess_000->setPropertyV(WSNlabelString,"Cannot write initialization file!");
   newmess_000->popup(); }

// get pipe files --------------------------------------------------------- 
    strcpy(PipeEvents,RUNDIR);
    strcpy(PipeStop,RUNDIR);
//  cout << outpupipes << endl;
    strncat(PipeEvents, "/pipes/", strlen("/pipes/"));
    strncat(PipeEvents, inival.PipeName, strlen(inival.PipeName) );
    strncat(PipeEvents, ".event", strlen(".event") );
    strncat(PipeStop, "/pipes/", strlen("/pipes/"));
    strncat(PipeStop, inival.PipeName, strlen(inival.PipeName) );
    strncat(PipeStop, ".stop", strlen(".stop") );
// define Stop
    inival.Stop=0;
    ofstream myoutsys(PipeStop, ios::out | ios::trunc);
    myoutsys << "0";
    myoutsys.close();
//---------------------------------------------------------------------------------



// make link for analmc programs
// for final settings
  remove(".analmc.ln");
  char   foutlink[80];
  strncpy(foutlink,"", 79);
  strncat(foutlink, "ln -s ", 6);
  strncat(foutlink, foutfile,  strlen(foutfile));
  strncat(foutlink, " .analmc.ln", 11);
  int irun1=system( foutlink );
//  cout << foutlink << endl;
  if (irun1 != 0) {
  newmess_000->setPropertyV(WSNlabelString,"Cannot link .analmc.ln file!");
  newmess_000->popup(); }



// --------------- close initialization file ----------------------------------


// mark DIS events
    int DIS=0; // =1 for DIS events
    if ( inival.Q2min > 1.) {
    if ( abs(inival.IDparticle1) < 17 && abs(inival.IDparticle2) > 2000 )  DIS=1;
    if ( abs(inival.IDparticle2) < 17 && abs(inival.IDparticle1) > 2000 )  DIS=1; }

 
// mark pp  events
    int PP=0; // =1 for pp events
    if ( abs(inival.IDparticle1) >2000 && abs(inival.IDparticle2) > 2000 )  PP=1;

// mark E+E-  events
    int EE=0; // =1 for pp events
    if ( abs(inival.IDparticle1) < 17 && abs(inival.IDparticle2) < 17  )  EE=1;

// mark gamma-gamma 
    int GG=0; // =1 for pp events
    if ( abs(inival.IDparticle1) == 22 && abs(inival.IDparticle2) == 22  )  GG=1;



// check settings
   int ierr=0;  char * ierr_mess = "settings look OK";   
   if (inival.Nevents < 1) { ierr=1; ierr_mess = "wrong number of events"; }; 
   if (inival.Energy1 < 1) { ierr=1; ierr_mess = "wrong energy of particle 1"; }; 
   if (inival.Energy2 < 1) { ierr=1; ierr_mess = "wrong energy of particle 2"; };
   if (inival.Q2max  <= inival.Q2min) { ierr=1; ierr_mess = "Q2min larger than Q2max "; };
   if (inival.Xmax  <= inival.Xmin) { ierr=1; ierr_mess = "Xmin larger than Xmax "; };
   if (inival.Ymax  <= inival.Ymin) { ierr=1; ierr_mess = "Ymin larger than Xmax "; }; 
   if (inival.Wmax  <= inival.Wmin) { ierr=1; ierr_mess = "Wmin larger than Wmax "; };
   if (inival.Xmax  >  1) { ierr=1; ierr_mess = "Xmax is larger than 1"; };
   if (inival.Xmin  >  1) { ierr=1; ierr_mess = "Xmin is larger than 1"; };
   if (inival.Xmin*inival.Xmax  <  0) { ierr=1; ierr_mess = "Xmin or Xmax is negative"; };
   if (inival.Ymax  >  1) { ierr=1; ierr_mess = "Ymax is larger than 1"; };
   if (inival.Ymin  >  1) { ierr=1; ierr_mess = "Ymin is larger than 1"; };
   if (inival.Ymin*inival.Ymax  <  0) { ierr=1; ierr_mess = "Ymin or Ymax is negative"; };
   if (inival.Q2max*inival.Q2min  <  0) { ierr=1; ierr_mess = "Q2min or Q2max is negative"; };
   if (inival.ETmin < 0) { ierr=1; ierr_mess = "ET min is negative"; };

//   cout << inival.PDFparticle1 << " " << inival.PDFparticle2 << " " << PP << endl;  
//   cout << inival.IDparticle1 << endl;

   if (PP == 1 && (inival.PDFparticle1 != inival.PDFparticle2) ) {
   ierr=1; ierr_mess = "PDFs should be the same! "; };

   if (inival.ETAmax  <= inival.ETAmin) { ierr=1; ierr_mess = "ETAmin larger than ETAmax "; };
   if (inival.Frame == 3 && DIS != 1) {
   ierr=1; ierr_mess = "The Breit frame is not defined \n for this process"; }; 
   if (inival.Frame == 2 && abs(inival.IDparticle1) < 20 && abs(inival.IDparticle2) < 20 ) {
   ierr=1; ierr_mess = "The HCM has no sense \n for e+e- process"; };
   if (inival.Frame == 2 && abs(inival.IDparticle1) > 2000 && abs(inival.IDparticle2) > 2000 ) {
   ierr=1; ierr_mess = "HCM is not implemented yet for \n hadron-hadron collisions"; };



   if (abs(inival.IDparticle1) < 20 && abs(inival.IDparticle2) < 20 &&
       inival.IDparticle1*inival.IDparticle2 > 0 ) {
       ierr=1; ierr_mess = "wrong definition of \n initial particles"; };

// error for PYTHIA
   if (inival.MCtype == 1 && DIS == 1) {
       ierr=1; ierr_mess = "Looks like DIS, \n better use \n LEPTO, ARIADNE, HERWIG"; }; 
   



// message for PYTHIA
    if (inival.MCtype == 1) {
       if ( iuser_pythia  == 0) {
       newmess_001->setPropertyV(WSNlabelString,"read user \"pythia6.cards\" file from the current directory \n  default parameters will be modified");
       } else {
       newmess_001->setPropertyV(WSNlabelString," No \"pythia6.cards\" found  \n default PYTHIA parameters will be used"); 
       }
    } else if (inival.MCtype == 2) {  
        if ( iuser_herwig  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"herwig6.cards\" file from the current directory \n  default parameters will be modified");
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"herwig6.cards\" found  \n default HERWIG parameters will be used");
        }
    } else if (inival.MCtype == 6) {
        if ( iuser_cascade  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"cascade.cards\" file from the current directory \n  default parameters will be modified");  
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"cascade.cards\" found  \n default HERWIG parameters will be used");
        }
    } else if (inival.MCtype == 8) {
        if ( iuser_rapgap  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"rapgap3.cards\" file from the current directory \n  default parameters will be modified"); 
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"rapgap3.cards\" found  \n default HERWIG parameters will be used");
        }
    } else if (inival.MCtype == 3 && DIS == 0) {
        if ( iuser_ariadne  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"ariadne.cards\" file from the current directory \n  default parameters will be modified");
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"ariadne.cards\" found  \n default ARIADNE parameters will be used");
         }
    } else if (inival.MCtype == 3 && DIS == 1) {
        if ( iuser_arlepto  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"arlepto.cards\" file from the current directory \n  default parameters will be modified");
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"arlepto.cards\" found  \n default ARIADNE/LEPTO parameters will be used");
         }
    } else if (inival.MCtype == 4) {
        if ( iuser_lepto  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"lepto65.cards\" file from the current directory \n  default parameters will be modified");
         } else {
         newmess_001->setPropertyV(WSNlabelString," No \"lepto65.cards\" found  \n default LEPTO parameters will be used");
         }
    }  else if (inival.MCtype == 5) {                                      
        if ( iuser_aroma  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"aroma22.cards\" file from the current directory \n  default parameters will be modified");
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"aroma22.cards\" found  \n default AROMA parameters will be used");
        }  
    } else if (inival.MCtype == 7) {
        if ( iuser_phojet  == 0) {
        newmess_001->setPropertyV(WSNlabelString,"read user \"phojet.cards\" file from the current directory \n  default parameters will be modified");
        } else {
        newmess_001->setPropertyV(WSNlabelString," No \"phojet.cards\" found  \n default PHOJET parameters will be used");
        }
    }  


    if (inival.MCtype == -1) {newmess_001->setPropertyV(WSNlabelString,"Analyse RUNMC  NTUPLE");}
    if (inival.MCtype == -2) {newmess_001->setPropertyV(WSNlabelString,"Analyse HEPEVT NTUPLE");}
 
    if (inival.MCtype < 6)  newmess_001->popup( );



// Run CASCADE  for ep and pp ------------------------------------------------
    if  ( inival.MCtype == 6) {
// check for  unintegrated gluon density 
     if ( iccfm  != 0 ) {
      cout << "Error! ------------------------" << endl; 
      cout << "Cannot find ccfm.dat input file with unintegrated PDF!" << endl;
      cout << "go to CASCADE web page (author Hannes Jung)" << endl;
      cout << "and link ccfm.dat or copy this file to this directory" << endl;
      cout << "Look at: www.quark.lu.se/~hannes/cascade " << endl;
      ierr=1;
      ierr_mess ="Copy ccfm.dat file with \n unintegrated densities file \n to your current directory";
      };       

// find out which steering card to use
    char * steer_pp="/main/mcarlo/cascade-12/steer/steer_pp";
    char * steer_ee="/main/mcarlo/cascade-12/steer/steer_ee";
    char * steer_ep="/main/mcarlo/cascade-12/steer/steer_ep";
    char * steer_gg="/main/mcarlo/cascade-12/steer/steer_gamgam";
// message  
    char * msteer_pp="$RUNMC/main/mcarlo/cascade-12/steer/steer_pp";
    char * msteer_ee="$RUNMC/main/mcarlo/cascade-12/steer/steer_ee";
    char * msteer_ep="$RUNMC/main/mcarlo/cascade-12/steer/steer_ep";
    char * msteer_gg="$RUNMC/main/mcarlo/cascade-12/steer/steer_gamgam";

     WSCstring str0("Use ");
     WSCstring str1;
     WSCstring str2("\n this is not safe - better use \"cascade.cards\" steering card \n  in your current directory",WS_EN_ISO8859_1);

    strncpy(steer, "", 400);
    strncpy(steer, RUNDIR,  strlen(RUNDIR));
    if (PP  == 1)        { 
    strncat(steer, steer_pp,  strlen(steer_pp));
    str1=msteer_pp;

    } else if (DIS == 1) { 
    strncat(steer, steer_ep,  strlen(steer_ep));
    str1=msteer_ep;

    } else if (EE  == 1) { 
     strncat(steer, steer_ee,  strlen(steer_ee));
     str1=msteer_ee;

    } else if (GG  == 1) { 
    strncat(steer, steer_gg,  strlen(steer_gg));
    str1=msteer_gg;
    } else { 

    str1=msteer_ep;  
    strncat(steer, steer_ep,  strlen(steer_ep)); } // default

    cout << " read file: " << steer << endl;
    cout << "    if you do not want run over this steering card" << endl;
    cout << "    put cascade.cards file to this directory" << endl;
    cout << "    unintegrated PDF is taken from ccfm.dat file (current directory)"; 
    cout << " WAIT - CASCADE intitialising : " << endl;

    if ( iuser_cascade  == 0) {  
    newmess_001->setPropertyV(WSNlabelString,"read user \"cascade.cards\" file from the current directory \n all event settings from RUNMC GUI are disable");
    } else { 
    str0 << str1; // combine 
    str0 << str2;
    newmess_001->setPropertyV(WSNlabelString,(char*)str0);
    cout << str1 << endl;
    }

    newmess_001->popup();

    }; 

    
 
// errors for LEPTO 
   if (inival.MCtype == 4 || inival.MCtype == 5 ) {
    if(abs(inival.IDparticle1) < 20 && abs(inival.IDparticle2) < 20) {
      ierr=1; ierr_mess = "can be initialized for \n DIS mode only (e+p,e-p,mu+p, etc)"; } 
    if(abs(inival.IDparticle1) > 20 && abs(inival.IDparticle2) > 20) {
     ierr=1; ierr_mess = "can be initialized for \n DIS mode only (e+p,e-p,mu+p, etc)"; }
    };


// check histograms
    for  (int i=1; i<=inihis.HistoN; i++ ) {
    if (inihis.HistoType[i]  > 0 ) {
    if (inihis.HistoMax[i] <=inihis.HistoMin[i]) { ierr=1; ierr_mess = "Histogram MIN value is \n larger than MAX value"; };
    if (inihis.HistoBins[i]<=0) { ierr=1; ierr_mess = "Number of bins is wrong !"; };
    }; };

// check histograms 
// first 2
    if (inihis.Histo2D[1] == 2 && inihis.Histo2D[2] == 2) {
    for  (int i=1; i<=2; i++ ) {
    if  (inihis.HistoMin[i] == 0 && inihis.HistoMax[i] == 0 && inihis.HistoBins[i] == 0) {
         ierr=1; ierr_mess = "Error in 2D histogram definition (No 1)"; }; }; };  
// second  2
    if (inihis.Histo2D[3] == 2 && inihis.Histo2D[4] == 2) {
    for  (int i=3; i<=4; i++ ) {
    if  (inihis.HistoMin[i] == 0 && inihis.HistoMax[i] == 0 && inihis.HistoBins[i] == 0) {
         ierr=1; ierr_mess = "Error in 2D histogram definition (No 2)"; }; }; };
// third  2
    if (inihis.Histo2D[5] == 2 && inihis.Histo2D[6] == 2) {
    for  (int i=5; i<=6; i++ ) {
    if  (inihis.HistoMin[i] == 0 && inihis.HistoMax[i] == 0 && inihis.HistoBins[i] == 0) {
         ierr=1; ierr_mess = "Error in 2D histogram definition (No 3)"; }; }; };
// forth  2
    if (inihis.Histo2D[7] == 2 && inihis.Histo2D[8] == 2) {
    for  (int i=7; i<=8; i++ ) {
    if  (inihis.HistoMin[i] == 0 && inihis.HistoMax[i] == 0 && inihis.HistoBins[i] == 0) {
         ierr=1; ierr_mess = "Error in 2D histogram definition (No 4)"; }; }; };



// _051 - first label
// _052 - second
// _053 - 3rd ..  

   if ( ierr == 1 ) { 
// set color red
   newvlab_000->setPropertyV(WSNlabelString, "" );
   newvlab_051->setPropertyV(WSNbackColor,"#c00000");
   newvlab_051->setPropertyV(WSNtopShadowColor,"#ff4040");
   newvlab_051->setPropertyV(WSNbottomShadowColor,"#800000");
   newvlab_051->setPropertyV(WSNlabelString, "Error!" );
   newvlab_052->setPropertyV(WSNlabelString,"press OK and correct settings");
   newvlab_056->setPropertyV(WSNlabelString, ierr_mess );
   newvlab_053->setPropertyV(WSNlabelString, "");
   newvlab_055->setPropertyV(WSNlabelString, "");
   newvlab_057->setPropertyV(WSNlabelString, ""); 
   }else { 

// set light green when it's OK
    newvlab_051->setPropertyV(WSNbackColor,"#80c0c0");
    newvlab_051->setPropertyV(WSNtopShadowColor,"#c0ffff");
    newvlab_051->setPropertyV(WSNbottomShadowColor,"#408080");

    newvlab_051->setPropertyV(WSNlabelString, MC[inival.MCtype] );
    if (inival.MCtype == -1) newvlab_051->setPropertyV(WSNlabelString, "RUNMC Ntuple");
    if (inival.MCtype == -2) newvlab_051->setPropertyV(WSNlabelString, "HEPEVT Ntuple");
 


    char   collision[31];
    strncpy(collision, " ", 30); 

    char * name1=getname(inival.IDparticle1);
    char * name2=getname(inival.IDparticle2);

    strncat(collision, name1, strlen( name1 ));
    char  szENE1[6],szENE2[6]; 
    sprintf(szENE1,"%6.2f", inival.Energy1 );
    sprintf(szENE2,"%6.2f", inival.Energy2 );
    strncat(collision, "(", 1 );
    strncat(collision, szENE1, strlen(szENE1) );
    strncat(collision, " GeV)", 5 );
    strncat(collision, "  ", 2);
    strncat(collision, name2, strlen(name2) ); 
    strncat(collision, "(", 1 );
    strncat(collision, szENE2, strlen(szENE2) );
    strncat(collision, " GeV)", 5 );
    if (inival.MCtype > 0) newvlab_052->setPropertyV(WSNlabelString, collision  );




 
    char   szPDF1[12], szPDF2[12]; 
    strncpy(szPDF1, "PDF: ", 12);
    strncpy(szPDF1, PDF[inival.PDFparticle1], strlen(PDF[inival.PDFparticle1]));
    if (inival.MCtype > 0) {
    newvlab_053->setPropertyV(WSNlabelString, szPDF1 );
    newvlab_052->setPropertyV(WSNlabelString,"Colliding particles");  }

    if (inival.MCtype < 0) {
    newvlab_053->setPropertyV(WSNlabelString, " ");
    newvlab_052->setPropertyV(WSNlabelString,"analyse ROOT ntuple(s)"); }
     
    strncpy(szPDF2, "PDF: ", 12);
    strncpy(szPDF2, PDF[inival.PDFparticle2], strlen(PDF[inival.PDFparticle2]));
    if (inival.MCtype > 0) newvlab_000->setPropertyV(WSNlabelString, szPDF2 );
    if (inival.MCtype < 0) newvlab_000->setPropertyV(WSNlabelString, " ");

    if (inival.MCtype > 0) { 
    if (abs(inival.IDparticle1) < 23 ) {
        if (inival.MCtype > 0) newvlab_053->setPropertyV(WSNlabelString, "default PDF" ); }; 
    if (abs(inival.IDparticle2) < 23 ) {
        if (inival.MCtype > 0) newvlab_000->setPropertyV(WSNlabelString, "default PDF" ); }; 
    }
 
 
    char collision1[31]; 
    strncpy(collision1, " ", 30);
    strncat(collision1, "for", 3);
    strncat(collision1, "  ", 3);
    strncat(collision1, FS[inival.FStype], strlen((FS[inival.FStype])));
    newvlab_055->setPropertyV(WSNlabelString, collision1);

    char   collision2[31], szEV[7]; 
    strncpy(collision2, " ", 30);
//    strncpy(collision2, "No events:", 10);
    sprintf(szEV,"%7d", inival.Nevents ); 
    strncat(collision2, szEV, strlen(szEV));
    strncat(collision2, " events ", 8);


// calculate number of histograms
    int N2D=0; int N1D=0; int NHtot=0; 
    for  (int i=1; i<=inihis.HistoN; i++ ) {
    if (inihis.HistoType[i]  > 0 ) {
    if (inihis.Histo2D[i] == 2) N2D++;
    if (inihis.Histo2D[i] == 1) N1D++; 
    }; };
    NHtot=N1D+ (N2D/2);

    sprintf(szEV,"%7d", NHtot );
    strncat(collision2, szEV, strlen(szEV));
    strncat(collision2, " histograms", 11);  
    newvlab_056->setPropertyV(WSNlabelString,  collision2);

    char   collision3[31]; 
    strncpy(collision3, " ", 30);
    strncat(collision3, "reconstruct ", 12);
    strncat(collision3, JET[inival.JetType], strlen(JET[inival.JetType]) );
    newvlab_057->setPropertyV(WSNlabelString,  collision3);


// show output modes
    if (inihis.HistoOptions[9] ==1 ) { 
    newvlab_070->setPropertyV(WSNlabelString, "Output: histogram file" ); 
    newvlab_070->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_070->setPropertyV(WSNforeColor,"#000080");
    newvlab_070->update(); 
    } 
    if (inihis.HistoOptions[10] ==1 ) {
    newvlab_071->setPropertyV(WSNlabelString, "Output: HEPEVT file (can be big!)" );
    newvlab_071->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_071->setPropertyV(WSNforeColor,"#000080");
    newvlab_071->update();
    }
    if (inihis.HistoOptions[11] ==1 ) {
    newvlab_072->setPropertyV(WSNlabelString, "Output: RUNMC file (can be big!)" );
    newvlab_072->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_072->setPropertyV(WSNforeColor,"#000080");
    newvlab_072->update();
    }


    if (inihis.HistoOptions[9] ==0 ) {
    newvlab_070->setPropertyV(WSNlabelString, "" );
    newvlab_070->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_070->setPropertyV(WSNforeColor,"#000080");
    newvlab_070->update();
    }
    if (inihis.HistoOptions[10] ==0 ) {
    newvlab_071->setPropertyV(WSNlabelString, "" );
    newvlab_071->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_071->setPropertyV(WSNforeColor,"#000080");
    newvlab_071->update();
    }
    if (inihis.HistoOptions[11] ==0 ) {
    newvlab_072->setPropertyV(WSNlabelString, "" );
    newvlab_072->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_072->setPropertyV(WSNforeColor,"#000080");
    newvlab_072->update();
    }




    }; // end OK status  
    



  long val = newdial_001->popup();
  if (val == WS_DIALOG_OK && ierr == 0 ){




// put zero to pipe. this traets meter correctly, otherwise some
// chaotic numbers at the beginning 
    int nxn=0; 
    ofstream myoutp(PipeEvents, ios::out | ios::trunc);
    if (!myoutp)  {
    newmess_000->setPropertyV(WSNlabelString,"Cannot write pipes to $RUNMC/pipes !");
    newmess_000->popup(); }
    myoutp << nxn << " " << nxn << endl;
    myoutp.close();


//  cout << " OK= " << PDF[2] << endl;
    newvlab_017->setProperty(WSNlabelString,"Running...");
    newvlab_017->setPropertyV(WSNbackColor,"#80c0c0");
    newvlab_017->setPropertyV(WSNtopShadowColor,"#c0ffff");
    newvlab_017->setPropertyV(WSNbottomShadowColor,"#408080");
    newvbtn_000->setVisible(False); // remove bottom run 


// remove log file
    PROJlog=inival.MOutput;
    PROJlog.addString(".log"); 
    remove((char*)PROJlog);

// remove error file
    PROJerr=inival.MOutput;
    PROJerr.addString(".err");
    remove((char*)PROJerr);


    int crossCheck=0; 
    int irun=0; 
// Run PYTHIA6 ------------------------------------------------------------
    if  (inival.MCtype == 1)  {
    WSCstring RUNCOM("analmc.pythia6");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start PYTHIA6 !");
       newmess_000->popup(); }else { crossCheck=1;}  }  

// Run HERWIG ------------------------------------------------------------
    else if (inival.MCtype == 2)  {
    WSCstring RUNCOM("analmc.herwig");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start HERWIG !");
       newmess_000->popup(); }else { crossCheck=1; } } 


// Run ARIADNE (not for DIS) -------------------------------------------
    else if (inival.MCtype == 3 && DIS != 1 )  {
    WSCstring RUNCOM("analmc.ariadne");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start ARIADNE !");
       newmess_000->popup(); }else { crossCheck=1; } }

// Run LEPTO ---------------------------------------------------------
    else if  (inival.MCtype == 4 && DIS == 1 )  {  
    WSCstring RUNCOM("analmc.lepto");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start LEPTO !");
       newmess_000->popup(); }else { crossCheck=1;} }  

// Run AROMA ---------------------------------------------------------
    else if  (inival.MCtype == 5 && DIS == 1 )  {
    WSCstring RUNCOM("analmc.aroma");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start AROMA !");
       newmess_000->popup(); }else { crossCheck=1;} }
// Run PHOJET ---------------------------------------------------------
    else if  (inival.MCtype == 7  )  {
    WSCstring RUNCOM("analmc.phojet");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start PHOJET !");
       newmess_000->popup(); }else { crossCheck=1;} }

// Run CASCADE  for ep and pp ------------------------------------------------
    else if  ( inival.MCtype == 6 && iccfm == 0 ) { 
    WSCstring RUNCOM("analmc.cascade");
// default 
    if (iuser_cascade == 0 ) {
    inival.Steering=1; // use personal steering card: GUI do not ovewrite this  
    }  else {  
    inival.Steering=0; 
    };
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
     irun=system( (char*)RUNCOM  );
     if (irun != 0) {
     newmess_000->setPropertyV(WSNlabelString,"Cannot start CASCADE !");
     newmess_000->popup(); }else { crossCheck=1;} }

    else if  (inival.MCtype == 8  )  {
    WSCstring RUNCOM("analmc.rapgap3");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start RAPGAP !");
       newmess_000->popup(); }else { crossCheck=1;} }
// Run LEPTO with ARIADNE (for DIS mode) ---------------------------------- 
    else if  (inival.MCtype == 3 && DIS == 1 ) { 
    WSCstring RUNCOM("analmc.lepto-ariadne");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start LEPTO-ARIADNE !");
       newmess_000->popup(); }else { crossCheck=1;}  }  

// Run over ntuples  ----------------------------------
    else if  (inival.MCtype == -1 || inival.MCtype == -2 ) {

// check ntuple file
      struct stat buf2;
      int irun = stat ( ".analmc.tup", &buf2 );
      if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot find .analmc.tup !");
       newmess_000->popup(); return; }

    WSCstring RUNCOM("analmc.pythia6");
    RUNCOM.addString(" 1> ");
    RUNCOM.addString(PROJlog);
    RUNCOM.addString(" 2> ");
    RUNCOM.addString(PROJerr);
    RUNCOM.addString(" &");
       irun=system( (char*)RUNCOM  );
       if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot start Ntuple analysis !");
       newmess_000->popup(); }else { crossCheck=1;}  }
    else { 
       newmess_000->setPropertyV(WSNlabelString,"No valid Monte Carlo type!");
        newmess_000->popup(); } 



// now, make a link to log file
  remove(".analmc.log");
  WSCstring MAKELINK("ln -s ");
  MAKELINK.addString(PROJlog);
  MAKELINK.addString(" .analmc.log");
//  cout << loglink << endl; 
  irun=system( (char*)MAKELINK );
      if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot make link to .analmc.log file !");
       newmess_000->popup(); }

/*
  remove(".analmc.err");
  WSCstring MAKELINKER("ln -s ");
  MAKELINKER.addString(PROJerr);
  MAKELINKER.addString(" .analmc.err");
//  cout << loglink << endl;
  irun=system( (char*)MAKELINKER );
      if (irun != 0) {
       newmess_000->setPropertyV(WSNlabelString,"Cannot make link to .analmc.err file !");
       newmess_000->popup(); }
*/
//

// tern on timer to check status 
   if ( crossCheck==1 )   { 
       if ((WSCbool)newvtim_000->getProperty(WSNrunning) == 0){
       newvtim_000->setProperty(WSNrunning,True);
       }else{
        newvtim_000->setProperty(WSNrunning,False);
       }   
    }else{ 
       newmess_000->setPropertyV(WSNlabelString,"This configuratin \n is not implemented !");
       newmess_000->popup(); 
    }; 

  }; 
  



//   else
//  if (val == WS_DIALOG_NO){
//     newvlab_007->setProperty(WSNlabelString,"DIALOG NO!");
//  }else
//  if (val == WS_DIALOG_CANCEL){
//     newvlab_007->setProperty(WSNlabelString,"DIALOG CANCEL!");
//  }






}
static WSCfunctionRegister  op("ep_run",(void*)ep_run);
