// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCvtimer.h>

#include <WSCfileSelect.h>
#include <WSCmessageDialog.h> //(B)
#include <WSCvifield.h>
#include <WSCstring.h>

#include <SetIni.h> // include class containing initializations for M
#include <SetHisto.h> // initialization of histograms

#include <WSCoption.h>
#include <WSCvbtn.h>
#include <WSCvifield.h>
#include <WSCcomboBox.h>
#include <WSCvslider.h>
#include <WSCradioGroup.h>
#include <WSCvradio.h>

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <fstream>
#include <sys/stat.h>
using namespace std;


extern int MCread( char * nn );
extern void ep_updategui();
extern void ep_showcomment();

extern WSCvtimer* newvtim_001;
extern WSCmessageDialog* newmess_000;
extern WSCmessageDialog* newmess_002;
extern WSCvlabel* newvlab_024;
extern WSCvlabel* newvlab_017; 
extern WSCvlabel* newvlab_049;
extern int MCwrite (char * nn);
extern WSCfileSelect* newfile_000;

// external variables 
WSCstring MCnamefile;
WSCstring RMCnamefile;

// installation directory
extern char * RUNDIR;
extern char * PXMDIR;
extern int  CheckWIN32;

 

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_settings(WSCbase* object){


  //do something...
   extern SetIni inival;

//   char * RUNDIR;
//   RUNDIR=getenv("RUNMC");
   char   putproj[700];
   char   getproj[700];
   char   rmcdir[700];
   char   mcdir[700];
   
  //Access to the global instance of the WSCmessageDialog class.
  WSCmessageDialog* msg = WSGIappMessageDialog(); //(G)
  msg->setProperty(WSNwidth,500);                 //(H)
  msg->setProperty(WSNheight,120);                //(I)
  msg->setProperty(WSNdefaultPosition,True);      //(J)

// get property:  
  long  val = object->getProperty(WSNvalue);


//   cout << val << endl;
 

// 1 - do not do anything
// do not do anything for option "settings" 
  if ( val == 1) { return; }

// read MC file
  if ( val == 2) {

// set mask 
  newfile_000->setProperty(WSNmaskFileName,"mc");  
  if (CheckWIN32 == 0) strcpy(mcdir,RUNDIR);
  if (CheckWIN32 == 1) strcpy(mcdir,PXMDIR);
  strncat(mcdir, "/proj", strlen("/proj"));
  newfile_000->setPropertyV(WSNdirName,mcdir);
  
//  fs->setProperty(WSNdefaultPosition,True); 
  long ret = newfile_000->popup();                  

  if (ret == WS_DIALOG_OK){          
// open dialog
    WSCstring  str, str1,str2="...",str3;
//  str << fs->getFileName() << " is selected.";
    str << newfile_000->getFileName(); 
    str1 << str << " is selected."; 
    long word = str1.getChars(); 
    MCnamefile=str;
//    cout << words << endl;
//    cout << str01 << endl;
    if (word>50) str1.deleteChars(0, word-45 );
    str3=str2+str1;
    msg->setProperty(WSNlabelString,str3);
    msg->update();
    long valmesg = msg->popup();
    if  (valmesg == WS_DIALOG_CANCEL) { return;} 
    if  (valmesg == WS_DIALOG_OK) {  

// read file  
   char * ffname =MCnamefile;

//   cout << " My file=" << ffname << endl;

   int wrr=MCread( ffname  );
   if (wrr  == 1 ){
    newmess_000->setPropertyV(WSNlabelString,"cannot read input file!");
    newmess_000->popup();
    };
// errors
    if (wrr == 2 ){
    newmess_000->setPropertyV(WSNlabelString,"error in reading \n input file!");
    newmess_000->popup();
    };

// display all of this on GUI 
    ep_updategui();

	  }else if (ret == WS_DIALOG_NO){     //(L)
    msg->setProperty(WSNlabelString,"Nothing is selected.");
    msg->popup();
  }else if (ret == WS_DIALOG_CANCEL){
    msg->setProperty(WSNlabelString,"The selection is canceled.");
    msg->popup();                     //(M)
  }; 

  } // end of OK dialog 
  } // end read of the file  






// write MC the settings   
  if ( val == 3) {
// open dialog
  msg->setProperty(WSNlabelString,"save the project?");
  msg->update();
  long valmes = msg->popup();

  if  (valmes == WS_DIALOG_CANCEL) { return;} 

  if  (valmes == WS_DIALOG_OK)  { 
// for settings
  char   foutfile[50];
  strncpy(foutfile,"", 50);
  strncat(foutfile, inival.MOutput, strlen(inival.MOutput));
  strncat(foutfile, ".mc", 3 );

// fix particle IP for deafult settings
   if (inival.IDparticle1 == 1) inival.IDparticle1=11;
   if (inival.IDparticle2 == 1) inival.IDparticle2=-11;

// write the file
  int wrr=MCwrite( foutfile  );
  if (wrr != 0) {
   newmess_000->setPropertyV(WSNlabelString,"Cannot write initialization file!");
   newmess_000->popup(); }

// show number of events
   newvlab_024->setProperty(WSNlabelString,"settings saved");

   } // end of massage dialog 
   } // end of write 






// read RMC file
  if ( val == 4) {

//Access to the global instance of the WSCfileSelect class.
  newfile_000->setPropertyV(WSNwidth,(unsigned short)500);
  newfile_000->setPropertyV(WSNheight,(unsigned short)400);
  newfile_000->setPropertyV(WSNlabelPixmap,"$(RUNMC)/main/sys/bi13.xpm");
  newfile_000->setPropertyV(WSNtitleString,"Select RunMC input file");
  if (CheckWIN32 == 0) strcpy(rmcdir,RUNDIR);
  if (CheckWIN32 == 1) strcpy(rmcdir,PXMDIR);
  strncat(rmcdir, "/archive", strlen("/archive"));
  newfile_000->setPropertyV(WSNdirName,rmcdir);
// set mask 
  newfile_000->setProperty(WSNmaskFileName,"rmc");  

  long ret =  newfile_000->popup();                  
  if (ret == WS_DIALOG_OK){           

// open dialog
    WSCstring  str0, str01, str02="...", str03;
    str0 << newfile_000->getFileName(); 
    str01 << str0 << " is selected"; 
    long words = str01.getChars(); 
    RMCnamefile = str0;

//    cout << words << endl;
//    cout << str01 << endl;
    if (words>50) str01.deleteChars(0,words-45);
    str03=str02+str01; 
    msg->setProperty(WSNlabelString,str03);
    msg->update();
    long valmesg = msg->popup();
    if  (valmesg == WS_DIALOG_CANCEL) { return;} 
    if  (valmesg == WS_DIALOG_OK) {  

    char * ffname1 =RMCnamefile;
    strcpy(getproj,RUNDIR);  
    strncat(getproj, "/main/runmc/proj_load.sh ", strlen("/main/runmc/proj_load.sh "));
    strncat(getproj, ffname1, strlen(ffname1));
    strncat(getproj, " &", 2);
// cout << getproj << endl;

// change colors 
    newvlab_017->setProperty(WSNlabelString,"Wait! RMC project compiling");
    newvlab_017->setPropertyV(WSNbackColor,"#ffc000");
    newvlab_017->setPropertyV(WSNtopShadowColor,"#ffc000");
    newvlab_017->setPropertyV(WSNbottomShadowColor,"#408080");
// put label
    newvlab_049->setPropertyV(WSNlabelString,"compiling (%)");
    newvlab_049->setPropertyV(WSNforeColor,"#8000ff");
   
// start project loading
    int irun1=system( getproj );
    newvtim_001->setProperty(WSNrunning,True); // start timer  
    if (irun1 != 0) {
    newmess_000->setPropertyV(WSNlabelString,"Cannot read/build this project");
    newmess_000->popup(); }

// reading/loading/displayin stuff in the
// ep_loadrmc.cpp

	  }else if (ret == WS_DIALOG_NO){     //(L)
    msg->setProperty(WSNlabelString,"Nothing is selected.");
    msg->popup();
  }else if (ret == WS_DIALOG_CANCEL){
    msg->setProperty(WSNlabelString,"The selection is canceled.");
    msg->popup();                     //(M)
  }; 

  } // end of OK dialog 
  } // end read of the file  


// RMC save the settings   
  if ( val == 5) {


// open dialog
  msg->setProperty(WSNlabelString,"save/archive the RMC project?");
  msg->update();
  long valmes = msg->popup();

  if  (valmes == WS_DIALOG_CANCEL) { return;} 

  if  (valmes == WS_DIALOG_OK)  { 


// first save MC settings
  char   foutfile[50];
  strncpy(foutfile,"", 50);
  strncat(foutfile, inival.MOutput, strlen(inival.MOutput));
  strncat(foutfile, ".mc", 3 );

// fix particle IP for deafult settings
   if (inival.IDparticle1 == 1) inival.IDparticle1=11;
   if (inival.IDparticle2 == 1) inival.IDparticle2=-11;

// write the file
  int wrr=MCwrite( foutfile  );
  if (wrr != 0) {
  newmess_000->setPropertyV(WSNlabelString,"Cannot write initialization file!");
  newmess_000->popup(); }


// check this file in archive
  struct stat buf; 
  char fold[700];
  strcpy(fold,RUNDIR);
  strncat(fold, "/archive/", strlen("/archive/")); 
  strncat(fold, inival.MOutput, strlen(inival.MOutput));
  strncat(fold, ".rmc", strlen(".rmc"));
  int ifile=-99; ifile = stat ( fold, &buf );

  long result =-999;
  if (ifile==0) { 
  newmess_002->setPropertyV(WSNlabelString,"Project with this name already exists \n Do you want to overwrite it ? ");
  result = newmess_002->popup(); };


  if (result == WS_DIALOG_OK || result == -999 ){

// show
  newvlab_024->setProperty(WSNlabelString,"RMC archived");
 
// zip and put to archive directory
  strcpy(putproj,RUNDIR);
  strncat(putproj, "/main/runmc/proj_create.sh ", strlen("/main/runmc/proj_create.sh "));
  strncat(putproj, " &", 2);
//   cout << putproj << endl;
  int irun2=system( putproj );
  if (irun2 != 0) {
  newmess_000->setPropertyV(WSNlabelString,"Cannot archive this project");
  newmess_000->popup(); }

  WSCstring  mess0=inival.MOutput;
  WSCstring  mess1=".rmc"; 
  WSCstring  mess2="$RUNMC/archive/"; 
  WSCstring  mess3=" saved"; 
  WSCstring  mess4=mess2+mess0+mess1+mess3;   

  newmess_002->setPropertyV(WSNx,(short)170);
  newmess_002->setPropertyV(WSNy,(short)120);
  newmess_002->setPropertyV(WSNlabelString,(char*)mess4 );
  newmess_002->popup(); 


  }else
  if (result == WS_DIALOG_NO){
       return;
  }else
  if (result == WS_DIALOG_CANCEL){
       return; 
  }; 


  } // end of massage dialog
  } // end of write

// view RunMC source usinf Snavigator 
  if ( val == 6) { 

  int irun10=system("$RUNMC/main/runmc/proj_view.sh &");
  if (irun10 != 0) {
  newmess_000->setPropertyV(WSNlabelString,"Cannot start RMC viewer");
  newmess_000->popup(); }

    };


// show info on RMC  
  if ( val == 7) { ep_showcomment(); };



}
static WSCfunctionRegister  op("ep_settings",(void*)ep_settings);
