// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCdialog.h>
#include <WSCmessageDialog.h>
// #include <string.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>
using namespace std;

#include <SetIni.h> // include class containing initializations for MC

extern int steerread();
extern WSCdialog* newdial_101;
extern WSCdialog* stedial_000;
char * namecard; // name of the steering cards

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_steering(WSCbase* object){
  //do something...

   extern SetIni inival;   

   WSCstring MessC;
// mark DIS events
    int DIS=0; // =1 for DIS events
    if ( inival.Q2min > 1.) {
    if ( abs(inival.IDparticle1) < 17 && abs(inival.IDparticle2) > 2000 )  DIS=1;
    if ( abs(inival.IDparticle2) < 17 && abs(inival.IDparticle1) > 2000 )  DIS=1; }

// steering card name
    struct stat buf;
    int icard=-99; icard = stat ( "pythia6.cards", &buf );
    if (inival.MCtype == 1) {
      namecard="pythia6.cards"; 
      icard = stat ( namecard, &buf);
      MessC="\"pythia6.cards\" not found, create it?"; 
    } else if (inival.MCtype == 2) { 
       namecard="herwig6.cards";
       icard = stat ( namecard, &buf);
       MessC="\"herwig6.cards\" not found, create it?";  
    } else if (inival.MCtype == 3) { 
       namecard="ariadne.cards";
       icard = stat ( namecard, &buf);
       MessC="\"ariadne.cards\" not found, create it?"; 
    } else if (inival.MCtype == 3 && DIS == 1 ) {
       namecard="arlepto.cards";
       icard = stat ( namecard, &buf);
       MessC="\"arlepto.cards\" not found, create it?"; 
    } else if (inival.MCtype == 4  ) {
       namecard="lepto65.cards";
       icard = stat ( namecard, &buf);
       MessC="\"lepto65.cards\" not found, create it?"; 
    } else if (inival.MCtype == 5  ) {
       namecard="aroma22.cards";
       icard = stat ( namecard, &buf);
       MessC="\"aroma22.cards\" not found, create it?"; 
    } else if (inival.MCtype == 6  ) {
       namecard="cascade.cards";
       icard = stat ( namecard, &buf);
       MessC="\"cascade.cards\" not found, create it?"; 
    }

  //Access to the global instance of the WSCmessageDialog class.
  WSCmessageDialog* msg = WSGIappMessageDialog(); //(G)
  msg->setPropertyV(WSNtitleString,"Message:");
  msg->setPropertyV(WSNx,(short)168);
  msg->setPropertyV(WSNy,(short)114);
  msg->setPropertyV(WSNwidth,(unsigned short)335);
  msg->setPropertyV(WSNheight,(unsigned short)122);
  msg->setPropertyV(WSNtopShadowColor,"DEF1");
  msg->setPropertyV(WSNbottomShadowColor,"DEF1");
  msg->setProperty(WSNlabelString,(char*)MessC);

// not found 
    if (icard != 0) { 
    long valmesg = msg->popup(); 
    if  (valmesg == WS_DIALOG_CANCEL) {
    return;}
    if  (valmesg == WS_DIALOG_OK) {
// create new file
       ofstream mycard(namecard, ios::out);
       mycard << "* RUNMC card file " << namecard;    
       mycard.close();
       int irun=steerread();
       if (irun != 0 ) {cout << "error in reading card file " << endl; return; } 
       stedial_000->setPropertyV(WSNvis,(WSCbool)1);
    }
    }

// found 
    if (icard == 0) {
    int irun=steerread();
    if (irun != 0 ) {cout << "error in reading card file " << endl; return; } 
    stedial_000->setPropertyV(WSNvis,(WSCbool)1);
    } 


}
static WSCfunctionRegister  op("ep_steering",(void*)ep_steering);
