// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>

#include <WSCfileSelect.h>
#include <WSCmessageDialog.h> //(B)
#include <WSCvifield.h>
#include <WSCstring.h>

#include <iostream>
#include <fstream>
#include <string> 

#include <SetIni.h> // include class containing initializations for M
#include <SetHisto.h> // initialization of histograms
#include <WSCtextField.h>
#include <WSCoption.h>
#include <WSCvbtn.h>
#include <WSCvifield.h>
#include <WSCcomboBox.h>
#include <WSCvslider.h>
#include <WSCradioGroup.h>
#include <WSCvradio.h>

#include <stdio.h>
#include <stdlib.h>
using namespace std;
extern WSCvlabel* newvlab_043;
extern WSCvlabel* newvlab_044;
extern WSCvlabel* newvlab_045;
extern WSCradioGroup* newradi_048;
extern WSCradioGroup* newradi_046;
extern WSCcomboBox* newcomb_006;
extern WSCcomboBox* newcomb_007;
extern WSCoption* newopti_000; 
extern WSCoption* newopti_004;
extern WSCoption* newopti_005;
extern WSCoption* newopti_030; 
extern WSCoption* newopti_032;
extern WSCoption* newopti_007; 
extern WSCoption* newopti_001;
extern WSCoption* newopti_003;
extern WSCoption* newopti_010;
extern WSCoption* newopti_011;
extern WSCoption* newopti_012;
extern WSCoption* newopti_013;
extern WSCoption* newopti_014;
extern WSCoption* newopti_014d;
extern WSCoption* newopti_015;
extern WSCoption* newopti_016;
extern WSCoption* newopti_022;
extern WSCoption* newopti_111;
extern WSCoption* newopti_112;
extern WSCoption* newopti_113;
extern WSCoption* newopti_114;


extern WSCvifield* newvifi_000;
extern WSCvifield* newvifi_001;
extern WSCvifield* newvifi_003;
extern WSCvifield* newvifi_004;
extern WSCvifield* newvifi_006;
extern WSCvifield* newvifi_007;
extern WSCvifield* newvifi_008;
extern WSCvifield* newvifi_009;
extern WSCoption* newopti_009;
extern WSCoption* newopti_002;
extern WSCvifield* newvifi_010;
extern WSCvifield* newvifi_011;
extern WSCvifield* newvifi_012;
extern WSCvifield* newvifi_013;
extern WSCvifield* newvifi_014; 
extern WSCvifield* newvifi_015; 
extern WSCvifield* newvifi_016;
extern WSCvifield* newvifi_017;
extern WSCvifield* newvifi_019; 
extern WSCvifield* newvifi_020;
extern WSCvifield* newvifi_021;
extern WSCvifield* newvifi_022;
extern WSCvifield* newvifi_023;
extern WSCvifield* newvifi_024;
extern WSCvifield* newvifi_028; 
extern WSCvifield* newvifi_031;
extern WSCvifield* newvifi_033;
extern WSCvifield* newvifi_018;
extern WSCoption* newopti_024;
extern WSCvifield* newvifi_025;
extern WSCvifield* newvifi_026;
extern WSCvifield* newvifi_027;
extern WSCvifield* newvifi_029; 
extern WSCvifield* newvifi_030; 
extern WSCvifield* newvifi_032;
extern WSCvifield* newvifi_034;
extern WSCvifield* newvifi_035;
extern WSCvifield* newvifi_036;
extern WSCvifield* newvifi_037;
extern WSCvifield* newvifi_038;
extern WSCvifield* newvifi_039;
extern WSCvifield* newvifi_040;
extern WSCvifield* newvifi_051;
extern WSCvifield* newvifi_052;
extern WSCvifield* newvifi_029; 
extern WSCvifield* newvifi_041;

extern WSCvbtn* newvbtn_001;
extern WSCvbtn* newvbtn_002;
extern WSCvbtn* newvbtn_003;
extern WSCvbtn* newvbtn_004;
extern WSCvbtn* newvbtn_005;
extern WSCvbtn* newvbtn_006;
extern WSCvbtn* newvbtn_008;
extern WSCvbtn* newvbtn_009;
extern WSCvbtn* newvbtn_111;

extern WSCstring float_convert(double number);

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_update_histo(){


    extern SetHisto inihis;

    WSCstring tmp;
// show histograms 
//     char  szHISTO[10], szHISTOB[5]; 

    if (inihis.HistoN>0) { 

// for minimum
     tmp = float_convert(inihis.HistoMin[1]); 
     newvifi_011->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear(); 

     tmp = float_convert(inihis.HistoMin[2]);
     newvifi_025->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp = float_convert(inihis.HistoMin[3]);
     newvifi_013->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp = float_convert(inihis.HistoMin[4]);
     newvifi_016->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMin[5]);
     newvifi_020->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp = float_convert(inihis.HistoMin[6]);
     newvifi_021->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMin[7]);
     newvifi_031->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMin[8]);
     newvifi_033->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


// for maximum 
     tmp = float_convert(inihis.HistoMax[1]);
     newvifi_012->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMax[2]);
     newvifi_026->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMax[3]);
     newvifi_014->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp = float_convert(inihis.HistoMax[4]);
     newvifi_017->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMax[5]);
     newvifi_022->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMax[6]);
     newvifi_028->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMax[7]);
     newvifi_034->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp = float_convert(inihis.HistoMax[8]);
     newvifi_035->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


// for bin sizes 
     tmp=inihis.HistoBins[1];
     newvifi_010->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp=inihis.HistoBins[2];
     newvifi_027->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp=inihis.HistoBins[3];
     newvifi_015->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp=inihis.HistoBins[4];
     newvifi_019->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp=inihis.HistoBins[5];
     newvifi_023->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp=inihis.HistoBins[6];
     newvifi_024->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();

     tmp=inihis.HistoBins[7];
     newvifi_036->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


     tmp=inihis.HistoBins[8];
     newvifi_037->setPropertyV(WSNlabelString, (char*)tmp);
     tmp.clear();


// titels
      newvbtn_001->setPropertyV(WSNlabelString, inihis.HistoName[1]);
      newvbtn_001->redraw();
      newvbtn_001->update();

//      cout << " i=1" << inihis.HistoName[1] << endl;
 
      newvbtn_002->setPropertyV(WSNlabelString, inihis.HistoName[2]);
      newvbtn_002->redraw();
      newvbtn_002->update();


//      cout << " i=2" << inihis.HistoName[2] << endl;

      newvbtn_003->setPropertyV(WSNlabelString, inihis.HistoName[3]);
      newvbtn_003->redraw();
      newvbtn_003->update();

//     cout << " i=3" << inihis.HistoName[3] << endl;

      newvbtn_004->setPropertyV(WSNlabelString, inihis.HistoName[4]);
      newvbtn_004->redraw();
      newvbtn_004->update();

//      cout << " i=4" << inihis.HistoName[4] << endl;


      newvbtn_005->setPropertyV(WSNlabelString, inihis.HistoName[5]);
      newvbtn_005->redraw();
      newvbtn_005->update();



      newvbtn_006->setPropertyV(WSNlabelString, inihis.HistoName[6]);
      newvbtn_006->redraw();
      newvbtn_006->update();


      newvbtn_008->setPropertyV(WSNlabelString, inihis.HistoName[7]);
      newvbtn_008->redraw();
      newvbtn_008->update();


      newvbtn_009->setPropertyV(WSNlabelString, inihis.HistoName[8]);
      newvbtn_009->redraw();
      newvbtn_009->update();


// 2D option
      newopti_111->setPropertyV(WSNlabelString, "1D");
      newopti_111->setPropertyV(WSNbackColor,"DEF1");
      newopti_112->setPropertyV(WSNlabelString, "1D");
      newopti_112->setPropertyV(WSNbackColor,"DEF1");
      newopti_113->setPropertyV(WSNlabelString, "1D");
      newopti_113->setPropertyV(WSNbackColor,"DEF1");
      newopti_114->setPropertyV(WSNlabelString, "1D");
      newopti_114->setPropertyV(WSNbackColor,"DEF1");
      if (inihis.Histo2D[1] ==2 && inihis.Histo2D[2] ==2 ) {
         newopti_111->setPropertyV(WSNlabelString, "2D"); 
         newopti_111->setPropertyV(WSNbackColor,"#c0c0ff");
         };
      if (inihis.Histo2D[3] ==2 && inihis.Histo2D[4] ==2 ) {
         newopti_112->setPropertyV(WSNbackColor,"#c0c0ff");
         newopti_112->setPropertyV(WSNlabelString, "2D"); };
      if (inihis.Histo2D[5] ==2 && inihis.Histo2D[6] ==2 ) {
         newopti_113->setPropertyV(WSNbackColor,"#c0c0ff");
         newopti_113->setPropertyV(WSNlabelString, "2D"); };
      if (inihis.Histo2D[7] ==2 && inihis.Histo2D[8] ==2 ) {
         newopti_114->setPropertyV(WSNbackColor,"#c0c0ff");
         newopti_114->setPropertyV(WSNlabelString, "2D"); };
 
   } // end non-zero histograms 

      
}
