// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>

#include <WSCfileSelect.h>
#include <WSCmessageDialog.h> //(B)
#include <WSCvifield.h>
#include <WSCstring.h>

#include <iostream>
#include <fstream>
#include <string> 

#include <SetIni.h> // include class containing initializations for M
#include <SetHisto.h> // initialization of histograms
#include <WSCtextField.h>
#include <WSCoption.h>
#include <WSCvbtn.h>
#include <WSCvifield.h>
#include <WSCcomboBox.h>
#include <WSCvslider.h>
#include <WSCradioGroup.h>
#include <WSCvradio.h>

#include <stdio.h>
#include <stdlib.h>
using namespace std;
extern void show_DIS_on_GUI();
extern void set_histo_spreadsheet( long number, long position );

extern int get_ntnames(); // update files

char * getname( int ii) {
       char * name="";
       if (ii== 11) name ="e-"; 
       if (ii== -11) name  ="e+";
       if (ii== 13) name ="mu-";
       if (ii== -13) name ="mu+";
       if (ii==  22) name ="gamma";
       if (ii==  2112) name ="n";
       if (ii==  -2112) name ="nbar";
       if (ii==  2212) name ="p";
       if (ii==  -2212) name ="pbar";
       return name;
       }

extern char * PDF[]; 
extern char * MC[];
extern char * NTUPLES[];
extern char * FS[];
extern char * JET[];
extern char * OPT1[];
extern char * OPT2[];
extern char * OPT3[];
extern char * OPT4[];
extern char * OPT4D[];
extern char * OPT5[];
extern char * OPT6[];
extern char * MFrame[];
extern char * Jangle[];
extern char * Jrecom[];
extern char * JNfixed[];

extern WSCvlabel* newvlab_043;
extern WSCvlabel* newvlab_044;
extern WSCvlabel* newvlab_045;
extern WSCradioGroup* newradi_048;
extern WSCradioGroup* newradi_046;
extern WSCcomboBox* newcomb_006;
extern WSCcomboBox* newcomb_007;
extern WSCoption* newopti_000; 
extern WSCoption* newopti_004;
extern WSCoption* newopti_005;
extern WSCoption* newopti_030; 
extern WSCoption* newopti_032;
extern WSCoption* newopti_007; 
extern WSCoption* newopti_001;
extern WSCoption* newopti_003;
extern WSCoption* newopti_010;
extern WSCoption* newopti_011;
extern WSCoption* newopti_012;
extern WSCoption* newopti_013;
extern WSCoption* newopti_014;
extern WSCoption* newopti_014d;
extern WSCoption* newopti_015;
extern WSCoption* newopti_016;
extern WSCoption* newopti_022;
extern WSCoption* newopti_111;
extern WSCoption* newopti_112;
extern WSCoption* newopti_113;
extern WSCoption* newopti_114;


extern WSCvifield* newvifi_000;
extern WSCvifield* newvifi_001;
extern WSCvifield* newvifi_003;
extern WSCvifield* newvifi_004;
extern WSCvifield* newvifi_006;
extern WSCvifield* newvifi_007;
extern WSCvifield* newvifi_008;
extern WSCvifield* newvifi_009;
extern WSCoption* newopti_009;
extern WSCoption* newopti_002;
extern WSCvifield* newvifi_010;
extern WSCvifield* newvifi_011;
extern WSCvifield* newvifi_012;
extern WSCvifield* newvifi_013;
extern WSCvifield* newvifi_014; 
extern WSCvifield* newvifi_015; 
extern WSCvifield* newvifi_016;
extern WSCvifield* newvifi_017;
extern WSCvifield* newvifi_019; 
extern WSCvifield* newvifi_020;
extern WSCvifield* newvifi_021;
extern WSCvifield* newvifi_022;
extern WSCvifield* newvifi_023;
extern WSCvifield* newvifi_024;
extern WSCvifield* newvifi_028; 
extern WSCvifield* newvifi_031;
extern WSCvifield* newvifi_033;
extern WSCvifield* newvifi_018;
extern WSCoption* newopti_024;
extern WSCvifield* newvifi_025;
extern WSCvifield* newvifi_026;
extern WSCvifield* newvifi_027;
extern WSCvifield* newvifi_029; 
extern WSCvifield* newvifi_030; 
extern WSCvifield* newvifi_032;
extern WSCvifield* newvifi_034;
extern WSCvifield* newvifi_035;
extern WSCvifield* newvifi_036;
extern WSCvifield* newvifi_037;
extern WSCvifield* newvifi_038;
extern WSCvifield* newvifi_039;
extern WSCvifield* newvifi_040;
extern WSCvifield* newvifi_051;
extern WSCvifield* newvifi_052;
extern WSCvifield* newvifi_029; 
extern WSCvifield* newvifi_041;
extern WSCmessageDialog* newmess_000;
extern WSCvslider* newvsli_000;

extern WSCvbtn* newvbtn_001;
extern WSCvbtn* newvbtn_002;
extern WSCvbtn* newvbtn_003;
extern WSCvbtn* newvbtn_004;
extern WSCvbtn* newvbtn_005;
extern WSCvbtn* newvbtn_006;
extern WSCvbtn* newvbtn_008;
extern WSCvbtn* newvbtn_009;
extern WSCvbtn* newvbtn_111;
extern WSCvlabel* newvlab_024;
extern WSCvbtn* newvbtn_201;

extern WSCvradio* newvrad_000;
extern WSCvradio* newvrad_001;
extern WSCvradio* newvrad_002;

extern WSCstring float_convert(double number);


// for histogram updates 
extern void ep_update_histo();

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void ep_updategui(){


  //do something...
    extern SetIni inival;
    extern SetHisto inihis;

// display all of this 
    char * name1; 
    char * name2;
    name1=getname(inival.IDparticle1);
    name2=getname(inival.IDparticle2);


// for MC
    if (inival.MCtype>0) {
       newopti_000->setPropertyV(WSNlabelString, MC[inival.MCtype] );
       // MC settings 
       newvbtn_201->setPropertyV(WSNvis,(WSCbool)1);
       // for PHOJET - no MC settings bottom
       if (inival.MCtype == 7) newvbtn_201->setPropertyV(WSNvis,(WSCbool)0);
    }

// for ntuples
    if (inival.MCtype < 0) {
      newvbtn_201->setPropertyV(WSNvis,(WSCbool)0);
     if (inival.MCtype == -1) newopti_000->setPropertyV(WSNlabelString, NTUPLES[1] ); 
     if (inival.MCtype == -2) newopti_000->setPropertyV(WSNlabelString, NTUPLES[2] );
    }
 

    newopti_002->setPropertyV(WSNlabelString, FS[inival.FStype] );
    newopti_030->setPropertyV(WSNlabelString, name1);
    newopti_032->setPropertyV(WSNlabelString, name2);
    newopti_004->setPropertyV(WSNlabelString, PDF[inival.PDFparticle1]);
    newopti_005->setPropertyV(WSNlabelString, PDF[inival.PDFparticle2]);


// Remove PDF label
   if (abs(inival.IDparticle1) < 20) {
   newopti_004->setVisible(False); // remove PDF option for electron etc
   }else{
   newopti_004->setVisible(True); // set for other
   };
// Remove PDF label
   if ( abs(inival.IDparticle2) < 20 ) {
   newopti_005->setVisible(False); // remove PDF option for electron etc
   }else{
   newopti_005->setVisible(True); // set for other
   };
    newopti_004->update();
    newopti_005->update();
    newopti_030->update();
    newopti_032->update();   
    newopti_000->update();
    newopti_002->update();


    newopti_001->setPropertyV(WSNlabelString, OPT1[inihis.HistoOptions[0]]);
    newopti_003->setPropertyV(WSNlabelString, OPT2[inihis.HistoOptions[1]]);
    newopti_009->setPropertyV(WSNlabelString, OPT3[inihis.HistoOptions[2]]);
// color style
    newopti_014->setPropertyV(WSNlabelString, OPT4[inihis.HistoOptions[5]]);
// 2D color style
    newopti_014d->setPropertyV(WSNlabelString, OPT4D[inihis.HistoOptions[12]]);
    newopti_015->setPropertyV(WSNlabelString, OPT5[inihis.HistoOptions[6]]);
    newopti_016->setPropertyV(WSNlabelString, OPT5[inihis.HistoOptions[7]]);
    newopti_022->setPropertyV(WSNlabelString, OPT6[inihis.HistoOptions[8]]);


    newopti_010->setPropertyV(WSNlabelString, MFrame[inival.Frame]);
    newopti_011->setPropertyV(WSNlabelString, Jangle[inival.JetAngle]);
    newopti_012->setPropertyV(WSNlabelString, Jrecom[inival.JetRecomb]); 
    newopti_013->setPropertyV(WSNlabelString, JNfixed[inival.JetNfixed]);
    newopti_010->update();
    newopti_011->update();
    newopti_012->update();
    newopti_013->update();
    newopti_015->update();
    newopti_016->update();
    newopti_022->update();


     
     WSCstring tmp;
     tmp = float_convert(inival.Q2max); 
     newvifi_000->setPropertyV(WSNlabelString, (char*)tmp ); 
     tmp.clear();

     tmp = float_convert(inival.Q2min);
     newvifi_003->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.Xmin);
     newvifi_001->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.Xmax);
     newvifi_004->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.Ymin);
     newvifi_007->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.Ymax);
     newvifi_006->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();


     tmp = float_convert(inival.Wmax);
     newvifi_008->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.Wmin);
     newvifi_009->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.NTlumi);
     newvifi_041->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();
 
// output fils
//   cout << inival.MOutput << endl;
     newvifi_029->setPropertyV(WSNlabelString,  inival.MOutput  );

// set Jet Type
      unsigned long jtype=1;
      if (inival.JetType==1) {jtype=1;} 
      if (inival.JetType==2) {jtype=1;}
      if (inival.JetType==3) {jtype=2;}
      if (inival.JetType==4) {jtype=3;}
      newradi_048->setPropertyV(WSNvalue, jtype);
      newradi_048->update();

// set all files for ntuple
      unsigned long  ntype=1;
      if (inival.NTread == 0) ntype=1;
      if (inival.NTread == 1) ntype=2;
      newradi_046->setPropertyV(WSNvalue, ntype); 
      newradi_046->update();


// set Jet/Particles 
      if (inival.JetType==1) {jtype=1;}
      if (inival.JetType >1) {jtype=2;}
      newopti_007->setPropertyV(WSNlabelString, JET[jtype] );


// energy 
     tmp = float_convert(inival.Energy1);
     newvifi_032->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.Energy2);
     newvifi_030->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();


// set cuts on jets 
     tmp = float_convert(inival.ETmin);
     newvifi_039->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.ETmax);
     newvifi_038->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.JetYcut);
     newvifi_040->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.ETAmin);
     newvifi_051->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

     tmp = float_convert(inival.ETAmax);
     newvifi_052->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear();

// Canvas Size
     tmp=inihis.HistoOptions[3];
     newcomb_006->setPropertyV(WSNlabelString, (char*)tmp );

     tmp=inihis.HistoOptions[4];
     newcomb_007->setPropertyV(WSNlabelString, (char*)tmp );


// set type of hadronic final state
    newopti_002->setPropertyV(WSNlabelString, FS[inival.FStype] );


// show number of events  
     tmp=inival.Nevents;
     newvifi_018->setPropertyV(WSNlabelString, (char*)tmp );
     tmp.clear(); 
 
// initialize slider
    long vvslide=inival.Renice;
    newvsli_000->setPropertyV(WSNuserValue,vvslide);

// output files 
    if (inihis.HistoOptions[9] == 1) {newvrad_000->setPropertyV(WSNstatus,(WSCbool)1);}
    else {newvrad_000->setPropertyV(WSNstatus,(WSCbool)0);}  
    if (inihis.HistoOptions[10] == 1) {newvrad_001->setPropertyV(WSNstatus,(WSCbool)1);}
    else {newvrad_001->setPropertyV(WSNstatus,(WSCbool)0);}
    if (inihis.HistoOptions[11] == 1) {newvrad_002->setPropertyV(WSNstatus,(WSCbool)1);}
    else {newvrad_002->setPropertyV(WSNstatus,(WSCbool)0);}


// show histograms 
     ep_update_histo();

// now updating spreadsheet for histograms  
    if (inihis.HistoN>1) {
    for  (int i=1; i<inihis.HistoN; i++ ) {
          set_histo_spreadsheet( i, i+1 );
    }; }; 





// is this Monte Carlo ?
     if (inival.MCtype > 0) {
    newopti_030->setVisible(True);
    newopti_032->setVisible(True);
    newvifi_032->setVisible(True);
    newvifi_030->setVisible(True);
    newvlab_043->setVisible(True);
    newvlab_044->setVisible(True);
// remove Ntuple staff
    newradi_046->setPropertyV(WSNvis,(WSCbool)0);
    newvlab_045->setPropertyV(WSNvis,(WSCbool)0);
    newvifi_041->setPropertyV(WSNvis,(WSCbool)0);
    newvbtn_111->setPropertyV(WSNvis,(WSCbool)0);
    }

// is this Ntuple ?
  if (inival.MCtype < 0) {
    newopti_030->setVisible(False);
    newopti_032->setVisible(False);
    newvifi_032->setVisible(False);
    newvifi_030->setVisible(False);
    newvlab_043->setVisible(False);
    newvlab_044->setVisible(False);
 
// add  Ntuple staff
    newradi_046->setPropertyV(WSNvis,(WSCbool)1);
    newvlab_045->setPropertyV(WSNvis,(WSCbool)1);
    newvifi_041->setPropertyV(WSNvis,(WSCbool)1);
    newvbtn_111->setPropertyV(WSNvis,(WSCbool)1);

     int incc=get_ntnames();
     if (incc != 0 ) cout << "Errors in get_ntnames();" << endl;
    }


// is this DIS? 
     show_DIS_on_GUI(); 

}
