// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
// Get ntuples names  
// 
// root stuff
#include<iostream>
#include<fstream>
#include<sys/stat.h>
#include<WSCstring.h>

using namespace std;
#include<SetIni.h>    // include class containing initializations for RunMC



char * NtupleNames[1000];
int   NTnumber;


int  get_ntnames() { 

  extern SetIni inival; 
  if (inival.MCtype > 0) return 0;


// check/remove file
  struct stat buf1;
  int ile1= stat ( ".analmc.tup", &buf1 );
  if (ile1 == 0) remove(".analmc.tup"); 

  WSCstring ss("/");
  WSCstring dir=inival.NTdir;
  WSCstring fullname=inival.NTdir;
  WSCstring name=inival.NTname; 
  fullname.addString(ss);
  fullname.addString(name);
  fullname.addString("\n");

// put into file 
    if (inival.NTread == 0) {
       ofstream myntuple(".analmc.tup", ios::out);
       myntuple << fullname;
       myntuple.close();
       return 0;
    }
 

  if (inival.NTread == 1) {
// now if all ntuples are required 
// get lists of ntuples
  WSCstring la01("ls -1 ");
  WSCstring la02("ls -1 ");

  WSCstring ls01("/*.rtup > .analmc.tup &");
  WSCstring ls02("/*.htup > .analmc.tup &");

  la01.addString(dir);
  la02.addString(dir); 

  la01.addString(ls01);
  la02.addString(ls02);

   int irun=0;
   if (inival.MCtype == -1)  {
   irun=system( (char*)la01);
   if (irun != 0) cout << "error in creating lists of files" << endl; return 1; }

   if (inival.MCtype == -2)  {
   irun=system( (char*)la02);
   if (irun != 0) cout << "error in creating lists of files" << endl; return 1;}

   }

 return 0;
}
