// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
#include <WSCdialog.h>
#include <SetIni.h> // include class containing initializations for M
#include <SetHisto.h> // initialization of histograms    
using namespace std;
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <stdlib.h>
#include <WSCstring.h>
#include <WSCtextField.h> 
#include <WSCsheet.h>

extern WSCsheet* newshee_002;
extern WSCdialog* newdial_220;
extern void ep_update_histo(); // update files
extern int MaxHisto;


void histo_fast_update(){


   extern SetHisto inihis; 
   char *  xnone("none");

// set to zero
   char tt[2]=" ";
   for (int i=0; i<=500; i++) {
       inihis.HistoType[i]=0;
       inihis.HistoMax[i]=0.;
       inihis.HistoMin[i]=0.;
       inihis.HistoBins[i]=0;
       inihis.Histo2D[i]=1;
       inihis.HistoWeight[i]=1.;
       inihis.HistoName[i] = new char[strlen(tt)+1]; // empty
       strcpy(inihis.HistoName[i],tt);
       inihis.HistoComm[i] = new char[strlen(tt)+1]; // empty
       strcpy(inihis.HistoComm[i],tt);
     };


  WSCstring tmp0,tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7;
  WSCstring empty;
  int nn=0;
  inihis.HistoNcurrent=0; 
  for(int i=2; i <= newshee_002->getRowCount(); i++){
  tmp1=newshee_002->getText(1, i);
  tmp2=newshee_002->getText(2, i);
  tmp3=newshee_002->getText(3, i);
  tmp4=newshee_002->getText(4, i);
  tmp5=newshee_002->getText(5, i);
  tmp6=newshee_002->getText(6, i);
  tmp7=newshee_002->getText(7, i);
  if (tmp1.getChars()>0)  { 
      nn++;
      inihis.HistoType[nn]=nn;
//      if ( strcmp((char*)tmp1, (char*)xnone) == 0 ) inihis.HistoType[nn]=0; 
      inihis.Histo2D[nn]=atoi((char*)tmp2);
      inihis.HistoMin[nn]=atof((char*)tmp3);
      inihis.HistoMax[nn]=atof((char*)tmp4);
      inihis.HistoBins[nn]=atoi((char*)tmp5);
      inihis.HistoWeight[nn]=atof((char*)tmp6);
      inihis.HistoName[nn] = new char[strlen(tmp1)]; 
      strcpy(inihis.HistoName[nn],tmp1);  
      inihis.HistoComm[nn] = new char[strlen(tmp7)]; 
      strcpy(inihis.HistoComm[nn],tmp7);
 //     cout << nn << " " << inihis.HistoName[nn] << " " << inihis.HistoType[nn] << endl;
   }
  tmp1.clear(); 
  tmp2.clear(); 
  tmp3.clear(); 
  tmp4.clear(); 
  tmp5.clear(); 
  tmp6.clear();
  tmp7.clear();
 }

   inihis.HistoNcurrent=nn;
   inihis.HistoN=nn;

   if (inihis.HistoN == 0) inihis.HistoN=1;

// set to zero  
   for(int i=1; i<=inihis.HistoN; i++){
//     cout << i << "DEBUG =  " << inihis.HistoName[i] << endl;
     if ( strcmp(inihis.HistoName[i], xnone) == 0 ) inihis.HistoType[i]=0;
   };
 
//   cout << "Total number of histograms = " << inihis.HistoN << endl;
 

// update GUI
   ep_update_histo();

}
