#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCsheet.h>
#include <WSCstring.h>
#include <WSCpopupMenu.h>
#include <iostream>
#include <WSDmouse.h>

// label if copy was done 
static short icopy=0;
static short ipressed=0;

// colors
char * col1="#c0c0ff"; // WSNbackColor 
char * col2="#ffffff"; //  
char * col3="#8080c0";
char * col0="#000000"; // WSNforeColor 


//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
using namespace std;

WSCpopupMenu*  pmenu1;
WSCpopupMenu*  pmenu2;
WSCpopupMenu*  pmenu3;
WSCpopupMenu*  pmenu4;

//--- OBJECT instance variable ---//
extern WSCsheet* newshee_002;

// keep info during copy with mouse 
static WSCstring pool[500][7]; 
static long Nmin=0;
static long Nmax=0;
extern void histo_fast_update();



// delete function
void menu1(WSCbase* client){


  long old=newshee_002->getRowCount(); 
  long mstart = newshee_002->getStartRow();
  long mend = newshee_002->getEndRow(); 

  if (mstart < 2) mstart=2;
  long ntot=mend-mstart+1; // how many rows to remove
 
  if (ntot < 1 ) {
     pmenu1->setPropertyV(WSNvis,(WSCbool)0);
     pmenu2->setPropertyV(WSNvis,(WSCbool)0);
     pmenu3->setPropertyV(WSNvis,(WSCbool)0);
     pmenu4->setPropertyV(WSNvis,(WSCbool)0);
     delete pmenu1;
     delete pmenu2;
     delete pmenu3;
     delete pmenu4;
     ipressed = 0;
     return;
   };

// just for protection 
   if (mend > old) mend=old;



/* 
// now remove
   WSCstring tmp1;
   tmp1.clear();
   for(long i=mstart; i<=mend; i++){
   newshee_002->setText(1, i, tmp1);
//   cout << "removing =" << i << endl;
   newshee_002->setText(2, i, tmp1);
   newshee_002->setText(3, i, tmp1);
   newshee_002->setText(4, i, tmp1);
   newshee_002->setText(5, i, tmp1);
   newshee_002->setText(6, i, tmp1);
   newshee_002->setText(7, i, tmp1);
   }
*/


  newshee_002->deleteRow(mstart, ntot);
  newshee_002->setPropertyV(WSNrows, (long)(old-ntot));
  newshee_002->setFocusCell(1, (long)(old-ntot));
  newshee_002->redraw();
  newshee_002->update();


//   for(long i=2; i<=newshee_002->getRowCount() ; i++){
//   tmp1=newshee_002->getText(1, i);
//   cout << "New sheet=" << tmp1 << endl;  
//   }
 

// update parameters
  histo_fast_update();

  ipressed = 0;
  pmenu1->setPropertyV(WSNvis,(WSCbool)0);
  pmenu2->setPropertyV(WSNvis,(WSCbool)0);
  pmenu3->setPropertyV(WSNvis,(WSCbool)0);
  pmenu4->setPropertyV(WSNvis,(WSCbool)0);
  delete pmenu1;
  delete pmenu2;
  delete pmenu3;
  delete pmenu4; 

 
} // end delete 




// copy
void menu2(WSCbase* client){



  long mstart = newshee_002->getStartRow();
  long mend = newshee_002->getEndRow();
  if (mstart < 2) mstart=2;

  Nmin= mstart; 
  Nmax= mend;
  long lnumber=Nmax-Nmin+1;

// return 
  if (lnumber < 0 ) {
     pmenu1->setPropertyV(WSNvis,(WSCbool)0);
     pmenu2->setPropertyV(WSNvis,(WSCbool)0);
     pmenu3->setPropertyV(WSNvis,(WSCbool)0);
     pmenu4->setPropertyV(WSNvis,(WSCbool)0);
     delete pmenu1;
     delete pmenu2;
     delete pmenu3;
     delete pmenu4;
     ipressed = 0;
     return;
   };

  

//  cout << "Copied from " << Nmin << " to " << Nmax << endl;

  for(long i=0; i<lnumber; i++){
   long nn=Nmin+i; 
   pool[i][0]=newshee_002->getText(1, nn);
   pool[i][1]=newshee_002->getText(2, nn);
   pool[i][2]=newshee_002->getText(3, nn);
   pool[i][3]=newshee_002->getText(4, nn);
   pool[i][4]=newshee_002->getText(5, nn);
   pool[i][5]=newshee_002->getText(6, nn);
   pool[i][6]=newshee_002->getText(7, nn);
//   cout << i << " Copied " << pool[i][0] << endl;
  };

  ipressed = 0;
  icopy=1; 
  pmenu1->setPropertyV(WSNvis,(WSCbool)0);
  pmenu2->setPropertyV(WSNvis,(WSCbool)0);
  pmenu3->setPropertyV(WSNvis,(WSCbool)0);
  pmenu4->setPropertyV(WSNvis,(WSCbool)0);
  delete pmenu1;
  delete pmenu2;
  delete pmenu3;
  delete pmenu4;


} // end copy


// paste
void menu3(WSCbase* client){

  WSCstring tmp1;


  if (Nmax !=0 && Nmin !=0) {
    long lold=newshee_002->getRowCount(); 
    long lfoc=newshee_002->getFocusRow();
    long lmany=Nmax-Nmin+1; 
    long lshift=lold+lmany;
    newshee_002->setPropertyV(WSNrows, lshift);
    newshee_002->insertRow(lfoc+1, lmany);
    
// format nicely 
  for(long i=lold; i<=lold+lmany; i++){
  newshee_002->setCellBkColor(1,i, "DEF3");
  newshee_002->setCellAlignemnt(1,i,WS_LEFT);
  newshee_002->setCellAlignemnt(2,i,WS_CENTER);
  newshee_002->setCellBkColor(7, i, "#ffffcc");
  newshee_002->setCellAlignemnt(7,i,WS_LEFT);
  newshee_002->setCellAlignemnt(6,i,WS_CENTER);
  newshee_002->setCellAlignemnt(5,i,WS_LEFT);
  newshee_002->setCellAlignemnt(3,i,WS_LEFT);
  newshee_002->setCellAlignemnt(4,i,WS_LEFT);
  }


//   cout << "Insert = " <<  lmany  << "starting from = " << lfoc << endl; 

// now replace 
   for(long i=0; i<lmany ; i++){
   long nn= lfoc+i+1; 
//   cout << i << " " << pool[i][1] << endl;
   newshee_002->setText(1, nn, pool[i][0]);
   newshee_002->setText(2, nn, pool[i][1]);
   newshee_002->setText(3, nn, pool[i][2]);
   newshee_002->setText(4, nn, pool[i][3]);
   newshee_002->setText(5, nn, pool[i][4]);
   newshee_002->setText(6, nn, pool[i][5]);
   newshee_002->setText(7, nn, pool[i][6]);
 // clear 
   for(long j=0; j<7 ; j++) pool[i][j].clear();
   }


    Nmin=0;
    Nmax=0;
    icopy=0;

  newshee_002->redraw();
  newshee_002->update();

// update parameters
  histo_fast_update();


  ipressed = 0;
  pmenu1->setPropertyV(WSNvis,(WSCbool)0);
  pmenu2->setPropertyV(WSNvis,(WSCbool)0);
  pmenu3->setPropertyV(WSNvis,(WSCbool)0);
  pmenu4->setPropertyV(WSNvis,(WSCbool)0);
  delete pmenu1;
  delete pmenu2;
  delete pmenu3;
  delete pmenu4;


  }



}

void menu4(WSCbase* client){

  pmenu1->setPropertyV(WSNvis,(WSCbool)0);
  pmenu2->setPropertyV(WSNvis,(WSCbool)0);
  pmenu3->setPropertyV(WSNvis,(WSCbool)0);
  pmenu4->setPropertyV(WSNvis,(WSCbool)0);

  newshee_002->setFocusCell(1, 1);
  newshee_002->update();

  ipressed = 0; 
  delete pmenu1;
  delete pmenu2;
  delete pmenu3;
  delete pmenu4;

  //executes by Menu 4 
}


//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void histo_sheet_pop(WSCbase* client){


  long col_start=newshee_002->getStartCol(); 
  long col_end=newshee_002->getEndCol(); 
//  cout << "Coulumb start and end=" << col_start << " " <<  col_end << endl;
  long col_n=col_end-col_start; // how many colums? 


//  pmenu1 = new WSCpopupMenu(NULL,"menu1");
//  pmenu2 = new WSCpopupMenu(NULL,"menu2");
//  pmenu3 = new WSCpopupMenu(NULL,"menu3");
//  pmenu4 = new WSCpopupMenu(NULL,"menu4");


//  cout << ipressed << endl;

// only when all colums are selected! 
  if (   col_n>5 && ipressed == 0) { 


  ipressed++;
  pmenu1 = new WSCpopupMenu(NULL,"menu1");
  pmenu1->initialize();
  pmenu1->setPropertyV(WSNmenuItemHeight,(WSCushort)24);
  pmenu1->setPropertyV(WSNshadowThickness,(WSCuchar)1);
  pmenu1->setPropertyV(WSNforeColor,col0);
  pmenu1->setPropertyV(WSNbackColor,col1);
  pmenu1->setPropertyV(WSNtopShadowColor,col2);
  pmenu1->setPropertyV(WSNbottomShadowColor,col3);
  pmenu1->setEmboss(True);
  pmenu1->setPropertyV(WSNwidth,(unsigned short)70);
  pmenu1->setPropertyV(WSNheight,(unsigned short)24);
  pmenu1->setPropertyV(WSNmenuItems, "Delete:menu1");

/*
//highlight
    WSCprocedure*  op_pmenu1a = new WSCprocedure("Highlight-ON",11);
    extern void in_ep1(WSCbase*);
    op_pmenu1a->setFunction(in_ep1,"in_ep1");
    pmenu1->addProcedure(op_pmenu1a);
    WSCprocedure* op_pmenu1b = new WSCprocedure("Highlight-OFF",12);
    extern void out_ep1(WSCbase*);
    op_pmenu1b->setFunction(out_ep1,"out_ep1");
    pmenu1->addProcedure(op_pmenu1b);
*/

  pmenu2 = new WSCpopupMenu(NULL,"menu2");
  pmenu2->initialize();
  pmenu2->setPropertyV(WSNmenuItemHeight,(WSCushort)24);
  pmenu2->setPropertyV(WSNshadowThickness,(WSCuchar)1);
  pmenu2->setPropertyV(WSNforeColor,col0);
  pmenu2->setPropertyV(WSNbackColor,col1);
  pmenu2->setPropertyV(WSNtopShadowColor,col2);
  pmenu2->setPropertyV(WSNbottomShadowColor,col3);
  pmenu2->setEmboss(True);
  pmenu2->setPropertyV(WSNwidth,(unsigned short)70);
  pmenu2->setPropertyV(WSNheight,(unsigned short)24);
  if (icopy == 1) {
    pmenu2->setPropertyV(WSNheight,(unsigned short)0);
    pmenu2->setPropertyV(WSNvis,(WSCbool)0);
    pmenu2->setPropertyV(WSNmenuItemHeight,(WSCushort)0);
  }
  pmenu2->setPropertyV(WSNmenuItems, "Copy:menu2");

/*
//highlight
    WSCprocedure*  op_pmenu2a = new WSCprocedure("Highlight-ON",11);
    extern void in_ep1(WSCbase*);
    op_pmenu2a->setFunction(in_ep1,"in_ep1");
    pmenu2->addProcedure(op_pmenu2a);
    WSCprocedure* op_pmenu2b = new WSCprocedure("Highlight-OFF",12);
    extern void out_ep1(WSCbase*);
    op_pmenu2b->setFunction(out_ep1,"out_ep1");
    pmenu2->addProcedure(op_pmenu2b);
*/


  pmenu3 = new WSCpopupMenu(NULL,"menu3");
  pmenu3->initialize();
  pmenu3->setPropertyV(WSNmenuItemHeight,(WSCushort)24);
  pmenu3->setPropertyV(WSNshadowThickness,(WSCuchar)1);
  pmenu3->setPropertyV(WSNforeColor,col0);
  pmenu3->setPropertyV(WSNbackColor,col1);
  pmenu3->setPropertyV(WSNtopShadowColor,col2);
  pmenu3->setPropertyV(WSNbottomShadowColor,col3);
  pmenu3->setEmboss(True);
  pmenu3->setPropertyV(WSNwidth,(unsigned short)70);
  pmenu3->setPropertyV(WSNheight,(unsigned short)24);
  if (icopy == 0) {
    pmenu3->setPropertyV(WSNheight,(unsigned short)0);
    pmenu3->setPropertyV(WSNvis,(WSCbool)0);
    pmenu3->setPropertyV(WSNmenuItemHeight,(WSCushort)0);
  }
  pmenu3->setPropertyV(WSNmenuItems, "Paste:menu3");


//highlight
/*
    WSCprocedure*  op_pmenu3a = new WSCprocedure("Highlight-ON",11);
    extern void in_ep1(WSCbase*);
    op_pmenu3a->setFunction(in_ep1,"in_ep1");
    pmenu3->addProcedure(op_pmenu3a);
    WSCprocedure* op_pmenu3b = new WSCprocedure("Highlight-OFF",12);
    extern void out_ep1(WSCbase*);
    op_pmenu3b->setFunction(out_ep1,"out_ep1");
    pmenu3->addProcedure(op_pmenu3b);
*/


  pmenu4 = new WSCpopupMenu(NULL,"menu4");
  pmenu4->initialize();
  pmenu4->setPropertyV(WSNmenuItemHeight,(WSCushort)24);
  pmenu4->setPropertyV(WSNshadowThickness,(WSCuchar)1);
  pmenu4->setPropertyV(WSNforeColor,col0);
  pmenu4->setPropertyV(WSNbackColor,col1);
  pmenu4->setPropertyV(WSNtopShadowColor,col2);
  pmenu4->setPropertyV(WSNbottomShadowColor,col3);
  pmenu4->setEmboss(True);
  pmenu4->setPropertyV(WSNwidth,(unsigned short)70);
  pmenu4->setPropertyV(WSNheight,(unsigned short)24);
  pmenu4->setPropertyV(WSNmenuItems, "Exit:menu4");

//highlight
/*
    WSCprocedure*  op_pmenu4a = new WSCprocedure("Highlight-ON",11);
    extern void in_ep1(WSCbase*);
    op_pmenu4a->setFunction(in_ep1,"in_ep1");
    pmenu4->addProcedure(op_pmenu4a);
    WSCprocedure* op_pmenu4b = new WSCprocedure("Highlight-OFF",12);
    extern void out_ep1(WSCbase*);
    op_pmenu4b->setFunction(out_ep1,"out_ep1");
    pmenu4->addProcedure(op_pmenu4b);
*/


  WSDmouse* mouse = WSGIappMouse(); 
  short x=0; short y=0;
  mouse->getMousePosition(&x,&y);
  pmenu1->setPropertyV(WSNx,x);
  pmenu1->setPropertyV(WSNy,y);
  pmenu2->setPropertyV(WSNx,x);
  pmenu2->setPropertyV(WSNy,(short)(y+24));
  pmenu3->setPropertyV(WSNx,x);
  pmenu3->setPropertyV(WSNy,(short)(y+48));
  pmenu4->setPropertyV(WSNx,x);
  pmenu4->setPropertyV(WSNy,(short)(y+72));


  if (icopy  == 0) {
  pmenu2->setPropertyV(WSNx,x);
  pmenu2->setPropertyV(WSNy,(short)(y+24));
  pmenu4->setPropertyV(WSNx,x);
  pmenu4->setPropertyV(WSNy,(short)(y+48));
  }



  if (icopy  == 1) {
  pmenu3->setPropertyV(WSNx,x);
  pmenu3->setPropertyV(WSNy,(short)(y+24));
  pmenu4->setPropertyV(WSNx,x);
  pmenu4->setPropertyV(WSNy,(short)(y+48));
 }



// visible
  pmenu1->setPropertyV(WSNvis,(WSCbool)1);
  pmenu2->setPropertyV(WSNvis,(WSCbool)1);
  pmenu3->setPropertyV(WSNvis,(WSCbool)1);
  pmenu4->setPropertyV(WSNvis,(WSCbool)1);


//  WSCprocedure* pmop1 = new WSCprocedure("menu1",WSEV_MOUSE_PRESS);
  WSCprocedure* pmop1 = new WSCprocedure("menu1",WSEV_MOUSE_RELEASE);
  pmop1->setFunction(menu1,"menu1");
  pmenu1->addProcedure(pmop1);
  pmenu1->registerClient(client);


//  WSCprocedure* pmop2 = new WSCprocedure("menu2",WSEV_MOUSE_PRESS);
  WSCprocedure* pmop2 = new WSCprocedure("menu2",WSEV_MOUSE_RELEASE);
  pmop2->setFunction(menu2,"menu2");
  pmenu2->addProcedure(pmop2);
  pmenu2->registerClient(client);

//  WSCprocedure* pmop3 = new WSCprocedure("menu3",WSEV_MOUSE_PRESS);
  WSCprocedure* pmop3 = new WSCprocedure("menu3",WSEV_MOUSE_RELEASE);
  pmop3->setFunction(menu3,"menu3");
  pmenu3->addProcedure(pmop3);
  pmenu3->registerClient(client);

//  WSCprocedure* pmop4 = new WSCprocedure("menu4",WSEV_MOUSE_PRESS);
  WSCprocedure* pmop4 = new WSCprocedure("menu4",WSEV_MOUSE_RELEASE);
  pmop4->setFunction(menu4,"menu3");
  pmenu4->addProcedure(pmop4);
  pmenu4->registerClient(client);



  } else {  

// remove pop-up menu
//  pmenu1->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu2->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu3->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu4->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu1->unregisterClient(client);
//  pmenu2->unregisterClient(client);
//  pmenu3->unregisterClient(client);
//  pmenu4->unregisterClient(client);
   }


}
static WSCfunctionRegister  op("histo_sheet_pop",(void*)histo_sheet_pop);
