// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <WSCstring.h>
#include <SetHisto.h> // initialization of histograms
#include <WSCsheet.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <fstream>
#include <sys/stat.h>
using namespace std;

// installation directory
extern char * RUNDIR;
extern char * PXMDIR;
extern int  CheckWIN32;
extern WSCsheet* newshee_002;

// for convertion 
extern WSCstring float_convert(double number); 

//----------------------------------------------------------
// set item number "number" to histogram spreadsheet at "position"
// put at the end and create new empty entry
//----------------------------------------------------------
void set_histo_spreadsheet( long number, long position ){

// get histograms
  extern SetHisto inihis;

   WSCstring tmp;
   long MaxSpreed=newshee_002->getRowCount();
//   number=number+1; // take into account that first is used line

//    MaxSpreed++; 

// it seems your selected with mouth another position
// do not change max cell number in this case, only replace this cell
//      cout << "DEBUG position=" << position  << endl;
//      cout << "DEBUG number=" << number  << endl;
//      cout << "Item =" << inihis.HistoName[number]  << endl;
//      cout << "DEBUG mouthselect=" << mouthselect  << endl;



    long nextraw=position; // position on spreadsheet
    newshee_002->setPropertyV(WSNrows, position+1);

// make first empty cell
//  newshee_002->setCellLock(1,nextraw,(WSCbool)1);
  newshee_002->setCellBkColor(1,nextraw, "DEF3");
  newshee_002->setCellAlignemnt(1,nextraw,WS_LEFT);
  newshee_002->setCellAlignemnt(2,nextraw,WS_CENTER);
  newshee_002->setCellBkColor(7, nextraw, "#ffffcc");
  newshee_002->setCellAlignemnt(7,nextraw,WS_LEFT);
  newshee_002->setCellAlignemnt(6,nextraw,WS_CENTER);
  newshee_002->setCellAlignemnt(5,nextraw,WS_LEFT);
  newshee_002->setCellAlignemnt(3,nextraw,WS_LEFT);
  newshee_002->setCellAlignemnt(4,nextraw,WS_LEFT);
  newshee_002->setFocusCell(1, nextraw);

// move to strings to clean all of then
    newshee_002->setText(1, nextraw,  inihis.HistoName[number]);
    newshee_002->setText(2, nextraw, (long)inihis.Histo2D[ number]  );
    newshee_002->setText(5, nextraw, (long)inihis.HistoBins[number]  );
    newshee_002->setText(7, nextraw,  inihis.HistoComm[number]);
//    newshee_002->setPropertyV(WSNrows, nextraw);
 
// this is for real numbers
    tmp=float_convert(inihis.HistoMin[number]);
    newshee_002->setText(3, nextraw, (char*)tmp  );
    tmp.clear();
 
// this is for real numbers
    tmp=float_convert(inihis.HistoMax[number]);
    newshee_002->setText(4, nextraw, (char*)tmp  );
    tmp.clear();
 
// this is for real numbers
    tmp = float_convert(inihis.HistoWeight[number]);
    newshee_002->setText(6, nextraw, (char*)tmp  );
    tmp.clear();



}
