// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include <iostream>
#include <WSCdialog.h>
#include <WSClist.h>
#include <WSCstring.h>
#include <SetIni.h> // include class containing MC initializations
using namespace std;

extern WSCdialog* newdial_004;
extern WSClist* newlist_000;
// installation directory
extern char * RUNDIR;
extern char * PXMDIR;
extern int    CheckWIN32;
extern void titels_to_win32();

// for input histograms
int InputCurrent=0;
WSCstring InputTitle[501];
WSCstring InputComme[501];


//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void show_variableGUI(){

  extern SetIni inival;

// first create new file using USER drectory
        WSCstring  px3=PXMDIR;
    
        if (inival.FStype < 6) {    
        if (CheckWIN32 == 1)  titels_to_win32(); // convert to windows format
        if (CheckWIN32 == 0) px3.addString("/main/sys/HistogramTitels.runmc");
        if (CheckWIN32 == 1) px3.addString("/main/sys/HistogramTitelsWin32.runmc");
        }

        if (inival.FStype == 6) {
        px3.addString("/proj/user-name.txt");
        }


        newlist_000->setPropertyV(WSNdataSource,(unsigned char)2);
        newlist_000->setPropertyV(WSNdataSourceName,(char*)px3);

// get title and comments and decomposer
       InputCurrent = newlist_000->getNum();
       WSCstring word[20]; long ww=0;
       WSCstring item;
       for(int j=0; j<InputCurrent; j++){
       item = newlist_000->getItem(j);
       ww=item.getWords();
             for(int ii=0; ii<ww; ii++) {
             if (ii<20) word[ii] = item.getWord(ii); };
       InputTitle[j]=word[0];
       InputTitle[j].delHeadSpace();
       InputTitle[j].delTailSpace();
       long ls=InputTitle[j].getChars();
       item.deleteChars(0,ls+1);
       InputComme[j]=item;
       InputComme[j].delHeadSpace();
       InputComme[j].delTailSpace();
       item.clear();
//       cout << InputTitle[j] << "   " << InputComme[j] << endl;
       }



  newlist_000->update();
  newdial_004->popup();

   
}
