// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
#include <WSCdialog.h>
#include <SetIni.h> // include class containing initializations for M
using namespace std;
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <stdlib.h>
#include <WSCstring.h>
#include <WSCtextField.h> 
#include <WSCmessageDialog.h> 
#include <WSCsheet.h>
#include <WSCpopupMenu.h>

extern WSCpopupMenu*  pmenu1;
extern WSCpopupMenu*  pmenu2;
extern WSCpopupMenu*  pmenu3;
extern WSCpopupMenu*  pmenu4;


extern char * namecard;
extern int MaxParSteer;
extern WSCtextField* stetext_005; 
extern WSCmessageDialog* newmess_002;
extern WSCsheet* steshee_001;
extern WSCdialog* stedial_000;
extern WSCdialog* newdial_004; 

void steer_save(WSCbase* object){
  //do something...


//  cout << "pressed" << endl;
//  pmenu1->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu2->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu3->setPropertyV(WSNvis,(WSCbool)0);
//  pmenu4->setPropertyV(WSNvis,(WSCbool)0);




  WSCdialog* dialog = (WSCdialog*)object->cast("WSCdialog");
  if (dialog ->getStatus() == WS_DIALOG_CANCEL){
//      cout << "cancel" << endl;
      return;
  }
  if (dialog->getStatus() == WS_DIALOG_OK){

//pop the dialog up.
  //wait until the dialog is done.
  newmess_002->setPropertyV(WSNwidth,(unsigned short)350);
  newmess_002->setPropertyV(WSNlabelString,"Do you want to save it?");
  long result = newmess_002->popup();
  if (result == WS_DIALOG_OK){

// open file 
   ofstream mycard(namecard, ios::out | ios::trunc);
   if (!mycard) { cout << "cannot open " << namecard << endl;  return; }
// get string, put comments 
   WSCstring text = stetext_005->getString();
   WSCstring lines[500]; 
   long words = text.getWords("\n"); //3 is returned
// cout << "words="<< words << endl;
    for(int i=0; i < words; i++){
    lines[i] = text.getWord(i,"\n");
    mycard << "* "<< lines[i] << endl;  
    }

// get values
  const int MaxCellSeed=300;
  WSCstring Name[MaxCellSeed];
  WSCstring Ind1[MaxCellSeed]; 
  WSCstring Ind2[MaxCellSeed];  
  WSCstring Value[MaxCellSeed]; 
  WSCstring Comm[MaxCellSeed];
  WSCstring tmp1,tmp2,tmp3,tmp4,tmp5;
  int in1;
  int in2;
  int nn=0; 
  for(int i=2; i <= steshee_001->getRowCount() ; i++){ 
  tmp1=steshee_001->getText(1, i); 
  tmp2=steshee_001->getText(2, i);
  tmp3=steshee_001->getText(3, i);
  tmp4=steshee_001->getText(4, i);
  tmp5=steshee_001->getText(5, i);
  if (tmp1.getChars()>0 && 
      tmp2.getChars()>0 && 
      tmp3.getChars()>0 && 
      tmp4.getChars()>0) {
      Name[nn]=tmp1;
      Ind1[nn]=tmp2;
      Ind2[nn]=tmp3;
      Value[nn]=tmp4;
      Comm[nn]=tmp5;
      in1=atoi((char*)Ind1[nn]); 
      in2=atoi((char*)Ind2[nn]);  
      mycard << " '" << Name[nn] << "'" << "  " << in1 << "  ";
      mycard << in2 << "  " << Value[nn] << "  ! " << Comm[nn] << endl;   
      nn++; 
   }
  } 
  mycard << "* summary:           " << endl;  
  mycard << "* Number of non-zero entries = " << nn << endl;
  mycard << "END$" << endl; 
 
// close file  
   mycard.close(); 
   stedial_000->setPropertyV(WSNvis,(WSCbool)0);
   return;
  }else if (result == WS_DIALOG_NO){  
    //NO button is pressed.
  }else if (result == WS_DIALOG_CANCEL){ 
  //   cout <<"CANCEL" << endl;

  newdial_004->setPropertyV(WSNvis,(WSCbool)0);
  } 


  }

}
static WSCfunctionRegister  op("steer_save",(void*)steer_save);
