// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC;

import java.net.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.text.html.*;


public class AboutDialog extends JDialog{
    private JTabbedPane tabbedPane;
    private JButton closeButton;
    private	JPanel	panel1;
    private	JPanel	panel2;

    public AboutDialog() {

    super( Global.mainFrame );

    setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

   setTitle("About");
   setModal( true );
   setResizable( true );


   // Get the system resolution
   Dimension res = Toolkit.getDefaultToolkit().getScreenSize();

   // make sure the dialog is not too big
   Dimension size = new Dimension(Math.min(600, res.width), Math.min(600, res.height));

   setSize(size);
//   setLocationRelativeTo(parent);

  JPanel topPanel = new JPanel();
  JPanel lowerPanel = new JPanel();
  lowerPanel.setPreferredSize(new Dimension(800, 35));


  closeButton = new JButton();
  closeButton.setText( ResourceLoader.getCommand("menu.file.exit") );
  closeButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
             setVisible(false); dispose();
        }  });

  lowerPanel.add(closeButton, null);
  topPanel.setLayout( new BorderLayout() );
  getContentPane().add( topPanel, java.awt.BorderLayout.CENTER );
  getContentPane().add( lowerPanel, java.awt.BorderLayout.SOUTH );



   tabbedPane = new javax.swing.JTabbedPane();
   // Create the tab pages
	createPage1();
        createPage2();

		// Create a tabbed pane
	tabbedPane = new JTabbedPane();
	tabbedPane.addTab( ResourceLoader.getCommand( "menu.help.about" ), panel1 );
	tabbedPane.addTab( ResourceLoader.getCommand( "menu.help.jslovolicense" ), panel2 );
  //              tabbedPane.addTab("System Information", 
  //                                 new SystemPropertiesPanel());
		topPanel.add( tabbedPane, BorderLayout.CENTER );


// set visible and put on center
     setVisible();
    }




// create about
      public void createPage1() {

      panel1 = new JPanel();
      panel1.setLayout(new BorderLayout());
      JEditorPane epane = new JEditorPane();
      epane.setOpaque( false );
      epane.setContentType( "text/html;charset=ISO-8859-1" );
      epane.setAutoscrolls(true);
      epane.setEditable(false);
      String hstr = ResourceLoader.getCommand( "html.help.about" );
      URL page = ResourceLoader.getResourceURL( "#standards/" + hstr );
     try {
         epane.setPage( page );
      }
      catch ( Exception e )
      {
         System.err.println("Couldn't create URL: " + hstr);
         epane.setContentType( "text/plain" );
      }
       JScrollPane jsp = new JScrollPane(epane);
       panel1.add(jsp);

      }



// create about
      public void createPage2() {

      panel2 = new JPanel();
      panel2.setLayout(new BorderLayout());
      JEditorPane epane = new JEditorPane();
      epane.setOpaque( false );
      epane.setContentType( "text/html;charset=ISO-8859-1" );
      epane.setAutoscrolls(true);
      epane.setEditable(false);
      String hstr = ResourceLoader.getCommand( "html.help.jrunmclicense" );
      URL page = ResourceLoader.getResourceURL( "#standards/" + hstr );
     try {
         epane.setPage( page );
      }
      catch ( Exception e )
      {
         System.err.println("Couldn't create URL: " + hstr);
         epane.setContentType( "text/plain" );
      }
       JScrollPane jsp = new JScrollPane(epane);
       panel2.add(jsp);

      }





// create about
   public void setVisible() {
// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(1.1*w),res.width),
                        Math.min((int)(1.2*h), res.height) );
    this.setSize(size);
    Util.centreWithin( Global.mainFrame, this );

    show();
   }


}
