// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

class EditorCards 
                extends         JFrame
 {


    private JPanel contentPane;
    private JPanel jPanel1;
    private JButton jB1;
    private JButton jB2;
    private JButton jB3;
    private JButton jB4;
    private FlowLayout flowLayout1;
    private JSplitPane jSplitPane1;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    private JTextArea jT1;
    private JTable   jTab1;
    private MyTableModel model;
    private BorderLayout borderLayout1;
 
    private String par;  
    private String index1; 
    private String index2;
    private String value; 
    private String commen; 
       
        // Instance attributes used in this dialog
        public EditorCards(String cname, String status )  {

         setDefaultCloseOperation( DISPOSE_ON_CLOSE ); 
         jPanel1 = new JPanel();
         jB1 = new JButton();
         jB2 = new JButton();
         jB3 = new JButton();
         jB4 = new JButton(); 
         flowLayout1 = new FlowLayout();
         jSplitPane1 = new JSplitPane();
         jScrollPane1 = new JScrollPane();
         jScrollPane2 = new JScrollPane();
         borderLayout1 = new BorderLayout();

          
        contentPane = (JPanel)getContentPane();
        setDefaultCloseOperation( DISPOSE_ON_CLOSE );
        setTitle( "Steering card editor");
        contentPane.setLayout(borderLayout1);
        setSize(new Dimension(520, 340));
        contentPane.setPreferredSize(new Dimension(500, 335));

// menu bar
         JMenuBar jMenuBar1 = new JMenuBar();
         JMenu jMenuExit = new JMenu();
         JMenu jMenuOpt = new JMenu();
         JMenuItem jExit1 = new JMenuItem();
         JMenuItem jMenuFonts = new JMenuItem();
         JMenuItem jMenuBack = new JMenuItem();
         JMenuItem jMenuForg = new JMenuItem();
         jMenuExit.setText("File");
         jExit1.setText("Exit");
         jMenuOpt.setText("Options");
         jMenuFonts.setText("Fonts");
         jMenuBack.setText("Background color");
         jMenuForg.setText("Foreground color");
         jMenuBar1.add(jMenuExit);
         jMenuBar1.add(jMenuOpt);
         jMenuOpt.add(jMenuBack);
         jMenuOpt.add(jMenuForg);
         jMenuOpt.add(jMenuFonts);
         jMenuExit.add(jExit1);
         setJMenuBar(jMenuBar1);
         // exit 
         jExit1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit Editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
           SetIni.ShowStatus="Last action: Exit Editor";
           setVisible(false); dispose();}
        }  });




        jPanel1.setLayout(flowLayout1);
        jPanel1.setPreferredSize(new Dimension(500, 35));
        jPanel1.setToolTipText("");
        jB1.setText("Save");
        
        jB1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Save Settings?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {   
                 try { SaveCard();
                       SetIni.ShowStatus="Last action: saving initial parameters";
                } catch (Exception e) {
                  System.out.println("Error when saving file..");
                  // show error
                  JOptionPane dialog = new JOptionPane();
                  dialog.showMessageDialog(dialog, "Cannot save steering card",
                  "Error", JOptionPane.ERROR_MESSAGE ); } 
           }
         }  });

         // comments
         jT1 = new JTextArea();
         jT1.setFont(SetEnv.FontBold);
         jT1.setEditable(true);
        
        jB2.setText("Exit");
        jB2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit Editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { 
           SetIni.ShowStatus="Last action: Exit Editor";  
           setVisible(false); dispose();}
        }  });


        // jT1.setText("");
        jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setDividerLocation(100);
        
        
        
// Create a new table instance
       model = new MyTableModel();
       jTab1 = new JTable( model ); 
       model.addColumn("No");
       model.addColumn("Parameter");
       model.addColumn("Index I");
       model.addColumn("Index II");
       model.addColumn("Value");
       model.addColumn("Comments");

    jMenuBack.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Color color = JColorChooser.showDialog(contentPane,"Background Color",jTab1.getBackground());
    if (color != null) {
      jTab1.setBackground(color);
    }
    //repaints menu after item is selected
    contentPane.repaint();
     }  });

    jMenuForg.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Color color = JColorChooser.showDialog(contentPane,"Foreground Color",jTab1.getForeground());
    if (color != null) {
      jTab1.setForeground(color);
    }
    //repaints menu after item is selected
    contentPane.repaint();
     }  });


   jMenuFonts.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Font f = FontChooser.showDialog(EditorCards.this,
                                    "Choose font",
                                    jTab1.getFont());
    if (f != null) {
    jTab1.setFont(f);
    }
    contentPane.repaint();
     }  });











// add rows dynamically 
        jB3.setText("add new row");
        jB3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
         int nn=model.getRowCount()+1;
         model.addRow( 
                new Object[]{new Integer(nn),new String(" "), new Integer(0),
                new Integer(0), new String(" "), new String(" ")});
                jTab1.setRowHeight(20);
                jTab1.repaint(); 
         }  });

// remove rows
        jB4.setText("remove selected");
        jB4.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
                  removeSelected();
        }  });



// channge size  
          TableColumn column = null;
          column = jTab1.getColumnModel().getColumn(0);
          column.setPreferredWidth(35);
          column.setMinWidth(20);
          column.setMaxWidth(50);  
          column = jTab1.getColumnModel().getColumn(1);
          column.setPreferredWidth(80);
          column.setMinWidth(60);
          column.setMaxWidth(120);
          column = jTab1.getColumnModel().getColumn(2);
          column.setPreferredWidth(50);
          column.setMinWidth(30);
          column.setMaxWidth(80);
          column = jTab1.getColumnModel().getColumn(3);
          column.setPreferredWidth(50);
          column.setMinWidth(30);
          column.setMaxWidth(80);         
          column = jTab1.getColumnModel().getColumn(4);
          column.setPreferredWidth(80);
          column.setMinWidth(60);
          column.setMaxWidth(120); 
          column = jTab1.getColumnModel().getColumn(5);
          column.setPreferredWidth(200);
          column.setMinWidth(100);
          column.setMaxWidth(800);              
          
           if(status.equals("old"))  try { FilljTab1(cname);
               } catch (Exception e) {
                  System.out.println("Error in file openning");
                  // show error
                  JOptionPane dialog = new JOptionPane();
                  dialog.showMessageDialog(dialog, "Cannot read "+cname,
                  "Error", JOptionPane.ERROR_MESSAGE ); }
           
        
        jTab1.setMaximumSize(new Dimension(8000, 1000));
        jTab1.setMinimumSize(new Dimension(100, 10));
      //  jTab1.setPreferredSize(new Dimension(380, 270));
        jTab1.setFont(SetEnv.FontBold);
        jTab1.setShowHorizontalLines( true );
        jTab1.setRowSelectionAllowed( true );
        jTab1.setColumnSelectionAllowed( true );
        // Change the selection colour
        // jTab1.setSelectionForeground( Color.white );
        //jTab1.setSelectionBackground( Color.red );

        
        
        jPanel1.add(jB1, null);
        jPanel1.add(jB2, null);
        jPanel1.add(jB3, null);
        jPanel1.add(jB4, null);
     //   jPanel1.add(jB5, null);
        jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
        jScrollPane1.getViewport().add(jT1);
        jSplitPane1.add(jScrollPane2, JSplitPane.RIGHT);
        contentPane.add(jSplitPane1, java.awt.BorderLayout.CENTER);
        contentPane.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jScrollPane2.getViewport().add(jTab1);
        
           
        }   
          
       
// save your numbers
       public void SaveCard() throws Exception {  

         // System.out.print("create new");
         String S1=SetIni.card[SetIni.MCtype];
         jTab1.clearSelection();
         int Ierr=1;
         int nn=0; double dd=0.0;


          boolean Create=false;
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Create or update "+S1+"?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { Create=true; }

         if (Create && model.getRowCount()>0) { 
 
        // check settings
         for (int i=0;i<model.getRowCount();i++) {
          Object tmp1=model.getValueAt(i,1);
          Object tmp2=model.getValueAt(i,2);
          Object tmp3=model.getValueAt(i,3);
          Object tmp4=model.getValueAt(i,4);
          Object tmp5=model.getValueAt(i,5);
          String tmp=(String)tmp4;
         //  System.out.println(tmp+" "+ idot); 
  
        try { nn=Integer.parseInt(tmp); Ierr=0;} 
        catch (NumberFormatException e) { Ierr=1;};

         // double numbr
        try { dd=Double.parseDouble(tmp); Ierr=0;}
        catch (NumberFormatException e) { Ierr=1;};  

        } // end loop

         if (Ierr>0) { 
         // System.out.println("Error in reading integer from "+s);
         JOptionPane dialogError = new JOptionPane();
         dialogError.showMessageDialog(dialogError,"Error in reading line "+Ierr,"Error",
         JOptionPane.ERROR_MESSAGE);
         Ierr=0;
         }



         // System.out.print("create new");
         String scom=jT1.getText();
         String[] words = scom.split ("\n");
         String[] sword; sword = new String[100]; // max number of words
         
         FileOutputStream f1 = new  FileOutputStream (S1);
         PrintStream tx = new PrintStream(f1);
        
          for (int i=0;i<words.length;i++) {
          words[i]=words[i].trim();
          if (words[i].length()>1) tx.print("* "+words[i]+"\n");
          }
         
     //   System.out.println("number of rows= "+model.getRowCount()); 
       // get all objects    
       for (int i=0;i<model.getRowCount();i++) {          
          Object tmp1=model.getValueAt(i,1);
          Object tmp2=model.getValueAt(i,2);
          Object tmp3=model.getValueAt(i,3);
          Object tmp4=model.getValueAt(i,4);
          Object tmp5=model.getValueAt(i,5);
          String ss1=(String)tmp1;
          ss1.trim();
          String ss2=(String)tmp5;
          ss2.trim();
          tx.print(" '"+ss1+"'  "+tmp2+"  "+tmp3+"  "+tmp4);; 
          tx.println("  ! "+ss2); 
       } // end loop
          tx.println("END$");
          f1.close();

          } // end create question 

       
       };





// fill table from th file 
  public void  FilljTab1(String Sname)  throws Exception {
   
      int Nc=0; 
      FileReader inFC = new FileReader(Sname);
      BufferedReader brc = new BufferedReader(inFC);
      String s; String scomment="";  int rows=0;
      int ntot=0;
      while (( s=brc.readLine())!= null) {
        s=s.trim();  // System.out.println(s);
        if (s.startsWith("*")) {
         String stmp1 = s.substring(1,s.length());
         s=s.trim();
         if(stmp1.length()>1) scomment= scomment+stmp1+"\n"; 
         rows++;
        } else {
         // System.out.println(s);
          // trim, take non empty strings
          String[] words = s.split (" ");
          String[] sword; sword = new String[100]; // max number of words
          int n=0;
          for (int i=0;i<words.length;i++) {
             words[i]=words[i].trim();
             if (words[i].length()>0) {
               sword[n]=words[i];
              // System.out.println(sword[n]);
               n++;  }  };
          
         
          if (n>3){
          String ss=""; 
          String stmp = sword[0].substring(1,sword[0].length()-1);
          
          if (stmp.length()>0 && 
              sword[0].startsWith("'") && 
              sword[0].endsWith("'")   )  {
          par=stmp; 
          index1=sword[1];
          index2=sword[2];
          value=sword[3];
          if (sword[4].startsWith("!")) for (int j=5;j<n;j++) ss=ss+sword[j]+" ";
          commen=ss;
          // add row
          int in1=Utility.GetInt(index1); 
          int in2=Utility.GetInt(index2); 
          Nc++; 
          model.addRow(new Object[]{new Integer(Nc),new String(par), new Integer(in1),
                new Integer(in1), new String(value), new String(commen)});
          jTab1.setRowHeight(20); 

          } }
          
        } // end if 
        
        
        } // end while  
       inFC.close();     
   
      jT1.setText(scomment);
    
  } // end function


   /**
     * Removes item from the table.
     */
    public void removeSelected()
    {


            int selectedMin=jTab1.getSelectedRow();
            int selectedN=jTab1.getSelectedRowCount(); 
            int selectedMax=selectedMin+selectedN;
            int totalCounts=model.getRowCount();
 
            int ntot=0;
           // System.out.println(selectedMin+ " " + selectedMax+ " "+totalCounts);

 
            Object tmp1,tmp2,tmp3,tmp4,tmp5;
            for (int i=0;i<totalCounts; i++) {
            tmp1=jTab1.getValueAt(i, 1);
            tmp2=jTab1.getValueAt(i, 2);
            tmp3=jTab1.getValueAt(i, 3);
            tmp4=jTab1.getValueAt(i, 4);
            tmp5=jTab1.getValueAt(i, 5);
             if (i>=selectedMin && i<selectedMax) {
             //  model.removeRow(i);
             } else {
              ntot++;
              model.addRow(new Object[]{new Integer(ntot),tmp1,tmp2,tmp3,tmp4,tmp5});
             }

           };

             //   examples 
             //   model.removeRow(0);
             //   model.removeRow(model.getRowCount()-1);
             // removeLast(jTab1.getSelectedRowCount()); 
                removeFirst(totalCounts-1); 

    }




    /**
     * Removes all items from the table.
     */
    public void removeAll()
    {
        while(model.getRowCount() > 0)
            model.removeRow(0);
    }


    /**
     * Removes first Nmin entries.
     */

    public void removeFirst(int Nmin)
    {
        for (int i=0;i<=Nmin; i++) model.removeRow(0); 
           
     //  while(model.getRowCount()>model.getRowCount()-Nmin)
      //      model.removeRow(model.getRowCount(0));
    }



} // end class

