// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.math.*;
import java.lang.*;

class EditorHisto 
                extends         JFrame
 {


    public int  Nvariable=0;     // current number of variables 
    public Vector  listData;    // with variables                              
    public Vector  HVariables;  // with variables   
    public Vector  HComments;   // with variables   
    public static  int Hcurrent=0; // current position in table when inset
    public DefaultListModel variableModel;
    private JPanel contentPane;
    private JPanel jPanel1;
    public  JButton jHB1;
    public  JButton jHB2;
    public  JButton jHB3;
    private FlowLayout flowLayout1;
    private JSplitPane jSplitPane1;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    public  JList jHlist;
    public  DefaultListModel HlistModel;
    public  JTable    jHTab1;
    private BorderLayout borderLayout1;
    private MyTableModel model;
  
       
        // Instance attributes used in this dialog
        public EditorHisto()  {

         setDefaultCloseOperation( DISPOSE_ON_CLOSE ); 
         jPanel1 = new JPanel();
         jHB1 = new JButton();
         jHB2 = new JButton();
         jHB3 = new JButton();
         flowLayout1 = new FlowLayout();
         jSplitPane1 = new JSplitPane();
         jScrollPane1 = new JScrollPane();
         jScrollPane2 = new JScrollPane();
         borderLayout1 = new BorderLayout();
          
                  
        contentPane = (JPanel)getContentPane();
        setDefaultCloseOperation( DISPOSE_ON_CLOSE );
        setTitle( "Variables and Histogram editor");
        contentPane.setLayout(borderLayout1);
        setSize(new Dimension(820, 340));
        contentPane.setPreferredSize(new Dimension(800, 335));
        jPanel1.setLayout(flowLayout1);
        jPanel1.setPreferredSize(new Dimension(800, 35));
        jPanel1.setToolTipText("");
        jHB1.setText("Save");
// save histograms in Histogram editor
        jHB1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Save Settings?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
          if (ask == JOptionPane.YES_OPTION) {
                    // System.out.print("Something is wrong");
                    boolean doCheck=true; // save with checking
                    SaveHistograms(doCheck);
                    setMessage(); 
                    SetIni.ShowStatus="Last action: histograms saved";
          }
         }  });

 
        
         
    // Create the data model for this example
    variableModel = new DefaultListModel();
    listData = new Vector();
    HVariables = new Vector();
    HComments = new Vector();
    jHlist = new JList(variableModel);
    jHlist.setCellRenderer( new HistoCellRenderer() );
    jHlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jHlist.setSelectedIndex(0);
    jHlist.setVisibleRowCount(30);
    jHlist.setFont(SetEnv.FontBold);
    jHlist.addListSelectionListener(new ValueReporter());
         
// Create a new table instance
       model = new MyTableModel();
       jHTab1 = new JTable( model );
       model.addColumn("No");
       model.addColumn("Title");
       model.addColumn("D");
       model.addColumn("Min");
       model.addColumn("Max");
       model.addColumn("Bins");
       model.addColumn("W");
       model.addColumn("Comments");



// menu bar
         JMenuBar jMenuBar1 = new JMenuBar();
         JMenu jMenuExit = new JMenu();
         JMenu jMenuOpt = new JMenu();
         JMenuItem jExit1 = new JMenuItem();
         JMenuItem jMenuFonts = new JMenuItem();
         JMenuItem jMenuBack = new JMenuItem();
         JMenuItem jMenuForg = new JMenuItem();
         jMenuExit.setText("File");
         jExit1.setText("Exit");
         jMenuOpt.setText("Options");
         jMenuFonts.setText("Fonts");
         jMenuBack.setText("Background color");
         jMenuForg.setText("Foreground color");
         jMenuBar1.add(jMenuExit);
         jMenuBar1.add(jMenuOpt);
         jMenuOpt.add(jMenuBack);
         jMenuOpt.add(jMenuForg);
         jMenuOpt.add(jMenuFonts);
         jMenuExit.add(jExit1);
         setJMenuBar(jMenuBar1);



         // exit
         jExit1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit histogram editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
           SetIni.ShowStatus="Last action: Histogram editor is closed";
           setVisible(false); dispose();}
        }  });

    jMenuBack.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Color color = JColorChooser.showDialog(contentPane,"Background Color",jHTab1.getBackground());
    if (color != null) {
      jHTab1.setBackground(color);
    }
    //repaints menu after item is selected
    contentPane.repaint();
     }  });

    jMenuForg.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Color color = JColorChooser.showDialog(contentPane,"Foreground Color",jHTab1.getForeground());
    if (color != null) {
      jHTab1.setForeground(color);
    }
    //repaints menu after item is selected
    contentPane.repaint();
     }  });


// setting fonts
   jMenuFonts.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
   Font f = FontChooser.showDialog(EditorHisto.this,
                                    "Choose font",
                                    jHTab1.getFont());
    if (f != null) {
    jHTab1.setFont(f);
    }
    contentPane.repaint();
    }  });
        


        jHB2.setText("Exit");
        jHB2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, 
          "Exit histogram editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {   
             SetIni.ShowStatus="Last action: Histogram editor is closed";
             setVisible(false); // dispose();
             }
        }  });

        

        
        // jT1.setText("");
        jSplitPane1.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setDividerLocation(300);
        
        
// channge size  
          TableColumn column = null;
          column = jHTab1.getColumnModel().getColumn(0);
          column.setPreferredWidth(50); 
          column.setMinWidth(15);
          column.setMaxWidth(70);
          column = jHTab1.getColumnModel().getColumn(1);
          column.setPreferredWidth(200);
          column.setMinWidth(80);
          column.setMaxWidth(400);
          column = jHTab1.getColumnModel().getColumn(2);
          column.setPreferredWidth(20);
          column.setMinWidth(15);
          column.setMaxWidth(35);
          column = jHTab1.getColumnModel().getColumn(3);
          column.setPreferredWidth(70);
          column.setMinWidth(40);
          column.setMaxWidth(100);
          column = jHTab1.getColumnModel().getColumn(4);
          column.setPreferredWidth(70);
          column.setMinWidth(40);
          column.setMaxWidth(100);          
          column = jHTab1.getColumnModel().getColumn(5);
          column.setPreferredWidth(60);
          column.setMinWidth(40);
          column.setMaxWidth(100);    
          column = jHTab1.getColumnModel().getColumn(6);
          column.setPreferredWidth(40); 
          column.setMinWidth(20);
          column.setMaxWidth(50);
          column = jHTab1.getColumnModel().getColumn(7);
          column.setPreferredWidth(300); 
          column.setMinWidth(100);
          column.setMaxWidth(800);
        jHTab1.getTableHeader().setToolTipText(
        "Specify dimension, Min, Max values, the bin width, weight for histograms");
          
                        
          
        jHTab1.setMaximumSize(new Dimension(8000, 1000));
        jHTab1.setMinimumSize(new Dimension(100, 10));
        jHTab1.setFont(SetEnv.FontBold);
        jHTab1.setShowHorizontalLines( true );
        jHTab1.setRowSelectionAllowed( true );
        jHTab1.setColumnSelectionAllowed( true );

   
        
        
        jHB3.setText("remove selected");
        jHB3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog3 = new JOptionPane();
          int ask=dialog3.showConfirmDialog(dialog3, "remove selected items?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { 
                  removeSelected();
            jScrollPane2.revalidate();
            jScrollPane2.repaint(); 
            }         
        }  });
        

        jPanel1.add(jHB1, null);
        jPanel1.add(jHB2, null);
        jPanel1.add(jHB3, null);
        jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
        jScrollPane1.getViewport().add(jHlist);
        jSplitPane1.add(jScrollPane2, JSplitPane.RIGHT);
        contentPane.add(jSplitPane1, java.awt.BorderLayout.CENTER);
        contentPane.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jScrollPane2.getViewport().add(jHTab1);
        
           
        }   
          
// set variables from the file 
        public void SetVariables()  { 
         

          // clean first 
          HVariables.clear();
          HComments.clear();
          listData.clear();

 
          try {
          FileReader inF = new FileReader(SetEnv.RUNDIR+"/main/sys/HistogramTitels.runmc");
          BufferedReader br = new BufferedReader(inF);
          String s; String s1; int icoma;   
          String[] sword; sword = new String[100];
          while (( s=br.readLine())!= null) { 
          s=s.trim();
          icoma=s.indexOf(",")+1;
          if (s.length()>5 && icoma>4) {
          s1=s.substring(icoma, s.length());
          
          // make nice formatting
          // find first space
          icoma=s1.indexOf(" ")+1;
          String var1=s1.substring(0,icoma);
          String com1=s1.substring(icoma,s1.length());
          com1=com1.trim(); // trim
          var1=var1.trim();
          HVariables.addElement( var1 );
          HComments.addElement( com1 );
         //System.out.println(var1);
         // System.out.println(com1);
          
           int ispace=20-var1.length();
           // System.out.println(ispace);
           
           String space="_";
           for (int i=0;i<ispace;i++) space=space+"_";
           String newitem=var1+space+com1;
           // String newitem=var1+"   "+com1;
           // System.out.println(ispace);
           
           listData.addElement( newitem );
           Nvariable++;
          // System.out.println(s1);
          }
          }
          inF.close(); 
          }catch (IOException et) {System.out.println("Error in HistogramTitels.runmc");}
         
          // set and repaint
          jHlist.setListData( listData );
//          jSplitPane1.revalidate();
          jSplitPane1.repaint();     
        
        }  
          
    
        // set variables from the file 
        public void SaveHistograms(boolean DoCheck)  {
        //DoCheck=true - check the settings
        //DoCheck=false - just save without checking  
   
        int hmax=jHTab1.getRowCount();
        int nn=0;
 
         for (int i=0;i<hmax;i++) {
            Object tmp1=jHTab1.getValueAt(i, 1);
            Object tmp2=jHTab1.getValueAt(i, 2);  
            Object tmp3=jHTab1.getValueAt(i, 3);
            Object tmp4=jHTab1.getValueAt(i, 4);
            Object tmp5=jHTab1.getValueAt(i, 5);
            Object tmp6=jHTab1.getValueAt(i, 6);
            Object tmp7=jHTab1.getValueAt(i, 7);
           
            if (tmp1 != null &&
                tmp2 != null &&
                tmp3 != null &&
                tmp4 != null  ) {
             //   System.out.println("Saving this histogram= "+(String)tmp1);
                SetIni.HistoName[nn]=(String)tmp1;
                SetIni.Histo2D[nn]=Utility.GetInt(tmp2.toString());
                SetIni.HistoMin[nn]=Utility.GetDouble(tmp3.toString());
                SetIni.HistoMax[nn]=Utility.GetDouble(tmp4.toString());
                SetIni.HistoBins[nn]=Utility.GetInt(tmp5.toString());
                SetIni.HistoWeight[nn]=Utility.GetDouble(tmp6.toString());
                SetIni.HistoComm[nn]=(String)tmp7;
                SetIni.HistoType[nn]=nn+1;
                nn++;
             }  
                }
       
     SetIni.HistoN=nn;
     if (nn == 0) SetIni.HistoN=0; 
   
    if (DoCheck) { // check  
   // make checks.........................     
    String ierr_mess="none";
    int ierr=0;
    
     // check histograms
    for  (int i=1; i<=SetIni.HistoN; i++ ) {
    if (SetIni.HistoType[i]  > 0 ) {
    if (SetIni.HistoMax[i] <=SetIni.HistoMin[i]) { 
    ierr=1; ierr_mess = "Histogram MIN value is \n larger than MAX value"; };
    if (SetIni.HistoBins[i]<=0) { ierr=1; ierr_mess = "Number of bins is wrong !"; };
    }; };
   
        
   // check histograms
// first 2
    if (SetIni.Histo2D[1] == 2 && SetIni.Histo2D[2] == 2) {
    for  (int i=1; i<=2; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
    ierr=1; ierr_mess = "Error in 2D histogram definition (No 1)"; }; }; };
// second  2
    if (SetIni.Histo2D[3] == 2 && SetIni.Histo2D[4] == 2) {
    for  (int i=3; i<=4; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 2)"; }; }; };
// third  2
    if (SetIni.Histo2D[5] == 2 && SetIni.Histo2D[6] == 2) {
    for  (int i=5; i<=6; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 3)"; }; }; };
// forth  2
    if (SetIni.Histo2D[7] == 2 && SetIni.Histo2D[8] == 2) {
    for  (int i=7; i<=8; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 4)"; }; }; };

// show error message    
        if (ierr>0) {  
        JOptionPane dialog2 = new JOptionPane();
        dialog2.showMessageDialog(dialog2, ierr_mess,
        "Error", JOptionPane.ERROR_MESSAGE ); } 
   } // of of the check   
    
    
    
   } // end save histograms
 
    
        
  // set variables from the file 
        public void LoadHistograms()  {
           
        //int hmax=jHTab1.getRowCount();
         //System.out.println(SetIni.HistoN);
          
         for (int i=0;i<SetIni.HistoN;i++) {

          model.addRow(new Object[]{new Integer(i+1),
                                    new String(SetIni.HistoName[i]),
                                    new Integer(SetIni.Histo2D[i]),
                                    new Double(SetIni.HistoMin[i]),
                                    new Double(SetIni.HistoMax[i]),
                                    new Integer(SetIni.HistoBins[i]),
                                    new Double(SetIni.HistoWeight[i]),
                                    new String(" "+SetIni.HistoComm[i]) });

            // jHTab1.fireTableRowsInserted;
            // System.out.println(SetIni.HistoComm[i]);  
         }  
               
          jScrollPane2.revalidate();
          jScrollPane2.repaint(); 
         
        }
          
        
        
       
        
      public class ValueReporter implements ListSelectionListener {
      public void valueChanged(ListSelectionEvent event) {
      if (!event.getValueIsAdjusting() &&
          jHlist.getSelectedIndex()>=0 && 
          jHlist.getSelectedIndex()<=HVariables.size() ) {
          
          int  index=jHlist.getSelectedIndex();
          Object tmp1=HVariables.elementAt(index);
          String s1=(String)tmp1;
          Object tmp2=HComments.elementAt(index);
          String s2=(String)tmp2;
          
          int hmax=jHTab1.getRowCount();
          int ncurrent=0;
           
          
          for (int i=0;i<hmax;i++) {
            Object tmp0=jHTab1.getValueAt(i, 1);
            if (tmp0 != null) ncurrent++;
          }
          
          // start with current value
          Hcurrent=ncurrent;
          
         // jHTab1.addRowSelectionInterval(0,1); 
          model.addRow(new Object[]{new Integer(Hcurrent+1),
                                    new String(s1), 
                                    new Integer(1),
                                    new Double(0.0),
                                    new Double(1.0),
                                    new Integer(10),  
                                    new Double(1),
                                    new String(" "+s2) }); 
          jHTab1.setRowHeight(20);
          Hcurrent++;
          // refrash
          jScrollPane2.revalidate();
          jScrollPane2.repaint(); 
      }  } }
  





   /**
     * Removes item from the table.
     */
    public void removeSelected()
    {
            int selectedMin=jHTab1.getSelectedRow();
            int selectedN=jHTab1.getSelectedRowCount();
            int selectedMax=selectedMin+selectedN;
            int totalCounts=model.getRowCount();
            int ntot=0;
            // System.out.println(selectedMin+ " " + selectedMax+ " "+totalCounts);

            Object tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7,tmp8;
            for (int i=0;i<totalCounts; i++) {
            tmp1=jHTab1.getValueAt(i, 1);
            tmp2=jHTab1.getValueAt(i, 2);
            tmp3=jHTab1.getValueAt(i, 3);
            tmp4=jHTab1.getValueAt(i, 4);
            tmp5=jHTab1.getValueAt(i, 5);
            tmp6=jHTab1.getValueAt(i, 6);
            tmp7=jHTab1.getValueAt(i, 7);
             if (i>=selectedMin && i<selectedMax) {
             //  model.removeRow(i);
             } else {
              ntot++;
              model.addRow(new Object[]{new Integer(ntot),tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7});
             }

           };

             //   examples
             //   model.removeRow(0);
             //   model.removeRow(model.getRowCount()-1);
             // removeLast(jTab1.getSelectedRowCount());
                removeFirst(totalCounts-1);

    }

 
          
 /**
     * Removes all items from the table.
     */
    public void removeAll()
    {
        while(model.getRowCount() > 0)
            model.removeRow(0);
    }


    /**
     * Removes first Nmin entries.
     */

    public void removeFirst(int Nmin)
    {
        for (int i=0;i<=Nmin; i++) model.removeRow(0);

     //  while(model.getRowCount()>model.getRowCount()-Nmin)
      //      model.removeRow(model.getRowCount(0));
    }

// store message 
     private void setMessage()  {
          SetIni.ShowHistoN=Integer.toString(SetIni.HistoN)+" histograms";
     } 
          
          
} // end class






 // change defaults for JList
class HistoCellRenderer
 extends  JLabel
 implements ListCellRenderer 
{
 private ImageIcon image[];
  
 final static ImageIcon longIcon = new ImageIcon("long.gif");
 final static ImageIcon shortIcon = new ImageIcon("short.gif");
  
 

 public HistoCellRenderer()
 {
  setOpaque(true);

 
  /*
  // Pre-load the graphics images to save time
  image = new ImageIcon[4];
  image[0] = new ImageIcon( "circles.gif" );
  image[1] = new ImageIcon( "bubbles.gif" );
  image[2] = new ImageIcon( "thatch.gif" );
  image[3] = new ImageIcon( "pinstripe.gif" );
 
 */
 }
  
  
 public Component getListCellRendererComponent(
   JList list, Object value, int index, 
   boolean isSelected, boolean cellHasFocus )
   
 
 {
  // Display the text for this item
  
   
   
  String s = value.toString();
         setText(s);
         setIcon((s.length() > 10) ? longIcon : shortIcon);
  
  
  // Draw the correct colors and font
  if( isSelected )
  {
   // Set the color and font for a selected item
   setBackground( Color.blue );
   setForeground( Color.white );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }
  else
  {
   // Set the color and font for an unselected item
   setBackground( Color.white );
   setForeground( Color.black );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }

  return this;
 }





}

