// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *

package JRunMC;


import java.awt.Frame;
import java.awt.Toolkit;
import java.net.URL;
import java.util.*;
import java.lang.*;
import java.io.*;


public class Main{


    protected static SplashScreen splashScreen;
    private static int countCallsToAdvance = 0;
    private static int splashProgressLength = 7;
    private static long lastSplashAdvanceTime = System.currentTimeMillis();
    private static long splashAdvanceTimeDiff = 0;

    public static void main(String[] args) {


        // Read the image data and open the splash screen
        // ----------------------------------------------
            try {
            splashScreen = new SplashScreen( Options.getOption("jrunmc.version")  );
            splashScreen.setProgressLength(splashProgressLength);
            } catch (Exception e) {
            //if an error gets here, we want to know about it.
            System.out.println("Error to get splash screen");
            e.printStackTrace();
            System.exit(0);
            }


            splashScreenAdvance();


// initialisation of Global parameters 
         SetEnv.init(); 
            splashScreenAdvance();

// initialisation of available MC models
         SetMC.init();
            splashScreenAdvance();

// initialisation of Global parameters
         SetIni.init();
            splashScreenAdvance();

// initialisation of Global GUI components 
         Global.init();
            splashScreenAdvance();


// read options
        Options.init();
           splashScreenAdvance();
  
        ResourceLoader.init( "JRunMC/resources/");
           splashScreenAdvance();

// start apllication
       int w=Options.getIntOption( "frame.width" );
       int h=Options.getIntOption( "frame.height" );


//     for (int i = 0; i < args.length; i++)
      String nn="none";
      if (args.length == 0) Global.mainFrame = new JRunMC(nn);
      if (args.length > 0) Global.mainFrame = new JRunMC(args[0]);

       splashScreen.dispose();
//       nstart.setSize(w,h);
//       nstart.setVisible(true);

  }


  public static void splashScreenAdvance() {
        countCallsToAdvance++;
        splashScreen.advance();

        //TODO: improve the progress bars divisions.
        //debugging which calls to advance need more advance calls in their lower objects
        //so far, setLookAndFeel and SDMFrame take the longest
        if ((System.currentTimeMillis() - lastSplashAdvanceTime) > splashAdvanceTimeDiff) {
            //Log.out("Advance Splash progress for # " + countCallsToAdvance + " : time = " + lastSplashAdvanceTime);
            splashAdvanceTimeDiff = System.currentTimeMillis() - lastSplashAdvanceTime;
        }

        lastSplashAdvanceTime = System.currentTimeMillis();
    }






}
