// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.util.Hashtable;

 public class Tab6 extends JPanel {
     
    public JSlider Srenice;
    static final int FPS_MIN = 0;
    static final int FPS_MAX = 20;
    static final int FPS_INIT = 0;    //initial frames per second
   
    public JButton  bcancel;
    public JButton  blog;
    public JButton  hview;
    public JButton  edproc; 
     
    
    
    
    
    public Tab6() {
    this.setPreferredSize(new java.awt.Dimension(500, 250));
    this.setMinimumSize(new java.awt.Dimension(50, 50)); 
    
   
     Srenice= new JSlider(JSlider.HORIZONTAL,
                                      FPS_MIN, FPS_MAX, FPS_INIT);
    
    
    //Turn on labels at major tick marks.
    Srenice.setMajorTickSpacing(10);
    Srenice.setMinorTickSpacing(1);
    Srenice.setPaintTicks(true);
    Srenice.setPaintLabels(true);
    
    //Create the label table
     Hashtable labelTable = new Hashtable();
     labelTable.put( new Integer( 0 ), new JLabel("renice=0") ); 
     labelTable.put( new Integer( FPS_MAX/2 ), new JLabel("10") );
     labelTable.put( new Integer( FPS_MAX ), new JLabel("20") );
     Srenice.setLabelTable( labelTable );
     Srenice.setPaintLabels(true);
     Srenice.setValue(10); 
     this.add(Srenice);
     Srenice.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
            JSlider source = (JSlider)evt.getSource();
            if (!source.getValueIsAdjusting()) {
             SetIni.Renice = (int)source.getValue();
            } }  });


 
   
     hview = new JButton("Histogram viewer");
     hview.setToolTipText("To look at histograms, click here");
     hview.setFont(SetEnv.FontBold);
     hview.setPreferredSize(new java.awt.Dimension(200, 25));
     hview.setMinimumSize(new java.awt.Dimension(40, 10));
     this.add(hview);
     hview.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
                String sh = "bash"; String cop = "-c";
                String cmd = SetEnv.RUNDIR+"/bin/histoview "+SetIni.MOutput+".root &";
                String[] exe0 = new String[] {sh, cop, cmd};
                try { Process p = Runtime.getRuntime().exec(exe0);
                } catch (Exception err) {err.printStackTrace(); }

       } });









    
       
     bcancel = new JButton("cancel");
     bcancel.setToolTipText("To terminate all jobs, click here");
     bcancel.setFont(SetEnv.FontBold);
     bcancel.setPreferredSize(new java.awt.Dimension(120, 25));
     bcancel.setMinimumSize(new java.awt.Dimension(40, 10));
     this.add(bcancel);
   
         bcancel.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, 
          "This will kill all processes \n associated with RunMC. \n Do you want to kill all of them ?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
          if (ask == JOptionPane.YES_OPTION)  {  
          
          String sh = "bash"; String cop = "-c"; 
          String cmd0 = "pkill "; 

          Process pMC; 
          // kill all MC stuff 
          for (int i=1; i<SetIni.exeMC.length; i++) {
          String cmd = cmd0+SetIni.exeMC[i];  

          String[] exe = new String[] {sh, cop, cmd};
          try { pMC  = Runtime.getRuntime().exec(exe);
          //      System.out.println("analmc.pythia6 killed");
          } catch (Exception err) {err.printStackTrace(); } 
          
          }

 
          String cmd1 = "pkill histoview";
          String[] exe1 = new String[] {sh, cop, cmd1};
          try { Process p = Runtime.getRuntime().exec(exe1);
           //     System.out.println("histoview killed");
          } catch (Exception err) {err.printStackTrace(); }  
          
         
          cmd1 = "pkill ntupview";
          exe1 = new String[] {sh, cop, cmd1};
          try { Process p = Runtime.getRuntime().exec(exe1);
           //     System.out.println("ntupview  killed");
          } catch (Exception err) {err.printStackTrace(); }
          
          }
        }  });

     
     edproc = new JButton("Processes");
     edproc.setToolTipText("To check the jobs, click here");
     edproc.setFont(SetEnv.FontBold);
     edproc.setPreferredSize(new java.awt.Dimension(160, 25));
     edproc.setMinimumSize(new java.awt.Dimension(40, 10));
     this.add(edproc);
         edproc.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
             // show process
             SetIni.ShowStatus="Last action: show process editor";
             EditorProcess s1 = new EditorProcess(); s1.setVisible();

        }  });

     
     
     
     blog = new JButton("view log");
     blog.setToolTipText("To look at log file, click here");
     blog.setFont(SetEnv.FontBold);
     blog.setPreferredSize(new java.awt.Dimension(120, 25));
     blog.setMinimumSize(new java.awt.Dimension(40, 10));
     this.add(blog);
    // show log file
     blog.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
           SetIni.ShowStatus="Last action: show log file";
           new LogFileEditor();
           }  });
     
       
      }


// update this pannel with new settings
   public void setPan()  {


      // update renice
     if (SetIni.Renice>=0 && SetIni.Renice<=20){
       Srenice.setValue((int)SetIni.Renice); }




     }








    
 }
