// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package JRunMC;

import java.net.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeSet;


public class SystemInfo {

      private HtmlBrowserDialog dlg;
      private StringBuffer sbuf;
      private Map.Entry entry;
      private TreeSet sort;
      private Iterator it;
      private String hstr;
      private boolean special;


    public  SystemInfo() {

  // sort system properties
      sort = new TreeSet( new Comparator()
      {
         public int compare ( Object k1, Object k2 )
         {
            Map.Entry e1, e2;

            if ( k1 == null | k2 == null )
               throw new IllegalArgumentException();
            e1 = (Map.Entry)k1;
            e2 = (Map.Entry)k2;
            return e1.getKey().toString().compareTo( e2.getKey() );
         }
      });
      for ( it = System.getProperties().entrySet().iterator(); it.hasNext(); )
         sort.add( it.next() );

    // compile text from system properties
      sbuf = new StringBuffer(2048);
      sbuf.append( "<html><body><h3><u>Runtime System Properties</u></h3>" );
      for ( it = sort.iterator(); it.hasNext(); )
      {
         special = false;
         entry = (Map.Entry)it.next();
         sbuf.append( "<font color=\"maroon\"><b>" );
         hstr = (String)entry.getKey();
         sbuf.append( Util.htmlEncoded( hstr ) );
         sbuf.append( "</b></font> = " );
         if ( hstr.startsWith( "user." ) )
         {
            sbuf.append( "<font color=\"green\"><b>" );
            special = true;
         }
         if ( hstr.startsWith( "java.vm." ) || hstr.startsWith( "os." ) )
         {
            sbuf.append( "<font color=\"#005FBF\"><b>" );
            special = true;
         }
         else if ( hstr.startsWith( "java." ) )
         {
            sbuf.append( "<font color=\"black\"><b>" );
            special = true;
         }
         sbuf.append( Util.htmlEncoded( (String)entry.getValue() ) );
         if ( special )
            sbuf.append( "</b></font>" );
         sbuf.append( "<br>" );
      }
      sbuf.append( "#</p></body></html>" );

      hstr = ResourceLoader.getDisplay( "dlg.systeminfo" );
      dlg = new HtmlBrowserDialog( Global.mainFrame, hstr, true );
      if ( Toolkit.getDefaultToolkit().getScreenSize().width > 800 )
         dlg.setSize( new Dimension( 600, 400 ) );
      dlg.setText( sbuf.toString() );
      dlg.show();


    }


}
