
package JRunMC;

import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class FullSlider extends JPanel
                        implements ActionListener, ChangeListener {

  double val;
  double max;
  double min;
  boolean integer;
  JTextField value = new JTextField(8);
  JLabel minl = new JLabel("");
  JLabel maxl = new JLabel("");
  JSlider slider = new JSlider(0, 1000);

  public FullSlider(double mi, double va, double ma, boolean in) {
    integer = in;
    set(mi, va, ma);
    slider.addChangeListener(this);
    value.addActionListener(this);
    add(minl);
    add(slider);
    add(maxl);
    add(value);
  }

  public void set(double mi, double va, double ma) {
    min = mi;
    max = ma;
    val = mi;
    minl.setText("" + min);
    maxl.setText("" + max);
    setValue(va);
  }

  private void setValue(double v) {
    if ( v >= min && v <= max ) val = v;
    slider.setValue((int)(1000.0*(val - min)/(max - min)));
    if ( integer )
      value.setText("" + (int)(val + 0.5));
    else
      value.setText("" + val);
  }

  public int getInt() {
    return (int)(val + 0.5);
  }

  public double getDouble() {
    return val;
  }

  public void addActionListener(ActionListener l) {
    value.addActionListener(l);
  }

  public void addChangeListener(ChangeListener l) {
    slider.addChangeListener(l);
  }

  public void actionPerformed(ActionEvent e) {
    if ( e.getSource() == value ) {
      try {
	setValue(Double.parseDouble(value.getText()));
      }
      catch ( NumberFormatException ex ) {
	setValue(val);
      }
    }
  }

  public void stateChanged(ChangeEvent e) {
    if ( e.getSource() == slider ) {
      setValue(min + slider.getValue()*(max - min)*0.001);
    }
  }

}
