
package JRunMC;


import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class Parameter extends JDialog implements ActionListener {

  SetupTheEG owner;
  String object;
  String parameter;
  String description = "";
  double def;
  double min;
  double max;
  double current;
  boolean integer;
  boolean readonly;

  JButton ok = new JButton("Ok");
  JButton cancel = new JButton("Cancel");
  JButton apply = new JButton("Apply");
  JButton reset = new JButton("Reset");
  JButton setdef = new JButton("Default");
  FullSlider slider;
  JTextArea info = new JTextArea();

  public Parameter(SetupTheEG own, ObjectFrame obj, LinkedList input, boolean in) {
    super(obj);
    owner = own;
    object = obj.fullName();
    integer = in;
    if ( !setup(input) ) {
      JOptionPane.showMessageDialog(own, "Could not create Parameter view",
				    "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    getContentPane().setLayout(new BorderLayout());
    info.setText(description);
    info.setEditable(false);
    info.setLineWrap(true);
    info.setWrapStyleWord(true);
    getContentPane().add(new JScrollPane(info), BorderLayout.CENTER);
    if ( readonly ) {
      JLabel lab = new JLabel("");
      if ( integer )
	lab.setText("Readonly value is " + slider.getInt());
      else
	lab.setText("Readonly value is " + slider.getDouble());
      lab.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
      getContentPane().add(lab, BorderLayout.NORTH);
      ok.addActionListener(this);
      getContentPane().add(ok, BorderLayout.SOUTH);
    } else {
      JPanel buttons = new JPanel();
      buttons.add(cancel);
      buttons.add(reset);
      buttons.add(setdef);
      buttons.add(apply);
      buttons.add(ok);
      cancel.addActionListener(this);
      reset.addActionListener(this);
      setdef.addActionListener(this);
      apply.addActionListener(this);
      ok.addActionListener(this);
      getContentPane().add(buttons, BorderLayout.SOUTH);
      getContentPane().add(slider, BorderLayout.NORTH);
    }
    setSize(500,150);
    setVisible(true);
  }

  private boolean setup(LinkedList input) {
    String s = (String)input.remove(0);
    if ( input.size() > 0 ) parameter = (String)input.remove(0);
    else return false;
    while ( input.size() > 0 && ( s = (String)input.remove(0) ) != null &&
	    !s.equals("-*-mutable-*-") && !s.equals("-*-readonly-*-") )
      description += s + " ";
    if ( s.equals("-*-mutable-*-") ) readonly = false;
    else if ( s.equals("-*-readonly-*-") ) readonly = true;
    else return false;
    try {
      current = Double.parseDouble((String)input.remove(0));
      min = Double.parseDouble((String)input.remove(0));
      def = Double.parseDouble((String)input.remove(0));
      max = Double.parseDouble((String)input.remove(0));
      if ( slider == null )
	slider = new FullSlider(min, current, max, integer);
      else
	slider.set(min, current, max);
    }
    catch ( NumberFormatException e ) {
      return false;
    }
    return true;
  }

  private void setValue() {
    String cmd = "set " + object + ":" + parameter + " ";
    if ( integer ) cmd += slider.getInt();
    else cmd += slider.getDouble();

    owner.action(cmd);

    LinkedList ret = owner.exec("fulldescribe " + object + ":" + parameter);
    setup(ret);
  }

  public void actionPerformed(ActionEvent e) {
    if ( e.getSource() == cancel ) {
      dispose();
    }
    else if ( e.getSource() == ok ) {
      if ( !readonly ) setValue();
      dispose();
    }
    else if ( e.getSource() == apply ) {
      setValue();
    }
    else if ( e.getSource() == setdef ) {
      slider.set(min, def, max);
    }
    else if ( e.getSource() == reset ) {
      slider.set(min, current, max);
    }
  }

}


