
package JRunMC;

import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;

public class SetupTheEG extends JFrame implements ActionListener {

  
  Process theProcess;
  PrintWriter cmdStream;
  BufferedReader inStream;
  BufferedReader errStream;
  BufferedReader stdin;
  JMenuItem open = new JMenuItem("Open ...");
  JMenuItem quit = new JMenuItem("Quit");

  TreeMap objects = new TreeMap();

  Vector actions = new Vector();
  File actionFile;
  boolean actionsPerformed;

  JMenuItem saveActionsAs = new JMenuItem("Save Actions As ...");
  JMenuItem saveActions = new JMenuItem("Save Actions");

  boolean debug;

  SetupTheEG(String name, boolean deb) {
    super(name);

    debug = deb;

// S.Chekanov - do not know what is doing ...
//   String [] cmdarray = { "setupThePEG", "-java", "-r", "Pythia7Defaults.rpo" };
    String [] cmdarray = { "echo", "hi"}; 


    try {
      theProcess = Runtime.getRuntime().exec(cmdarray);
      cmdStream =
	new PrintWriter(new OutputStreamWriter(theProcess.getOutputStream()));
      inStream =
	new BufferedReader(new InputStreamReader(theProcess.getInputStream()));
      errStream =
	new BufferedReader(new InputStreamReader(theProcess.getErrorStream()));
      stdin =
	new BufferedReader(new InputStreamReader(System.in));
      
      JMenuBar menubar = new JMenuBar();
      JMenu file = new JMenu("File");
      open.addActionListener(this);
      file.add(open);
      file.add(new JSeparator());
      saveActions.addActionListener(this);
      saveActions.setEnabled(false);
      file.add(saveActions);
      saveActionsAs.addActionListener(this);
      file.add(saveActionsAs);
      file.add(new JSeparator());
      quit.addActionListener(this);
      file.add(quit);
      menubar.add(file);
      setJMenuBar(menubar);

      addWindowListener(new WindowAdapter() {
	  public void windowClosing(WindowEvent e) {
	    safeQuit();
	  }
	});

      setSize(300,300);
      setVisible(true);
      inStream.readLine();
    }
    catch (IOException ex) {
      System.err.println("Could not start sub process. Exiting.");
      System.exit(1);
    }
  }

  public synchronized LinkedList action(String cmd) {
    LinkedList ret = exec(cmd);
    if ( ret == null ) return ret;
    actions.add(cmd);
    actionsPerformed = false;
    saveActions.setEnabled(true);
    return ret;
  }

  public synchronized LinkedList exec(String cmd) {
    LinkedList ret = new LinkedList();
    try {
      if ( debug ) System.err.println("> " + cmd);
      cmdStream.println(cmd);
      cmdStream.flush();
      String s;
      while ( ( s = inStream.readLine() ) != null && !s.equals("-*-ready-*-")) {
	if ( debug ) System.err.println("< " + s);
	if ( s.length() >= 6 && s.substring(0,6).equals("Error:") ) {
	  JOptionPane.showMessageDialog(this, s, "Error",
					JOptionPane.ERROR_MESSAGE);
	  return null;
	}
	ret.add(s);
      }
    } catch ( IOException ex ) {
      System.err.println("Lost contact with sub process. Exiting.");
      System.exit(2);
    }
    return ret;
  }

  public void openObject(String dir) {
    ObjectChooser ch = new ObjectChooser(this, dir);
    String sel = ch.selected();
    if ( sel == null ) return;
    Object o = objects.get(sel);
    if ( o == null ) {
      ObjectFrame obj = new ObjectFrame(this, sel);
      objects.put(sel, obj);
    } else {
      ((ObjectFrame)o).setState(JFrame.NORMAL);
      ((ObjectFrame)o).toFront();
    }
  }

  public void remove(String obj) {
    objects.remove(obj);
  }

  public void safeQuit() {
    System.exit(0);
  }

  public void saveChanges() {
    if ( actionFile == null ) saveChangesAs();
    else {
      try {
	PrintWriter out = new PrintWriter(new FileWriter(actionFile));
	for ( Iterator it = actions.iterator(); it.hasNext(); )
	  out.println((String)it.next());
	actionsPerformed = false;
      }
      catch ( IOException ex ) {
	JOptionPane.showMessageDialog(this, "Save failed!", ex.getMessage(),
				      JOptionPane.ERROR_MESSAGE);
      }
    }
  }




  public void saveChangesAs() {
    JFileChooser f = new JFileChooser();
    if ( f.showSaveDialog(this) != JFileChooser.APPROVE_OPTION ) return;
    actionFile = f.getSelectedFile();
    if ( actionFile != null ) saveChanges();
  }

  public void actionPerformed(ActionEvent e) {
    if ( e.getSource() == open ) openObject("/");
    else if ( e.getSource() == quit ) safeQuit();
    else if ( e.getSource() == saveActions ) saveChanges();
    else if ( e.getSource() == saveActionsAs ) saveChangesAs();
  }

// remove 
//  public static void main(String [] args) {
//    SetupTheEG setup = new SetupTheEG("Setup TheEG", true);
//  }

}
