CDECK  ID>, HWH2PS.
*CMZ :-        -14/03/01  09:03:25  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2PS(WEIGHT,GEN,MQ,MQ2)
C-----------------------------------------------------------------------
C     Phase Space for vector boson plus 2 jets
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION WEIGHT,XMASS,PLAB,PRW,PCM,Y(3),Y35,Y34,Y45,RAND,
     &     HWRGEN,HWRUNI,M35,M35S,G(IMAXCH),DEM,MT(3),PT(3),MJAC,ETOT,
     &     STOT,MQ(3),MQ2(3),PS35,HWUPCM,TWOPI2,MT35,PTJ(3),MT2(3),A,C,
     &     PT2(3),YMIN,YMAX,EY(3),EY34,YJAC,YJJMAX,YJJMIN,EY35,PHI(3),
     &     MT45,PS45,EY45,M45,M45S,M34,PS34,M34S,MT34,XJAC,SJAC,PST,TAU,
     &     FLUX,ETMP,PZTMP,XT1,XT2,WI(IMAXCH)
      COMMON /HWPSOM/ WI
      INTEGER I,ICH,J
      COMMON/HWHEWP/XMASS(10),PLAB(5,10),PRW(5,2),PCM(5,10)
      LOGICAL GEN
      EXTERNAL HWRGEN,HWRUNI,HWUPCM
      PARAMETER(YJJMIN=-8.0D0,YJJMAX=8.0D0)
      IF(IERROR.NE.0) RETURN
      TWOPI2 = FOUR*PIFAC**2
      WEIGHT = ZERO
      IF(OPTM) THEN
        DO I=1,IMAXCH
          WI(I) = ZERO
        ENDDO
      ENDIF
      GEN = .FALSE.
C--centre of mass energy
      ETOT = PHEP(5,3)
      STOT = ETOT**2
C--first select the channel to be used
      RAND=HWRGEN(0)
      DO ICH=1,IMAXCH
        IF(CHON(ICH)) THEN
          IF(CHNPRB(ICH).GT.RAND) GOTO 10
          RAND = RAND-CHNPRB(ICH)
        ENDIF
      ENDDO
 10   CONTINUE
C--generate the phase space according to the channel selected
C--FIRST CHANNEL
      IF(ICH.EQ.1) THEN
C--first generate the mass of 35
        CALL HWH2P1(2,MJAC,MQ2(1),M35S,(ETOT-MQ(2))**2,(MQ(1)+MQ(3))**2)
        M35 = SQRT(M35S)
        PS35 = HWUPCM(M35,MQ(1),MQ(3))
        MJAC = HALF*MJAC*PS35/M35/TWOPI2
C--the generate the PT of 4
        CALL HWH2P2(2,PTJ(1),MT2(2),MQ2(2)+PTMAX**2,MQ2(2)+PTMIN**2)
        MT (2) = SQRT(MT2(2))
        PT2(2) = MT2(2)-MQ2(2)
        PT(2)  = SQRT(PT2(2))
        MT35   = SQRT(M35S+PT2(2))
C--generate the rapidities of 4 and 35
        YMAX  = MIN(YJJMAX, LOG(PHEP(5,3)/MT35))
        YMIN  = MAX(YJJMIN,-LOG(PHEP(5,3)/MT35))
        IF(YMAX.LT.YMIN) RETURN
        Y35   = HWRUNI(1,YMIN,YMAX)
        EY35  = EXP(Y35)
        YJAC  = (YMAX-YMIN)
        YMAX  = MIN(YJMAX, LOG((PHEP(5,3)-MT35*EY35)/MT(2)))
        YMIN  = MAX(YJMIN,-LOG((PHEP(5,3)-MT35/EY35)/MT(2)))
        IF(YMAX.LT.YMIN) RETURN
        Y(2)  = HWRUNI(2,YMIN,YMAX)
        YJAC  = (YMAX-YMIN)*YJAC
        EY(2) = EXP(Y(2))
C--generate the incoming quark momentum fractions
        XX(1) = (MT(2)*EY(2)+MT35*EY35)/ETOT
        XX(2) = (MT(2)/EY(2)+MT35/EY35)/ETOT
        STOT = XX(1)*XX(2)*STOT
C--azimuthal angle of 4 and 35
        PHI(1) = HWRUNI(3,ZERO,TWO*PIFAC)
C--construct the momenta of 4 and 35
        PLAB(1,4) = PT(2)*SIN(PHI(1))
        PLAB(2,4) = PT(2)*COS(PHI(1))
        PLAB(3,4) = HALF*MT(2)*(EY(2)-ONE/EY(2))
        PLAB(4,4) = HALF*MT(2)*(EY(2)+ONE/EY(2))
        PLAB(5,4) = MQ(2)
        PLAB(1,6) =-PT(2)*SIN(PHI(1))
        PLAB(2,6) =-PT(2)*COS(PHI(1))
        PLAB(3,6) = HALF*MT35*(EY35-ONE/EY35)
        PLAB(4,6) = HALF*MT35*(EY35+ONE/EY35)
        PLAB(5,6) = M35
C--perform the decay 35 --> 3+5
        PLAB(5,3) = MQ(1)
        PLAB(5,5) = MQ(3)
        CALL HWDTWO(PLAB(1,6),PLAB(1,3),PLAB(1,5),PS35,TWO,.TRUE.)
C--phase space weight
        FLUX = MJAC*YJAC*PTJ(1)/16.0D0/PIFAC/STOT**2
C--SECOND CHANNEL
      ELSEIF(ICH.EQ.2) THEN
C--first generate the pt's and azimuthal angles of 3 and 4
        DO I=1,2
           CALL HWH2P2(2,PTJ(I),MT2(I),MQ2(I)+PTMAX**2,MQ2(I)+PTMIN**2)
           PT2(I) = MT2(I)-MQ2(I)
           MT(I) = SQRT(MT2(I))
           PT(I) = SQRT(PT2(I))
           PHI(I) = HWRUNI(I,ZERO,TWO*PIFAC)
        ENDDO
C--find the pt and azimuth of 5 by conservation of transverse momentum
        A      = PT(1)*SIN(PHI(1))+PT(2)*SIN(PHI(2))
        C      = PT(1)*COS(PHI(1))+PT(2)*COS(PHI(2))
        PT(3)  = A**2+C**2
        MT(3)  = SQRT(PT(3)+MQ2(3))
        PT(3)  = SQRT(PT(3))
        PHI(3) = -ACOS(-C/PT(3))
        IF(A.LT.ZERO) PHI(3)=-PHI(3)
C--generate the rapidities of 3,4 and 5
        XX(1) = ZERO
        XX(2) = ZERO
        YJAC  = ONE
        DO I=1,3
          YMAX = MIN(YJMAX, LOG((PHEP(5,3)-XX(1))/MT(I)))
          YMIN = MAX(YJMIN,-LOG((PHEP(5,3)-XX(2))/MT(I)))
          IF(YMAX.LT.YMIN) RETURN
          Y(I)  = HWRUNI(I+2,YMIN,YMAX)
          EY(I) = EXP(Y(I))
          XX(1) = XX(1)+MT(I)*EY(I)
          XX(2) = XX(2)+MT(I)/EY(I)
          YJAC  = YJAC*(YMAX-YMIN)
        ENDDO
C--generate the incoming quark momentum fractions
        XX(1) = XX(1)/PHEP(5,3)
        XX(2) = XX(2)/PHEP(5,3)
        IF(XX(1).GT.ONE.OR.XX(2).GT.ONE) RETURN
C--Construct the 4-momenta of the outgoing particles
        DO I=1,3
          PLAB(1,I+2) = PT(I)*SIN(PHI(I))
          PLAB(2,I+2) = PT(I)*COS(PHI(I))
          PLAB(3,I+2) = HALF*MT(I)*(EY(I)-ONE/EY(I))
          PLAB(4,I+2) = HALF*MT(I)*(EY(I)+ONE/EY(I))
          PLAB(5,I+2) = MQ(I)
       ENDDO
C--phase space weight
       STOT = XX(1)*XX(2)*STOT
       FLUX = YJAC*PTJ(1)*PTJ(2)/64.0D0/PIFAC/TWOPI2/STOT**2
C--THIRD CHANNEL
      ELSEIF(ICH.EQ.3) THEN
C--first generate the mass of 45
        CALL HWH2P1(2,MJAC,MQ2(2),M45S,(ETOT-MQ(1))**2,(MQ(2)+MQ(3))**2)
        M45 = SQRT(M45S)
        PS45 = HWUPCM(M45,MQ(2),MQ(3))
        MJAC = HALF*MJAC*PS45/M45/TWOPI2
C--the generate the PT of 4
        CALL HWH2P2(2,PTJ(1),MT2(1),MQ2(1)+PTMAX**2,MQ2(1)+PTMIN**2)
        MT (1) = SQRT(MT2(1))
        PT2(1) = MT2(1)-MQ2(1)
        PT(1)  = SQRT(PT2(1))
        MT45   = SQRT(M45S+PT2(1))
C--generate the rapidities of 3 and 45
        YMAX  = MIN(YJJMAX, LOG(PHEP(5,3)/MT45))
        YMIN  = MAX(YJJMIN,-LOG(PHEP(5,3)/MT45))
        IF(YMAX.LT.YMIN) RETURN
        Y45   = HWRUNI(1,YMIN,YMAX)
        EY45  = EXP(Y45)
        YJAC  = (YMAX-YMIN)
        YMAX  = MIN(YJMAX, LOG((PHEP(5,3)-MT45*EY45)/MT(1)))
        YMIN  = MAX(YJMIN,-LOG((PHEP(5,3)-MT45/EY45)/MT(1)))
        IF(YMAX.LT.YMIN) RETURN
        Y(1)  = HWRUNI(2,YMIN,YMAX)
        YJAC  = (YMAX-YMIN)*YJAC
        EY(1) = EXP(Y(1))
C--generate the incoming quark momentum fractions
        XX(1) = (MT(1)*EY(1)+MT45*EY45)/ETOT
        XX(2) = (MT(1)/EY(1)+MT45/EY45)/ETOT
        STOT = XX(1)*XX(2)*STOT
C--azimuthal angle of 3 and 45
        PHI(1) = HWRUNI(3,ZERO,TWO*PIFAC)
C--construct the momenta of 3 and 45
        PLAB(1,3) = PT(1)*SIN(PHI(1))
        PLAB(2,3) = PT(1)*COS(PHI(1))
        PLAB(3,3) = HALF*MT(1)*(EY(1)-ONE/EY(1))
        PLAB(4,3) = HALF*MT(1)*(EY(1)+ONE/EY(1))
        PLAB(5,3) = MQ(1)
        PLAB(1,6) =-PT(1)*SIN(PHI(1))
        PLAB(2,6) =-PT(1)*COS(PHI(1))
        PLAB(3,6) = HALF*MT45*(EY45-ONE/EY45)
        PLAB(4,6) = HALF*MT45*(EY45+ONE/EY45)
        PLAB(5,6) = M45
C--perform the decay 45 --> 4+5
        PLAB(5,4) = MQ(2)
        PLAB(5,5) = MQ(3)
        CALL HWDTWO(PLAB(1,6),PLAB(1,4),PLAB(1,5),PS45,TWO,.TRUE.)
C--phase space weight
        FLUX = MJAC*YJAC*PTJ(1)/16.0D0/PIFAC/STOT**2
C--FOURTH CHANNEL
      ELSEIF(ICH.EQ.4) THEN
C--generate shat according to a power law
        CALL HWHGB1(1,2,200,SJAC,STOT,PHEP(5,3)**2,
     &                                        (MQ(1)+MQ(2)+MQ(3))**2)
        ETOT = SQRT(STOT)
C--generate x1
        TAU   = STOT/PHEP(5,3)**2
        XJAC  = -LOG(TAU)
        XX(1) = EXP(HWRUNI(2,LOG(TAU),ZERO))
        XX(2) = TAU/XX(1)
C--generate m35
        CALL HWH2P1(2,MJAC,MQ2(1),M35S,(ETOT-MQ(2))**2,
     &                                               (MQ(1)+MQ(3))**2)
        M35 = SQRT(M35S)
        PS35 = HWUPCM(M35,MQ(1),MQ(3))
        MJAC = HALF*MJAC*PS35/M35/TWOPI2
C--generate the momenta of 4 and 35
        PST = HWUPCM(ETOT,M35,MQ(2))
        PLAB(1,7) = ZERO
        PLAB(2,7) = ZERO
        PLAB(3,7) = HALF*(XX(1)-XX(2))*PHEP(5,3)
        PLAB(4,7) = HALF*(XX(1)+XX(2))*PHEP(5,3)
        PLAB(5,7) = ETOT
        PLAB(5,3) = MQ(1)
        PLAB(5,6) = M35
        PLAB(5,4) = MQ(2)
        CALL HWDTWO(PLAB(1,7),PLAB(1,4),PLAB(1,6),PST,TWO,.TRUE.)
C--perform the decay 35 --> 3+5
        PLAB(5,4) = MQ(2)
        PLAB(5,5) = MQ(3)
        CALL HWDTWO(PLAB(1,6),PLAB(1,3),PLAB(1,5),PS35,TWO,.TRUE.)
C--phase space weight
        FLUX = SJAC*XJAC*MJAC*PST/ETOT/STOT**2/8.0D0/PIFAC
C--FIFTH CHANNEL
      ELSEIF(ICH.EQ.5) THEN
C--generate shat according to a power law
        CALL HWHGB1(1,2,200,SJAC,STOT,PHEP(5,3)**2,
     &                                        (MQ(1)+MQ(2)+MQ(3))**2)
        ETOT = SQRT(STOT)
C--generate x1
        TAU   = STOT/PHEP(5,3)**2
        XJAC  = -LOG(TAU)
        XX(1) = EXP(HWRUNI(2,LOG(TAU),ZERO))
        XX(2) = TAU/XX(1)
C--generate m45
        CALL HWH2P1(2,MJAC,MQ2(2),M45S,(ETOT-MQ(1))**2,(MQ(2)+MQ(3))**2)
        M45 = SQRT(M45S)
        PS45 = HWUPCM(M45,MQ(2),MQ(3))
        MJAC = HALF*MJAC*PS45/M45/TWOPI2
C--generate the momenta of 4 and 35
        PST = HWUPCM(ETOT,M45,MQ(1))
        PLAB(1,7) = ZERO
        PLAB(2,7) = ZERO
        PLAB(3,7) = HALF*(XX(1)-XX(2))*PHEP(5,3)
        PLAB(4,7) = HALF*(XX(1)+XX(2))*PHEP(5,3)
        PLAB(5,7) = ETOT
        PLAB(5,3) = MQ(1)
        PLAB(5,6) = M45
        CALL HWDTWO(PLAB(1,7),PLAB(1,3),PLAB(1,6),PST,TWO,.TRUE.)
C--perform the decay 45 --> 4+5
        PLAB(5,4) = MQ(2)
        PLAB(5,5) = MQ(3)
        CALL HWDTWO(PLAB(1,6),PLAB(1,4),PLAB(1,5),PS45,TWO,.TRUE.)
C--phase space weight
        FLUX = SJAC*XJAC*MJAC*PST/ETOT/STOT**2/8.0D0/PIFAC
C--SIXTH CHANNEL
      ELSEIF(ICH.EQ.6) THEN
C--first generate the mass of 34
        CALL HWH2P1(2,MJAC,ZERO,M34S,(ETOT-MQ(3))**2,MJJMIN**2)
        M34 = SQRT(M34S)
        PS34 = HWUPCM(M34,MQ(1),MQ(2))
        MJAC = HALF*MJAC*PS34/M34/TWOPI2
C--the generate the PT of 5
        CALL HWH2P2(2,PTJ(1),MT2(3),MQ2(3)+PTMAX**2,MQ2(3))
        MT (3) = SQRT(MT2(3))
        PT2(3) = MT2(3)-MQ2(3)
        PT(3)  = SQRT(PT2(3))
        MT34   = SQRT(M34S+PT2(3))
C--generate the rapidities of 5 and 34
        YMAX  = MIN(YJJMAX, LOG(PHEP(5,3)/MT34))
        YMIN  = MAX(YJJMIN,-LOG(PHEP(5,3)/MT34))
        IF(YMAX.LT.YMIN) RETURN
        Y34   = HWRUNI(1,YMIN,YMAX)
        EY34  = EXP(Y34)
        YJAC  = (YMAX-YMIN)
        YMAX  = MIN(YJMAX, LOG((PHEP(5,3)-MT34*EY34)/MT(3)))
        YMIN  = MAX(YJMIN,-LOG((PHEP(5,3)-MT34/EY34)/MT(3)))
        IF(YMAX.LT.YMIN) RETURN
        Y(3)  = HWRUNI(2,YMIN,YMAX)
        YJAC  = (YMAX-YMIN)*YJAC
        EY(3) = EXP(Y(3))
C--generate the incoming quark momentum fractions
        XX(1) = (MT(3)*EY(3)+MT34*EY34)/ETOT
        XX(2) = (MT(3)/EY(3)+MT34/EY34)/ETOT
        STOT = XX(1)*XX(2)*STOT
C--azimuthal angle of 3 and 45
        PHI(1) = HWRUNI(3,ZERO,TWO*PIFAC)
C--construct the momenta of 5 and 34
        PLAB(1,5) = PT(3)*SIN(PHI(1))
        PLAB(2,5) = PT(3)*COS(PHI(1))
        PLAB(3,5) = HALF*MT(3)*(EY(3)-ONE/EY(3))
        PLAB(4,5) = HALF*MT(3)*(EY(3)+ONE/EY(3))
        PLAB(5,5) = MQ(3)
        PLAB(1,6) =-PT(3)*SIN(PHI(1))
        PLAB(2,6) =-PT(3)*COS(PHI(1))
        PLAB(3,6) = HALF*MT34*(EY34-ONE/EY34)
        PLAB(4,6) = HALF*MT34*(EY34+ONE/EY34)
        PLAB(5,6) = M34
C--perform the decay 34 --> 3+4
        PLAB(5,3) = MQ(1)
        PLAB(5,4) = MQ(2)
        CALL HWDTWO(PLAB(1,6),PLAB(1,3),PLAB(1,4),PS34,TWO,.TRUE.)
C--phase space weight
        FLUX = MJAC*YJAC*PTJ(1)/16.0D0/PIFAC/STOT**2
      ELSE
        CALL HWWARN('HWH2PS',500,*999)
      ENDIF
C--calculate the variables we need for the smoothing functions
C--pt,mt and y for outgoing particles
      DO I=1,3
        J=I+2
        PT2(I) = PLAB(1,J)**2+PLAB(2,J)**2
        PT(I)  = SQRT(PT2(I))
        MT2(I) = MQ2(I)+PT2(I)
        MT(I)  = SQRT(MT2(I))
        Y(I)   = HALF*LOG((PLAB(4,J)+PLAB(3,J))/(PLAB(4,J)-PLAB(3,J)))
        EY(I)  = EXP(Y(I))
        IF(I.LE.2.AND.(Y(I).LT.YJMIN.OR.Y(I).GT.YJMAX)) RETURN
      ENDDO
      IF(PT(1).LT.PTMIN.OR.PT(2).LT.PTMIN) RETURN
C--masses of composite particles
      M34S = (PLAB(4,3)+PLAB(4,4))**2
      M45S = (PLAB(4,4)+PLAB(4,5))**2
      M35S = (PLAB(4,3)+PLAB(4,5))**2
      DO I=1,3
        M34S = M34S-(PLAB(I,3)+PLAB(I,4))**2
        M45S = M45S-(PLAB(I,4)+PLAB(I,5))**2
        M35S = M35S-(PLAB(I,3)+PLAB(I,5))**2
      ENDDO
      M34 = SQRT(M34S)
      M45 = SQRT(M45S)
      M35 = SQRT(M35S)
      IF(M34.LT.MJJMIN) RETURN
C--tramsverse masses of the composite particles
      MT34 = ZERO
      MT35 = ZERO
      MT45 = ZERO
      DO I=1,2
        MT34 = MT34+(PLAB(I,3)+PLAB(I,4))**2
        MT35 = MT35+(PLAB(I,3)+PLAB(I,5))**2
        MT45 = MT45+(PLAB(I,4)+PLAB(I,5))**2
      ENDDO
      MT34 = SQRT(M34S+MT34)
      MT35 = SQRT(M35S+MT35)
      MT45 = SQRT(M45S+MT45)
C--final the momenta
      PS34 = HWUPCM(M34,MQ(1),MQ(2))
      PS35 = HWUPCM(M35,MQ(1),MQ(3))
      PS45 = HWUPCM(M45,MQ(2),MQ(3))
C--the rapidities of the composite particles
      ETMP  = PLAB(4,3)+PLAB(4,4)
      PZTMP = PLAB(3,3)+PLAB(3,4)
      Y34   = HALF*LOG((ETMP+PZTMP)/(ETMP-PZTMP))
      EY34  = EXP(Y34)
      ETMP  = PLAB(4,3)+PLAB(4,5)
      PZTMP = PLAB(3,3)+PLAB(3,5)
      Y35   = HALF*LOG((ETMP+PZTMP)/(ETMP-PZTMP))
      EY35  = EXP(Y35)
      ETMP  = PLAB(4,4)+PLAB(4,5)
      PZTMP = PLAB(3,4)+PLAB(3,5)
      Y45   = HALF*LOG((ETMP+PZTMP)/(ETMP-PZTMP))
      EY45  = EXP(Y45)
C--find the pdf's and set the scale
      ETOT = SQRT(STOT)
      EMSCA = ETOT
      CALL HWSGEN(.FALSE.)
C--construct the incoming momenta
      DO I=1,2
        PLAB(1,I) = ZERO
        PLAB(2,I) = ZERO
        PLAB(3,I) = HALF*XX(I)*PHEP(5,3)
        PLAB(4,I) = HALF*XX(I)*PHEP(5,3)
        PLAB(5,I) = ZERO
      ENDDO
      PLAB(3,2) = -PLAB(3,2)
      TAU   = XX(1)*XX(2)
C--find the smoothing functions for the different channels
C--function for first channel
      IF(CHON(1)) THEN
        CALL HWH2P1(1,MJAC,MQ2(1),M35S,(PHEP(5,3)-MQ(2))**2,
     &                                              (MQ(1)+MQ(3))**2)
        MJAC = MJAC/PS35*M35
        CALL HWH2P2(1,PTJ(1),MT2(2),PTMAX**2+MQ2(2),MQ2(2)+PTMIN**2)
        YMAX  = MIN(YJJMAX, LOG(PHEP(5,3)/MT35))
        YMIN  = MAX(YJJMIN,-LOG(PHEP(5,3)/MT35))
        YJAC  = (YMAX-YMIN)
        YMAX  = MIN(YJMAX, LOG((PHEP(5,3)-MT35*EY35)/MT(2)))
        YMIN  = MAX(YJMIN,-LOG((PHEP(5,3)-MT35/EY35)/MT(2)))
        YJAC  = (YMAX-YMIN)*YJAC
        G(1)  = 2.0D0*MJAC*PTJ(1)/YJAC
      ENDIF
C--function for second channel
      IF(CHON(2)) THEN
        DO I=1,2
           CALL HWH2P2(1,PTJ(I),MT2(I),PTMAX**2+MQ2(I),MQ2(I)+PTMIN**2)
        ENDDO
        XT1 = ZERO
        XT2 = ZERO
        YJAC  = ONE
        DO I=1,3
          YMAX = MIN(YJMAX, LOG((PHEP(5,3)-XT1)/MT(I)))
          YMIN = MAX(YJMIN,-LOG((PHEP(5,3)-XT2)/MT(I)))
          XT1  = XT1+MT(I)*EY(I)
          XT2  = XT2+MT(I)/EY(I)
          YJAC  = YJAC*(YMAX-YMIN)
        ENDDO
        G(2) = 4.0D0*PTJ(1)*PTJ(2)/YJAC
      ENDIF
C--function for third channel
      IF(CHON(3)) THEN
        CALL HWH2P1(1,MJAC,MQ2(2),M45S,(PHEP(5,3)-MQ(1))**2,
     &                                            (MQ(2)+MQ(3))**2)
        MJAC = MJAC/PS45*M45
        CALL HWH2P2(1,PTJ(1),MT2(1),PTMAX**2+MQ2(1),MQ2(1)+PTMIN**2)
        YMAX  = MIN(YJJMAX, LOG(PHEP(5,3)/MT45))
        YMIN  = MAX(YJJMIN,-LOG(PHEP(5,3)/MT45))
        YJAC  = (YMAX-YMIN)
        YMAX  = MIN(YJMAX, LOG((PHEP(5,3)-MT45*EY45)/MT(1)))
        YMIN  = MAX(YJMIN,-LOG((PHEP(5,3)-MT45/EY45)/MT(1)))
        YJAC  = (YMAX-YMIN)*YJAC
        G(3)  = 2.0D0*MJAC*PTJ(1)/YJAC
      ENDIF
C--function for fourth channel
      IF(CHON(4)) THEN
        CALL HWHGB1(1,1,200,SJAC,STOT,PHEP(5,3)**2,
     &                                        (MQ(1)+MQ(2)+MQ(3))**2)
        XJAC  = -LOG(TAU)
        CALL HWH2P1(1,MJAC,MQ2(1),M35S,(ETOT-MQ(2))**2,(MQ(1)+MQ(3))**2)
        M35 = SQRT(M35S)
        MJAC = MJAC/PS35*M35
        PST = HWUPCM(ETOT,M35,MQ(2))
        G(4) = SJAC*MJAC/XJAC*ETOT/PST
      ENDIF
C--function for fifth channel
      IF(CHON(5)) THEN
        CALL HWHGB1(1,1,200,SJAC,STOT,PHEP(5,3)**2,
     &                                        (MQ(1)+MQ(2)+MQ(3))**2)
        XJAC  = -LOG(TAU)
        CALL HWH2P1(1,MJAC,MQ2(2),M45S,(ETOT-MQ(1))**2,(MQ(2)+MQ(3))**2)
        MJAC = MJAC/PS45*M45
        PST = HWUPCM(ETOT,M45,MQ(1))
        G(5) = SJAC/XJAC*MJAC/PST*ETOT
      ENDIF
C--function for sixth chaneel
      IF(CHON(6)) THEN
        CALL HWH2P1(1,MJAC,ZERO,M34S,(PHEP(5,3)-MQ(3))**2,MJJMIN**2)
        MJAC = MJAC/PS34*M34
        CALL HWH2P2(1,PTJ(1),MT2(3),MQ2(3)+PTMAX**2,MQ2(3))
        YMAX  = MIN(YJJMAX, LOG(PHEP(5,3)/MT34))
        YMIN  = MAX(YJJMIN,-LOG(PHEP(5,3)/MT34))
        YJAC  = (YMAX-YMIN)
        YMAX  = MIN(YJMAX, LOG((PHEP(5,3)-MT34*EY34)/MT(3)))
        YMIN  = MAX(YJMIN,-LOG((PHEP(5,3)-MT34/EY34)/MT(3)))
        YJAC  = (YMAX-YMIN)*YJAC
        G(6)  = 2.0D0*MJAC/YJAC*PTJ(1)
      ENDIF
C--add them all up
      DEM = ZERO
      DO I=1,IMAXCH
        IF(CHON(I)) DEM = DEM+CHNPRB(I)*G(I)
      ENDDO
C--now the weight
      WEIGHT = FLUX*GEV2NB*G(ICH)/DEM
      GEN = .TRUE.
C--compute the weights for the different channels if optimizing
      IF(OPTM) THEN
        DO I=1,IMAXCH
          IF(CHON(I)) WI(I)=G(I)*WEIGHT**2/DEM
        ENDDO
      ENDIF
 999  END
CDECK  ID>, HWH2P1.
*CMZ :-        -02/04/01  12.11.55  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2P1(IOPT,FJAC,MQ2,M2,MMX,MMN)
C-----------------------------------------------------------------------
C     Subroutine to select virtual quark mass for HWH2PS
C     IOPT=1 return the function at M2
C     IOPT=2 calculate M2
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER IOPT
      DOUBLE PRECISION FJAC,MPOW,MMN,MQ2,M2,A1,A01,RPOW,QPOW,HWRGEN,MMX
      EXTERNAL HWRGEN
C--smooth a powerlaw
      IF(EMPOW.EQ.TWO) THEN
        A01   = LOG(MMN-MQ2)
        A1    = LOG(MMX-MQ2)-A01
        IF(IOPT.EQ.1) THEN
          FJAC = ONE/(M2-MQ2)/A1
        ELSE
          M2 = EXP(A01+A1*HWRGEN(2))
          FJAC  = A1*M2
          M2 = M2+MQ2
        ENDIF
      ELSE
        MPOW = -EMPOW/TWO
        QPOW =  ONE+MPOW
        RPOW =  ONE/QPOW
        A01  =  (MMN-MQ2)**QPOW
        A1   =  (MMX-MQ2)**QPOW-A01
        IF(IOPT.EQ.1) THEN
          FJAC = QPOW*(M2-MQ2)**MPOW/A1
        ELSE
          M2 = (A01+A1*HWRGEN(2))**RPOW
          FJAC  = A1*RPOW/M2**MPOW
          M2 = M2+MQ2
        ENDIF
      ENDIF
 999  END
CDECK  ID>, HWH2P2.
*CMZ :-        -02/04/01  12.11.55  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2P2(IOPT,FJAC,PT2,PTMX2,PTMN2)
C-----------------------------------------------------------------------
C     Subroutine to select virtual quark mass for HWH2PS
C     IOPT=1 return the function at M2
C     IOPT=2 calculate M2
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER IOPT
      DOUBLE PRECISION FJAC,MPOW,A1,A01,RPOW,QPOW,HWRGEN,PT2,
     &     PPOW,PTMN2,PTMX2,Z
      EXTERNAL HWRGEN
C--smooth a powerlaw
      PPOW = HALF*PTPOW
      IF(PPOW.EQ.ONE) THEN
        A01   = LOG(PTMN2)
        A1    = LOG(PTMX2)-A01
        IF(IOPT.EQ.1) THEN
          FJAC = ONE/PT2/A1
        ELSE
          PT2 = EXP(A01+A1*HWRGEN(2))
          FJAC  = A1*PT2
        ENDIF
      ELSE
        MPOW = -PPOW
        QPOW =  ONE+MPOW
        RPOW =  ONE/QPOW
        A01  =  PTMN2**QPOW
        A1   =  PTMX2**QPOW-A01
        IF(IOPT.EQ.1) THEN
          FJAC = QPOW*PT2**MPOW/A1
        ELSE
          Z    = A01+A1*HWRGEN(2)
          PT2  = Z**RPOW
          FJAC = A1*RPOW/Z*PT2
        ENDIF
      ENDIF
 999  END
CDECK  ID>, HWH2QH.
*CMZ :-        -26/11/00  17.21.55  by  Bryan Webber
*-- Author :  Kosuke Odagiri
C-----------------------------------------------------------------------
      SUBROUTINE HWH2QH(SQS,P1,P2,P3,P4,P5,RM3,RM4,RM5,FACGPM,MGM3,
     & IGG,IQQ,GGQQHT,GGQQHU,GGQQHNP,QQQQH)
C-----------------------------------------------------------------------
C     MATRIX ELEMENT SQUARED FOR THE PROCESS GG/QQ(BAR) -> QQ(BAR) HIGGS
C-----------------------------------------------------------------------
C     NEEDS PREFACTOR G_S^4. COUPLINGS, E.G. FOR T(3)B(4)H-(5) ARE:
C     FACGPM(1) = GW/SQRT(TWO) M_B / M_W * TANB
C     FACGPM(2) = GW/SQRT(TWO) M_T / M_W / TANB
C     MGM3 = (TOP MASS)*(TOP WIDTH)
C     INITIAL STATE MOMENTA: P1=(SQS/2)(1,0,0,1), P2=(SQS/2)(1,0,0,-1)
C     PREFACTORS:
C     GGQQHTOT = (G_S**4)*(GGQQHT+GGQQHU-GGQQHNP/CAFAC**2)/(8.*CFFAC)
C     QQQQHTOT = (G_S**4)*(QQQQH                         )*(1.-1./CAFAC**2)/4.
C     N.B. SUBROUTINE CANNOT BE USED FOR PHOTON PHOTON -> ...
C-----------------------------------------------------------------------
      IMPLICIT NONE
C --- SUBPROCESS
      INTEGER IGG,IQQ
C --- CENTRE-OF-MASS ENERGY, FOUR-MOMENTA, MASSES AND WIDTHS
      DOUBLE PRECISION SQS,P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      DOUBLE PRECISION K3(0:3),K4(0:3), Q3(0:3),Q4(0:3), R3(0:3),R4(0:3)
      DOUBLE PRECISION RM3,RM4,RM5, MGM3,MGM4, TWOSQS
C --- SPINORS
      DOUBLE COMPLEX U0(4), F3(4,2),F4(4,2), F3K(4,2),F4K(4,2)
      DOUBLE COMPLEX F3Q(4,2,2),F4Q(4,2,2), F3R(4,2,2),F4R(4,2,2)
C --- MOMENTUM PROJECTION OPERATORS
      DOUBLE COMPLEX P3PROJ(4,4),P4PROJ(4,4),K3PROJ(4,4),K4PROJ(4,4)
      DOUBLE COMPLEX Q3PROJ(4,4),Q4PROJ(4,4),R3PROJ(4,4),R4PROJ(4,4)
C --- SPINOR INDICES AND PERMUTATION MATRICES
      INTEGER I,J,K,L, PERM0(4), PL(4,2),PR(4,2), PERMU0(4)
C --- CHIRALITY PROJECTION OPERATORS: 1 = - ,  2 = +
      DOUBLE PRECISION FACGPM(2),FACL(2,2),FACR(2,2),FAC0(2,2)
C --- GG AMPLITUDES
      DOUBLE COMPLEX AMPS1(2,2),AMPS2(2,2)
      DOUBLE COMPLEX AMPT1(2,2,2,2),AMPT2(2,2,2,2),AMPT3(2,2,2,2)
      DOUBLE COMPLEX AMPU1(2,2,2,2),AMPU2(2,2,2,2),AMPU3(2,2,2,2)
      DOUBLE COMPLEX AMPS, AMPT, AMPU, AMPST, AMPSU, AMPTU
      DOUBLE PRECISION AMPST2, AMPSU2, AMPTU2
      DOUBLE PRECISION GGQQHT,GGQQHU,GGQQHNP,QQQQH
C --- QQ AMPLITUDES
      DOUBLE PRECISION RM3452
      DOUBLE PRECISION S,PT32,PT42,PT52,GLAMBDA,LAMBDA,LAMBDAI,LA34,
     &                 PROP2,PROP3R,PROP3I,PROP4R,PROP4I,PROP34R,PT3452
      DOUBLE COMPLEX PROP3,PROP4,PROP
C --- CONSTANTS
      DOUBLE PRECISION ZERO,ONE,TWO,MONE,FAC
      DOUBLE COMPLEX CZERO,CONE
      INTEGER LEFT,RIGHT
C --- PARAMETER DEFINITIONS
      PARAMETER (ZERO=0.D0,ONE=1.D0,TWO=2.D0,MONE=-ONE, LEFT=1,RIGHT=2)
      PARAMETER (CZERO=(0.D0,0.D0),CONE=(1.D0,0.D0))
      DATA MGM4,U0,FAC0   /ZERO, 4*CONE        ,   ONE,ZERO, ZERO, ONE /
      DATA PERM0  ,PERMU0 / 1,2, 3,4           ,   1,0, 0,4            /
      DATA PL     ,PR     / 0,3, 0,1,  4,0, 2,0,   4,0, 2,0,  0,3, 0,1 /
      DATA FACL   ,FACR   /MONE, ONE,  ONE,MONE,   ONE,MONE, MONE, ONE /
      SAVE MGM4,PERM0,PL,FACL,PR,FACR,PERMU0,FAC0,U0
C --- INITIALIZE
      GGQQHT=ZERO
      GGQQHU=ZERO
      GGQQHNP=ZERO
      QQQQH=ZERO
C --- GG ME.
      IF(IGG.EQ.0)GOTO 100
      TWOSQS = 0.5D0/SQS
      DO I = 0, 3
       Q3(I) = P3(I)-P1(I)
       Q4(I) = P4(I)-P2(I)
       R3(I) = P3(I)-P2(I)
       R4(I) = P4(I)-P1(I)
       K3(I) = P3(I)+P5(I)
       K4(I) = P4(I)+P5(I)
      END DO
      CALL HWUMPO(P3, RM3,     (P3(0)-P3(3))  ,ZERO,P3PROJ, .FALSE.)
      CALL HWUMPO(P4,-RM4,     (P4(0)+P4(3))  ,ZERO,P4PROJ, .FALSE.)
      CALL HWUMPO(Q3, RM3,-SQS*(P3(0)-P3(3))  ,ZERO,Q3PROJ, .FALSE.)
      CALL HWUMPO(Q4,-RM4,-SQS*(P4(0)+P4(3))  ,ZERO,Q4PROJ, .FALSE.)
      CALL HWUMPO(R3, RM3,-SQS*(P3(0)+P3(3))  ,ZERO,R3PROJ, .FALSE.)
      CALL HWUMPO(R4,-RM4,-SQS*(P4(0)-P4(3))  ,ZERO,R4PROJ, .FALSE.)
      CALL HWUMPO(K3, RM4,SQS*(SQS-2.D0*P4(0)),MGM4,K3PROJ, .TRUE.)
      CALL HWUMPO(K4,-RM3,SQS*(SQS-2.D0*P3(0)),MGM3,K4PROJ, .TRUE.)
      DO I=1,2
       CALL  HWUMPP(P3PROJ,FAC0(1,I),PERMU0 ,U0     ,F3(1,I)   , LEFT)
       CALL  HWUMPP(K3PROJ,FACGPM   ,PERM0  ,F3(1,I),F3K(1,I)  , LEFT)
       CALL  HWUMPP(P4PROJ,FAC0(1,I),PERMU0 ,U0     ,F4(1,I)   , RIGHT)
       CALL  HWUMPP(K4PROJ,FACGPM   ,PERM0  ,F4(1,I),F4K(1,I)  , RIGHT)
       DO J=1,2
        CALL HWUMPP(Q3PROJ,FACL(1,J),PL(1,J),F3(1,I),F3Q(1,I,J), LEFT)
        CALL HWUMPP(R3PROJ,FACL(1,J),PL(1,J),F3(1,I),F3R(1,I,J), LEFT)
        CALL HWUMPP(R4PROJ,FACR(1,J),PR(1,J),F4(1,I),F4R(1,I,J), RIGHT)
        CALL HWUMPP(Q4PROJ,FACR(1,J),PR(1,J),F4(1,I),F4Q(1,I,J), RIGHT)
       END DO
      END DO
      DO I=1,2
       DO J=1,2
        AMPS1(I,J)=( - F3K(1,I)* F4(3,J) + F3K(2,I)* F4(4,J)
     &               + F3K(3,I)* F4(1,J) - F3K(4,I)* F4(2,J) ) * TWOSQS
        AMPS2(I,J)=( -  F3(1,I)*F4K(3,J) +  F3(2,I)*F4K(4,J)
     &               +  F3(3,I)*F4K(1,J) -  F3(4,I)*F4K(2,J) ) * TWOSQS
        DO K=1,2
         AMPT1(1,K,I,J)= F3K(1,I)*F4Q(4,J,K)-F3K(3,I)*F4Q(2,J,K)
         AMPT1(2,K,I,J)=-F3K(2,I)*F4Q(3,J,K)+F3K(4,I)*F4Q(1,J,K)
         AMPT3(K,1,I,J)= F3Q(1,I,K)*F4K(4,J)-F3Q(3,I,K)*F4K(2,J)
         AMPT3(K,2,I,J)=-F3Q(2,I,K)*F4K(3,J)+F3Q(4,I,K)*F4K(1,J)
         AMPU1(K,1,I,J)= F3K(1,I)*F4R(4,J,K)-F3K(3,I)*F4R(2,J,K)
         AMPU1(K,2,I,J)=-F3K(2,I)*F4R(3,J,K)+F3K(4,I)*F4R(1,J,K)
         AMPU3(1,K,I,J)= F3R(1,I,K)*F4K(4,J)-F3R(3,I,K)*F4K(2,J)
         AMPU3(2,K,I,J)=-F3R(2,I,K)*F4K(3,J)+F3R(4,I,K)*F4K(1,J)
         DO L=1,2
          AMPT2(K,L,I,J)
     &    = FACGPM(1)*( F3Q(1,I,K)*F4Q(1,J,L)+F3Q(2,I,K)*F4Q(2,J,L) )
     &    + FACGPM(2)*( F3Q(3,I,K)*F4Q(3,J,L)+F3Q(4,I,K)*F4Q(4,J,L) )
          AMPU2(L,K,I,J)
     &    = FACGPM(1)*( F3R(1,I,K)*F4R(1,J,L)+F3R(2,I,K)*F4R(2,J,L) )
     &    + FACGPM(2)*( F3R(3,I,K)*F4R(3,J,L)+F3R(4,I,K)*F4R(4,J,L) )
         END DO
        END DO
       END DO
      END DO
      AMPST2 = ZERO
      AMPSU2 = ZERO
      AMPTU2 = ZERO
      DO I = 1, 2
       DO J = 1, 2
        DO K = 1, 2
         DO L = 1, 2
          IF (I.NE.J) THEN
           AMPS  = AMPS1(K,L) - AMPS2(K,L)
          ELSE
           AMPS  = CZERO
          END IF
          AMPT   = AMPT1(I,J,K,L)+AMPT2(I,J,K,L)+AMPT3(I,J,K,L)
          AMPU   = AMPU1(I,J,K,L)+AMPU2(I,J,K,L)+AMPU3(I,J,K,L)
          AMPST  = AMPS - AMPT
          AMPSU  = AMPS + AMPU
          AMPTU  = AMPT + AMPU
          AMPST2 = AMPST2 + DREAL(DCONJG(AMPST)*AMPST)
          AMPSU2 = AMPSU2 + DREAL(DCONJG(AMPSU)*AMPSU)
          AMPTU2 = AMPTU2 + DREAL(DCONJG(AMPTU)*AMPTU)
         END DO
        END DO
       END DO
      END DO
      FAC  = (P3(0)-P3(3))*(P4(0)+P4(3))
      GGQQHT  = FAC*AMPST2
      GGQQHU  = FAC*AMPSU2
      GGQQHNP = FAC*AMPTU2
 100  CONTINUE
C --- QQ ME.
      IF(IQQ.EQ.0)GOTO 200
      S       = SQS**2
      PT32    = P3(1)**2+P3(2)**2
      PT42    = P4(1)**2+P4(2)**2
      PT52    = P5(1)**2+P5(2)**2
      PT3452  = (PT32+PT42-PT52)/TWO
      RM3452  = (RM3**2+RM4**2-RM5**2)/TWO
      GLAMBDA = FACGPM(1)**2+FACGPM(2)**2
      LAMBDA  = TWO*FACGPM(1)*FACGPM(2)/GLAMBDA
      LAMBDAI = (FACGPM(2)**2-FACGPM(1)**2)/GLAMBDA
      LA34    = S/TWO-SQS*P5(0)-RM3452-LAMBDA*RM3*RM4
      PROP3   = ONE/DCMPLX(SQS*(SQS-TWO*P4(0)),ZERO)
      PROP4   = ONE/DCMPLX(SQS*(SQS-TWO*P3(0)),MGM3)
      PROP    = PROP3+PROP4
      PROP2   = DREAL(DCONJG(PROP)*PROP)
      PROP3R  = DREAL(DCONJG(PROP)*PROP3)
      PROP3I  = DIMAG(DCONJG(PROP)*PROP3)
      PROP4R  = DREAL(DCONJG(PROP)*PROP4)
      PROP4I  = DIMAG(DCONJG(PROP)*PROP4)
      PROP34R = DREAL(DCONJG(PROP3)*PROP4)
      QQQQH   = TWO*GLAMBDA/S*(S*PROP2*(PT3452+TWO*P3(0)*P4(0)-
     & LA34)+TWO*LA34*(PROP3R*PT42+PROP4R*PT32-PROP34R*PT52)-TWO*SQS*((
     & PROP3R*(P3(0)*PT42+P4(0)*PT3452)+PROP4R*(P4(0)*PT32+P3(0)*PT3452)
     & )-(PROP3I*P4(3)-PROP4I*P3(3))*LAMBDAI*(P3(1)*P4(2)-P3(2)*P4(1))))
 200  CONTINUE
      RETURN
      END
