CDECK  ID>, HWH2SH.
*CMZ :-        -30/06/01  18.25.35  by  Stefano Moretti
*-- Author :  Kosuke Odagiri & Stefano Moretti
C-----------------------------------------------------------------------
      SUBROUTINE HWH2SH(SQS,P1,P2,P3,P4,P5,RM3,RM4,RM5,MGM3,MGM4,
     & IGG,IQQ,GGSQHT,GGSQHU,GGSQHN,QQSQH)
C-----------------------------------------------------------------------
C     MATRIX ELEMENT SQUARED FOR THE PROCESS GG/QQ(BAR) -> SQ SQ* HIGGS
C-----------------------------------------------------------------------
C     NEEDS PREFACTOR G_S^4 AND G_(HIGGS-SQ-SQ)^2
C     MGM3, MGM4 = MASS * WIDTH
C     INITIAL STATE MOMENTA: P1=(SQS/2)(1,0,0,1), P2=(SQS/2)(1,0,0,-1)
C     PREFACTORS:
C     GGSQHTOT =
C     (G_S**4)*(G_HIGGS**2)*(GGSQHT+GGSQHU-GGSQHN/CAFAC**2)/(8.*CFFAC)
C     QQSQHTOT =
C     (G_S**4)*(G_HIGGS**2)*(QQSQH                        )*(1.-1./CAFAC**2)/4.
C     N.B. SUBROUTINE CANNOT BE USED FOR PHOTON PHOTON -> ...
C
C...First release:  08-OCT-1999 by Kosuke Odagiri
C...First modified: 12-NOV-1999 by Stefano Moretti
C-----------------------------------------------------------------------
      IMPLICIT NONE
C --- SUBPROCESS
      INTEGER IGG,IQQ
C --- CENTRE-OF-MASS ENERGY, FOUR-MOMENTA, MASSES AND WIDTHS
      DOUBLE PRECISION SQS,P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      DOUBLE PRECISION RM3,RM4,RM5, MGM3,MGM4
C --- POLARISATION INDICES, PROPAGATORS AND GG AMPLITUDES
      INTEGER I,J
      DOUBLE PRECISION G14,G24,G23,G13,MSQS, GGSQHT,GGSQHU,GGSQHN
      DOUBLE COMPLEX G35,G45, AMPT,AMPU,AMPS,AMPC, AMPST,AMPSU,AMPTU
C --- QQ AMPLITUDES
      DOUBLE PRECISION QQSQH
      DOUBLE PRECISION PT32,PT42,PT34
      DOUBLE COMPLEX PROP3,PROP4
C --- CONSTANT PARAMETERS
      DOUBLE PRECISION ZERO,ONE,TWO,SQTWO,MSQTWO
      PARAMETER (ZERO=0.D0,ONE=1.D0,TWO=2.D0)
      SQTWO=SQRT(TWO)
      MSQTWO=-SQTWO/4.D0
      GGSQHT = ZERO
      GGSQHU = ZERO
      GGSQHN = ZERO
      QQSQH  = ZERO
      IF(IGG.EQ.0)GOTO 100
C -- GG SCATTERING.
      MSQS = -SQTWO/SQS
      G13  = MSQS/(P3(0)-P3(3))
      G23  = MSQS/(P3(0)+P3(3))
      G14  = MSQS/(P4(0)-P4(3))
      G24  = MSQS/(P4(0)+P4(3))
      G35  = SQTWO/CMPLX(SQS*(SQS-TWO*P4(0)),MGM4)
      G45  = SQTWO/CMPLX(SQS*(SQS-TWO*P3(0)),MGM3)
      AMPS = 0.5D0*MSQS*(P4(3)*G35-P3(3)*G45)
      AMPC = MSQTWO*(G35+G45)
      DO 10 I = 1,2
       DO 20 J = 1,2
        AMPT=P3(I)*P4(J)*G24*G13-P4(I)*P4(J)*G24*G35-P3(I)*P3(J)*G13*G45
        AMPU=P4(I)*P3(J)*G14*G23-P4(I)*P4(J)*G14*G35-P3(I)*P3(J)*G23*G45
        IF (I.EQ.J) THEN
         AMPST = AMPT-AMPS+AMPC
         AMPSU = AMPU+AMPS+AMPC
        ELSE
         AMPST = AMPT
         AMPSU = AMPU
        END IF
        AMPTU  = AMPST+AMPSU
        GGSQHT = GGSQHT + DREAL(DCONJG(AMPST)*AMPST)
        GGSQHU = GGSQHU + DREAL(DCONJG(AMPSU)*AMPSU)
        GGSQHN = GGSQHN + DREAL(DCONJG(AMPTU)*AMPTU)
 20    CONTINUE
 10   CONTINUE
 100  CONTINUE
      IF(IQQ.EQ.0)GOTO 200
C -- QQ SCATTERING.
      PT32  = P3(1)**2+P3(2)**2
      PT42  = P4(1)**2+P4(2)**2
      PT34  = P3(1)*P4(1)+P3(2)*P4(2)
      PROP3 = ONE/CMPLX(SQS*(SQS-TWO*P3(0)),MGM3)
      PROP4 = ONE/CMPLX(SQS*(SQS-TWO*P4(0)),MGM4)
      QQSQH = TWO/SQS**2*DREAL(PT32*DCONJG(PROP3)*PROP3+
     &            PT42*DCONJG(PROP4)*PROP4-TWO*PT34*DCONJG(PROP3)*PROP4)
 200  CONTINUE
      RETURN
      END
