CDECK  ID>, HWHSPN.
*CMZ :-        -01/10/01  19.41.18  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHSPN
C-----------------------------------------------------------------------
C     Calculates the spin correlations for the hard process
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER NDIAHD
      PARAMETER(NDIAHD=10)
      DOUBLE COMPLEX ZI,S,D,ME(2,2,2,2,NCFMAX),MED(2,2,2,2),F3(2,2,8),
     &     F4(2,2,8),F3M(2,2,8),F4M(2,2,8),FTP(2,2,8,8),FTM(2,2,8,8),
     &     FUP(2,2,8,8),FUM(2,2,8,8),FST(2,2,8)
      DOUBLE PRECISION P(5,4),A(2,NDIAHD),B(2,NDIAHD),XMASS,PLAB,
     &     PRW,PCM,MS(NDIAHD),MWD(NDIAHD),MR(NDIAHD),HWULDO,EE,
     &     PREF(5),EPS,N(3),HWVDOT,PP,PRE,SH,TH,UH,PM(5,4),DIJ(2,2),
     &     MA(4),MA2(4),PTMP(5),WGT,WGTB(NCFMAX),WGTC,HWRGEN
      INTEGER ICM,IHEP,IST,JHEP,KHEP,ID,LHEP,MHEP,IK,IL,IM,IJ,L1,L2,I,J,
     &     IDP(4+NDIAHD),DRTYPE(NDIAHD),NDIA,P1,P2,P3,P4,IFLOW(NDIAHD),
     &     ID1,ID2,III,JJJ,KKK,O(2),LLL,MMM
      DOUBLE PRECISION SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3),HWUAEM
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      LOGICAL SPIN,FIRST
      EXTERNAL HWUAEM
      PARAMETER(ZI=(0.0D0,1.0D0))
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      COMMON/HWSPHC/F3,F4,F3M,F4M,FTP,FTM,FUP,FUM,FST,A,B,MS,MWD,MR,MA,
     &     MA2,SH,TH,UH,IDP,DRTYPE
      COMMON/HWHEWP/XMASS(10),PLAB(5,10),PRW(5,2),PCM(5,10)
      DATA PREF/1.0D0,0.0D0,0.0D0,1.0D0,0.0D0/
      DATA DIJ/1.0D0,0.0D0,0.0D0,1.0D0/
      DATA O/2,1/
      DATA FIRST/.TRUE./
      PARAMETER(EPS=1D-20)
      EXTERNAL HWULDO,HWVDOT,HWRGEN
      SAVE FIRST
      IF(IERROR.NE.0) RETURN
      IF(FIRST) THEN
        CALL HWISPC
        FIRST = .FALSE.
      ENDIF
C--search the event record for the hard process
      DO 1 IHEP=1,NHEP
      IST = ISTHEP(IHEP)
      IF(IST.EQ.110.OR.IST.EQ.120) THEN
        ICM = IHEP
        GOTO 2
      ENDIF
 1    CONTINUE
C--now decide whether or not to perform spin correlation
 2    KHEP = JDAHEP(1,ICM)
      IK   = IDHW(KHEP)
      JHEP = JDAHEP(2,ICM)
      IJ   = IDHW(JHEP)
      IF(JHEP-KHEP+1.NE.2) CALL HWWARN('HWHSPN',500,*999)
      SPIN = .FALSE.
      DO 3 IHEP=KHEP,JHEP
        ID = IDHW(IHEP)
        IF(RSPIN(ID).EQ.0.5D0) SPIN=.TRUE.
 3    CONTINUE
      IF(.NOT.SPIN) RETURN
      IF((RSPIN(IDHW(KHEP)).EQ.ONE.AND.RSPIN(IDHW(JHEP)).EQ.ZERO).OR.
     &  (RSPIN(IDHW(KHEP)).EQ.ZERO.AND.RSPIN(IDHW(JHEP)).EQ.ONE)) RETURN 
      LHEP = JMOHEP(1,ICM)
      MHEP = JMOHEP(2,ICM)
C--now identify the hard process
C--SM processes first
C--fermion-antifermion production in lepton-lepton collisions
C--or via Z/gamma in hadron-hadron collisions
      IF(IPRO.EQ.1.OR.IPRO.EQ.13) THEN
C--only need spin correlations for top and tau production
        IF((IK.EQ.  6.AND.IJ.EQ. 12).OR.(IK.EQ. 12.AND.IJ.EQ.6  ).OR.
     &     (IK.EQ.125.AND.IJ.EQ.131).OR.(IK.EQ.131.AND.IJ.EQ.125)) THEN
C--check fermion first and change order if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--Id's of the incoming and outgoing fermions
          IL  = IDHW(LHEP)
          ID1 = IL-6*INT((IL-1)/6)+10*INT((IL-1)/120)
          ID2 = IK-6*INT((IK-1)/6)+10*INT((IK-1)/120)
C--couplings for the diagrams
C--first the photon exchange
          A(1,1) = -QFCH(ID1)
          A(2,1) = -QFCH(ID1)
          B(1,1) = -QFCH(ID2)
          B(2,1) = -QFCH(ID2)
          IDP(5) = 59
          DRTYPE(1) = 4
C--then the Z exchange
          A(1,2) = -RFCH(ID1)
          A(2,2) = -LFCH(ID1)
          B(1,2) = -RFCH(ID2)
          B(2,2) = -LFCH(ID2)
          IDP(6) = 200
          DRTYPE(2) = 4
C--setup the colour flow
          NDIA = 2
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
          IFLOW(2) = 1
        ELSE
          RETURN
        ENDIF
C--fermion-antifermion via s-channel W in hadron-hadron
      ELSEIF(IPRO.EQ.14) THEN
        IF(IK.EQ.  6.OR.IK.EQ. 12.OR.IJ.EQ.  6.OR.IJ.EQ. 12.OR.
     &     IK.EQ.125.OR.IJ.EQ.131.OR.IK.EQ.131.OR.IJ.EQ.125) THEN
C--check fermion first and reorder if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--couplings for the diagram
          A(1,1) = ZERO
          A(2,1) =-ORT/SW
          B(1,1) = ZERO
          B(2,1) =-ORT/SW
          IDP(5) = 198
          DRTYPE(1) = 4
          NDIA = 1
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
        ELSE
          RETURN
        ENDIF
C--top quark production via QCD
      ELSEIF(IPRO.EQ.15.OR.IPRO.EQ.17) THEN
        IF((IK.EQ.6.AND.IJ.EQ.12).OR.(IK.EQ.12.AND.IJ.EQ.6)) THEN
C--check if the outgoing fermion is first and change order if not
          IF(IDHEP(KHEP).LT.0) THEN
            ID   = KHEP
            KHEP = JHEP
            JHEP = ID
          ENDIF
C--quark-quark to t tbar
          IF(IDHW(LHEP).LE.12.AND.IDHW(MHEP).LE.12) THEN
C--first check the incoming fermion is first and change order if not
            IF(IDHEP(LHEP).LT.0) THEN
              ID   = LHEP
              LHEP = MHEP
              MHEP = ID
            ENDIF
            IL   = IDHW(LHEP)
C--couplings for the diagram
            A(1,1) =-ONE
            A(2,1) =-ONE
            B(1,1) =-ONE
            B(2,1) =-ONE
            IDP(5) = 13
            DRTYPE(1) = 4
            NDIA = 1
C--setup the colour flow
            NCFL(1) = 1
            SPNCFC(1,1,1) = TWO/9.0D0
            IFLOW(1) = 1
C--gluon-gluon to t tbar
          ELSEIF(IDHW(LHEP).EQ.13.AND.IDHW(MHEP).EQ.13) THEN
C--setup the diagrams
            IDP(5) = 12
            IDP(6) = 12
            IDP(7) = 13
            IDP(8) = 13
            DRTYPE(1) = 5
            DRTYPE(2) = 6
            DRTYPE(3) = 7
            DRTYPE(4) = 7
            NDIA = 4
C--setup the colour flow
            NCFL(1) = 2
            IFLOW(1) = 1
            IFLOW(2) = 2
            IFLOW(3) = 1
            IFLOW(4) = 2
            SPNCFC(1,1,1) = 0.25D0/THREE
            SPNCFC(2,2,1) = SPNCFC(1,1,1)
            SPNCFC(1,2,1) = ONE/THREE/32.0D0
            SPNCFC(2,1,1) = ONE/THREE/32.0D0
C--incorrect initial state
          ELSE
            CALL HWWARN('HWHSPN',501,*999)
          ENDIF
C--don't need spin correlations haven't produced top
        ELSE
          RETURN
        ENDIF
C--single top quark production in hadron collisions
      ELSEIF(IPRO.EQ.20) THEN
C--change order if b quark not first and identify incoming particles
        IF(ABS(IDHEP(LHEP)).NE.5) THEN
          ID   = LHEP
          LHEP = MHEP
          MHEP = ID
        ENDIF
        IL  = IDHEP(LHEP)
        IM  = IDHEP(MHEP)
C--change order if t quark not first
        IF(ABS(IDHEP(KHEP)).NE.6) THEN
          ID   = KHEP
          KHEP = JHEP
          JHEP = ID
        ENDIF
C--identify diagram type
C--fermion fermion
        IF(IL.GT.0.AND.IM.GT.0) THEN
          DRTYPE(1) = 17
C--fermion antifermion
        ELSEIF(IL.GT.0.AND.IM.LT.0) THEN
          DRTYPE(1) = 18
C--antifermion fermion
        ELSEIF(IL.LT.0.AND.IM.GT.0) THEN
          DRTYPE(1) = 19
C--antifermion antifermion
        ELSEIF(IL.LT.0.AND.IM.LT.0) THEN
          DRTYPE(1) = 20
C--incorrect initial state
        ELSE
          CALL HWWARN('HWHSPN',502,*999)
        ENDIF
C--couplings
        A(1,1) = ZERO
        A(2,1) = -ORT/SW
        B(1,1) = ZERO
        B(2,1) = -ORT/SW
C--virtual particle etc
        IDP(5) = 198
        NDIA = 1
        NCFL(1) = 1
        SPNCFC(1,1,1) = ONE
        IFLOW(1) = 1
C--SUSY particle production
      ELSEIF(IPRO.EQ.7.OR.IPRO.EQ.30) THEN
        IF(MOD(IPROC,10000).GT.3030) RETURN
C--fermion-antifermion to neutralino neutralino
        IF(IK.GE.450.AND.IK.LE.453.AND.IJ.GE.450.AND.IJ.LE.453) THEN
C--first check the fermion is first and change order if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
          IL   = IDHW(LHEP)
          IM   = IDHW(MHEP)
C--couplings of the various diagrams
          L1     = IK-449
          L2     = IJ-449
          ID     = IL-6*INT((IL-1)/6)+10*INT((IL-1)/120)
C--couplings for the Z exchange diagram
          A(1,1) = -RFCH(ID)
          A(2,1) = -LFCH(ID)
          B(2,1) = HALF*(-ZMIXSS(L1,3)*ZMIXSS(L2,3)
     &                   +ZMIXSS(L1,4)*ZMIXSS(L2,4))/SW/CW
          B(1,1) = -B(2,1)
          B(2,1) = B(2,1)*ZSGNSS(L1)*ZSGNSS(L2)
          DRTYPE(1) = 1
          IDP(5) = 200
C--couplings for the t-channel diagrams
          A(1,2) = ZERO
          A(2,2) =-RT*SLFCH(ID,L1)
          B(1,2) =-RT*SLFCH(ID,L2)
          B(2,2) = ZERO
          IDP(6) = IL-6*INT((IL-1)/6)+24*INT((IL-1)/120)+400
          A(1,3) =-RT*SRFCH(ID,L1)*ZSGNSS(L1)
          A(2,3) = ZERO
          B(1,3) = ZERO
          B(2,3) =-RT*SRFCH(ID,L2)*ZSGNSS(L2)
          IDP(7) = IL-6*INT((IL-1)/6)+24*INT((IL-1)/120)+412
          DRTYPE(2) = 2
          DRTYPE(3) = 2
C--couplings for the u-channel diagrams
          A(1,4) = ZERO
          A(2,4) =-RT*SLFCH(ID,L2)*ZSGNSS(L2)
          B(1,4) =-RT*SLFCH(ID,L1)*ZSGNSS(L1)
          B(2,4) = ZERO
          IDP(8) = IDP(6)
          A(1,5) =-RT*SRFCH(ID,L2)
          A(2,5) = ZERO
          B(1,5) = ZERO
          B(2,5) =-RT*SRFCH(ID,L1)
          IDP(9) = IDP(7)
          DRTYPE(4) = 3
          DRTYPE(5) = 3
          NDIA=5
C--setup the colour flow
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
          IFLOW(2) = 1
          IFLOW(3) = 1
          IFLOW(4) = 1
          IFLOW(5) = 1
C--chargino pair production
        ELSEIF(IK.GE.454.AND.IK.LE.457.AND.IJ.GE.454.AND.IJ.LE.457) THEN
C--first check the fermion is first and change order if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
          IL   = IDHW(LHEP)
          IM   = IDHW(MHEP)
C--couplings of the various diagrams
          L1     = IK-453-2*INT((IK-454)/2)
          L2     = IJ-453-2*INT((IJ-454)/2)
          ID     = IL-6*INT((IL-1)/6)+10*INT((IL-1)/120)
C--couplings for the s-channel photon exchange
          A(1,1) = -QFCH(ID)
          A(2,1) = -QFCH(ID)
          B(1,1) = -DIJ(L1,L2)
          B(2,1) = -DIJ(L1,L2)
          IDP(5) = 59
          DRTYPE(1) = 1
C--couplings for the s-channel Z exchange
          A(1,2) = -RFCH(ID)
          A(2,2) = -LFCH(ID)
          B(1,2) =(-WMXUSS(L1,1)*WMXUSS(L2,1)
     &         -HALF*WMXUSS(L1,2)*WMXUSS(L2,2)+DIJ(L1,L2)*SWEIN)/CW/SW
          B(2,2) =WSGNSS(L1)*WSGNSS(L2)*(-WMXVSS(L1,1)*WMXVSS(L2,1)
     &         -HALF*WMXVSS(L1,2)*WMXVSS(L2,2)+DIJ(L1,L2)*SWEIN)/CW/SW
          IDP(6) = 200
          DRTYPE(2) = 1
C--couplings for the t-channel diagram
          IF(IDHEP(KHEP).GT.0.AND.MOD(IL,2).EQ.0) THEN
            A(1,3)    = ZERO
            A(2,3)    =-WMXUSS(L1,1)/SW
            B(1,3)    =-WMXUSS(L2,1)/SW
            B(2,3)    = ZERO
            DRTYPE(3) = 2
          ELSEIF(IDHEP(KHEP).LT.0.AND.MOD(IL,2).NE.0) THEN
            A(1,3)    =-WMXVSS(L1,1)*WSGNSS(L1)/SW
            A(2,3)    = ZERO
            B(1,3)    = ZERO
            B(2,3)    =-WMXVSS(L2,1)*WSGNSS(L2)/SW
            DRTYPE(3) = 2
          ELSEIF(IDHEP(KHEP).GT.0.AND.MOD(IL,2).NE.0) THEN
            A(1,3)    = ZERO
            A(2,3)    =-WMXVSS(L2,1)*WSGNSS(L2)/SW
            B(1,3)    =-WMXVSS(L1,1)*WSGNSS(L1)/SW
            B(2,3)    = ZERO
            DRTYPE(3) = 3
          ELSE
            A(1,3)    =-WMXUSS(L2,1)/SW
            A(2,3)    = ZERO
            B(1,3)    = ZERO
            B(2,3)    =-WMXUSS(L1,1)/SW
            DRTYPE(3) = 3
          ENDIF
          IDP(7) = IL-6*INT((IL-1)/6)+24*INT((IL-1)/120)+400
     &             +2*MOD(IL,2)-1
          NDIA = 3
C--setup the colour flow
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
          IFLOW(2) = 1
          IFLOW(3) = 1
C--chargino neutralino production
        ELSEIF((IK.GE.454.AND.IK.LE.457.AND.IJ.GE.450.AND.IJ.LE.453).OR.
     &       (IJ.GE.454.AND.IJ.LE.457.AND.IK.GE.450.AND.IK.LE.453)) THEN
C--first check the fermion is first and change order if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--chargino first
          IF(IK.GT.453) THEN
C--change order of outgoing particles if negative chargino
            IF(IDHEP(KHEP).LT.0) THEN
              ID =KHEP
              KHEP=JHEP
              JHEP=ID
            ENDIF
            L1 = IK-453-2*INT((IK-454)/2)
            L2 = IJ-449
C--chargino second
          ELSE
            IF(IDHEP(JHEP).GT.0) THEN
              ID =KHEP
              KHEP=JHEP
              JHEP=ID
            ENDIF
            L1 = IJ-453-2*INT((IJ-454)/2)
            L2 = IK-449
          ENDIF
C--first the W exchange diagram
          A(1,1) = ZERO
          A(2,1) =-ORT/SW
          B(1,1) =( ORT*ZMXNSS(L2,3)*WMXUSS(L1,2)
     &         +ZMXNSS(L2,2)*WMXUSS(L1,1))/SW
          B(2,1) =WSGNSS(L1)*ZSGNSS(L2)*(-ORT*ZMXNSS(L2,4)*WMXVSS(L1,2)
     &         +ZMXNSS(L2,2)*WMXVSS(L1,1))/SW
          IDP(5) = 198
          DRTYPE(1) = 1
C--intermediate particles for the t and u channel diagrams
          IL = IDHW(LHEP)
          IM = IDHW(MHEP)
          IDP(6) = IM+394
          IDP(7) = IL+406
          IF(MOD(IL,2).EQ.0) THEN
            A(1,2) = ZERO
            A(2,2) =-WMXUSS(L1,1)/SW
            B(1,2) =-RT*SLFCH(IM-6,L2)
            B(2,2) = ZERO
            DRTYPE(2) = 2
            A(1,3) = ZERO
            A(2,3) =-RT*ZSGNSS(L2)*SLFCH(IL,L2)
            B(1,3) =-WSGNSS(L1)*WMXVSS(L1,1)/SW
            B(2,3) = ZERO
            DRTYPE(3) = 3
          ELSE
            A(1,2) = ZERO
            A(2,2) =-WSGNSS(L1)*WMXVSS(L1,1)/SW
            B(1,2) =-RT*ZSGNSS(L2)*SLFCH(IM-6,L2)
            B(2,2) = ZERO
            DRTYPE(2) = 3
            A(1,3) = ZERO
            A(2,3) =-RT*SLFCH(IL,L2)
            B(1,3) =-WMXUSS(L1,1)/SW
            B(2,3) = ZERO
            DRTYPE(3) = 2
          ENDIF
C--setup the colour flow
          NDIA = 3
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
          IFLOW(2) = 1
          IFLOW(3) = 1
C--neutralino gluino production
        ELSEIF((IK.EQ.449.AND.IJ.GE.450.AND.IJ.LE.453).OR.
     &         (IJ.EQ.449.AND.IK.GE.450.AND.IK.LE.453)) THEN
C--first check the fermion is first and change order if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--check neutralino first and change order if not
          IF(IK.EQ.449) THEN
            L1 = IJ-449
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
          ELSE
            L1 = IK-449
          ENDIF
          IL = IDHW(LHEP)
C--coupling for the diagrams
C--first t-channel squark exchange
          IDP(5) = 400+IL
          A(1,1) = ZERO
          A(2,1) =-RT*SLFCH(IL,L1)
          B(1,1) =-RT
          B(2,1) = ZERO
          DRTYPE(1) = 2
          IDP(6) = 412+IL
          A(1,2) =-RT*ZSGNSS(L1)*SRFCH(IL,L1)
          A(2,2) = ZERO
          B(1,2) = ZERO
          B(2,2) = RT
          DRTYPE(2) = 2
C--then u-channel s squark exchange
          IDP(7) = 400+IL
          A(1,3) = ZERO
          A(2,3) =-RT
          B(1,3) =-RT*ZSGNSS(L1)*SLFCH(IL,L1)
          B(2,3) = ZERO
          DRTYPE(3) = 3
          IDP(8) = 412+IL
          A(1,4) = RT
          A(2,4) = ZERO
          B(1,4) = ZERO
          B(2,4) =-RT*SRFCH(IL,L1)
          DRTYPE(4) = 3
C--colour flow information
          NDIA = 4
          NCFL(1) = 1
          IFLOW(1) = 1
          IFLOW(2) = 1
          IFLOW(3) = 1
          IFLOW(4) = 1
          SPNCFC(1,1,1) = ONE
C--chargino gluino production
        ELSEIF((IK.GE.454.AND.IK.LE.457.AND.IJ.EQ.449).OR.
     &         (IJ.GE.454.AND.IJ.LE.457.AND.IK.EQ.449)) THEN
C--first check the fermion is first and change order if not
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--check chargino first and change order if not
          IF(IK.EQ.449) THEN
            L1 = IJ-453-2*INT((IJ-454)/2)
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
          ELSE
            L1 = IK-453-2*INT((IK-454)/2)
          ENDIF
          IL = IDHW(LHEP)
          IM = IDHW(MHEP)
          IDP(5) = IM+394
          IDP(6) = IL+406
          IF(MOD(IL,2).EQ.0) THEN
            A(1,1) = ZERO
            A(2,1) =-WMXUSS(L1,1)/SW
            B(1,1) =-RT
            B(2,1) = ZERO
            DRTYPE(1) = 2
            A(1,2) = ZERO
            A(2,2) =-RT
            B(1,2) =-WSGNSS(L1)*WMXVSS(L1,1)/SW
            B(2,2) = ZERO
            DRTYPE(2) = 3
          ELSE
            A(1,1) = ZERO
            A(2,1) =-WSGNSS(L1)*WMXVSS(L1,1)/SW
            B(1,1) =-RT
            B(2,1) = ZERO
            DRTYPE(1) = 2
            A(1,2) = ZERO
            A(2,2) =-RT
            B(1,2) =-WMXUSS(L1,1)/SW
            B(2,2) = ZERO
            DRTYPE(2) = 3
          ENDIF
C--setup the colour flow
          NDIA = 2
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
          IFLOW(2) = 1
C--quark quark to gluino gluino
        ELSEIF(IJ.EQ.449.AND.IK.EQ.449.AND.
     &         IDHW(LHEP).LE.12.AND.IDHW(MHEP).LE.12) THEN
C--change order if antiquark first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
          IL   = IDHW(LHEP)
C--couplings of the various diagrams
          A(1,1) = ZERO
          A(2,1) =-RT
          B(1,1) =-RT
          B(2,1) = ZERO
          A(1,2) = RT
          A(2,2) = ZERO
          B(1,2) = ZERO
          B(2,2) = RT
          DO 4 I=1,2
          A(I,3) = A(I,1)
          B(I,3) = B(I,1)
          A(I,4) = A(I,2)
 4        B(I,4) = B(I,2)
          A(1,5) = ONE
          A(2,5) = ONE
          B(1,5) = ONE
          B(2,5) = ONE
          A(1,6) =-ONE
          A(2,6) =-ONE
          B(1,6) = ONE
          B(2,6) = ONE
C--intermediate particles
          IDP(5) = 400+IL
          IDP(6) = 412+IL
          IDP(7) = 400+IL
          IDP(8) = 412+IL
          IDP(9)  = 13
          IDP(10) = 13
C--types of diagram
          DRTYPE(1) = 2
          DRTYPE(2) = 2
          DRTYPE(3) = 3
          DRTYPE(4) = 3
          DRTYPE(5) = 1
          DRTYPE(6) = 1
          NDIA = 6
C--setup the colour flow
          NCFL(1) = 2
          SPNCFC(1,1,1) = 8.0D0/27.0D0
          SPNCFC(2,2,1) = 8.0D0/27.0D0
          SPNCFC(1,2,1) =-ONE/27.0D0
          SPNCFC(2,1,1) =-ONE/27.0D0
          IFLOW(1) = 1
          IFLOW(2) = 1
          IFLOW(3) = 2
          IFLOW(4) = 2
          IFLOW(5) = 1
          IFLOW(6) = 2
C--gluon gluon to gluino gluino
        ELSEIF(IDHW(LHEP).EQ.13.AND.IDHW(MHEP).EQ.13.AND.IJ.EQ.449
     &         .AND.IK.EQ.449) THEN
C--setup the diagrams
          IDP(5) = 449
          IDP(6) = 449
          IDP(7) = 13
          IDP(8) = 13
          DRTYPE(1) = 14
          DRTYPE(2) = 15
          DRTYPE(3) = 16
          DRTYPE(4) = 16
          NDIA = 4
C--setup the colour flow
          NCFL(1) = 2
          IFLOW(1) = 1
          IFLOW(2) = 2
          IFLOW(3) = 1
          IFLOW(4) = 2
          SPNCFC(1,1,1) = 9.0D0/16.0D0
          SPNCFC(2,2,1) = SPNCFC(1,1,1)
          SPNCFC(1,2,1) =-9.0D0/32.0D0
          SPNCFC(2,1,1) =-9.0D0/32.0D0
C--neutralino squark production
        ELSEIF(    (IK.GE.450.AND.IK.LE.453.AND.
     &        ((IJ.GE.401.AND.IJ.LE.406).OR.(IJ.GE.413.AND.IJ.LE.418)))
     &        .OR.(IJ.GE.450.AND.IJ.LE.453.AND.
     &        ((IK.GE.401.AND.IK.LE.406).OR.(IK.GE.413.AND.IK.LE.418))))
     &         THEN
C--change order if gluon first
          IF(IDHW(LHEP).EQ.13) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--change order in squark first
          IF(IJ.GE.450) THEN
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
            IK = IDHW(KHEP)
            IJ = IDHW(JHEP)
          ENDIF
          IL = IDHW(LHEP)
          L1 = IK-449
C--left handed (lighter) squark
          IF(IJ.LT.412) THEN
            A(1,1) =-RT*SRFCH(IL,L1)*QMIXSS(IL,2,1)
            A(2,1) =-RT*ZSGNSS(L1)*SLFCH(IL,L1)*QMIXSS(IL,1,1)
C--right handed (heavier) squark
          ELSEIF(IJ.GT.412) THEN
            A(1,1) =-RT*SRFCH(IL,L1)*QMIXSS(IL,2,2)
            A(2,1) =-RT*ZSGNSS(L1)*SLFCH(IL,L1)*QMIXSS(IL,1,2)
          ENDIF
          DO 5 I=1,2
 5        A(I,2) = A(I,1)
          IDP(5) = IJ
          IDP(6) = IL
C--colour flow info
          DRTYPE(1) = 8
          DRTYPE(2) = 10
          NDIA = 2
          NCFL(1) = 1
          SPNCFC(1,1,1) = HALF/THREE
          IFLOW(1) = 1
          IFLOW(2) = 1
C--neutralino antisquark production
        ELSEIF(    (IK.GE.450.AND.IK.LE.453.AND.
     &        ((IJ.GE.407.AND.IJ.LE.412).OR.(IJ.GE.419.AND.IJ.LE.424)))
     &        .OR.(IJ.GE.450.AND.IJ.LE.453.AND.
     &        ((IK.GE.407.AND.IK.LE.412).OR.(IK.GE.419.AND.IK.LE.424))))
     &         THEN
C--change order if gluon first
          IF(IDHW(LHEP).EQ.13) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--change order in squark first
          IF(IJ.GE.450) THEN
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
            IK = IDHW(KHEP)
            IJ = IDHW(JHEP)
          ENDIF
          IL = IDHW(LHEP)-6
          L1 = IK-449
C--left handed (lighter) squark
          IF(IJ.LE.412) THEN
            A(1,1) =-RT*ZSGNSS(L1)*SLFCH(IL,L1)*QMIXSS(IL,1,1)
            A(2,1) =-RT*SRFCH(IL,L1)*QMIXSS(IL,2,1)
C--right handed (heavier) squark
          ELSEIF(IJ.GT.412) THEN
            A(1,1) =-RT*ZSGNSS(L1)*SLFCH(IL,L1)*QMIXSS(IL,1,2)
            A(2,1) =-RT*SRFCH(IL,L1)*QMIXSS(IL,2,2)
          ENDIF
          DO 6 I=1,2
 6        A(I,2) = A(I,1)
          IDP(5) = IJ
          IDP(6) = IL
C--colour flow info
          DRTYPE(1) = 9
          DRTYPE(2) = 11
          NDIA = 2
          NCFL(1) = 1
          SPNCFC(1,1,1) = HALF/THREE
          IFLOW(1) = 1
          IFLOW(2) = 1
C--chargino squark
        ELSEIF((IK.GE.454.AND.IK.LE.457.AND.
     &         ((IJ.GE.401.AND.IJ.LE.406).OR.(IJ.GE.413.AND.IJ.LE.418)))
     &         .OR.(IJ.GE.454.AND.IJ.LE.457.AND.
     &        ((IK.GE.401.AND.IK.LE.406).OR.(IK.GE.413.AND.IK.LE.418))))
     &         THEN
C--change order if gluon first
          IF(IDHW(LHEP).EQ.13) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--change order if squark first
          IF(IJ.GE.454) THEN
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
            IK = IDHW(KHEP)
            IJ = IDHW(JHEP)
          ENDIF
          IL = IDHW(LHEP)
          L1 = IK-453-2*INT((IK-454)/2)
C--left handed (lighter) squark
          A(1,1) = ZERO
          IF(IJ.LE.412) THEN
            IF(MOD(IL,2).EQ.0) THEN
              A(2,1) = -WMXUSS(L1,1)*QMIXSS(IL-1,1,1)/SW
            ELSE
              A(2,1) = -WSGNSS(L1)*WMXVSS(L1,1)*QMIXSS(IL+1,1,1)/SW
            ENDIF
C--right handed (heavier) squark
          ELSEIF(IJ.GT.412) THEN
            IF(MOD(IL,2).EQ.0) THEN
              A(2,1) = -WMXUSS(L1,1)*QMIXSS(IL-1,1,2)/SW
            ELSE
              A(2,1) = -WSGNSS(L1)*WMXVSS(L1,1)*QMIXSS(IL+1,1,2)/SW
            ENDIF
          ENDIF
          DO 7 I=1,2
 7        A(I,2) = A(I,1)
          IDP(5) = IJ
          IDP(6) = IL
C--colour flow info
          DRTYPE(1) = 8
          DRTYPE(2) = 10
          NDIA = 2
          NCFL(1) = 1
          SPNCFC(1,1,1) = HALF/THREE
          IFLOW(1) = 1
          IFLOW(2) = 1
C--chargino antisquark
        ELSEIF((IK.GE.454.AND.IK.LE.457.AND.
     &         ((IJ.GE.407.AND.IJ.LE.412).OR.(IJ.GE.419.AND.IJ.LE.424)))
     &         .OR.(IJ.GE.454.AND.IJ.LE.457.AND.
     &        ((IK.GE.407.AND.IK.LE.412).OR.(IK.GE.419.AND.IK.LE.424))))
     &         THEN
C--change order if gluon first
          IF(IDHW(LHEP).EQ.13) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--change order in squark first
          IF(IJ.GE.454) THEN
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
            IK = IDHW(KHEP)
            IJ = IDHW(JHEP)
          ENDIF
          IL = IDHW(LHEP)-6
          L1 = IK-453-2*INT((IK-454)/2)
C--left handed (lighter) squark
          A(2,1) = ZERO
          IF(IJ.LE.412) THEN
            IF(MOD(IL,2).EQ.0) THEN
              A(1,1) = -WMXUSS(L1,1)*QMIXSS(IL-1,1,1)/SW
            ELSE
              A(1,1) = -WSGNSS(L1)*WMXVSS(L1,1)*QMIXSS(IL+1,1,1)/SW
            ENDIF
C--right handed (heavier) squark
          ELSEIF(IJ.GT.412) THEN
            IF(MOD(IL,2).EQ.0) THEN
              A(1,1) = -WMXUSS(L1,1)*QMIXSS(IL-1,1,2)/SW
            ELSE
              A(1,1) = -WMXVSS(L1,1)*QMIXSS(IL+1,1,2)/SW
            ENDIF
          ENDIF
          DO 8 I=1,2
 8        A(I,2) = A(I,1)
          IDP(5) = IJ
          IDP(6) = IL
C--colour flow info
          DRTYPE(1) = 9
          DRTYPE(2) = 11
          NDIA = 2
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          IFLOW(1) = 1
          IFLOW(2) = 1
C--squark gluino production
        ELSEIF((IK.EQ.449.AND.((IJ.GE.401.AND.IJ.LE.406)
     &                         .OR.(IJ.GE.413.AND.IJ.LE.418)))
     &         .OR.(IJ.GE.449.AND.((IK.GE.401.AND.IK.LE.406)
     &                         .OR.(IK.GE.413.AND.IK.LE.418)))) THEN
C--change order if gluon first
          IF(IDHW(LHEP).EQ.13) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
          IL = IDHW(LHEP)
C--change order in squark first
          IF(IJ.EQ.449) THEN
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
            IJ = IDHW(JHEP)
          ENDIF
          ID = INT((IJ-401)/12)+1
          IF(ID.EQ.1) THEN
            A(1,1) = ZERO
            A(2,1) =-RT
          ELSE
            A(1,1) = RT
            A(2,1) = ZERO
          ENDIF
          DO 9 I=1,2
          A(I,2) =-A(I,1)
          A(I,3) = A(I,1)
 9        A(I,4) = A(I,1)
          DRTYPE(1) = 12
          DRTYPE(2) = 12
          DRTYPE(3) = 8
          DRTYPE(4) = 10
          IDP(5) = 449
          IDP(6) = 449
          IDP(7) = IJ
          IDP(8) = IL
C--colour flows
          NDIA = 4
          NCFL(1) = 2
          IFLOW(1) = 1
          IFLOW(2) = 2
          IFLOW(3) = 1
          IFLOW(4) = 2
          SPNCFC(1,1,1) = 2.0D0/9.0D0
          SPNCFC(2,2,1) = 2.0D0/9.0D0
          SPNCFC(1,2,1) = -0.25D0/9.0D0
          SPNCFC(2,1,1) = -0.25D0/9.0D0
C--antisquark gluino production
        ELSEIF((IK.GE.449..AND.((IJ.GE.407.AND.IJ.LE.412)
     &                          .OR.(IJ.GE.419.AND.IJ.LE.424)))
     &         .OR.(IJ.GE.449.AND.((IK.GE.407.AND.IK.LE.412)
     &                          .OR.(IK.GE.419.AND.IK.LE.424)))) THEN
C--change order if gluon first
          IF(IDHW(LHEP).EQ.13) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
          IL = IDHW(LHEP)
C--change order in squark first
          IF(IJ.EQ.449) THEN
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
            IJ = IDHW(JHEP)
          ENDIF
          ID = INT((IJ-401)/12)+1
          IF(ID.EQ.1) THEN
            A(1,1) =-RT
            A(2,1) = ZERO
          ELSE
            A(1,1) = ZERO
            A(2,1) = RT
          ENDIF
          DO 10 I=1,2
          A(I,2) =-A(I,1)
          A(I,3) = A(I,1)
 10       A(I,4) = A(I,1)
          DRTYPE(1) = 13
          DRTYPE(2) = 13
          DRTYPE(3) = 9
          DRTYPE(4) = 11
          IDP(5) = 449
          IDP(6) = 449
          IDP(7) = IJ
          IDP(8) = IL
C--colour flows
          NDIA = 4
          NCFL(1) = 2
          IFLOW(1) = 1
          IFLOW(2) = 2
          IFLOW(3) = 1
          IFLOW(4) = 2
          SPNCFC(1,1,1) = 2.0D0/9.0D0
          SPNCFC(2,2,1) = 2.0D0/9.0D0
          SPNCFC(1,2,1) = -0.25D0/9.0D0
          SPNCFC(2,1,1) = -0.25D0/9.0D0
C--unrecognised SUSY process
        ELSE
          CALL HWWARN('HWHSPN',503,*999)
        ENDIF
C--LLE processes
      ELSEIF(IPRO.EQ.8) THEN
C--neutralino antineutrino production
        IF(IK.GE.450.AND.IK.LE.453.AND.
     &     IJ.GE.127.AND.IJ.LE.132.AND.MOD(IJ,2).EQ.0) THEN
C--ensure lepton first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IJ-126)/2
          JJJ = (IDHW(LHEP)-119)/2
          KKK = (IDHW(MHEP)-125)/2
          L1  = IK-449
          IDP(5) = 424+2*III
          DO 11 I=1,2
          IDP(5+I) = 423+2*JJJ+(I-1)*12
 11       IDP(7+I) = 423+2*KKK+(I-1)*12
C--types of diagram
          DRTYPE(1) = 21
          DRTYPE(2) = 22
          DRTYPE(3) = 22
          DRTYPE(4) = 23
          DRTYPE(5) = 23
C--RPV couplings
          A(1,1) = ZERO 
          A(2,1) = -LAMDA1(III,JJJ,KKK)
          DO 12 I=1,2
          B(1,I+1) = ZERO
          B(2,I+1) = -LMIXSS(2*JJJ-1,1,I)*LAMDA1(III,JJJ,KKK)
          A(1,I+3) = ZERO
 12       A(2,I+3) = -LMIXSS(2*KKK-1,2,I)*LAMDA1(III,JJJ,KKK)
C--MSSM couplings
          DO 13 J=1,2
          B(J,1) = AFN(O(J),2*III+6,1,L1)
          DO 13 I=1,2
          A(J,I+1) = AFN(O(J),2*JJJ+5,I,L1)
 13       B(J,I+3) = AFN(  J ,2*KKK+5,I,L1)
C--colour flows
          NDIA = 5
          NCFL(1) = 1
          DO 14 I=1,5
 14       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE
C--neutralino neutrino production
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.
     &         IJ.GE.121.AND.IJ.LE.126.AND.MOD(IJ,2).EQ.0) THEN
C--ensure lepton first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IJ-120)/2
          JJJ = (IDHW(MHEP)-125)/2
          KKK = (IDHW(LHEP)-119)/2
          L1  = IK-449
          IDP(5) = 424+2*III
          DO 15 I=1,2
          IDP(5+I) = 423+2*JJJ+(I-1)*12
 15       IDP(7+I) = 423+2*KKK+(I-1)*12
C--types of diagram
          DRTYPE(1) = 24
          DRTYPE(2) = 25
          DRTYPE(3) = 25
          DRTYPE(4) = 26
          DRTYPE(5) = 26
C--RPV couplings
          A(1,1) = -LAMDA1(III,JJJ,KKK)
          A(2,1) = ZERO 
          DO 16 I=1,2
          B(1,I+1) = -LMIXSS(2*JJJ-1,1,I)*LAMDA1(III,JJJ,KKK)
          B(2,I+1) = ZERO
          A(1,I+3) = -LMIXSS(2*KKK-1,2,I)*LAMDA1(III,JJJ,KKK)
 16       A(2,I+3) = ZERO
C--MSSM couplings
          DO 17 J=1,2
          B(J,1) = AFN(  J ,2*III+6,1,L1)
          DO 17 I=1,2
          A(J,I+1) = AFN(  J ,2*JJJ+5,I,L1)
 17       B(J,I+3) = AFN(O(J),2*KKK+5,I,L1)
C--colour flows
          NDIA = 5
          NCFL(1) = 1
          DO 18 I=1,5
 18       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE
C--chargino antilepton
        ELSEIF(IK.GE.456.AND.IK.LE.457.AND.
     &         IJ.GE.127.AND.IJ.LE.132.AND.MOD(IJ,2).EQ.1) THEN
C--ensure lepton first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IJ-125)/2
          JJJ = (IDHW(LHEP)-119)/2
          KKK = (IDHW(MHEP)-125)/2
          L1 = IK-455
          IDP(5) = 2*III+424
          IDP(6) = 2*JJJ+424
C--RPV couplings
          A(1,1) = ZERO
          A(2,1) = LAMDA1(III,JJJ,KKK)
          B(1,2) = ZERO
          B(2,2) =-LAMDA1(III,JJJ,KKK)
C--MSSM couplings
          DO 19 J=1,2
          B(J,1) = AFC(O(J),2*III+6,1,L1)
 19       A(J,2) = AFC(O(J),2*JJJ+6,1,L1)
C--colour flows
          DRTYPE(1) = 21
          DRTYPE(2) = 22
          NDIA = 2
          NCFL(1) = 1
          DO 20 I=1,2
 20       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE
C--chargino lepton
        ELSEIF(IK.GE.454.AND.IK.LE.455.AND.
     &         IJ.GE.121.AND.IJ.LE.126.AND.MOD(IJ,2).EQ.1) THEN
C--ensure lepton first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IJ-119)/2
          JJJ = (IDHW(MHEP)-125)/2
          KKK = (IDHW(LHEP)-119)/2
          L1 = IK-453
          IDP(5) = 2*III+424
          IDP(6) = 2*JJJ+424
C--RPV couplings
          A(1,1) = LAMDA1(III,JJJ,KKK)
          A(2,1) = ZERO
          B(1,2) =-LAMDA1(III,JJJ,KKK)
          B(2,2) = ZERO
C--MSSM couplings
          DO 21 J=1,2
          B(J,1) = AFC(J,2*III+6,1,L1)
 21       A(J,2) = AFC(J,2*JJJ+6,1,L1)
C--colour flows
          DRTYPE(1) = 24
          DRTYPE(2) = 25
          NDIA = 2
          NCFL(1) = 1
          DO 22 I=1,2
 22       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE
C--e+e- production
        ELSEIF(IK.GE.121.AND.IK.LE.132.AND.MOD(IK,2).EQ.1.AND.
     &         IJ.GE.121.AND.IJ.LE.132.AND.MOD(IJ,2).EQ.1) THEN
C--ensure incoming lepton first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--ensure outgoing lepton first
          IF(IDHEP(KHEP).LT.0) THEN
            ID = IK
            IK = IJ
            IJ = ID
            ID = KHEP
            KHEP = JHEP
            JHEP = ID
          ENDIF
C--only need the correlations for tau production
          IF(IK.NE.125.AND.IJ.NE.131) RETURN
C--find the RPV indices
          III = (IDHW(LHEP)-119)/2
          KKK = (IK-119)/2
          LLL = (IJ-125)/2
          NDIA = 0
          EE = SQRT(HWUAEM(SH)*FOUR*PIFAC)
C--s-channel photon and Z exchange if needed
          IF(KKK.EQ.LLL) THEN
            NDIA = 2
            ID1 = 9+2*III
            ID2 = 9+2*KKK
C--photon first
            A(1,1) = -EE*QFCH(ID1)
            A(2,1) = -EE*QFCH(ID1)
            B(1,1) = -EE*QFCH(ID2)
            B(2,1) = -EE*QFCH(ID2)
            IDP(5) = 59
            DRTYPE(1) = 4
C--then the Z exchange
            A(1,2) = -EE*RFCH(ID1)
            A(2,2) = -EE*LFCH(ID1)
            B(1,2) = -EE*RFCH(ID2)
            B(2,2) = -EE*LFCH(ID2)
            IDP(6) = 200
            DRTYPE(2) = 4
          ENDIF
          DO 23 JJJ=1,3
C--s-channel sneutrino exchange
            IF(ABS(LAMDA1(III,JJJ,III)*LAMDA1(LLL,JJJ,KKK)).GT.EPS) THEN
              NDIA = NDIA+1
              DRTYPE(NDIA) = 21
              IDP(NDIA+4) = 424+2*JJJ
              A(1,NDIA)   = LAMDA1(III,JJJ,III)
              A(2,NDIA)   = ZERO
              B(1,NDIA)   = ZERO
              B(2,NDIA)   = LAMDA1(LLL,JJJ,KKK)
            ENDIF
C--s-channel antisneutrino exchange
            IF(ABS(LAMDA1(III,JJJ,III)*LAMDA1(KKK,JJJ,LLL)).GT.EPS) THEN
              NDIA = NDIA+1
              DRTYPE(NDIA) = 21
              IDP(NDIA+4)  = 424+2*JJJ
              A(1,NDIA)    = ZERO
              A(2,NDIA)    = LAMDA1(III,JJJ,III)
              B(1,NDIA)    = LAMDA1(KKK,JJJ,LLL)
              B(2,NDIA)    = ZERO
            ENDIF
C--t-channel sneutrino exchange
            IF(ABS(LAMDA1(KKK,JJJ,III)*LAMDA1(LLL,JJJ,III)).GT.EPS) THEN
              NDIA = NDIA+1
              DRTYPE(NDIA) = 22
              IDP(NDIA+4)  = 424+2*JJJ
              A(1,NDIA)    = LAMDA1(KKK,JJJ,III)
              A(2,NDIA)    = ZERO
              B(1,NDIA)    = ZERO
              B(2,NDIA)    = LAMDA1(LLL,JJJ,III)
            ENDIF
C--t-channel antisneutrino exchange
            IF(ABS(LAMDA1(III,JJJ,KKK)*LAMDA1(III,JJJ,LLL)).GT.EPS) THEN
              NDIA = NDIA+1
              DRTYPE(NDIA) = 22
              IDP(NDIA+4)  = 424+2*JJJ
              A(1,NDIA)    = ZERO
              A(2,NDIA)    = LAMDA1(III,JJJ,KKK)
              B(1,NDIA)    = LAMDA1(III,JJJ,LLL)
              B(2,NDIA)    = ZERO
            ENDIF
 23       CONTINUE
C--setup the colour flow
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
          DO 24 I=1,NDIA
 24       IFLOW(I) = 1
C--d dbar production
        ELSEIF(IK.LE.12.AND.IK.LE.12.AND.
     &         MOD(IJ,2).EQ.1.AND.MOD(IK,2).EQ.1) THEN
C--can't produce quark which decays before hadronization
          RETURN
C--unrecognised process
        ELSE
          CALL HWWARN('HWHSPN',504,*999)
        ENDIF 
C--LQD processes
      ELSEIF(IPRO.EQ.40) THEN
C--change outgoing order
        ID = IJ
        IJ = IK
        IK = ID
        ID = JHEP
        JHEP = KHEP
        KHEP = ID
C--neutrino neutralino production
        IF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.0.AND.
     &     IDPDG(IJ).GT.0) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV coupling
          III = (IJ-120)/2
          JJJ = (IDHW(MHEP)-5)/2
          KKK = (IDHW(LHEP)+1)/2
          L1  = IK - 449
          IDP(5) = 424+2*III
          DO 25 I=1,2
          IDP(5+I) = 399+2*JJJ+(I-1)*12
 25       IDP(7+I) = 399+2*KKK+(I-1)*12
C--types of diagram
          DRTYPE(1) = 24
          DRTYPE(2) = 25
          DRTYPE(3) = 25
          DRTYPE(4) = 26
          DRTYPE(5) = 26
C--RPV couplings
          A(1,1) = -LAMDA2(III,JJJ,KKK)
          A(2,1) = ZERO 
          DO 26 I=1,2
          B(1,I+1) = -QMIXSS(2*JJJ-1,1,I)*LAMDA2(III,JJJ,KKK)
          B(2,I+1) = ZERO
          A(1,I+3) = -QMIXSS(2*KKK-1,2,I)*LAMDA2(III,JJJ,KKK)
 26       A(2,I+3) = ZERO
C--MSSM couplings
          DO 27 J=1,2
          B(J,1) = AFN(  J ,2*III+6,1,L1)
          DO 27 I=1,2
          A(J,I+1) = AFN(  J ,2*JJJ-1,I,L1)
 27       B(J,I+3) = AFN(O(J),2*KKK-1,I,L1)
C--colour flows
          NDIA = 5
          NCFL(1) = 1
          DO 28 I=1,5
 28       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--antineutrino neutralino production
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.0.AND.
     &         IDPDG(IJ).LT.0) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV coupling
          III = (IJ-126)/2
          JJJ = (IDHW(LHEP)+1)/2
          KKK = (IDHW(MHEP)-5)/2
          L1  = IK - 449
          IDP(5) = 424+2*III
          DO 29 I=1,2
          IDP(5+I) = 399+2*JJJ+(I-1)*12
 29       IDP(7+I) = 399+2*KKK+(I-1)*12
C--types of diagram
          DRTYPE(1) = 21
          DRTYPE(2) = 22
          DRTYPE(3) = 22
          DRTYPE(4) = 23
          DRTYPE(5) = 23
C--RPV couplings
          A(1,1) = ZERO 
          A(2,1) = -LAMDA2(III,JJJ,KKK)
          DO 30 I=1,2
          B(1,I+1) = ZERO
          B(2,I+1) = -QMIXSS(2*JJJ-1,1,I)*LAMDA2(III,JJJ,KKK)
          A(1,I+3) = ZERO
 30       A(2,I+3) = -QMIXSS(2*KKK-1,2,I)*LAMDA2(III,JJJ,KKK)
C--MSSM couplings
          DO 31 J=1,2
          B(J,1) = AFN(O(J),2*III+6,1,L1)
          DO 31 I=1,2
          A(J,I+1) = AFN(O(J),2*JJJ-1,I,L1)
 31       B(J,I+3) = AFN(  J ,2*KKK-1,I,L1)
C--colour flows
          NDIA = 5
          NCFL(1) = 1
          DO 32 I=1,5
 32       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--lepton neutralino production
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.1.AND.
     &         IDPDG(IJ).GT.0) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV coupling
          III = (IJ-119)/2
          JJJ = (IDHW(MHEP)-6)/2
          KKK = (IDHW(LHEP)+1)/2
          L1  = IK - 449
          DO 33 I=1,2
          IDP(4+I) = 423+2*III+(I-1)*12
          IDP(6+I) = 400+2*JJJ+(I-1)*12
 33       IDP(8+I) = 399+2*KKK+(I-1)*12
C--types of diagram
          DRTYPE(1) = 24
          DRTYPE(2) = 24
          DRTYPE(3) = 25
          DRTYPE(4) = 25
          DRTYPE(5) = 26
          DRTYPE(6) = 26
C--RPV couplings
          DO 34 I=1,2
          A(1,I  ) = LMIXSS(2*III-1,1,I)*LAMDA2(III,JJJ,KKK)
          A(2,I  ) = 0.0D0
          B(1,I+2) = QMIXSS(2*JJJ  ,1,I)*LAMDA2(III,JJJ,KKK)
          B(2,I+2) = 0.0D0
          A(1,I+4) = QMIXSS(2*KKK-1,2,I)*LAMDA2(III,JJJ,KKK)
          A(2,I+4) = 0.0D0
C--MSSM couplings
          DO 34 J=1,2
          B(J,I  ) = AFN(  J ,2*III+5,I,L1)
          A(J,I+2) = AFN(  J ,2*JJJ  ,I,L1)
 34       B(J,I+4) = AFN(O(J),2*KKK-1,I,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 35 I=1,6
 35       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--antilepton neutralino production
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.1.AND.
     &         IDPDG(IJ).LT.0) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV coupling
          III = (IJ-125)/2
          JJJ = IDHW(LHEP)/2
          KKK = (IDHW(MHEP)-5)/2
          L1  = IK - 449
          DO 36 I=1,2
          IDP(4+I) = 423+2*III+(I-1)*12
          IDP(6+I) = 400+2*JJJ+(I-1)*12
 36       IDP(8+I) = 399+2*KKK+(I-1)*12
C--types of diagram
          DRTYPE(1) = 21
          DRTYPE(2) = 21
          DRTYPE(3) = 22
          DRTYPE(4) = 22
          DRTYPE(5) = 23
          DRTYPE(6) = 23
C--RPV couplings
          DO 37 I=1,2
          A(1,I  ) = 0.0D0
          A(2,I  ) = LMIXSS(2*III-1,1,I)*LAMDA2(III,JJJ,KKK)
          B(1,I+2) = 0.0D0
          B(2,I+2) = QMIXSS(2*JJJ  ,1,I)*LAMDA2(III,JJJ,KKK)
          A(1,I+4) = 0.0D0
          A(2,I+4) = QMIXSS(2*KKK-1,2,I)*LAMDA2(III,JJJ,KKK)
C--MSSM couplings
          DO 37 J=1,2
          B(J,I  ) = AFN(O(J),2*III+5,I,L1)
          A(J,I+2) = AFN(O(J),2*JJJ  ,I,L1)
 37       B(J,I+4) = AFN(  J ,2*KKK-1,I,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 39 I=1,6
 39       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C-- +ve chargino antineutrino
        ELSEIF(IK.GE.454.AND.IK.LE.455.AND.MOD(IJ,2).EQ.0) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV
          III = (IJ-126)/2
          JJJ =  IDHW(LHEP)/2
          KKK = (IDHW(MHEP)-5)/2
          L1 = IK-453
          DO 40 I=1,2
          IDP(4+I) = 423+2*III+(I-1)*12
 40       IDP(6+I) = 399+2*JJJ+(I-1)*12
C--types of diagram
          DRTYPE(1) = 21
          DRTYPE(2) = 21
          DRTYPE(3) = 22
          DRTYPE(4) = 22
          DO 41 I=1,2
C--RPV couplings
          A(1,I  ) = ZERO
          A(2,I  ) = LMIXSS(2*III-1,1,I)*LAMDA2(III,JJJ,KKK)
          B(1,I+2) = ZERO
          B(2,I+2) =-QMIXSS(2*JJJ-1,1,I)*LAMDA2(III,JJJ,KKK)
C--MSSM couplings
          DO 41 J=1,2
          B(J,I  ) = AFC(O(J),2*III+5,I,L1)
 41       A(J,I+2) = AFC(O(J),2*JJJ-1,I,L1)
C--colour flows
          NDIA = 4
          NCFL(1) = 1
          DO 42 I=1,4
 42       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C-- -ve chargino neutrino
        ELSEIF(IK.GE.456.AND.IK.LE.457.AND.MOD(IJ,2).EQ.0) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV
          III = (IJ-120)/2
          JJJ = (IDHW(MHEP)-6)/2
          KKK = (IDHW(LHEP)+1)/2
          L1 = IK-455
          DO 43 I=1,2
          IDP(4+I) = 423+2*III+(I-1)*12
 43       IDP(6+I) = 399+2*JJJ+(I-1)*12
C--types of diagram
          DRTYPE(1) = 24
          DRTYPE(2) = 24
          DRTYPE(3) = 25
          DRTYPE(4) = 25
          DO 44 I=1,2
C--RPV couplings
          A(1,I  ) = LMIXSS(2*III-1,1,I)*LAMDA2(III,JJJ,KKK)
          A(2,I  ) = ZERO
          B(1,I+2) =-QMIXSS(2*JJJ-1,1,I)*LAMDA2(III,JJJ,KKK)
          B(2,I+2) = ZERO
C--MSSM couplings
          DO 44 J=1,2
          B(J,I  ) = AFC(J,2*III+5,I,L1)
 44       A(J,I+2) = AFC(J,2*JJJ-1,I,L1)
C--colour flows
          NDIA = 4
          NCFL(1) = 1
          DO 45 I=1,4
 45       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C-- -ve chargino antilepton
        ELSEIF(IK.GE.456.AND.IK.LE.457.AND.MOD(IJ,2).EQ.1) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV
          III = (IJ-125)/2
          JJJ = (IDHW(LHEP)+1)/2
          KKK = (IDHW(MHEP)-5)/2
          L1 = IK-455
          IDP(5) = 424+2*III
          DO 46 I=1,2
 46       IDP(5+I) = 400+2*JJJ+(I-1)*12
C--types of diagram
          DRTYPE(1) = 21
          DRTYPE(2) = 22
          DRTYPE(3) = 22
C--RPV couplings
          A(1,1) = 0.0D0
          A(2,1) =-LAMDA2(III,JJJ,KKK)
          DO 47 I=1,2
          B(1,I+1) = 0.0D0
 47       B(2,I+1) = QMIXSS(2*JJJ,1,I)*LAMDA2(III,JJJ,KKK)
C--MSSM couplings
          DO 48 J=1,2
          B(J,1) = AFC(O(J),2*III+6,1,L1) 
          DO 48 I=1,2
 48       A(J,I+1) = AFC(O(J),2*JJJ,I,L1)
C--colour flows
          NDIA = 3
          NCFL(1) = 1
          DO 49 I=1,3
 49       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C-- +ve chargino lepton
        ELSEIF(IK.GE.454.AND.IK.LE.455.AND.MOD(IJ,2).EQ.1) THEN
C--change order if antiparticle first
          IF(IDHEP(LHEP).LT.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--indices for RPV
          III = (IJ-119)/2
          JJJ = (IDHW(MHEP)-5)/2
          KKK = (IDHW(LHEP)+1)/2
          L1 = IK-453
          IDP(5) = 424+2*III
          DO 50 I=1,2
 50       IDP(5+I) = 400+2*JJJ+(I-1)*12
C--types of diagram
          DRTYPE(1) = 24
          DRTYPE(2) = 25
          DRTYPE(3) = 25
C--RPV couplings
          A(1,1) =-LAMDA2(III,JJJ,KKK)
          A(2,1) = 0.0D0
          DO 51 I=1,2
          B(1,I+1) = QMIXSS(2*JJJ,1,I)*LAMDA2(III,JJJ,KKK)
 51       B(2,I+1) = 0.0D0
C--MSSM couplings
          DO 52 J=1,2
          B(J,1) = AFC(J,2*III+6,1,L1) 
          DO 52 I=1,2
 52       A(J,I+1) = AFC(J,2*JJJ,I,L1)
C--colour flows
          NDIA = 3
          NCFL(1) = 1
          DO 53 I=1,3
 53       IFLOW(I) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--d dbar d dbar
        ELSEIF(IK.LE.12.AND.IJ.LE.12.AND.
     &         MOD(IJ,2).EQ.1.AND.MOD(IK,2).EQ.1) THEN
C--can't produce unstable quark (on hadronization timescale)
          RETURN
C--u    dbar --> u    dbar
        ELSEIF((IJ.LE. 6.AND.MOD(IJ,2).EQ.0.AND.
     &          IK.LE.12.AND.MOD(IK,2).EQ.1).OR.
     &         (IK.LE.6 .AND.MOD(IK,2).EQ.0.AND.
     &          IJ.LE.12.AND.MOD(IJ,2).EQ.1)) THEN
C--ensure u first (incoming)
          IF(MOD(IDHW(LHEP),2).EQ.1) THEN
            ID   = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--ensure u first (outgoing)
          IF(MOD(IK,2).EQ.1) THEN
            ID = IJ
            IJ = IK
            IK = ID
            ID = JHEP
            JHEP = KHEP
            KHEP = ID
          ENDIF
C--can't produce unstable quark (on hadronization timescale)
          IF(IK.NE.6) RETURN
C--RPV indices
          JJJ = IDHW(LHEP)/2
          KKK = (IDHW(MHEP)-5)/2
          LLL = IK/2
          MMM = (IJ-5)/2
          NDIA = 0
          DO 54 III=1,3
          IF(ABS(LAMDA2(III,JJJ,KKK)*LAMDA2(III,LLL,MMM)).LT.EPS) 
     &            GOTO 54
          DO 55 J=1,2
          IFLOW(NDIA+J) = 1
          IDP(4+NDIA+J) = 423+2*III+12*(J-1)
          A(1,NDIA+J) = ZERO
          A(2,NDIA+J) = LAMDA2(III,JJJ,KKK)*LMIXSS(2*III-1,1,J)
          B(1,NDIA+J) = LAMDA2(III,LLL,MMM)*LMIXSS(2*III-1,1,J)
          B(2,NDIA+J) = ZERO
 55       DRTYPE(NDIA+J) = 21
          NDIA = NDIA+2
 54       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
C--ubar d    --> ubar d
        ELSEIF((IJ.LE.12.AND.MOD(IJ,2).EQ.0.AND.
     &          IK.LE. 6.AND.MOD(IK,2).EQ.1).OR.
     &         (IK.LE.12.AND.MOD(IK,2).EQ.0.AND.
     &          IJ.LE. 6.AND.MOD(IJ,2).EQ.1)) THEN
C--ensure d first (incoming)
          IF(MOD(IDHW(LHEP),2).EQ.0) THEN
            ID   = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--ensure d first (outgoing)
          IF(MOD(IK,2).EQ.0) THEN
            ID = IJ
            IJ = IK
            IK = ID
            ID = JHEP
            JHEP = KHEP
            KHEP = ID
          ENDIF
C--can't produce unstable quark (on hadronization timescale)
          IF(IJ.NE.12) RETURN
C--RPV indices
          JJJ = (IDHW(MHEP)-6)/2
          KKK = (IDHW(LHEP)+1)/2
          LLL = (IJ-6)/2
          MMM = (IK+1)/2
          NDIA = 0
          DO 56 III=1,3
          IF(ABS(LAMDA2(III,JJJ,KKK)*LAMDA2(III,LLL,MMM)).LT.EPS)
     &             GOTO 56
          DO 57 J=1,2
          IFLOW(NDIA+J) = 1
          IDP(4+NDIA+J) = 423+2*III+12*(J-1)
          A(1,NDIA+J) = LAMDA2(III,JJJ,KKK)*LMIXSS(2*III-1,1,J)
          A(2,NDIA+J) = ZERO
          B(1,NDIA+J) = ZERO
          B(2,NDIA+J) = LAMDA2(III,LLL,MMM)*LMIXSS(2*III-1,1,J)
 57       DRTYPE(NDIA+J) = 21
          NDIA = NDIA+2
 56       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE
C--d dbar --> ell- ell+
        ELSEIF(IDHW(LHEP).LE.12.AND.MOD(IDHW(LHEP),2).EQ.1.AND.
     &         IDHW(MHEP).LE.12.AND.MOD(IDHW(MHEP),2).EQ.1.AND.
     &         IK.GE.127.AND.IK.LE.132.AND.MOD(IK,2).EQ.1.AND.
     &         IJ.GE.121.AND.IJ.LE.126.AND.MOD(IJ,2).EQ.1) THEN
C--change outgoing order
          ID = IK
          IK = IJ
          IJ = ID
          ID = JHEP
          JHEP = KHEP
          KHEP = ID
C--change order if dbar first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--don't do correlations if no taus
          IF(IK.NE.125.AND.IJ.NE.131) RETURN
C--RPV couplings
          JJJ = (IDHW(LHEP)+1)/2
          KKK = (IDHW(MHEP)-5)/2
          LLL = (IK-119)/2
          MMM = (IJ-125)/2
          NDIA = 0
          DO 58 III=1,3
          IF(ABS(LAMDA2(III,JJJ,KKK)*LAMDA1(III,LLL,MMM)).LT.EPS)
     &             GOTO 58
          NDIA = NDIA+1
          IFLOW(NDIA) = 1
          IDP(4+NDIA) = 424+2*III
          A(1,NDIA) = ZERO
          A(2,NDIA) = LAMDA2(III,JJJ,KKK)
          B(1,NDIA) = LAMDA1(III,LLL,MMM)
          B(2,NDIA) = ZERO
          DRTYPE(NDIA) = 21
 58       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--dbar d --> ell+ ell-
        ELSEIF(IDHW(LHEP).LE.12.AND.MOD(IDHW(LHEP),2).EQ.1.AND.
     &         IDHW(MHEP).LE.12.AND.MOD(IDHW(MHEP),2).EQ.1.AND.
     &         IK.GE.121.AND.IK.LE.126.AND.MOD(IK,2).EQ.1.AND.
     &         IJ.GE.127.AND.IJ.LE.132.AND.MOD(IJ,2).EQ.1) THEN
C--change order if dbar first
          IF(IDHEP(LHEP).LT.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--don't do correlations if no taus
          IF(IK.NE.125.AND.IJ.NE.131) RETURN
C--RPV couplings
          JJJ = (IDHW(MHEP)-5)/2
          KKK = (IDHW(LHEP)+1)/2
          LLL = (IJ-125)/2
          MMM = (IK-119)/2
          NDIA = 0
          DO 59 III=1,3
          IF(ABS(LAMDA2(III,JJJ,KKK)*LAMDA1(III,LLL,MMM)).LT.EPS)
     &             GOTO 59
          NDIA = NDIA+1
          IFLOW(NDIA) = 1
          IDP(4+NDIA) = 424+2*III
          A(1,NDIA) = LAMDA2(III,JJJ,KKK)
          A(2,NDIA) = ZERO
          B(1,NDIA) = ZERO
          B(2,NDIA) = LAMDA1(III,LLL,MMM)
          DRTYPE(NDIA) = 21
 59       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--u dbar --> nu ell+
        ELSEIF((IK.GE.121.AND.IK.LE.126.AND.MOD(IK,2).EQ.0.AND.
     &          IJ.GE.127.AND.IJ.LE.132.AND.MOD(IJ,2).EQ.1).OR.
     &         (IK.GE.127.AND.IK.LE.132.AND.MOD(IK,2).EQ.1.AND.
     &          IJ.GE.121.AND.IJ.LE.126.AND.MOD(IJ,2).EQ.0)) THEN
C--ensure u first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--ensure nu first
          IF(MOD(IK,2).NE.0) THEN
            ID = IK
            IK = IJ
            IJ = ID
            ID = JHEP
            JHEP = KHEP
            KHEP = ID
          ENDIF
C--only need correlations if tau
          IF(IJ.NE.131) RETURN
C--RPV couplings
          JJJ = IDHW(LHEP)/2 
          KKK = (IDHW(MHEP)-5)/2
          LLL = (IK-120)/2
          MMM = (IJ-125)/2
          NDIA = 0
          DO 60 III=1,3
          IF(ABS(LAMDA2(III,JJJ,KKK)*LAMDA1(III,LLL,MMM)).LT.EPS)
     &             GOTO 60
          DO 61 J=1,2
          IFLOW(NDIA+J) = 1
          IDP(4+NDIA+J) = 423+2*III+12*(J-1)
          A(1,NDIA+J) = ZERO
          A(2,NDIA+J) = LAMDA2(III,JJJ,KKK)*LMIXSS(2*III-1,1,J)
          B(1,NDIA+J) = LAMDA1(III,LLL,MMM)*LMIXSS(2*III-1,1,J)
          B(2,NDIA+J) = ZERO
 61       DRTYPE(NDIA+J) = 21
          NDIA = NDIA+2
 60       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--ubar d --> ell nubar
        ELSEIF((IK.GE.127.AND.IK.LE.132.AND.MOD(IK,2).EQ.0.AND.
     &          IJ.GE.121.AND.IJ.LE.126.AND.MOD(IJ,2).EQ.1).OR.
     &         (IK.GE.121.AND.IK.LE.126.AND.MOD(IK,2).EQ.1.AND.
     &          IJ.GE.127.AND.IJ.LE.132.AND.MOD(IJ,2).EQ.0)) THEN
C--ensure u second
          IF(MOD(IDHW(MHEP),2).NE.0) THEN
            ID = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--   ensure nu second
          IF(MOD(IJ,2).NE.0) THEN
            ID = IK
            IK = IJ
            IJ = ID
            ID = JHEP
            JHEP = KHEP
            KHEP = ID
          ENDIF
C--only need correlations if tau
          IF(IK.NE.125) RETURN
C--RPV couplings
          JJJ = (IDHW(MHEP)-6)/2 
          KKK = (IDHW(LHEP)+1)/2
          LLL = (IJ-126)/2
          MMM = (IK-119)/2
          NDIA = 0
          DO 62 III=1,3
          IF(ABS(LAMDA2(III,JJJ,KKK)*LAMDA1(III,LLL,MMM)).LT.EPS)
     &             GOTO 62
          DO 63 J=1,2
          IFLOW(NDIA+J) = 1
          IDP(4+NDIA+J) = 423+2*III+12*(J-1)
          A(1,NDIA+J) = LAMDA2(III,JJJ,KKK)*LMIXSS(2*III-1,1,J)
          A(2,NDIA+J) = ZERO
          B(1,NDIA+J) = ZERO
          B(2,NDIA+J) = LAMDA1(III,LLL,MMM)*LMIXSS(2*III-1,1,J)
 63       DRTYPE(NDIA+J) = 21
          NDIA = NDIA+2
 62       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--unrecognized process
        ELSE
          CALL HWWARN('HWHSPN',505,*999)
        ENDIF
C--UDD processes
      ELSEIF(IPRO.EQ.41) THEN
C--change outgoing order
        ID = IJ
        IJ = IK
        IK = ID
        ID = JHEP
        JHEP = KHEP
        KHEP = ID
C--ubar neutralino
        IF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.0.AND.
     &     IDPDG(IJ).LT.0) THEN
C--indices for RPV
          III = (IJ-6)/2
          JJJ = (IDHW(LHEP)+1)/2
          KKK = (IDHW(MHEP)+1)/2
          L1  = IK - 449
C--types of diagram
          DRTYPE(1) = 27
          DRTYPE(2) = 27
          DRTYPE(3) = 28
          DRTYPE(4) = 28
          DRTYPE(5) = 29
          DRTYPE(6) = 29
C--RPV couplings
          DO 64 J=1,2
          A(1,J  ) = QMIXSS(2*III,2,J)*LAMDA3(III,JJJ,KKK)
          A(2,J  ) = ZERO
          B(1,J+2) = QMIXSS(2*JJJ-1,2,J)*LAMDA3(III,JJJ,KKK)
          B(2,J+2) = ZERO
          A(1,J+4) = QMIXSS(2*KKK-1,2,J)*LAMDA3(III,JJJ,KKK)
          A(2,J+4) = ZERO
C--particles
          IDP(4+J) = 400+2*III+12*(J-1)
          IDP(6+J) = 399+2*JJJ+12*(J-1)
          IDP(8+J) = 399+2*KKK+12*(J-1)
C--MSSM couplings
          DO 64 I=1,2
          B(I,J)   = AFN(O(I),2*III,J,L1)
          A(I,J+2) = AFN(O(I),2*JJJ-1,J,L1)
 64       B(I,J+4) = AFN(O(I),2*KKK-1,J,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 65 I=1,6
 65       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--u    neutralino
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.0.AND.
     &         IDPDG(IJ).GT.0) THEN
C--indices for RPV
          III = IJ/2
          JJJ = (IDHW(LHEP)-5)/2
          KKK = (IDHW(MHEP)-5)/2
          L1  = IK - 449 
C--types of diagram
          DRTYPE(1) = 30
          DRTYPE(2) = 30
          DRTYPE(3) = 31
          DRTYPE(4) = 31
          DRTYPE(5) = 32
          DRTYPE(6) = 32
C--RPV couplings
          DO 66 J=1,2
          A(1,J  ) = ZERO
          A(2,J  ) = QMIXSS(2*III,2,J)*LAMDA3(III,JJJ,KKK)
          B(1,J+2) = ZERO
          B(2,J+2) = QMIXSS(2*JJJ-1,2,J)*LAMDA3(III,JJJ,KKK)
          A(1,J+4) = ZERO
          A(2,J+4) = QMIXSS(2*KKK-1,2,J)*LAMDA3(III,JJJ,KKK)
C--particles
          IDP(4+J) = 400+2*III+12*(J-1)
          IDP(6+J) = 399+2*JJJ+12*(J-1)
          IDP(8+J) = 399+2*KKK+12*(J-1)
C--MSSM couplings
          DO 66 I=1,2
          B(I,J)   = AFN(I,2*III,J,L1)
          A(I,J+2) = AFN(I,2*JJJ-1,J,L1)
 66       B(I,J+4) = AFN(I,2*KKK-1,J,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 67 I=1,6
 67       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--dbar neutralino
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.1.AND.
     &         IDPDG(IJ).LT.0) THEN
C--ensure u type first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = IDHW(LHEP)/2
          JJJ = (IDHW(MHEP)+1)/2
          KKK = (IJ-5)/2
          L1  = IK - 449 
C--types of diagram
          DRTYPE(1) = 27
          DRTYPE(2) = 27
          DRTYPE(3) = 28
          DRTYPE(4) = 28
          DRTYPE(5) = 29
          DRTYPE(6) = 29
C--RPV couplings
          DO 68 I=1,2
          A(1,I  ) = QMIXSS(2*KKK-1,2,I)*LAMDA3(III,JJJ,KKK)
          A(2,I  ) = ZERO
          B(1,I+2) = QMIXSS(2*III,2,I)*LAMDA3(III,JJJ,KKK)
          B(2,I+2) = ZERO
          A(1,I+4) = QMIXSS(2*JJJ-1,2,I)*LAMDA3(III,JJJ,KKK)
          A(2,I+4) = ZERO
C--particles
          IDP(4+I) = 399+2*KKK+12*(I-1)
          IDP(6+I) = 400+2*III+12*(I-1)
          IDP(8+I) = 399+2*JJJ+12*(I-1)
C--MSSM couplings
          DO 68 J=1,2
          B(J,I  ) = AFN(O(J),2*KKK-1,I,L1)
          A(J,I+2) = AFN(O(J),2*III  ,I,L1)
 68       B(J,I+4) = AFN(O(J),2*JJJ-1,I,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 69 I=1,6
 69       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--d    neutralino
        ELSEIF(IK.GE.450.AND.IK.LE.453.AND.MOD(IJ,2).EQ.1.AND.
     &         IDPDG(IJ).GT.0) THEN
C--ensure u type first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IDHW(LHEP)-6)/2
          JJJ = (IDHW(MHEP)-5)/2
          KKK = (IJ+1)/2
          L1  = IK - 449 
C--types of diagram
          DRTYPE(1) = 30
          DRTYPE(2) = 30
          DRTYPE(3) = 31
          DRTYPE(4) = 31
          DRTYPE(5) = 32
          DRTYPE(6) = 32
C--RPV couplings
          DO 70 I=1,2
          A(1,I  ) = ZERO
          A(2,I  ) = QMIXSS(2*KKK-1,2,I)*LAMDA3(III,JJJ,KKK)
          B(1,I+2) = ZERO
          B(2,I+2) = QMIXSS(2*III,2,I)*LAMDA3(III,JJJ,KKK)
          A(1,I+4) = ZERO
          A(2,I+4) = QMIXSS(2*JJJ-1,2,I)*LAMDA3(III,JJJ,KKK)
C--particles
          IDP(4+I) = 399+2*KKK+12*(I-1)
          IDP(6+I) = 400+2*III+12*(I-1)
          IDP(8+I) = 399+2*JJJ+12*(I-1)
C--MSSM couplings
          DO 70 J=1,2
          B(J,I  ) = AFN(J,2*KKK-1,I,L1)
          A(J,I+2) = AFN(J,2*III  ,I,L1)
 70       B(J,I+4) = AFN(J,2*JJJ-1,I,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 71 I=1,6
 71       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--ubar gluino
        ELSEIF(IK.EQ.449.AND.MOD(IJ,2).EQ.0.AND.IDPDG(IJ).LT.0) THEN
C--indices for RPV
          III = (IJ-6)/2
          JJJ = (IDHW(LHEP)+1)/2
          KKK = (IDHW(MHEP)+1)/2
C--types of diagram
          DRTYPE(1) = 27
          DRTYPE(2) = 27
          DRTYPE(3) = 28
          DRTYPE(4) = 28
          DRTYPE(5) = 29
          DRTYPE(6) = 29
C--RPV couplings
          DO 72 J=1,2
          A(1,J  ) = QMIXSS(2*III,2,J)*LAMDA3(III,JJJ,KKK)
          A(2,J  ) = ZERO
          B(1,J+2) = QMIXSS(2*JJJ-1,2,J)*LAMDA3(III,JJJ,KKK)
          B(2,J+2) = ZERO
          A(1,J+4) = QMIXSS(2*KKK-1,2,J)*LAMDA3(III,JJJ,KKK)
          A(2,J+4) = ZERO
C--particles
          IDP(4+J) = 400+2*III+12*(J-1)
          IDP(6+J) = 399+2*JJJ+12*(J-1)
          IDP(8+J) = 399+2*KKK+12*(J-1)
C--MSSM couplings
          DO 72 I=1,2
          B(I,J)   = AFG(O(I),2*III,J)
          A(I,J+2) = AFG(O(I),2*JJJ-1,J)
 72       B(I,J+4) = AFG(O(I),2*KKK-1,J)
C--colour flows
          NDIA = 6
          NCFL(1) = 3
          DO 73 I=1,2
          IFLOW(I  ) = 1
          IFLOW(I+2) = 2
 73       IFLOW(I+4) = 3
          DO 74 I=1,3
          DO 74 J=1,3
          IF(I.EQ.J) THEN
            SPNCFC(I,J,1) = 8.0D0/9.0D0
          ELSE
            SPNCFC(I,J,1) =-4.0D0/9.0D0
          ENDIF
 74       CONTINUE
C--u    gluino
        ELSEIF(IK.EQ.449.AND.MOD(IJ,2).EQ.0.AND.IDPDG(IJ).GT.0) THEN
C--indices for RPV
          III = IJ/2
          JJJ = (IDHW(LHEP)-5)/2
          KKK = (IDHW(MHEP)-5)/2
C--types of diagram
          DRTYPE(1) = 30
          DRTYPE(2) = 30
          DRTYPE(3) = 31
          DRTYPE(4) = 31
          DRTYPE(5) = 32
          DRTYPE(6) = 32
C--RPV couplings
          DO 75 J=1,2
          A(1,J  ) = ZERO
          A(2,J  ) = QMIXSS(2*III,2,J)*LAMDA3(III,JJJ,KKK)
          B(1,J+2) = ZERO
          B(2,J+2) = QMIXSS(2*JJJ-1,2,J)*LAMDA3(III,JJJ,KKK)
          A(1,J+4) = ZERO
          A(2,J+4) = QMIXSS(2*KKK-1,2,J)*LAMDA3(III,JJJ,KKK)
C--particles
          IDP(4+J) = 400+2*III+12*(J-1)
          IDP(6+J) = 399+2*JJJ+12*(J-1)
          IDP(8+J) = 399+2*KKK+12*(J-1)
C--MSSM couplings
          DO 75 I=1,2
          B(I,J)   = AFG(I,2*III,J)
          A(I,J+2) = AFG(I,2*JJJ-1,J)
 75       B(I,J+4) = AFG(I,2*KKK-1,J)
C--colour flows
          NDIA = 6
          NCFL(1) = 3
          DO 76 I=1,2
          IFLOW(I  ) = 1
          IFLOW(I+2) = 2
 76       IFLOW(I+4) = 3
          DO 77 I=1,3
          DO 77 J=1,3
          IF(I.EQ.J) THEN
            SPNCFC(I,J,1) = 8.0D0/9.0D0
          ELSE
            SPNCFC(I,J,1) =-4.0D0/9.0D0
          ENDIF
 77       CONTINUE
C--dbar gluino
        ELSEIF(IK.EQ.449.AND.MOD(IJ,2).EQ.1.AND.IDPDG(IJ).LT.0) THEN
C--ensure u type first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = IDHW(LHEP)/2
          JJJ = (IDHW(MHEP)+1)/2
          KKK = (IJ-5)/2 
C--types of diagram
          DRTYPE(1) = 27
          DRTYPE(2) = 27
          DRTYPE(3) = 28
          DRTYPE(4) = 28
          DRTYPE(5) = 29
          DRTYPE(6) = 29
C--RPV couplings
          DO 78 I=1,2
          A(1,I  ) = QMIXSS(2*KKK-1,2,I)*LAMDA3(III,JJJ,KKK)
          A(2,I  ) = ZERO
          B(1,I+2) = QMIXSS(2*III,2,I)*LAMDA3(III,JJJ,KKK)
          B(2,I+2) = ZERO
          A(1,I+4) = QMIXSS(2*JJJ-1,2,I)*LAMDA3(III,JJJ,KKK)
          A(2,I+4) = ZERO
C--particles
          IDP(4+I) = 399+2*KKK+12*(I-1)
          IDP(6+I) = 400+2*III+12*(I-1)
          IDP(8+I) = 399+2*JJJ+12*(I-1)
C--MSSM couplings
          DO 78 J=1,2
          B(J,I  ) = AFG(O(J),2*KKK-1,I)
          A(J,I+2) = AFG(O(J),2*III  ,I)
 78       B(J,I+4) = AFG(O(J),2*JJJ-1,I)
C--colour flows
          NDIA = 6
          NCFL(1) = 3
          DO 79 I=1,2
          IFLOW(I  ) = 1
          IFLOW(I+2) = 2
 79       IFLOW(I+4) = 3
          DO 80 I=1,3
          DO 80 J=1,3
          IF(I.EQ.J) THEN
            SPNCFC(I,J,1) = 8.0D0/9.0D0
          ELSE
            SPNCFC(I,J,1) =-4.0D0/9.0D0
          ENDIF
 80       CONTINUE
C--d    gluino
        ELSEIF(IK.EQ.449.AND.MOD(IJ,2).EQ.1.AND.IDPDG(IJ).GT.0) THEN
C--ensure u type first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IDHW(LHEP)-6)/2
          JJJ = (IDHW(MHEP)-5)/2
          KKK = (IJ+1)/2 
C--types of diagram
          DRTYPE(1) = 30
          DRTYPE(2) = 30
          DRTYPE(3) = 31
          DRTYPE(4) = 31
          DRTYPE(5) = 32
          DRTYPE(6) = 32
C--RPV couplings
          DO 81 I=1,2
          A(1,I  ) = ZERO
          A(2,I  ) = QMIXSS(2*KKK-1,2,I)*LAMDA3(III,JJJ,KKK)
          B(1,I+2) = ZERO
          B(2,I+2) = QMIXSS(2*III,2,I)*LAMDA3(III,JJJ,KKK)
          A(1,I+4) = ZERO
          A(2,I+4) = QMIXSS(2*JJJ-1,2,I)*LAMDA3(III,JJJ,KKK)
C--particles
          IDP(4+I) = 399+2*KKK+12*(I-1)
          IDP(6+I) = 400+2*III+12*(I-1)
          IDP(8+I) = 399+2*JJJ+12*(I-1)
C--MSSM couplings
          DO 81 J=1,2
          B(J,I  ) = AFG(J,2*KKK-1,I)
          A(J,I+2) = AFG(J,2*III  ,I)
 81       B(J,I+4) = AFG(J,2*JJJ-1,I)
C--colour flows
          NDIA = 6
          NCFL(1) = 3
          DO 82 I=1,2
          IFLOW(I  ) = 1
          IFLOW(I+2) = 2
 82       IFLOW(I+4) = 3
          DO 83 I=1,3
          DO 83 J=1,3
          IF(I.EQ.J) THEN
            SPNCFC(I,J,1) = 8.0D0/9.0D0
          ELSE
            SPNCFC(I,J,1) =-4.0D0/9.0D0
          ENDIF
 83       CONTINUE
C--dbar -ve chargino
        ELSEIF(IK.GE.456.AND.IK.LE.457.AND.MOD(IJ,2).EQ.1) THEN
C--change order so highest generation first
          IF(IDHW(MHEP).GT.IDHW(LHEP)) THEN
            ID = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--RPV indices
          III = (IJ-5)/2
          JJJ = (IDHW(LHEP)+1)/2
          KKK = (IDHW(MHEP)+1)/2
          L1  = IK-455
C--types of diagram
          DRTYPE(1) = 27
          DRTYPE(2) = 27
          DRTYPE(3) = 28
          DRTYPE(4) = 28
          DRTYPE(5) = 29
          DRTYPE(6) = 29
C--RPV couplings
          DO 84 I=1,2
          A(1,I  ) = QMIXSS(2*III,2,I)*LAMDA3(III,JJJ,KKK)
          A(2,I  ) = ZERO
          B(1,I+2) = QMIXSS(2*JJJ,2,I)*LAMDA3(JJJ,KKK,III)
          B(2,I+2) = ZERO
          A(1,I+4) = QMIXSS(2*KKK,2,I)*LAMDA3(KKK,III,JJJ)
          A(2,I+4) = ZERO
C--particles
          IDP(4+I) = 400+2*III+12*(I-1)
          IDP(6+I) = 400+2*JJJ+12*(I-1)
          IDP(8+I) = 400+2*KKK+12*(I-1)
C--MSSM couplings
          DO 84 J=1,2
          B(J,I  ) = AFC(O(J),2*III,I,L1)
          A(J,I+2) = AFC(O(J),2*JJJ,I,L1)
 84       B(J,I+4) = AFC(O(J),2*KKK,I,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 85 I=1,6
 85       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--d    +ve chargino
        ELSEIF(IK.GE.454.AND.IK.LE.455.AND.MOD(IJ,2).EQ.1) THEN
C--change order so highest generation first
          IF(IDHW(MHEP).GT.IDHW(LHEP)) THEN
            ID = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--RPV indices
          III = (IJ+1)/2
          JJJ = (IDHW(LHEP)-5)/2
          KKK = (IDHW(MHEP)-5)/2
          L1  = IK-453
C--types of diagram
          DRTYPE(1) = 30
          DRTYPE(2) = 30
          DRTYPE(3) = 31
          DRTYPE(4) = 31
          DRTYPE(5) = 32
          DRTYPE(6) = 32
C--RPV couplings
          DO 86 I=1,2
          A(1,I  ) = ZERO
          A(2,I  ) = QMIXSS(2*III,2,I)*LAMDA3(III,JJJ,KKK)
          B(1,I+2) = ZERO
          B(2,I+2) = QMIXSS(2*JJJ,2,I)*LAMDA3(JJJ,KKK,III)
          A(1,I+4) = ZERO
          A(2,I+4) = QMIXSS(2*KKK,2,I)*LAMDA3(KKK,III,JJJ)
C--particles
          IDP(4+I) = 400+2*III+12*(I-1)
          IDP(6+I) = 400+2*JJJ+12*(I-1)
          IDP(8+I) = 400+2*KKK+12*(I-1)
C--MSSM couplings
          DO 86 J=1,2
          B(J,I  ) = AFC(J,2*III,I,L1)
          A(J,I+2) = AFC(J,2*JJJ,I,L1)
 86       B(J,I+4) = AFC(J,2*KKK,I,L1)
C--colour flows
          NDIA = 6
          NCFL(1) = 1
          DO 87 I=1,6
 87       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--ubar +ve chargino
        ELSEIF(IK.GE.454.AND.IK.LE.455.AND.MOD(IJ,2).EQ.0) THEN
C--ensure u type first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = IDHW(LHEP)/2
          JJJ = (IDHW(MHEP)+1)/2
          KKK = (IJ-6)/2
          L1  = IK-453
C--types of diagram
          DRTYPE(1) = 27
          DRTYPE(2) = 27
          DRTYPE(3) = 28
          DRTYPE(4) = 28
C--RPV couplings
          DO 88 I=1,2
          A(1,I  ) = QMIXSS(2*KKK-1,2,I)*LAMDA3(III,JJJ,KKK)
          A(2,I  ) = ZERO
          B(1,I+2) = QMIXSS(2*III-1,2,I)*LAMDA3(KKK,III,JJJ)
          B(2,I+2) = ZERO
C--particles
          IDP(4+I) = 399+2*KKK+12*(I-1)
          IDP(6+I) = 399+2*III+12*(I-1)
C--MSSM couplings
          DO 88 J=1,2
          B(J,I  ) = AFC(O(J),2*KKK-1,I,L1)
 88       A(J,I+2) = AFC(O(J),2*III-1,I,L1)
C--colour flows
          NDIA = 4
          NCFL(1) = 1
          DO 89 I=1,4
 89       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--u    -ve chargino
        ELSEIF(IK.GE.456.AND.IK.LE.457.AND.MOD(IJ,2).EQ.0) THEN
C--ensure u type first
          IF(MOD(IDHW(LHEP),2).NE.0) THEN
            ID   = LHEP
            LHEP = MHEP
            MHEP = ID
          ENDIF
C--RPV indices
          III = (IDHW(LHEP)-6)/2
          JJJ = (IDHW(MHEP)-5)/2
          KKK = IJ/2
          L1  = IK-455
C--types of diagram
          DRTYPE(1) = 30
          DRTYPE(2) = 30
          DRTYPE(3) = 31
          DRTYPE(4) = 31
C--RPV couplings
          DO 90 I=1,2
          A(1,I  ) = ZERO
          A(2,I  ) = QMIXSS(2*KKK-1,2,I)*LAMDA3(III,JJJ,KKK)
          B(1,I+2) = ZERO
          B(2,I+2) = QMIXSS(2*III-1,2,I)*LAMDA3(KKK,III,JJJ)
C--particles
          IDP(4+I) = 399+2*KKK+12*(I-1)
          IDP(6+I) = 399+2*III+12*(I-1)
C--MSSM couplings
          DO 90 J=1,2
          B(J,I  ) = AFC(J,2*KKK-1,I,L1)
 90       A(J,I+2) = AFC(J,2*III-1,I,L1)
C--colour flows
          NDIA = 4
          NCFL(1) = 1
          DO 91 I=1,4
 91       IFLOW(I) = 1
          SPNCFC(1,1,1) = TWO/THREE
C--d d --> d d 
        ELSEIF(IDPDG(IK).GT.0.AND.IDPDG(IK).GT.0.AND.
     &         MOD(IK,2).EQ.1.AND.MOD(IJ,2).EQ.1) THEN
C--can't produce unstable quark on hadronisation timescale
          RETURN
C--dbar dbar --> dbar dbar
        ELSEIF(IDPDG(IK).LT.0.AND.IDPDG(IJ).LT.0.AND.
     &         MOD(IJ,2).EQ.1.AND.MOD(IK,2).EQ.1) THEN
C--can't produce unstable quark on hadronisation timescale
          RETURN
C--u d --> u d
        ELSEIF(IDPDG(IK).GT.0.AND.IDPDG(IJ).GT.0.AND.
     &         ((MOD(IJ,2).EQ.1.AND.MOD(IK,2).EQ.0).OR.
     &          (MOD(IJ,2).EQ.0.AND.MOD(IK,2).EQ.1))) THEN 
C--ensure u first (incoming)
          IF(MOD(IDHW(LHEP),2).EQ.1) THEN
            ID   = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--ensure u first (outgoing)
          IF(MOD(IK,2).EQ.1) THEN
            ID = IJ
            IJ = IK
            IK = ID
            ID = JHEP
            JHEP = KHEP
            KHEP = ID
          ENDIF
C--can't produce unstable quark on hadronisation timescale
          IF(IK.NE.6) RETURN
C--RPV indices
          III = IDHW(LHEP)/2
          KKK = (IDHW(MHEP)+1)/2
          LLL = IK/2
          MMM = (IJ+1)/2
          NDIA = 0
          DO 92 JJJ=1,3
          IF(ABS(LAMDA3(III,JJJ,KKK)*LAMDA3(LLL,JJJ,MMM)).LT.EPS)
     &            GOTO 92
          DO 93 J=1,2
          IFLOW(NDIA+J) = 1
          IDP(4+NDIA+J) = 399+2*JJJ+12*(J-1)
          A(1,NDIA+J) = LAMDA3(III,JJJ,KKK)*QMIXSS(2*JJJ-1,2,J)
          A(2,NDIA+J) = ZERO
          B(1,NDIA+J) = ZERO
          B(2,NDIA+J) = LAMDA3(LLL,JJJ,MMM)*QMIXSS(2*JJJ-1,2,J)
 93       DRTYPE(NDIA+J) = 33
          NDIA = NDIA+2
 92       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--ubar dbar --> ubar dbar
        ELSEIF(IDPDG(IK).LT.0.AND.IDPDG(IJ).LT.0.AND.
     &         ((MOD(IJ,2).EQ.1.AND.MOD(IK,2).EQ.0).OR.
     &          (MOD(IJ,2).EQ.0.AND.MOD(IK,2).EQ.1))) THEN 
C--ensure u first (incoming)
          IF(MOD(IDHW(LHEP),2).EQ.1) THEN
            ID   = MHEP
            MHEP = LHEP
            LHEP = ID
          ENDIF
C--ensure u first (outgoing)
          IF(MOD(IK,2).EQ.1) THEN
            ID = IJ
            IJ = IK
            IK = ID
            ID = JHEP
            JHEP = KHEP
            KHEP = ID
          ENDIF
C--can't produce unstable quark on hadronisation timescale
          IF(IK.NE.6) RETURN
C--RPV indices
          III = (IDHW(LHEP)-6)/2
          KKK = (IDHW(MHEP)-5)/2
          LLL = (IK-6)/2
          MMM = (IJ-5)/2
          NDIA = 0
          DO 94 JJJ=1,3
          IF(ABS(LAMDA3(III,JJJ,KKK)*LAMDA3(LLL,JJJ,MMM)).LT.EPS)
     &             GOTO 94
          DO 95 J=1,2
          IFLOW(NDIA+J) = 1
          IDP(4+NDIA+J) = 399+2*JJJ+12*(J-1)
          A(1,NDIA+J) = ZERO
          A(2,NDIA+J) = LAMDA3(III,JJJ,KKK)*QMIXSS(2*JJJ-1,2,J)
          B(1,NDIA+J) = LAMDA3(LLL,JJJ,MMM)*QMIXSS(2*JJJ-1,2,J)
          B(2,NDIA+J) = ZERO
 95       DRTYPE(NDIA+J) = 34
          NDIA = NDIA+2
 94       CONTINUE
          NCFL(1) = 1
          SPNCFC(1,1,1) = ONE/THREE
C--unrecognized process
        ELSE
          CALL HWWARN('HWHSPN',506,*999)
        ENDIF
C--unrecognized process
      ELSE
        CALL HWWARN('HWHSPN',507,*999)
      ENDIF
C--copy the momenta into the internal array
      CALL HWVEQU(5,PHEP(1,LHEP),P(1,1))
      CALL HWVEQU(5,PHEP(1,MHEP),P(1,2))
      CALL HWVEQU(5,PHEP(1,KHEP),P(1,3))
      CALL HWVEQU(5,PHEP(1,JHEP),P(1,4))
C--now compute the masses etc for the diagrams
      IDP(1) = IDHW(LHEP)
      IDP(2) = IDHW(MHEP)
      IDP(3) = IDHW(KHEP)
      IDP(4) = IDHW(JHEP)
      DO 104 I=1,4
      MA (I) = P(5,I)
 104  MA2(I) = SIGN(MA(I)**2,MA(I))
      DO 105 I=1,NDIA
      MR(I) = RMASS(IDP(4+I))
      MS(I) = MR(I)**2
      IF(IDP(I+4).EQ.200) THEN
        MWD(I) = RMASS(200)*GAMZ
      ELSEIF(IDP(I+4).EQ.198.OR.IDP(I+4).EQ.199) THEN
        MWD(I) = RMASS(198)*GAMW
      ELSEIF(IDP(I+4).EQ.59.OR.IDP(I+4).EQ.13.OR.
     &  IDP(I+4).LE.5.OR.(IDP(I+4).GE.7.AND.IDP(I+4).LE.11)) THEN
        MR(I)  = ZERO
        MS(I)  = ZERO
        MWD(I) = ZERO
      ELSE
        MWD(I) = MR(I)*HBAR/RLTIM(IDP(I+4))
      ENDIF
 105  CONTINUE
C--set up the mandelstam variables
      SH = TWO*HWULDO(P(1,1),P(1,2))
      CALL HWVSCA(4,-ONE,P(1,3),PLAB(1,2))
      CALL HWVSUM(5,P(1,1),PLAB(1,2),PLAB(1,1))
      TH = P(5,3)**2-TWO*HWULDO(P(1,1),P(1,3))
      UH = P(5,4)**2-TWO*HWULDO(P(1,1),P(1,4))
C--copy the momenta into the common block for spinor computation
      DO 106 I=1,4
      IF(IDP(I).LT.400.AND.(IDP(I).NE.6.AND.IDP(I).NE.12
     &                .AND.IDP(I).NE.125.AND.IDP(I).NE.131)) THEN
        CALL HWVEQU(5,PREF,PLAB(1,I+4))
C--all other particles
      ELSE
        PP = SQRT(HWVDOT(3,P(1,I),P(1,I)))
        CALL HWVSCA(3,ONE/PP,P(1,I),N)
        PLAB(4,I+4) = HALF*(P(4,I)-PP)
        PP = HALF*(PP-P(5,I)-PP**2/(P(5,I)+P(4,I)))
        CALL HWVSCA(3,PP,N,PLAB(1,I+4))
        CALL HWUMAS(PLAB(1,I+4))
        PP = HWVDOT(3,PLAB(1,I+4),PLAB(1,I+4))
C--fix to avoid problems if approx massless due to energy
        IF(PP.LT.EPS) CALL HWVEQU(5,PREF,PLAB(1,I+4))
      ENDIF
C--now the massless vectors
      PP = HALF*MA2(I)/HWULDO(PLAB(1,I+4),P(1,I))
      DO 107 J=1,4
 107  PLAB(J,I) = P(J,I)-PP*PLAB(J,I+4)
 106  CALL HWUMAS(PLAB(1,I))
C--change order of momenta for call to HE code
      DO 108 I=1,4
      PM(1,I) = P(3,I)
      PM(2,I) = P(1,I)
      PM(3,I) = P(2,I)
      PM(4,I) = P(4,I)
 108  PM(5,I) = P(5,I)
      DO 109 I=1,8
      PCM(1,I)=PLAB(3,I)
      PCM(2,I)=PLAB(1,I)
      PCM(3,I)=PLAB(2,I)
      PCM(4,I)=PLAB(4,I)
 109  PCM(5,I)=PLAB(5,I)
C--compute the S functions
      CALL HWHEW2(8,PCM(1,1),S(1,1,2),S(1,1,1),D)
      DO 110 I=1,8
      DO 110 J=1,8
      S(I,J,2) = -S(I,J,2)
 110  D(I,J)   = TWO*D(I,J)
C--compute the F functions
      CALL HWH2F1(8,F3 ,7,PM(1,3), MA(3))
      CALL HWH2F2(8,F4 ,8,PM(1,4),-MA(4))
      CALL HWH2F1(8,F4M,8,PM(1,4), MA(4))
      CALL HWH2F2(8,F3M,7,PM(1,3),-MA(3))
C--t and u channel functions
C--first the t channel ones
      CALL HWVSCA(4,-ONE,PM(1,4),PTMP)
      CALL HWVSUM(4,PM(1,2),PTMP,PTMP)
      CALL HWUMAS(PTMP)
      CALL HWH2F3(8,FTP,PTMP, MR(1))
      CALL HWH2F3(8,FTM,PTMP,-MR(1))
C--then the u-channel ones
      CALL HWVSCA(4,-ONE,PM(1,4),PTMP)
      CALL HWVSUM(4,PM(1,1),PTMP,PTMP)
      CALL HWUMAS(PTMP)
      CALL HWH2F3(8,FUP,PTMP, MR(1))
      CALL HWH2F3(8,FUM,PTMP,-MR(1))
C--function for t-channel scalar exchange
      CALL HWVSUM(4,PM(1,4),PM(1,4),PTMP)
      CALL HWUMAS(PTMP)
      CALL HWH2F1(8,FST,2,PTMP,ZERO)
C--compute the prefactor for all diagrams
      PRE = HWULDO(PCM(1,7),PM(1,3))*HWULDO(PCM(1,8),PM(1,4))
      PRE = ONE/SQRT(PRE)
C--zero the matrix element
      DO 200 P1=1,2
      DO 200 P2=1,2
      DO 200 P3=1,2
      DO 200 P4=1,2
      DO 200 I=1,NCFL(1)
 200  ME(P1,P2,P3,P4,I) = (0.0D0,0.0D0)
C--now call the subroutines to compute the individual diagrams
      DO 210 I=1,NDIA
C--s-channel vector boson exchange diagram (f fbar to fermion fermion)
      IF(DRTYPE(I).EQ.1) THEN
        CALL HWHS01(I,MED)
C--t-channel sfermion exchange diagram (f fbar to fermion fermion)
      ELSEIF(DRTYPE(I).EQ.2) THEN
        CALL HWHS02(I,MED)
C--u-channel sfermion exchange diagram(f fbar to fermion fermion)
      ELSEIF(DRTYPE(I).EQ.3) THEN 
        CALL HWHS03(I,MED)
C--s-channel vector boson (f fbar to fermion antifermion)
      ELSEIF(DRTYPE(I).EQ.4) THEN
        CALL HWHS04(I,MED)
C--t-channel fermion exchange (g g to fermion antifermion)
      ELSEIF(DRTYPE(I).EQ.5) THEN
        CALL HWHS05(I,MED)
C--u-channel fermion exchange (g g to fermion antifermion)
      ELSEIF(DRTYPE(I).EQ.6) THEN
        CALL HWHS06(I,MED)
C--s-channel gluon exchange (g g to fermion antifermion)
      ELSEIF(DRTYPE(I).EQ.7) THEN
        CALL HWHS07(I,MED)
C--t-channel sfermion exchange (g q to fermion sfermion)
      ELSEIF(DRTYPE(I).EQ.8) THEN
        CALL HWHS08(I,MED)
C--t-channel sfermion exchange  (g qbar to fermion antisfermion)
      ELSEIF(DRTYPE(I).EQ.9) THEN
        CALL HWHS09(I,MED)
C--s-channel quark exchange     (g q to fermion antisfermion)
      ELSEIF(DRTYPE(I).EQ.10) THEN
        CALL HWHS10(I,MED)
C--s-channel antiquark exchange (g qbar to fermion antisfermion)
      ELSEIF(DRTYPE(I).EQ.11) THEN
        CALL HWHS11(I,MED)
C--u-channel gluino exchange (g q to fermion antisfermion)
      ELSEIF(DRTYPE(I).EQ.12) THEN
        CALL HWHS12(I,MED)
C--u-channel gluino exchange (g qbar to fermion antisfermion)
      ELSEIF(DRTYPE(I).EQ.13) THEN
        CALL HWHS13(I,MED)
C--t-channel fermion exchange (g g to fermion fermion)
      ELSEIF(DRTYPE(I).EQ.14) THEN
        CALL HWHS14(I,MED)
C--u-channel fermion exchange (g g to fermion fermion)
      ELSEIF(DRTYPE(I).EQ.15) THEN
        CALL HWHS15(I,MED)
C--s-channel gluon exchange (g g to fermion fermion)
      ELSEIF(DRTYPE(I).EQ.16) THEN
        CALL HWHS16(I,MED)
C--t-channel gauge boson exchange (fermion fermion)
      ELSEIF(DRTYPE(I).EQ.17) THEN
        CALL HWHS17(I,MED)
C--t-channel gauge boson exchange (fermion antifermion)
      ELSEIF(DRTYPE(I).EQ.18) THEN
        CALL HWHS18(I,MED)
C--t-channel gauge boson exchange (antifermion fermion)
      ELSEIF(DRTYPE(I).EQ.19) THEN
        CALL HWHS19(I,MED)
C--t-channel gauge boson exchange (antifermion antifermion)
      ELSEIF(DRTYPE(I).EQ.20) THEN
        CALL HWHS20(I,MED)
C--s-channel scalar exchange (f fbar --> f fbar)
      ELSEIF(DRTYPE(I).EQ.21) THEN
        CALL HWHS21(I,MED)
C--t-channel scalar exchange (f fbar --> f fbar)
      ELSEIF(DRTYPE(I).EQ.22) THEN
        CALL HWHS22(I,MED)
C--u-channel scalar exchange (f fbar --> f fbar)
      ELSEIF(DRTYPE(I).EQ.23) THEN
        CALL HWHS23(I,MED)
C--s-channel scalar exchange (fbar f --> f f)
      ELSEIF(DRTYPE(I).EQ.24) THEN
        CALL HWHS24(I,MED)
C--t-channel scalar exchange (fbar f --> f f)
      ELSEIF(DRTYPE(I).EQ.25) THEN
        CALL HWHS25(I,MED)
C--u-channel scalar exchange (fbar f --> f f)
      ELSEIF(DRTYPE(I).EQ.26) THEN
        CALL HWHS26(I,MED)
C--s-channel scalar exchange (f f --> f fbar)
      ELSEIF(DRTYPE(I).EQ.27) THEN
        CALL HWHS27(I,MED)
C--t-channel scalar exchange (f f --> f fbar)
      ELSEIF(DRTYPE(I).EQ.28) THEN
        CALL HWHS28(I,MED)
C--u-channel scalar exchange (f f --> f fbar)
      ELSEIF(DRTYPE(I).EQ.29) THEN
        CALL HWHS29(I,MED)
C--s-channel scalar exchange (fbar fbar --> f f)
      ELSEIF(DRTYPE(I).EQ.30) THEN
        CALL HWHS30(I,MED)
C--t-channel scalar exchange (fbar fbar --> f f)
      ELSEIF(DRTYPE(I).EQ.31) THEN
        CALL HWHS31(I,MED)
C--u-channel scalar exchange (fbar fbar --> f f)
      ELSEIF(DRTYPE(I).EQ.32) THEN
        CALL HWHS32(I,MED)
C--s-channel scalar exchange (f f --> f f)
      ELSEIF(DRTYPE(I).EQ.33) THEN
        CALL HWHS33(I,MED)
C--s-channel scalar exchange (fbar fbar --> fbar fbar)
      ELSEIF(DRTYPE(I).EQ.34) THEN
        CALL HWHS34(I,MED)
C--error not known
      ELSE
        CALL HWWARN('HWHSPN',508,*999)
      ENDIF
C--add up the matrix elements
      DO 210 P1=1,2
      DO 210 P2=1,2
      DO 210 P3=1,2
      DO 210 P4=1,2
 210  ME(P1,P2,P3,P4,IFLOW(I)) = ME(P1,P2,P3,P4,IFLOW(I))
     &                             +MED(P1,P2,P3,P4)
C--preform the final normalisation
      DO 215 P1=1,2
      DO 215 P2=1,2
      DO 215 P3=1,2
      DO 215 P4=1,2
      DO 215 I=1,NCFL(1)
 215  ME(P1,P2,P3,P4,I) = PRE*ME(P1,P2,P3,P4,I)
C--now enter the matrix element in the spin common block
      NSPN        = 1
      IDSPN(1)    = ICM
      ISNHEP(ICM) = 1
      JMOSPN(1)   = 0
      JDASPN(1,1) = 2
      JDASPN(2,1) = 3
      DECSPN(1) = .FALSE.
      DO 225 P1=1,2
      DO 225 P2=1,2
      DO 225 P3=1,2
      DO 225 P4=1,2
      DO 225 I=1,NCFL(1)
 225  MESPN(P1,P2,P3,P4,I,1) = ME(P1,P2,P3,P4,I)
C--now enter the daughter particles
      NSPN         = NSPN+2
      IDSPN(2)     = KHEP
      ISNHEP(KHEP) = 2
      IDSPN(3)     = JHEP
      ISNHEP(JHEP) = 3
      JMOSPN(2)    = 1
      JMOSPN(3)    = 1
C--spin density matrices for daughter particles
      DO 230 P1=1,2
      DO 230 P2=1,2
      DO 230 I=1,3
      RHOSPN(1,1,I) = HALF
      RHOSPN(1,2,I) = ZERO
      RHOSPN(2,1,I) = ZERO
 230  RHOSPN(2,2,I) = HALF
      DECSPN(2) = .FALSE.
      DECSPN(3) = .FALSE.
C--select the colour flow if needed
      IF(SPCOPT.EQ.2.AND.NCFL(1).NE.1) THEN
        WGT = ZERO
C--assume no incoming polarization, no processes with more than one
C--colour flow in e+e-
        DO 335 I =1,NCFL(1)
        WGTB(I) = ZERO
        DO 335 P1=1,2
        DO 335 P2=1,2
        DO 335 P3=1,2
        DO 335 P4=1,2
        WGTB(I) = WGTB(I)+SPNCFC(I,I,1)*MESPN(P1,P2,P3,P4,I,1)*
     &                           DCONJG(MESPN(P1,P2,P3,P4,I,1))
        DO 335 J =1,NCFL(1)
 335    WGT = WGT+SPNCFC(I,J,1)*MESPN(P1,P2,P3,P4,I,1)*
     &                   DCONJG(MESPN(P1,P2,P3,P4,J,1))
        WGTC = ZERO
        DO 340 I=1,NCFL(1)
 340    WGTC = WGTC+WGTB(I)
        WGTC = WGT/WGTC
        DO 345 I=1,NCFL(1)
 345    WGTB(I) = WGTB(I)*WGTC
        WGTC = WGT*HWRGEN(0)
        DO 350 I=1,NCFL(1)
        IF(WGTB(I).GE.WGTC) THEN
          NCFL(1) = I
          RETURN
        ENDIF
 350    WGTC =WGTC-WGTB(I)
      ENDIF
 999  END
CDECK  ID>, HWHS01.
*CMZ :-        -02/10/01  10:17:10  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHS01(ID,ME)
C-----------------------------------------------------------------------
C  Subroutine to calculate the helicity amplitudes for the 2-to-2 cross
C  section f fbar --> gauge boson --> fermion fermion
C  This diagram 1 from DAMTP-2001-83 with opposite sign of P4
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER NDIAHD
      PARAMETER(NDIAHD=10)
      DOUBLE COMPLEX ME(2,2,2,2),S,D,F3(2,2,8),F4(2,2,8),PRE,ZI
     &     ,F3M(2,2,8),F4M(2,2,8),FST(2,2,8),
     &     FTP(2,2,8,8),FTM(2,2,8,8),FUP(2,2,8,8),FUM(2,2,8,8)
      DOUBLE PRECISION A(2,NDIAHD),B(2,NDIAHD),MS(NDIAHD),MWD(NDIAHD),
     &     MA(4),MA2(4),MR(NDIAHD),SH,TH,UH
      INTEGER P1,P2,P3,P4,ID,O(2),IDP(4+NDIAHD),DRTYPE(NDIAHD)
      COMMON/HWSPHC/F3,F4,F3M,F4M,FTP,FTM,FUP,FUM,FST,A,B,MS,MWD,MR,MA,
     &     MA2,SH,TH,UH,IDP,DRTYPE
      PARAMETER(ZI=(0.0D0,1.0D0))
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      DATA O/2,1/
C--compute the propagator factor
      PRE = -ONE/(SH-MS(ID)+ZI*MWD(ID))
      DO 10 P1=1,2
      DO 10 P2=1,2
      DO 10 P3=1,2
      DO 10 P4=1,2
        IF(P1.EQ.P2) THEN
          ME(P1,P2,P3,P4) = PRE*A(P1,ID)*(
     &          B(O(P1),ID)*F3(O(P3),  P1 ,1)*F4(  P1 ,P4,2)
     &         +B(  P1 ,ID)*F3(O(P3),O(P1),2)*F4(O(P1),P4,1))
        ELSE
          ME(P1,P2,P3,P4) = ZERO
        ENDIF
 10   CONTINUE
      END
