CDECK  ID>, HWUDPR.
*CMZ :-        -27/07/99  13.33.03  by  Mike Seymour
*-- Author :    Ian Knowles, Bryan Webber & Kosuke Odagiri
C-----------------------------------------------------------------------
      SUBROUTINE HWUDPR
C-----------------------------------------------------------------------
C     Prints out particle properies/decay tables in a number of formats:
C     If (PRNDEF) ASCII to stout
C     If (PRNTEX) LaTeX to the file HW_decays.tex
C                 Paper size and offsets as set in HWUEPR
C                 Uses the package longtable.sty
C                 Designed to be printed as landscape
C     If (PRNWEB) HTML  to the file HW_decays/index.html
C                                            /PART0000001.html etc.
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER MMWIDE,MMLONG,MMHOFF,MMVOFF,IUNITT,IUNTW1,IUNTW2,I,NM,J,K,
     & L,M
      CHARACTER*1  Z
      CHARACTER*2  ZZ,ACHRG
      CHARACTER*3  ASPIN(0:10)
      CHARACTER*6  BGCOLS(5),TBCOLS(3)
      CHARACTER*7  HWUNST,TMPNME
      CHARACTER*17 FNAMEP
      CHARACTER*33 FNAMEW
      COMMON/PAPER/MMWIDE,MMLONG,MMHOFF,MMVOFF
      EXTERNAL HWUNST
      DATA BGCOLS/'ffffff','0000aa','aa0000','00aa00','aa00ff'/
      DATA TBCOLS/'ccccff','9966ff','ffff00'/
      DATA ASPIN/' 0 ','1/2',' 1 ','3/2',' 2 ','5/2',' 3 ','7/2',
     &           ' 4 ','9/2',' 5 '/
C
      Z=CHAR(92)
      ZZ=Z//Z
C
      IUNITT=50
      IUNTW1=51
      IUNTW2=52
C Open and write out file header information for index file
      IF (PRNDEF) THEN
        IF (NPRFMT.LE.1) THEN
          WRITE (6,10) NRES
        ELSE
          WRITE (6,20) NRES
        END IF
      END IF
      IF (PRNTEX) THEN
        OPEN(IUNITT,STATUS='UNKNOWN',FILE='HW_decays.tex')
        IF (NPRFMT.LE.1) THEN
          WRITE(IUNITT,30) Z,Z,Z,MMWIDE,Z,MMLONG,Z,MMHOFF,Z,MMVOFF,
     &     Z,Z,Z,Z,Z,ZZ,Z,Z,Z,Z,Z,Z,NRES,ZZ,Z,Z,ZZ,Z,Z
        ELSE
          WRITE(IUNITT,40) Z,Z,Z,MMLONG,Z,MMWIDE,Z,MMHOFF,Z,MMVOFF,
     &     Z,Z,Z,Z,Z,Z,ZZ,Z,Z,Z,Z,Z,Z,NRES,ZZ,Z,Z,Z,ZZ,Z,Z
        END IF
      ENDIF
      IF (PRNWEB) THEN
        OPEN(IUNTW1,STATUS='UNKNOWN',FILE='HW_decays/index.html')
        WRITE(IUNTW1,50) BGCOLS,TBCOLS,NRES,((TBCOLS(I),I=2,3),J=1,7)
      ENDIF
   10 FORMAT(1H1//15X,'TABLE OF PROPERTIES OF',I4,' PARTICLES USED'/)
   20 FORMAT(1H1//30X,'TABLE OF PROPERTIES OF',I4,' PARTICLES USED'//
     & 5X,'Name        IDPDG   Mass   Chg Spn Lifetime Modes ',
     & ' Branching fractions ME codes and decay products')
   30 FORMAT(A1,'documentclass{article}'/A1,'usepackage{longtable}'/
     & A1,'textwidth ',I4,'mm ',A1,'textheight ',I4,'mm'/
     & A1,'hoffset   ',I4,'mm ',A1,'voffset    ',I4,'mm'/
     & A1,'pagestyle{empty}'/A1,'begin{document}'/
     & A1,'begin{center}'/A1,'begin{longtable}{|r|c|r|r|r|r|r|r|}'/
     & A1,'hline'/'Id HW & Name & Id PDG & Mass & Charge & Spin ',
     & '& Lifetime & Modes ',A2/A1,'hline'/
     & A1,'endhead'/A1,'hline'/A1,'endfoot'/A1,'hline'/
     & A1,'multicolumn{8}{|c|}{HERWIG 6.0: Table of properties',
     & ' of the ',I3,' particles used} ',A2/A1,'hline',A1,'hline'/
     & 'Id HW & Name & Id PDG & Mass & Charge & Spin & ',
     & 'Lifetime & Modes ',A2/A1,'hline'/A1,'endfirsthead')
   40 FORMAT(A1,'documentclass{article}'/A1,'usepackage{longtable}'/
     & A1,'textwidth ',I4,'mm ',A1,'textheight ',I4,'mm'/
     & A1,'hoffset   ',I4,'mm ',A1,'voffset    ',I4,'mm'/
     & A1,'pagestyle{empty}'/A1,'begin{document}'/A1,'begin{center}'/
     & A1,'begin{longtable}{|r|c|r|r|r|r|r|r|c|r|ccccc|}'/
     & A1,'hline'/'Id HW & Name & Id PDG & Mass & Charge & Spin ',
     & '& Lifetime & Modes & B.R. & M.E. & ' /
     & A1,'multicolumn{5}{|c|}{Decay Products} ',A2/A1,'hline'/
     & A1,'endhead'/A1,'hline'/A1,'endfoot'/A1,'hline'/
     & A1,'multicolumn{15}{|c|}{HERWIG 6.0: Table of properties',
     & ' of the ',I3,' particles used} ',A2/A1,'hline',A1,'hline'/
     & 'Id HW & Name & Id PDG & Mass & Charge & Spin & ',
     & 'Lifetime & Modes & B.R. & M.E. & '/
     & A1,'multicolumn{5}{|c|}{Decay Products} ',A2/A1,'hline'/
     & A1,'endfirsthead')
   50 FORMAT('<!-- No Less productions -->'/'<HTML>'/'<HEAD>'/
     & '<TITLE>HERWIG 6.0 Particle Properties</TITLE>'/'</HEAD>'/
     & '<BODY BGCOLOR=#',A6,' TEXT=#',A6,' LINK=#',A6,
     & ' ALINK=#',A6,' VLINK=#',A6,'>'/'<CENTER>'/
     & '<TABLE ALIGN="CENTER" BGCOLOR=#',A6,'>',
     & '<TR>'/'<TH COLSPAN=8 BGCOLOR=#',A6,' ALIGN="CENTER">',
     & '<A HREF=="http://hepwww.rl.ac.uk/theory/seymour/herwig/">',
     & 'HERWIG 6.0:</A><FONT COLOR=#',A6,'> Table of properties of',
     & ' the ',I3,' particles used</FONT></TH>'/'<TR>'/'<TH></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Name</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="CENTER"><FONT COLOR=#',A6,'>',
     & 'Id PDG</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Mass</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Charge</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Spin</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Lifetime</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Modes</FONT></TH>'/
     & '</TR>')
C Loop through resonances
      DO 260 I=1,NRES
C Skip particles that can't be produced or blank lines
      IF ((VTOCDK(I).AND.VTORDK(I)).OR.
     &    (RNAME(I).EQ.'        ')) GOTO 260
C Open and write out header information for particle file
      IF (PRNWEB) THEN
        TMPNME = HWUNST(I)
        WRITE(FNAMEP,'(A5,A7,A5)') 'PART_',TMPNME,'.html'
        WRITE(FNAMEW,'(A,A17)') 'HW_decays/',FNAMEP
        OPEN(IUNTW2,STATUS='UNKNOWN',FILE=FNAMEW)
        WRITE(IUNTW2,60) RNAME(I),BGCOLS
        WRITE(IUNTW2,70) TBCOLS,((TBCOLS(L),L=2,3),M=1,6)
      ENDIF
   60 FORMAT('<!-- No Less productions -->'/'<HTML>'/'<HEAD>'/
     & '<TITLE>HERWIG 6.0: ',A8,' properties</TITLE>'/'</HEAD>'/
     & '<BODY BGCOLOR=#',A6,' TEXT=#',A6,' LINK=#',A6,
     & ' ALINK=#',A6,' VLINK=#',A6,'>'/'<CENTER>')
   70 FORMAT('<TABLE ALIGN="CENTER" BGCOLOR=#',A6,'>'/
     & '<TR>'/'<TH></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Name</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="CENTER"><FONT COLOR=#',A6,
     & '>Id PDG</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Mass</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Charge</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Spin</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Lifetime</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Modes</FONT></TH>'/
     & '</TR>')
C Trick to output charge in fractions for di/s - quarks
      IF ((I.GE.  1.AND.I.LE. 12).OR.(I.GE.109.AND.I.LE.120).OR.
     &    (I.GE.209.AND.I.LE.218).OR.(I.GE.401.AND.I.LE.424)) THEN
        ACHRG='/3'
      ELSE
        ACHRG='  '
      ENDIF
C Write out special particles with no decay modes
      IF (NMODES(I).EQ.0) THEN
        IF (PRNDEF) THEN
          IF (NPRFMT.LE.1) THEN
            WRITE(6,80) I,RNAME(I),IDPDG(I),RMASS(I),ICHRG(I),
     &                  ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),0
          ELSE
            WRITE(6,90) I,RNAME(I),IDPDG(I),RMASS(I),ICHRG(I),
     &                  ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),0
          ENDIF
        ENDIF
C Add particle to LaTeX file
        IF (PRNTEX) THEN
          IF (NPRFMT.LE.1) THEN
            WRITE(IUNITT,100) Z,I,TXNAME(1,I),IDPDG(I),RMASS(I),
     &       ICHRG(I),ACHRG,ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),0,ZZ
          ELSE
            WRITE(IUNITT,110) Z,I,TXNAME(1,I),IDPDG(I),RMASS(I),
     &       ICHRG(I),ACHRG,ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),0,Z,ZZ
          ENDIF
        ENDIF
        IF (PRNWEB) THEN
C Add properties to Web index
          WRITE(IUNTW1,120) TBCOLS(2),TBCOLS(3),I,FNAMEP,TXNAME(2,I),
     &                      IDPDG(I),RMASS(I),ICHRG(I),ACHRG,
     &                      ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),0
C Add properties to Web particle file
          WRITE(IUNTW2,130) TBCOLS(2),TBCOLS(3),I,TXNAME(2,I),
     &                      IDPDG(I),RMASS(I),ICHRG(I),ACHRG,
     &                      ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),0
        ENDIF
   80   FORMAT(/1X,I3,1X,A8,' IDPDG=',I8,', M=',F8.3,', Q=',I2,',  J=',
     &   A3,', T=',1P,E9.3,',',I3,' Modes')
   90   FORMAT(/1X,I3,1X,A8,1X,I8,1X,F8.3,1X,I2,1X,A3,1X,1P,E9.3,1X,I3)
  100   FORMAT(A1,'hline',I4,' & ',A37,' & $',I8,'$ & ',F8.3,' & $',I2,
     &   A2,'$ & ',A3,' & $',1P,E9.3,'$ & ',I3,' ',A2)
  110   FORMAT(A1,'cline{1-8}'/
     &   I4,' & ',A37,' & $',I8,'$ & ',F8.3,' & $',I2,A2,'$ & ',A3,
     &   ' & $',1P,E9.3,'$ & ',I3,' & ',A1,'multicolumn{7}{|c|}{} ',A2)
  120   FORMAT('<TR>'/
     &   '<TD ALIGN="RIGHT" BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>',I3,
     &   '</FONT></TD>'/
     &   '<TD ALIGN="CENTER"><A HREF="',A17,'">',A37,'</A></TD>'/
     &   '<TD ALIGN="RIGHT">',I8,'</TD>'/
     &   '<TD ALIGN="RIGHT">',F8.3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I2,A2,'</TD>'/
     &   '<TD ALIGN="RIGHT">',A3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',1P,E9.3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I3,'</TD>'/'</TR>')
  130   FORMAT('<TR>'/
     &   '<TD ALIGN="RIGHT" BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>',I3,
     &   '</FONT></TD>'/
     &   '<TD ALIGN="CENTER">',A37,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I8,'</TD>'/
     &   '<TD ALIGN="RIGHT">',F8.3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I2,A2,'</TD>'/
     &   '<TD ALIGN="RIGHT">',A3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',1P,E9.3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I3,'</TD>'/'</TR>'/'</TABLE>'/'<P>')
      ELSE
C Particle with decay modes
        IF (RSTAB(I)) THEN
          NM=0
        ELSEIF (VTOCDK(I)) THEN
          NM=-NMODES(I)
        ELSE
          NM=NMODES(I)
        ENDIF
        K=LSTRT(I)
C Write out properties and first decay mode
        IF (PRNDEF) THEN
          IF (NPRFMT.LE.1) THEN
            WRITE(6, 80) I,RNAME(I),IDPDG(I),RMASS(I),ICHRG(I),
     &       ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),NM
            WRITE(6,140) (RNAME(IDKPRD(L,K)),L=1,5),BRFRAC(K),NME(K)
          ELSE
            WRITE(6,150) I,RNAME(I),IDPDG(I),RMASS(I),ICHRG(I),
     &       ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),NM,BRFRAC(K),NME(K),
     &       (RNAME(IDKPRD(L,K)),L=1,5)
          ENDIF
        ENDIF
        IF (PRNTEX) THEN
          IF (NPRFMT.LE.1) THEN
            WRITE(IUNITT,160) Z,I,TXNAME(1,I),IDPDG(I),RMASS(I),
     &       ICHRG(I),ACHRG,ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),NM,ZZ,Z
            WRITE(IUNITT,170) Z,Z,(TXNAME(1,IDKPRD(L,K)),L=1,5),Z,
     &       BRFRAC(K),Z,NME(K),ZZ
          ELSE
            WRITE(IUNITT,180) Z,I,TXNAME(1,I),IDPDG(I),RMASS(I),
     &       ICHRG(I),ACHRG,ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),NM,
     &       BRFRAC(K),NME(K),(TXNAME(1,IDKPRD(L,K)),L=1,5),ZZ,Z
          ENDIF
        END IF
        IF (PRNWEB) THEN
C Add properties to index
          WRITE(IUNTW1,120) TBCOLS(2),TBCOLS(3),I,FNAMEP,TXNAME(2,I),
     &     IDPDG(I),RMASS(I),ICHRG(I),ACHRG,ASPIN(INT(TWO*RSPIN(I))),
     &     RLTIM(I),NM
C Add properties to Web particle file
          WRITE(IUNTW2,130) TBCOLS(2),TBCOLS(3),I,TXNAME(2,I),IDPDG(I),
     &     RMASS(I),ICHRG(I),ACHRG,ASPIN(INT(TWO*RSPIN(I))),RLTIM(I),NM
          WRITE(IUNTW2,190) TBCOLS,TXNAME(2,I),
     &     ((TBCOLS(L),L=2,3),M=1,3)
          WRITE(IUNTW2,200) TBCOLS(2),TBCOLS(3),1,BRFRAC(K),NME(K),
     &     (TXNAME(2,IDKPRD(L,K)),L=1,5)
        ENDIF
  140   FORMAT(5X,'BR[ -->',5(1X,A8),']=',F5.3,', ME code',I5)
  150   FORMAT(/1X,I3,1X,A8,1X,I8,1X,F8.3,1X,I2,1X,A3,1X,1P,E9.3,1X,I3,
     &   2X,F5.3,1X,I3,5(1X,A8))
  160   FORMAT(A1,'hline',
     &   I4,' & ',A37,' & $',I8,'$ & ',F8.3,' & $',I2,A2,'$ & ',
     &   A3,' & $',1P,E9.3,'$ & ',I3,' ',A2/A1,'cline{2-8}')
  170   FORMAT(' & & ',A1,'multicolumn{2}{l}{$',A1,'longrightarrow$'/
     &   5(A37,' '),'}'/' & ',A1,'multicolumn{2}{l}{BR = ',F5.3,'} & ',
     &   A1,'multicolumn{2}{l|}{ME code = ',I3,'} ',A2)
  180   FORMAT(A1,'hline'/
     &   I4,' & ',A37,' & $',I8,'$ & ',F8.3,' & $',I2,A2,'$ & ',
     &   A3,' & $',1P,E9.3,'$ & ',I3,' & ',F5.3,' & ',I3,
     &   5(' & ',A37), ' ',A2/A1,'cline{2-8}')
  190   FORMAT('<TABLE ALIGN="CENTER" BGCOLOR=#',A6,'>'/'<TR>'/
     &   '<TH COLSPAN=8 BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>',A37,
     &   ' Decay Modes</FONT></TH>'/'</TR>'/'<TR>'/'<TH></TH>',
     &   '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>B.R.</FONT></TH>'/
     &   '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>M.E.</FONT></TH>'/
     &   '<TH BGCOLOR=#',A6,' ALIGN="CENTER" COLSPAN=5>',
     &   '<FONT COLOR=#',A6,'>Decay products</FONT></TH>'/'</TR>')
  200   FORMAT('<TR>'/
     &   '<TD ALIGN="RIGHT" BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>',
     &   I3,'</FONT></TD>'/
     &   '<TD ALIGN="RIGHT">',F5.3,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I3,'</TD>'/
     &   5('<TD ALIGN="CENTER">',A37,'</TD>'/),'</TR>')
C Write out additional decay modes
        IF (NMODES(I).GE.2) THEN
          DO 210 J=2,NMODES(I)
          K=LNEXT(K)
          IF (PRNDEF) THEN
            IF (NPRFMT.LE.1) THEN
              WRITE(6,140) (RNAME(IDKPRD(L,K)),L=1,5),BRFRAC(K),NME(K)
            ELSE
              WRITE(6,220) BRFRAC(K),NME(K),(RNAME(IDKPRD(L,K)),L=1,5)
            END IF
          END IF
          IF (PRNTEX) THEN
            IF (NPRFMT.LE.1) THEN
              WRITE(IUNITT,170) Z,Z,(TXNAME(1,IDKPRD(L,K)),L=1,5),Z,
     &         BRFRAC(K),Z,NME(K),ZZ
            ELSE
              WRITE(IUNITT,230) Z,BRFRAC(K),NME(K),
     &         (TXNAME(1,IDKPRD(L,K)),L=1,5),ZZ
            ENDIF
          ENDIF
          IF (PRNWEB) WRITE(IUNTW2,200) TBCOLS(2),TBCOLS(3),J,
     &     BRFRAC(K),NME(K),(TXNAME(2,IDKPRD(L,K)),L=1,5)
  210     CONTINUE
          IF (PRNTEX.AND.NPRFMT.EQ.2.AND.NMODES(I+1).EQ.0)
     &     WRITE(IUNITT,240) Z
  220     FORMAT(54X,F5.3,1X,I3,5(1X,A8))
  230     FORMAT(' & ',A1,'multicolumn{7}{|c|}{} & ',F5.3,' & ',I3,
     &     5(' & ',A37),' ',A2)
  240     FORMAT(A1,'hline')
        ENDIF
      ENDIF
C Close Web particle file
      IF (PRNWEB) THEN
        WRITE(IUNTW2,250)
        CLOSE(IUNTW2)
      ENDIF
  250 FORMAT('</TABLE>'/'</CENTER>'/'<P>'/
     & 'Main particle <A HREF="index.html">index</A>'/
     & '</BODY>'/'</HTML>')
  260 CONTINUE
C Close the LaTeX file
      IF (PRNTEX) THEN
        WRITE(IUNITT,270) Z,Z,Z
        CLOSE(IUNITT)
      ENDIF
C Close the index file
      IF (PRNWEB) THEN
        WRITE(IUNTW1,280)
        CLOSE(IUNTW1)
      ENDIF
  270 FORMAT(A1,'end{longtable}'/A1,'end{center}'/A1,'end{document}')
  280 FORMAT('</TABLE>'/'</CENTER>'/'</BODY>'/'</HTML>')
      RETURN
      END
