      SUBROUTINE FITPAR(IOUTP)
C**********************************************************************
C
C     read input parameters according to PDFs
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER(ZERO=0.D0,
     &           ONE=1.D0,
     &          DEFA=-99999.D0,
     &          DEFB=-100000.D0,
     &         THOUS=1.D3)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      CHARACTER*8 PDFNAM
      COMMON /PARPDF/ PDFLAM(2),PDFQ2M(2),PDFNAM(2),IPARID(2),PARVI(2),
     &                IPAVA(2),ITYPE(2),IGRP(2),ISET(2),IEXT(2),NPAOLD
C
      COMMON /INPUTS/ PARINP(30)
      COMMON /REGGE/  ALPOM,ALPOMP,GP(2),B0POM(2),
     &                ALREG,ALREGP,GR(2),B0REG(2),
     &                GPPP,GPPR,B0PPP,B0PPR,
     &                VDMFAC(4),VDMQ2F(4),B0HAR,AKFAC
      COMMON /TWOCHA/ PHISUP(2),RMASS1,RMASS2,VAR
C
      DIMENSION   INUM(3),GPS(2),GRS(2),IFPAS(2)
      CHARACTER*8 CNAME8,PDFNA1,PDFNA2
      CHARACTER*10 CNAM10
      DATA CNAME8 /'        '/
      DATA CNAM10 /'          '/
      DATA INIT / 0 /
      DATA IFPAS / 0, 0 /
C
      IF((INIT.EQ.1).AND.
     &   (IFPAP(1).EQ.IFPAS(1)).AND.
     &   (IFPAP(2).EQ.IFPAS(2))) GOTO 1300
      INIT=1
      IFPAS(1) = IFPAP(1)
      IFPAS(2) = IFPAP(2)
C  parton distribution functions
      CALL ACTPDF(IFPAP(1),PVIRT(1),1)
      CALL GETPDF(1,PDFNA1,ALAM,Q2MIN,Q2MAX,XMIN,XMAX)
      CALL ACTPDF(IFPAP(2),PVIRT(2),2)
      CALL GETPDF(2,PDFNA2,ALAM,Q2MIN,Q2MAX,XMIN,XMAX)
      IF(IDEB(54).GE.0) THEN
        WRITE(6,'(/1X,A,I7,2X,A,3I7)') 'FITPAR:DEBUG: LOOKING FOR PDF',
     &    IFPAP(1),PDFNA1,IGRP(1),ISET(1),IEXT(1)
        WRITE(6,'(1X,A,I7,2X,A,3I7)') 'FITPAR:DEBUG: LOOKING FOR PDF',
     &    IFPAP(2),PDFNA2,IGRP(2),ISET(2),IEXT(2)
      ENDIF
*     GOTO 1010
C  get parameters of soft cross sections from parameter table
      OPEN(12,FILE='fitpar.dat',ERR=1010,STATUS='OLD')
 100  CONTINUE
        READ(12,'(A8)',ERR=1020,END=1010) CNAME8
        IF(CNAME8.EQ.'STOP') GOTO 1010
        IF(CNAME8.EQ.'NEXTDATA') THEN
          READ(12,'(I8,2X,A8,3I6)',ERR=1020,END=1010) IDPA1,CNAME8,INUM
          IF((IDPA1.EQ.IFPAP(1)).AND.(CNAME8.EQ.PDFNA1)
     &       .AND.(INUM(1).EQ.IGRP(1)).AND.(INUM(2).EQ.ISET(1))) THEN
            READ(12,'(I8,2X,A8,3I6)',ERR=1020,END=1010)IDPA2,CNAME8,INUM
            IF((IDPA2.EQ.IFPAP(2)).AND.(CNAME8.EQ.PDFNA2)
     &         .AND.(INUM(1).EQ.IGRP(2)).AND.(INUM(2).EQ.ISET(2))) THEN
              WRITE(6,'(/1X,A)') 'FITPAR:DEBUG: PARAMETER SET FOUND'
              READ(12,*) ALPOM,ALPOMP,GP,B0POM
              READ(12,*) ALREG,ALREGP,GR,B0REG
              READ(12,*) GPPP,B0PPP,GPPR,B0PPR
              READ(12,*) VDMFAC(1),VDMFAC(2),VDMFAC(3),VDMFAC(4)
              READ(12,*) B0HAR
              READ(12,*) AKFAC
              READ(12,*) PHISUP
              READ(12,*) RMASS1,RMASS2,VAR
              GOTO 1100
            ENDIF
          ENDIF
        ENDIF
      GOTO 100
 1020 CONTINUE
        WRITE(6,'(A)') ' FITPAR:ERROR: cannot read file fitpar.dat'
        WRITE(6,'(A,A10,A8)') ' last data card: ',CNAM10,CNAME8
 1010 CONTINUE
        WRITE(6,'(A)') ' FITPAR:WARNING: cannot find parameters'
        WRITE(6,'(A,A8,2X,A8)') ' PDF sets: ',PDFNA1,PDFNA2
        WRITE(6,'(A)') ' (initialization with default parameter values)'
C
C  general parameters
        ALPOM     = 1.097
        ALPOMP    = .250
        ALREG     = .490
        ALREGP    = 1.000
        AKFAC     = 1.000
        VAR       = 3.000
        GPPP      = .170
        B0PPP     = .500
        GPPR      = PARMDL(7)*GPPP
        B0PPR     = .300
C
C  gamma-gamma scattering
        IF((IFPAP(1).EQ.22).AND.(IFPAP(2).EQ.22)) THEN
          GP(1)     = 2.745
          GP(2)     = GP(1)
          B0POM(1)  = 1.225
          B0POM(2)  = B0POM(1)
          B0HAR     = 3.200
          GR(1)     = 6.640
          GR(2)     = GR(1)
          B0REG(1)  = 0.462 
          B0REG(2)  = B0REG(1)
          VDMFAC(1) = .00431
          VDMFAC(2) = .00008
          VDMFAC(3) = VDMFAC(1)
          VDMFAC(4) = VDMFAC(2)
          PHISUP(1) = .7
          PHISUP(2) = PHISUP(1)
          RMASS1    = 1.000
          RMASS2    = RMASS1
C
C  p-gamma scattering
        ELSE IF((ABS(IFPAP(1)).EQ.2212)
     &     .AND.(IFPAP(2).EQ.22)) THEN
          GP(1)     = 6.827
          GP(2)     = 2.745
          B0HAR     = 3.200
          B0POM(1)  = 1.136
          B0POM(2)  = 1.225
          GR(1)     = 11.740
          GR(2)     = 4.721
          B0REG(1)  =  .428
          B0REG(2)  =  .462
          VDMFAC(1) = 1.0000
          VDMFAC(2) = .00000
          VDMFAC(3) = .00431
          VDMFAC(4) = .00008
          PHISUP(1) = .600
          PHISUP(2) = .700
          RMASS1    = 1.100
          RMASS2    = 1.000
C
C  gamma-p scattering
        ELSE IF((IFPAP(1).EQ.22)
     &          .AND.(ABS(IFPAP(2)).EQ.2212)) THEN
          GP(1)     = 2.745
          GP(2)     = 6.827
          B0HAR     = 3.200
          B0POM(1)  = 1.225
          B0POM(2)  = 1.136
          GR(1)     = 4.721 
          GR(2)     = 11.740
          B0REG(1)  = .462
          B0REG(2)  = .428
          VDMFAC(1) = .00431
          VDMFAC(2) = .00008
          VDMFAC(3) = 1.0000
          VDMFAC(4) = .00000
          PHISUP(1) = .700
          PHISUP(2) = .600
          RMASS1    = 1.000
          RMASS2    = 1.100
C
C  p-p scattering
        ELSE IF((ABS(IFPAP(1)).EQ.2212)
     &          .AND.(ABS(IFPAP(2)).EQ.2212)) THEN
          GP(1)     = 6.827
          GP(2)     = GP(1)
          B0HAR     = 3.2000
          B0POM(1)  = 1.136
          B0POM(2)  = B0POM(1)
          GR(1)     = 13.098
          GR(2)     = GR(1)
          B0REG(1)  = 1.746
          B0REG(2)  = B0REG(1)
          VDMFAC(1) = 1.0000
          VDMFAC(2) = .00000
          VDMFAC(3) = VDMFAC(1)
          VDMFAC(4) = VDMFAC(2)
          PHISUP(1) = .600
          PHISUP(2) = PHISUP(1)
          RMASS1    = 1.100
          RMASS2    = RMASS1
C
C  p-pi scattering
        ELSE IF((ABS(IFPAP(2)).EQ.211)
     &          .AND.(ABS(IFPAP(1)).EQ.2212)) THEN
          GP(1)     = 6.827
          B0HAR     = 3.200
          B0POM(1)  = 1.136
          GR(1)     = 13.098
          B0REG(1)  = 1.746
          PHISUP(1) = .600
          PHISUP(2) = .700
          RMASS1    = 1.100
          RMASS2    = 0.500
          GP(2) = GP(1)*2.D0/3.D0
          GR(2) = GR(1)*2.D0/3.D0
          B0REG(2) = B0REG(1)*0.8D0
          B0POM(2) = B0POM(1)*0.8D0
          VDMFAC(1) = 1.0000
          VDMFAC(2) = .00000
          VDMFAC(3) = VDMFAC(1)
          VDMFAC(4) = VDMFAC(2)
C
C  pi-p scattering
        ELSE IF((ABS(IFPAP(2)).EQ.2212)
     &          .AND.(ABS(IFPAP(1)).EQ.211)) THEN
          GP(2)     = 6.827
          B0HAR     = 3.200
          B0POM(2)  = 1.136
          GR(2)     = 13.098
          B0REG(2)  = 1.746
          PHISUP(1) = .700
          PHISUP(2) = .600
          RMASS1    = 0.5
          RMASS2    = 1.100
          GP(1) = GP(2)*2.D0/3.D0
          GR(1) = GR(2)*2.D0/3.D0
          B0REG(1) = B0REG(2)*0.8D0
          B0POM(1) = B0POM(2)*0.8D0
          VDMFAC(1) = 1.0000
          VDMFAC(2) = .00000
          VDMFAC(3) = VDMFAC(1)
          VDMFAC(4) = VDMFAC(2)
C
C  pomeron-pomeron scattering
        ELSE IF((IFPAP(1).EQ.45).AND.(IFPAP(2).EQ.45)) THEN
          GP(1)     = 0.12
          GP(2)     = GP(1)
          B0POM(1)  = 0.500
          B0POM(2)  = B0POM(1)
          B0HAR     = 0.100
          GR(1)     = 0.25
          GR(2)     = GR(1)
          B0REG(1)  = 0.500
          B0REG(2)  = B0REG(1)
          VDMFAC(1) = 1.0000
          VDMFAC(2) = .00000
          VDMFAC(3) = VDMFAC(1)
          VDMFAC(4) = VDMFAC(2)
          PHISUP(1) = .662
          PHISUP(2) = PHISUP(1)
          RMASS1    = 1.100
          RMASS2    = RMASS1
C
C  unknown particles
        ELSE
          WRITE(6,'(//1X,A,2I8)')
     &      'FITPAR:ERROR:UNSUPPORTED PARTICLE COMBINATION',
     &      IFPAP(1),IFPAP(2)
          STOP
        ENDIF
 1100 CONTINUE
      CLOSE(12)
      GPS(1) = GP(1)
      GPS(2) = GP(2)
      GRS(1) = GR(1)
      GRS(2) = GR(2)
 1300 CONTINUE
C
C  overwrite parameters with input data cards
      IF(PARINP(1).GT.DEFA) THEN
        ALPOM     = PARINP(1)
        PARINP(1) = DEFB
      ENDIF
      IF(PARINP(2).GT.DEFA) THEN
        ALPOMP    = PARINP(2)
        PARINP(2) = DEFB
      ENDIF
      IF(PARINP(3).GT.DEFA) THEN
        GP(1)     = PARINP(3)
        PARINP(3) = DEFB
      ENDIF
      IF(PARINP(4).GT.DEFA) THEN
        GP(2)     = PARINP(4)
        PARINP(4) = DEFB
      ENDIF
      IF(PARINP(5).GT.DEFA) THEN
        B0POM(1)  = PARINP(5)
        PARINP(5) = DEFB
      ENDIF
      IF(PARINP(6).GT.DEFA) THEN
        B0POM(2)  = PARINP(6)
        PARINP(6) = DEFB
      ENDIF
      IF(PARINP(7).GT.DEFA) THEN
        ALREG     = PARINP(7)
        PARINP(7) = DEFB
      ENDIF
      IF(PARINP(8).GT.DEFA) THEN
        ALREGP    = PARINP(8)
        PARINP(8) = DEFB
      ENDIF
      IF(PARINP(9).GT.DEFA) THEN
        GR(1)     = PARINP(9)
        PARINP(9) = DEFB
      ENDIF
      IF(PARINP(10).GT.DEFA) THEN
        GR(2)      = PARINP(10)
        PARINP(10) = DEFB
      ENDIF
      IF(PARINP(11).GT.DEFA) THEN
        B0REG(1)  = PARINP(11)
        PARINP(11) = DEFB
      ENDIF
      IF(PARINP(12).GT.DEFA) THEN
        B0REG(2)  = PARINP(12)
        PARINP(12) = DEFB
      ENDIF
      IF(PARINP(13).GT.DEFA) THEN
        GPPP      = PARINP(13)
        PARINP(13) = DEFB
      ENDIF
      IF(PARINP(14).GT.DEFA) THEN
        B0PPP     = PARINP(14)
        PARINP(14)= DEFB
      ENDIF
      IF(PARINP(15).GT.DEFA) THEN
        VDMFAC(1) = PARINP(15)
        PARINP(15)= DEFB
      ENDIF
      IF(PARINP(16).GT.DEFA) THEN
        VDMFAC(2) = PARINP(16)
        PARINP(16)= DEFB
      ENDIF
      IF(PARINP(17).GT.DEFA) THEN
        VDMFAC(3) = PARINP(17)
        PARINP(17)= DEFB
      ENDIF
      IF(PARINP(18).GT.DEFA) THEN
        VDMFAC(4) = PARINP(18)
        PARINP(18)= DEFB
      ENDIF
      IF(PARINP(19).GT.DEFA) THEN
        B0HAR     = PARINP(19)
        PARINP(19)= DEFB
      ENDIF
      IF(PARINP(20).GT.DEFA) THEN
        AKFAC     = PARINP(20)
        PARINP(20)= DEFB
      ENDIF
      IF(PARINP(21).GT.DEFA) THEN
        PHISUP(1) = PARINP(21)
        PARINP(21)= DEFB
      ENDIF
      IF(PARINP(22).GT.DEFA) THEN
        PHISUP(2) = PARINP(22)
        PARINP(22)= DEFB
      ENDIF
      IF(PARINP(23).GT.DEFA) THEN
        RMASS1    = PARINP(23)
        PARINP(23)= DEFB
      ENDIF
      IF(PARINP(24).GT.DEFA) THEN
        RMASS2    = PARINP(24)
        PARINP(24)= DEFB
      ENDIF
      IF(PARINP(25).GT.DEFA) THEN
        VAR       = PARINP(25)
        PARINP(25)= DEFB
      ENDIF
      IF(PARINP(27).GT.DEFA) THEN
        GPPR      = PARINP(27)
        PARINP(27)= DEFB
      ENDIF
      IF(PARINP(28).GT.DEFA) THEN
        B0PPR     = PARINP(28)
        PARINP(28)= DEFB
      ENDIF
C
C  VDM couplings
*     RHOM2 = 0.6D0
*     ALPHA = 1.1D0
*     ALPHA = 1.D0
*     IF(IFPAP(1).EQ.22) THEN
*       VDMQ2F(1) = RHOM2/(RHOM2+PVIRT(1))*VDMFAC(1)
*       VDMQ2F(2) = RMASS1**2/(RMASS1**2+PVIRT(1))*VDMFAC(2)
*       GP(1) = GPS(1)*(RHOM2/(RHOM2+PVIRT(1)))**ALPHA
*       GR(1) = GRS(1)*(RHOM2/(RHOM2+PVIRT(1)))**ALPHA
*     ELSE
*       VDMQ2F(1) = VDMFAC(1)
*       VDMQ2F(2) = VDMFAC(2)
*     ENDIF
*     IF(IFPAP(2).EQ.22) THEN
*       VDMQ2F(3) = RHOM2/(RHOM2+PVIRT(2))*VDMFAC(3)
*       VDMQ2F(4) = RMASS2**2/(RMASS2**2+PVIRT(2))*VDMFAC(4)
*       GP(2) = GPS(2)*(RHOM2/(RHOM2+PVIRT(2)))**ALPHA
*       GR(2) = GRS(2)*(RHOM2/(RHOM2+PVIRT(2)))**ALPHA
*     ELSE
*       VDMQ2F(3) = VDMFAC(3)
*       VDMQ2F(4) = VDMFAC(4)
*     ENDIF
C
      VDMQ2F(1) = VDMFAC(1)
      VDMQ2F(2) = VDMFAC(2)
      VDMQ2F(3) = VDMFAC(3)
      VDMQ2F(4) = VDMFAC(4)
C  output of parameter set
      IF((IDEB(54).GE.5).OR.(IOUTP.GT.0)) THEN
        WRITE(6,'(/,A,/,A)') ' FITPAR:DEBUG:SOFT PARAMETER SET:',
     &                       ' ==============================='
        WRITE(6,'(2(A,F7.3),2(A,2F9.3))')
     &  '  ALPOM:',ALPOM,' ALPOMP:',ALPOMP,' GP:',GP,' B0POM:',
     &  B0POM
        WRITE(6,'(2(A,F7.3),2(A,2F9.3))')
     &  '  ALREG:',ALREG,' ALREGP:',ALREGP,' GR:',GR,' B0REG:',
     &  B0REG
        WRITE(6,'(4(A,F7.3))')
     &  '  GPPP :',GPPP,' B0PPP:',B0PPP,' GPPR :',GPPR,' B0PPR:',B0PPR
        WRITE(6,'(A,4F10.5)') ' VDMFAC:',VDMFAC
        WRITE(6,'(A,4F10.5)') ' VDMQ2F:',VDMQ2F
        WRITE(6,'(A,F8.3)')  '  B0HAR:',B0HAR
        WRITE(6,'(A,F8.3)')  '  AKFAC:',AKFAC
        WRITE(6,'(A,2F8.3)') ' PHISUP:',PHISUP
        WRITE(6,'(A,3F8.3)') '  RMASS:',RMASS1,RMASS2,VAR
      ENDIF
      CALL POHINI(1,IFPAP(1),IFPAP(2),PVIRT(1),PVIRT(2),6,IOUTP)
      END
