C
C
      SUBROUTINE GETLTR(P1,P2,GAM,GAMB,DELE,IREJ)
C********************************************************************
C
C     calculate Lorentz boots for arbitrary Lorentz transformation
C
C     input:   P1    initial 4 vector
C              P2    final 4 vector
C
C     output:  GAM(3),GAMB(3)
C              DELE   energy deviation
C              IREJ   0 success
C                     1 failure
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER ( ONE = 1.D0,
     &            ZERO = 0.D0,
     &            DREL = 0.001D0 )
      DIMENSION P1(4),P2(4),GAM(3),GAMB(3),PA(4),PP(4)
C
      IREJ = 1
      DO 50 K=1,4
        PA(K) = P1(K)
        PP(K) = P1(K)
 50   CONTINUE
      PM1 = P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2
      DO 100 I=1,3
        PP(I) = P2(I)
        PP(4) = PM1+PP(1)**2+PP(2)**2+PP(3)**2
        IF(PP(4).LE.ZERO) RETURN
        PP(4) = SQRT(PP(4))
        GAMB(I) = (SQRT(PA(4)**2-PA(I)**2+PP(I)**2)*PP(I)
     &             -PA(4)*PA(I))/(PA(4)**2+PP(I)**2)
        GAM(I) = ONE/SQRT(ONE-GAMB(I)**2)
        GAMB(I) = GAMB(I)*GAM(I)
        DO 150 K=1,4
          PA(K) = PP(K)
 150    CONTINUE
 100  CONTINUE
      DELE = P2(4)-PP(4)
      IREJ = 0
C  consistency check
*     IF(ABS(P2(4)-PP(4))/MAX(P2(4),PP(4)).GT.DREL) THEN
*       PM2 = P2(4)**2-P2(1)**2-P2(2)**2-P2(3)**2
*       WRITE(6,'(/1X,A,2E12.5)')
*    &    'GETLTR:WARNING: INCONSISTENT ENERGIES',P2(4),PP(4)
*       WRITE(6,'(1X,A,2E12.4)') 'INPUT MASSES',PM1,PM2
*       WRITE(6,'(1X,A,4E12.4)') 'INPUT ',P1
*       WRITE(6,'(1X,A,4E12.4)') 'OUTPUT',P2
*       WRITE(6,'(1X,A,4E12.4)') 'INTERN',PP
*     ENDIF
      END
