C
C
      SUBROUTINE HACODE(ID1,ID2,IDBAM1,IDBAM2)
C*********************************************************************
C
C     determination of hadron index from quarks
C
C     input:   ID1,ID2   parton code according to PDG conventions
C
C     output:  IDBAM1,2  BAMJET particle code
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON/INPDAT/IMPS(6,6),IMVE(6,6),IB08(6,21),IB10(6,21),
     *IA08(6,21),IA10(6,21),A1,B1,B2,B3,LT,LB,ISU,IYQ,BET,AS,B8,AME,DIQ
C
      IDBAM1 = 0
      IF(ABS(ID1).GT.6) THEN
C  diquark-antidiquark
        IF(ABS(ID2).GT.6) THEN
          IDBAM1 = 23
          IDBAM2 = 33
          RETURN
        ENDIF
        I = ICONV2(ID1,1)
        J = ICONV2(ID1,2)
        K = ICONV2(ID2,0)
        IBAR = 1
      ELSE IF(ABS(ID2).GT.6) THEN
        I = ICONV2(ID2,1)
        J = ICONV2(ID2,2)
        K = ICONV2(ID1,0)
        IBAR = 1
      ELSE IF((ID1*ID2).LT.0) THEN
        I = ICONV2(ID1,0)
        J = ICONV2(ID2,0)
        IBAR = 0
      ELSE
        WRITE(6,'(/1X,A,2I6)') 'HACODE:ERROR: INVALID FLAVORS ',ID1,ID2
        CALL POPREV(-1)
      ENDIF
C  baryon
      IF(IBAR.EQ.1) THEN
        IF(I.GT.6) THEN
          II = I -6
          JJ = J -6
          KK = K -6
          IABAR = 1
        ELSE
          II = I
          JJ = J
          KK = K
          IABAR = 0
        ENDIF
        IF((II*JJ*KK).LE.0) THEN
          WRITE(6,'(/1X,A,2I6)')
     &      'HACODE:ERROR: INCONSISTENT QUARK FLAVOURS ',ID1,ID2
          CALL POABRT
        ENDIF
        CALL INDEX2(II,JJ,IND)
        IF(IABAR.EQ.1) THEN
C  antibaryon
          IDBAM1 = IA08(KK,IND)
          IDBAM2 = IA10(KK,IND)
        ELSE
C  baryon
          IDBAM1 = IB08(KK,IND)
          IDBAM2 = IB10(KK,IND)
        ENDIF
C  meson
      ELSE
        IF(I.GT.6) THEN
          II = I -6
          JJ = J
        ELSE IF(J.GT.6) THEN
          II = J -6
          JJ = I
        ELSE
          WRITE(6,'(/1X,A,2I6)')
     &      'HACODE:ERROR: INCONSISTENT QUARK FLAVOURS ',ID1,ID2
          CALL POABRT
        ENDIF
        IDBAM1 = IMPS(II,JJ)
        IDBAM2 = IMVE(II,JJ)
      ENDIF
      IF(IDBAM1.EQ.0) IDBAM1 = IDBAM2
      IF(IDBAM2.EQ.0) IDBAM2 = IDBAM1
      END
