C
C
      SUBROUTINE PARSTA(IDBAM,EE,PT,ETA,IMODE)
C**********************************************************************
C
C     collect particle statistics
C               IMODE  table index
C                      1  collect statistics of resonances
C                      2  collect statistics of final state hadrons
C                         IDBAM  index of particle in /HEPEVS/
C                         EE     particle energy
C                         PT     particle transverse momentum
C                         ETA    pseudorapidity
C                      -1 initialization
C                      -2 output: 
C                         IDBAM = 1 resonances 
C                                 2 final state hadrons
C                         EE as the number of events
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER (DEPS=1.D-30)
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
C
C  local variables for particle statistics
      PARAMETER(LIMTAB=187)
      DIMENSION ENER(LIMTAB,2),PMUL(LIMTAB,2),PTRA(LIMTAB,2),CHSUM(2),
     &  SUM(2),PTCHR(2),PMCHR(2),ENCHR(2),CHNALL(2),CHN2P5(2),PTCALL(2),
     &  CHN2P0(2),CHN1P5(2),PTC2P5(2),PTC2P0(2),PTC1P5(2)
C
      IF(IMODE.GT.0) THEN
C  collect statistics
        IF(ICH(IDBAM).NE.0) THEN
          CHSUM(IMODE) = CHSUM(IMODE)+1.D0
          PTCHR(IMODE) = PTCHR(IMODE)+PT
          PMCHR(IMODE) = PMCHR(IMODE)+1.D0
          ENCHR(IMODE) = ENCHR(IMODE)+EE
          CHNALL(IMODE) = CHNALL(IMODE)+1.D0
          PTCALL(IMODE) = PTCALL(IMODE)+PT
          ETAABS = ABS(ETA)
          IF(ETAABS.LT.2.5D0) THEN
            CHN2P5(IMODE) = CHN2P5(IMODE)+1.D0
            PTC2P5(IMODE) = PTC2P5(IMODE)+PT
            IF(ETAABS.LT.2.0D0) THEN
              CHN2P0(IMODE) = CHN2P0(IMODE)+1.D0
              PTC2P0(IMODE) = PTC2P0(IMODE)+PT
              IF(ETAABS.LT.1.5D0) THEN
                CHN1P5(IMODE) = CHN1P5(IMODE)+1.D0
                PTC1P5(IMODE) = PTC1P5(IMODE)+PT
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        SUM(IMODE) = SUM(IMODE)+1.D0
        IF(IDBAM.LE.LIMTAB) THEN
          PMUL(IDBAM,IMODE) = PMUL(IDBAM,IMODE)+1.D0
          ENER(IDBAM,IMODE) = ENER(IDBAM,IMODE)+EE
          PTRA(IDBAM,IMODE) = PTRA(IDBAM,IMODE)+PT
        ENDIF
      ELSE IF(IMODE.EQ.-1) THEN
C  reset counters for initialization
        II = IDBAM
        CHNALL(II) = 0.D0
        CHNALL(II) = 0.D0
        CHN2P5(II) = 0.D0
        CHN2P0(II) = 0.D0
        CHN1P5(II) = 0.D0
        PTC2P5(II) = 0.D0
        PTC2P0(II) = 0.D0
        PTC1P5(II) = 0.D0
        CHSUM(II) = 0.D0
        SUM(II)   = 0.D0
        PTCHR(II) = 0.D0
        PMCHR(II) = 0.D0
        ENCHR(II) = 0.D0
        DO 100 I=1,LIMTAB
          PMUL(I,II) = 0.D0
          ENER(I,II) = 0.D0
          PTRA(I,II) = 0.D0
 100    CONTINUE
      ELSE IF(IMODE.EQ.-2) THEN
C  output of collected statistics
        SUM(IDBAM) = SUM(IDBAM)/EE
        CHSUM(IDBAM) = CHSUM(IDBAM)/EE
        PTCHR(IDBAM) = PTCHR(IDBAM)/EE
        PMCHR(IDBAM) = PMCHR(IDBAM)/EE
        ENCHR(IDBAM) = ENCHR(IDBAM)/EE
        DO 200 I=1,LIMTAB
          PMUL(I,IDBAM) = PMUL(I,IDBAM)/EE
          ENER(I,IDBAM) = ENER(I,IDBAM)/EE
          PTRA(I,IDBAM) = PTRA(I,IDBAM)/EE
 200    CONTINUE
        WRITE(6,'(/1X,A,I10,/1X,A)') 'PARSTA: FINAL OUTPUT:',INT(EE),
     &    '====================='
        IF(IDBAM.EQ.1) THEN
          WRITE(6,'(1X,A)') 'STATISTICS FOR PRIMARY RESONANCES'
        ELSE
          WRITE(6,'(1X,A)') 'STATISTICS FOR FINAL STATE PARTICLES'
        ENDIF
        WRITE(6,'(5X,A,2E12.4)') 'TOTAL,CHARGED MULTILICITY',
     &    SUM(IDBAM),CHSUM(IDBAM)
        IF(EE*SUM(IDBAM).LE.0.5D0) RETURN
        WRITE(6,'(5X,A,2E12.4)') 'FULL ETA      N-CH,<PT-CH>:',
     &    CHNALL(IDBAM)/EE,PTCALL(IDBAM)/MAX(CHNALL(IDBAM),1.D0)
        WRITE(6,'(5X,A,2E12.4)') 'ABS(ETA)<2.5  N-CH,<PT-CH>:',
     &    CHN2P5(IDBAM)/EE,PTC2P5(IDBAM)/MAX(CHN2P5(IDBAM),1.D0)
        WRITE(6,'(5X,A,2E12.4)') 'ABS(ETA)<2.0  N-CH,<PT-CH>:',
     &    CHN2P0(IDBAM)/EE,PTC2P0(IDBAM)/MAX(CHN2P0(IDBAM),1.D0)
        WRITE(6,'(5X,A,2E12.4)') 'ABS(ETA)<1.5  N-CH,<PT-CH>:',
     &    CHN1P5(IDBAM)/EE,PTC1P5(IDBAM)/MAX(CHN1P5(IDBAM),1.D0)
        WRITE(6,'(5X,A)')
     &    'PARTICLE    ID    MULT.    REL.MULT.   ENERGY   TRANS.MOM.'
        WRITE(6,'(5X,A8,I6,3X,4E12.4)') 'CHARGED ',0,PMCHR(IDBAM),
     &    PMCHR(IDBAM)/EE,ENCHR(IDBAM)/PMCHR(IDBAM),
     &    PTCHR(IDBAM)/PMCHR(IDBAM)
        DO 300 I=1,LIMTAB
          IF(PMUL(I,IDBAM).LT.DEPS) GOTO 299
          WRITE(6,'(5X,A8,I6,3X,4E12.4)') ANAME(I),I,PMUL(I,IDBAM),
     &      PMUL(I,IDBAM)/SUM(IDBAM),ENER(I,IDBAM)/PMUL(I,IDBAM),
     &      PTRA(I,IDBAM)/PMUL(I,IDBAM)
 299      CONTINUE
 300    CONTINUE
      ELSE
        WRITE(6,'(/1X,A,I10)') 'PARSTA:ERROR:INVALID ARGUMENT',IDBAM
        CALL POABRT
      ENDIF
      END
