C
C
      SUBROUTINE PARTRE(INDX,IOUT,IREM,IREJ)
C**********************************************************************
C
C     selection of parton remainder (quark or diquark)
C
C     input:    INDX   index of particle in COMMON HEPEVS
C               IOUT   parton already used
C
C     output:   IREM   remainder according to valence flavours
C               IREJ   0  flavour combination possible
C                      1  flavour combination impossible
C
C     all particle ID are given according to PDG conventions
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           OHALF  =  0.5D0,
     &           EPS    =  0.1D0,
     &           DEPS   =  1.D-40)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      DIMENSION IQUA(3)
C
      ID1 = IDHEP(INDX)
      ID2 = IMPART(INDX)
      IREJ = 0
C
      IF(ID2.EQ.0) THEN
        WRITE(6,'(1X,A,I6)') 'PARTRE:ERROR:NO BAMJET ID ',INDX
        CALL POABRT
      ENDIF
C  special particle with strong flavour mixing
      IQUA(1) = IPDGQU(1,ID2)
      IF(IQUA(1).EQ.0) THEN
        IF(ABS(IOUT).LE.4) THEN
          IREM = -IOUT
          GOTO 100
        ELSE
          GOTO 150
        ENDIF
      ENDIF
C  ordinary hadron
      IQUA(2) = IPDGQU(2,ID2)
      IQUA(3) = IPDGQU(3,ID2)
C  compare to flavour content
      IF(ABS(IOUT).LT.1000) THEN
C  single quark requested
        IF(IQUA(1).EQ.IOUT) THEN
          K1 = 2
          K2 = 3
        ELSE IF(IQUA(2).EQ.IOUT) THEN
          K1 = 1
          K2 = 3
        ELSE IF(IQUA(3).EQ.IOUT) THEN
          K1 = 1
          K2 = 2
        ELSE
          GOTO 150
        ENDIF
        IF(IQUA(3).EQ.0) THEN
          IREM = IQUA(K1)
        ELSE
          K3   = NDIQU(ABS(IQUA(K1)),ABS(IQUA(K2)))
          IREM = SIGN(K3,ID1)
        ENDIF
      ELSE IF(IQUA(3).NE.0) THEN
C  diquark requested
        K3   = NDIQU(ABS(IQUA(1)),ABS(IQUA(2)))
        IDQ1 = SIGN(K3,ID1)
        K3   = NDIQU(ABS(IQUA(2)),ABS(IQUA(1)))
        IDQ2 = SIGN(K3,ID1)
        K3   = NDIQU(ABS(IQUA(2)),ABS(IQUA(3)))
        IDQ3 = SIGN(K3,ID1)
        K3   = NDIQU(ABS(IQUA(3)),ABS(IQUA(2)))
        IDQ4 = SIGN(K3,ID1)
        K3   = NDIQU(ABS(IQUA(1)),ABS(IQUA(3)))
        IDQ5 = SIGN(K3,ID1)
        K3   = NDIQU(ABS(IQUA(3)),ABS(IQUA(1)))
        IDQ6 = SIGN(K3,ID1)
        IF((IDQ1.EQ.IOUT).OR.(IDQ2.EQ.IOUT)) THEN
          IREM = IQUA(3)
        ELSE IF((IDQ3.EQ.IOUT).OR.(IDQ4.EQ.IOUT)) THEN
          IREM = IQUA(1)
        ELSE IF((IDQ5.EQ.IOUT).OR.(IDQ6.EQ.IOUT)) THEN
          IREM = IQUA(2)
        ELSE
          GOTO 150
        ENDIF
      ELSE
        GOTO 150
      ENDIF
C
 100  CONTINUE
C  debug output
      IF(IDEB(72).GE.10) THEN
        WRITE(6,'(1X,A,5I6)')
     &    'PARTRE:DEBUG:INDX,ID-PDG,ID-BAM,IOUT,IREM ',
     &    INDX,ID1,ID2,IOUT,IREM
      ENDIF
      RETURN
C  rejection
 150  CONTINUE
      IREJ = 1
      IF(IDEB(72).GE.2)
     &  WRITE(6,'(1X,A,5I7)')
     &  'PARTRE:REJECTION IDPDG,Q1-3,IOUT',IDHEP(INDX),IQUA,IOUT
      END
