      SUBROUTINE PDIS(X,SCALE2,NPAR,PD)
C***************************************************************
C
C     call different PDF sets for different particle types
C
C     input:      X        momentum fraction
C                 SCALE2   squared scale (GeV**2)
C                 NPAR     1     IGRP(1),ISET(1)
C                          2     IGRP(2),ISET(2)
C
C     output      PD(-6:6) field containing the x*PDF fractions
C
C***************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION PD(-6:6)
C
      PARAMETER ( ONE = 1.D0,
     &           ZERO = 0.D0 )
      CHARACTER*8 PDFNAM
      COMMON /PARPDF/ PDFLAM(2),PDFQ2M(2),PDFNAM(2),IPARID(2),PARVI(2),
     &                IPAVA(2),ITYPE(2),IGRP(2),ISET(2),IEXT(2),NPAOLD
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      DIMENSION PARAM(20),VALUE(20)
      CHARACTER*20 PARAM
C
      REAL XR,P2R,Q2R,F2GM,XPDFGM
      DIMENSION XPDFGM(-6:6)
C
      XI = X
      IF(X.GE.1.D0) THEN
        IF(IDEB(37).GE.0) THEN
          WRITE(6,'(/,1X,A,E15.8/)') 'PDIS:WARNING: X >= 1 ',X
          CALL POPREV(-1)
        ENDIF
        XI = 0.99999999999D0
      ELSE IF(X.LE.0.D0) THEN
        IF(IDEB(37).GE.0) THEN
          WRITE(6,'(/,1X,A,E15.8/)') 'PDIS:WARNING: X <= 0 ',X
          CALL POPREV(-1)
        ENDIF
        XI = 0.0001D0
      ENDIF
C
      DO 100 I=-6,6
        PD(I) = ZERO
 100  CONTINUE
      IRET = 1
C
      IF((NPAR.EQ.1).OR.(NPAR.EQ.2)) THEN
C
C  internal PDFs
C
        IF(IEXT(NPAR).EQ.0) THEN
          IF(ITYPE(NPAR).EQ.1) THEN
C  proton PDFs
            IF(IGRP(NPAR).EQ.5) THEN
              IF(ISET(NPAR).EQ.3) THEN
                CALL DOR92HO(XI,SCALE2, UDV, DV, GL, UDB, SB, CB, BB)
                UV = UDV-DV
                UDB = 2.D0*UDB
                DEL = 0.D0
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.4) THEN
                CALL DOR92LO(XI,SCALE2, UDV, DV, GL, UDB, SB, CB, BB)
                UV = UDV-DV
                UDB = 2.D0*UDB
                DEL = 0.D0
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.5) THEN
                CALL DOR94HO(XI,SCALE2,UV, DV, DEL, UDB, SB, GL)
                CB = 0.D0
                BB = 0.D0
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.6) THEN
                CALL DOR94LO(XI,SCALE2,UV, DV, DEL, UDB, SB, GL)
                CB = 0.D0
                BB = 0.D0
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.7) THEN
                CALL DOR94DI(XI,SCALE2,UV, DV, DEL, UDB, SB, GL)
                CB = 0.D0
                BB = 0.D0
                IRET = 0
              ENDIF
              PD(-5) = BB
              PD(-4) = CB
              PD(-3) = SB
              PD(-2) = 0.5D0*(UDB+DEL)
              PD(-1) = 0.5D0*(UDB-DEL)
              PD(0)  = GL
              PD(1)  = DV+PD(-1)
              PD(2)  = UV+PD(-2)
              PD(3)  = PD(-3)
              PD(4)  = PD(-4)
              PD(5)  = PD(-5)
            ENDIF
          ELSE IF(ITYPE(NPAR).EQ.2) THEN
C  pion PDFs
            IF(IGRP(NPAR).EQ.5) THEN
              IF(ISET(NPAR).EQ.1) THEN
                CALL DORPHO (XI,SCALE2, VA, GL, QB, CB, BB)
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.2) THEN
                CALL DORPLO (XI,SCALE2, VA, GL, QB, CB, BB)
                IRET = 0
              ENDIF
              PD(-5) = BB
              PD(-4) = CB
              PD(-3) = QB
              PD(-2) = QB
              PD(-1) = QB
              PD(0)  = GL
              PD(1)  = VA+PD(-1)
              PD(2)  = VA+PD(-2)
              PD(3)  = PD(-3)
              PD(4)  = PD(-4)
              PD(5)  = PD(-5)
            ENDIF
          ELSE IF(ITYPE(NPAR).EQ.3) THEN
C  photon PDFs
            IF(IGRP(NPAR).EQ.5) THEN
              IF(ISET(NPAR).EQ.1) THEN
                CALL DORGH0 (XI,SCALE2, UB, DB, SB, CB, BB, GL)
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.2) THEN
                CALL DORGHO (XI,SCALE2, UB, DB, SB, CB, BB, GL)
                IRET = 0
              ELSE IF(ISET(NPAR).EQ.3) THEN
                CALL DORGLO (XI,SCALE2, UB, DB, SB, CB, BB, GL)
                IRET = 0
              ENDIF
              PD(-5) = BB/137.D0
              PD(-4) = CB/137.D0
              PD(-3) = SB/137.D0
              PD(-2) = UB/137.D0
              PD(-1) = DB/137.D0
              PD(0)  = GL/137.D0
              PD(1)  = PD(-1)
              PD(2)  = PD(-2)
              PD(3)  = PD(-3)
              PD(4)  = PD(-4)
              PD(5)  = PD(-5)
            ENDIF
          ELSE IF(ITYPE(NPAR).EQ.20) THEN
C  Pomeron pdfs
            MODE = IGRP(NPAR)
            IF(MODE.EQ.1) THEN
              PD(0) = 6.D0*(ONE-XI)**5*PARMDL(26)
              IRET = 0
            ELSE IF(MODE.EQ.2) THEN
              PD(0) = 6.D0*XI*(ONE-XI)*PARMDL(26)
              IRET = 0
            ELSE IF(MODE.EQ.3) THEN
              PD(0) = (0.18D0/XI+5.46D0)*(ONE-XI)*PARMDL(26)
              IRET = 0
            ELSE IF(MODE.EQ.4) THEN
              CALL CKMTPD(45,XI,SCALE2,PD)
              IRET = 0
            ENDIF
          ENDIF
C
C  external PDFs
C
        ELSE IF(IEXT(NPAR).EQ.1) THEN
C  PDFLIB call: old numbering
          IF(NPAR.NE.NPAOLD) THEN
            PARAM(1) = 'MODE'
            PARAM(2) = ' '
            VALUE(1) = ABS(IGRP(NPAR))
            CALL PDFSET(PARAM,VALUE)
          ENDIF
          SCALE = SQRT(SCALE2)
          CALL STRUCTM(XI,SCALE,PD(2),PD(1),PD(-2),PD(-1),PD(-3),
     &      PD(-4),PD(-5),PD(-6),PD(0))
          DO 110 I=3,6
            PD(I) = PD(-I)
 110      CONTINUE
          IF(ABS(IGRP(NPAR)).LT.200) THEN
            PD(1) = PD(1)+PD(-1)
            PD(2) = PD(2)+PD(-2)
          ENDIF
          IRET = 0
        ELSE IF(IEXT(NPAR).EQ.2) THEN
C  PDFLIB call: new numbering
          IF(NPAR.NE.NPAOLD) THEN
            PARAM(1) = 'NPTYPE'
            PARAM(2) = 'NGROUP'
            PARAM(3) = 'NSET'
            PARAM(4) = ' '
            VALUE(1) = ITYPE(NPAR)
            VALUE(2) = ABS(IGRP(NPAR))
            VALUE(3) = ISET(NPAR)
            CALL PDFSET(PARAM,VALUE)
          ENDIF
          SCALE = SQRT(SCALE2)
          CALL PFTOPDG(XI,SCALE,PD)
          IRET = 0
        ELSE IF(IEXT(NPAR).EQ.3) THEN
C  PHOLIB call: version 2.0
          CALL PHVAL(IGRP(NPAR),ISET(NPAR),XI,SCALE2,PD,IRET)
          IF(IRET.LT.0) THEN
            WRITE(6,'(/1X,A,I2)') 'PDIS:ERROR:PHVAL RETURN CODE',IRET
            CALL POABRT
          ENDIF
          IRET = 0
C
C  photon PDFs depending on photon virtuality
C
        ELSE IF(IEXT(NPAR).EQ.4) THEN
          IF(IGRP(NPAR).EQ.1) THEN
C  Schuler/Sjostrand PDF (interface to single precision)
            XR = XI
            Q2R = SCALE2
            P2R = 0.
            IF(IPAMDL(115).GE.2) P2R = PARVI(NPAR)
            CALL SASGAM(ISET(NPAR),XR,Q2R,P2R,F2GM,XPDFGM)
            DO 120 I=-6,6
              PD(I) = DBLE(XPDFGM(I))
 120        CONTINUE
            IRET = 0
          ENDIF
        ENDIF
        IF(IRET.NE.0) THEN
          WRITE(6,'(/1X,A,/10X,5I6)')
     &      'PDIS:ERROR:UNSUPPORTED PDF(NPAR,IEXT,ITYPE,IGRP,ISET)',
     &      NPAR,IEXT(NPAR),ITYPE(NPAR),IGRP(NPAR),ISET(NPAR)
          CALL POABRT
        ENDIF
C  error in NPAR
      ELSE
        WRITE(6,'(/1X,A,I5)') 'PDIS:ERROR:INVALID NPAR(1,2) ',NPAR
        CALL POABRT
      ENDIF
      NPAOLD = NPAR
C
C  valence quark treatment
C
      IF(ITYPE(NPAR).EQ.3) THEN
C  photon conventions (correct PDFLIB bug)
        PD(1) = PD(-1)
        PD(2) = PD(-2)
      ELSE IF(ITYPE(NPAR).EQ.2) THEN
C  pion conventions
        IF(IPARID(NPAR).EQ.111) THEN
          DUMMY  = PD(1)-PD(-1)
          PD(-1) = PD(-1)+DUMMY/2.D0
          PD(1)  = PD(-1)
          DUMMY  = PD(2)-PD(-2)
          PD(-2) = PD(-2)+DUMMY/2.D0
          PD(2)  = PD(-2)
        ELSE
          DUMMY  = PD(-1)
          PD(-1) = PD(1)
          PD(1)  = DUMMY
        ENDIF
      ELSE IF(ITYPE(NPAR).EQ.1) THEN
C  nucleon conventions
        IF(ABS(IPARID(NPAR)).EQ.2112) THEN
          DUMMY = PD(1)
          PD(1) = PD(2)
          PD(2) = DUMMY
        ENDIF
      ENDIF
C  antiparticle
      IF(IPARID(NPAR).LT.0) THEN
        DO 140 I=1,6
          DUMMY=PD(I)
          PD(I)=PD(-I)
          PD(-I)=DUMMY
 140    CONTINUE
      ENDIF
C  remove valence quarks
      IF(IPAVA(NPAR).EQ.0) THEN
        DO 200 I=1,4
          PD(I) = MIN(PD(-I),PD(I))
          PD(-I) = PD(I)
 200    CONTINUE
      ENDIF
C  debug information
      IF(IDEB(37).GE.25) THEN
        WRITE(6,'(1X,A,2E12.4,I4/,2X,A,6E10.3,/2X,A,E10.3,
     &    /2X,A,6E10.3)') 'PHOPDF:DEBUG:X,SCALE**2,NPAR',X,SCALE2,NPAR,
     &    'PD(-6..-1)',(PD(I),I=-6,-1),
     &    'PD(0)     ',PD(0),
     &    'PD(1..6)  ',(PD(I),I=1,6)
      ENDIF
      END
