C
C
      SUBROUTINE POHCOL(MSPR,V,IP1,ICA1,ICA2,IP2,ICB1,ICB2,
     &                  IP3,ICC1,ICC2,IP4,ICD1,ICD2)
C*********************************************************************
C
C     get color flow for hard resolved process
C
C     input:    IP1..4  flavour of partons (PDG convention)
C               V       parton subprocess Mandelstam variable  V = t/s
C                       (lightcone momenta assumed)
C               ICA,ICB color labels
C               MSPR    process number
C                       -1   initialization of statistics
C                       -2   output of statistics
C
C     output:   ICC,ICD color label of final partons
C
C     (it is possible to use the same variables for in and output)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER ( OHALF = 0.5D0,
     &            ZERO  = 0.D0,
     &            ONE   = 1.D0,
     &            TWO   = 2.D0,
     &            THREE = 3.D0 )
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      PARAMETER ( MAXPRO = 16 )
      CHARACTER*18 PROC
      COMMON /PEPROC/ PROC(0:MAXPRO)
C
      DIMENSION PC(3),ICONF(8,5)
C
C  initialization
      IF(MSPR.EQ.-1) THEN
        DO 200 I=1,8
          DO 210 K=1,5
            ICONF(I,K) = 0
 210      CONTINUE
 200    CONTINUE
        RETURN
C  output of statistics
      ELSE IF(MSPR.EQ.-2) THEN
        IF(IDEB(26).LT.1) RETURN
        WRITE(6,'(/1X,A,/1X,A)')
     &    'POHCOL:DEBUG:SAMPLED COLOR CONFIGURATIONS',
     &    '========================================='
        WRITE(6,'(6X,A)')
     &    'DIAGRAM                  COLOR CONFIGURATIONS (1-4)      SUM'
        DO 300 I=1,8
          DO 310 K=1,4
            ICONF(I,5) = ICONF(I,5) + ICONF(I,K)
 310      CONTINUE
          WRITE(6,'(2X,A,4I11,I12)') PROC(I),(ICONF(I,K),K=1,5)
 300    CONTINUE
        RETURN
      ENDIF
C
C  gluons:  first color positive
      IF((IP1.EQ.0).AND.(ICA1.LT.0)) THEN
        I = ICA2
        ICA2 = ICA1
        ICA1 = I
      ENDIF
      IF((IP2.EQ.0).AND.(ICB1.LT.0)) THEN
        I = ICB2
        ICB2 = ICB1
        ICB1 = I
      ENDIF
C
C  large Nc limit of all graphs
C  ------------------------------------------------------------
      IF((ISWMDL(11).EQ.1).AND.(MSPR.LT.10)) THEN
C  g g --> g g
        IF(MSPR.EQ.1) THEN
          IF(RNDM(V).GT.OHALF) THEN
            IC1 = ICA1
            IC2 = ICB2
            IC3 = ICB1
            IC4 = ICA2
          ELSE
            IC1 = ICB1
            IC2 = ICA2
            IC3 = ICA1
            IC4 = ICB2
          ENDIF
          ICONF(MSPR,3) = ICONF(MSPR,3)+1
C  q q --> g g
        ELSE IF(MSPR.EQ.2) THEN
          CALL SELCOL(0,0,I1,K1,I2,K2,1)
          IF(ICA1.LT.0) THEN
            IC1 = I1
            IC2 = ICA1
            IC3 = ICB1
            IC4 = I2
            ICONF(MSPR,2) = ICONF(MSPR,2)+1
          ELSE
            IC1 = ICA1
            IC2 = I2
            IC3 = I1
            IC4 = ICB1
            ICONF(MSPR,1) = ICONF(MSPR,1)+1
          ENDIF
C  q g --> q g
        ELSE IF(MSPR.EQ.3) THEN
          IF(IP1.NE.0) THEN
            K = ICA1
            ICA1 = ICB1
            ICA2 = ICB2
            ICB1 = K
            ICB2 = 0
          ENDIF
          IF(ICB1*ICA1.GT.0) THEN
            K = ICA1
            ICA1 = ICA2
            ICA2 = K
          ENDIF
          IF(IP1.NE.0) THEN
            IC1 = ICA2
            IC2 = 0
            IC3 = ICA1
            IC4 = ICB1
            ICONF(MSPR,1) = ICONF(MSPR,1)+1
          ELSE
            IC1 = ICA1
            IC2 = ICB1
            IC3 = ICA2
            IC4 = 0
            ICONF(MSPR,2) = ICONF(MSPR,2)+1
          ENDIF
C  g g --> q q
        ELSE IF(MSPR.EQ.4) THEN
C  one closed color line necessary
          IC1 = ICA2
          IC2 = 0
          IC3 = ICB1
          IC4 = 0
          CALL POHCOR(-ICB2,ICA1)
          IF(IP3*IC1.LT.0) THEN
            I = IC1
            IC1 = IC3
            IC3 = I
          ENDIF
          ICONF(MSPR,2) = ICONF(MSPR,2)+1
C  q q --> q q
        ELSE IF((MSPR.EQ.5).OR.(MSPR.EQ.7).OR.(MSPR.EQ.8)) THEN
          IF(IP3*ICA1.LT.0) THEN
            IC1 = ICB1
            IC3 = ICA1
          ELSE
            IC1 = ICA1
            IC3 = ICB1
          ENDIF
          IC2 = 0
          IC4 = 0
          ICONF(MSPR,2) = ICONF(MSPR,2)+1
C  q q --> q q
        ELSE IF(MSPR.EQ.6) THEN
          IF(IP3*ICA1.LT.0) THEN
            IC1 = ICB1
            IC3 = ICA1
            ICONF(MSPR,1) = ICONF(MSPR,1)+1
          ELSE
            IC1 = ICA1
            IC3 = ICB1
            ICONF(MSPR,2) = ICONF(MSPR,2)+1
          ENDIF
          IC2 = 0
          IC4 = 0
C  unknown process
        ELSE
          WRITE(6,'(/1X,A,I3)')
     &      'POHCOL:ERROR:UNSUPPORTED PROCESS',MSPR
          CALL POABRT
        ENDIF
C
C  closer to real QCD
C  -----------------------------------------------------
      ELSE
        U = -(ONE+V)
C  g g --> g g
        IF(MSPR.EQ.1) THEN
          PC(1) = 1/V**2  +TWO/V    +THREE  +TWO*V    +V**2
          PC(2) = 1/U**2  +TWO/U    +THREE  +TWO*U    +U**2
          PC(3) = (V/U)**2+TWO*(V/U)+THREE  +TWO*(U/V)+(U/V)**2
          XI = (PC(1)+PC(2)+PC(3))*RNDM(U)
          PCS = ZERO
          DO 100 I=1,3
            PCS = PCS+PC(I)
            IF(XI.LT.PCS) GOTO 110
 100      CONTINUE
 110      CONTINUE
          IF(I.EQ.1) THEN
            CALL SELCOL(0,0,I1,K1,I2,K2,1)
            IF(RNDM(V).GT.OHALF) THEN
              IC1 = I1
              IC2 = ICA2
              IC3 = ICB1
              IC4 = I2
              CALL POHCOR(-ICB2,ICA1)
            ELSE
              IC1 = ICA1
              IC2 = I2
              IC3 = I1
              IC4 = ICB2
              CALL POHCOR(-ICB1,ICA2)
            ENDIF
          ELSE IF(I.EQ.2) THEN
            CALL SELCOL(0,0,I1,K1,I2,K2,1)
            IF(RNDM(U).GT.OHALF) THEN
              IC1 = ICB1
              IC2 = I2
              IC3 = I1
              IC4 = ICA2
              CALL POHCOR(-ICB2,ICA1)
            ELSE
              IC1 = I1
              IC2 = ICB2
              IC3 = ICA1
              IC4 = I2
              CALL POHCOR(-ICB1,ICA2)
            ENDIF
          ELSE
            IF(RNDM(V).GT.OHALF) THEN
              IC1 = ICB1
              IC2 = ICA2
              IC3 = ICA1
              IC4 = ICB2
            ELSE
              IC1 = ICA1
              IC2 = ICB2
              IC3 = ICB1
              IC4 = ICA2
            ENDIF
          ENDIF
          ICONF(MSPR,I) = ICONF(MSPR,I)+1
C  q q --> g g
        ELSE IF(MSPR.EQ.2) THEN
          PC(1) = U/V-TWO*U**2
          PC(2) = V/U-TWO*V**2
          CALL SELCOL(0,0,I1,K1,I2,K2,1)
          XI = (PC(1)+PC(2))*RNDM(U)
          IF(XI.LT.PC(1)) THEN
            IF(ICA1.GT.0) THEN
              IC1 = ICA1
              IC2 = I2
              IC3 = I1
              IC4 = ICB1
              ICONF(MSPR,1) = ICONF(MSPR,1)+1
            ELSE
              IC1 = I1
              IC2 = ICA1
              IC3 = ICB1
              IC4 = I2
              ICONF(MSPR,2) = ICONF(MSPR,2)+1
            ENDIF
          ELSE
            IF(ICA1.GT.0) THEN
              IC1 = I1
              IC2 = ICB1
              IC3 = ICA1
              IC4 = I2
              ICONF(MSPR,3) = ICONF(MSPR,3)+1
            ELSE
              IC1 = ICB1
              IC2 = I2
              IC3 = I1
              IC4 = ICA1
              ICONF(MSPR,4) = ICONF(MSPR,4)+1
            ENDIF
          ENDIF
C  q g --> q g
        ELSE IF(MSPR.EQ.3) THEN
          IF(IP1.EQ.0) THEN
            K = ICB1
            ICB1 = ICA1
            ICB2 = ICA2
            ICA1 = K
            ICA2 = 0
          ENDIF
          PC(1) = TWO*(U/V)**2-U
          PC(2) = TWO/V**2-ONE/U
          XI = (PC(1)+PC(2))*RNDM(V)
          IF(XI.LT.PC(1)) THEN
            CALL SELCOL(0,0,I1,K1,I2,K2,1)
            IF(ICA1.GT.0) THEN
              IC1 = I1
              IC2 = 0
              IC3 = ICB1
              IC4 = I2
              CALL POHCOR(-ICB2,ICA1)
              ICONF(MSPR,1) = ICONF(MSPR,1)+1
            ELSE
              IC1 = I2
              IC2 = 0
              IC3 = I1
              IC4 = ICB2
              CALL POHCOR(-ICB1,ICA1)
              ICONF(MSPR,2) = ICONF(MSPR,2)+1
            ENDIF
          ELSE
            IF(ICA1.GT.0) THEN
              IC1 = ICB1
              IC2 = 0
              IC3 = ICA1
              IC4 = ICB2
              ICONF(MSPR,3) = ICONF(MSPR,3)+1
            ELSE
              IC1 = ICB2
              IC2 = 0
              IC3 = ICB1
              IC4 = ICA1
              ICONF(MSPR,4) = ICONF(MSPR,4)+1
            ENDIF
          ENDIF
          IF(IP1.EQ.0) THEN
            I1 = IC1
            I2 = IC2
            IC1 = IC3
            IC2 = IC4
            IC3 = I1
            IC4 = I2
          ENDIF
C  g g --> q q
        ELSE IF(MSPR.EQ.4) THEN
          IC2 = 0
          IC4 = 0
C  one closed color line necessary
          PC(1) = U/V-TWO*U**2
          PC(2) = V/U-TWO*V**2
          XI = (PC(1)+PC(2))*RNDM(U)
          IF(XI.LT.PC(1)) THEN
            IF(IP3.GT.0) THEN
              CALL POHCOR(-ICB1,ICA2)
              IC1 = ICA1
              IC3 = ICB2
              ICONF(MSPR,1) = ICONF(MSPR,1)+1
            ELSE
              CALL POHCOR(-ICB2,ICA1)
              IC1 = ICA2
              IC3 = ICB1
              ICONF(MSPR,2) = ICONF(MSPR,2)+1
            ENDIF
          ELSE
            IF(IP3.GT.0) THEN
              CALL POHCOR(-ICB2,ICA1)
              IC1 = ICB1
              IC3 = ICA2
              ICONF(MSPR,3) = ICONF(MSPR,3)+1
            ELSE
              CALL POHCOR(-ICB1,ICA2)
              IC1 = ICB2
              IC3 = ICA1
              ICONF(MSPR,4) = ICONF(MSPR,4)+1
            ENDIF
          ENDIF
C  q q --> q q
        ELSE IF((MSPR.EQ.5).OR.(MSPR.EQ.6).OR.
     &          ((MSPR.EQ.8).AND.(IP1*IP2.LT.0))) THEN
          IC2 = 0
          IC4 = 0
          PC(1) = (ONE+U**2)/V**2
          PC(2) = (V**2+U**2)
          XI = (PC(1)+PC(2))*RNDM(V)
          IF(XI.LT.PC(1)) THEN
            CALL POHCOR(-ICB1,ICA1)
            CALL SELCOL(0,0,I1,K1,I2,K2,1)
            IF(IP3.GT.0) THEN
              IC1 = I1
              IC3 = I2
              ICONF(MSPR,1) = ICONF(MSPR,1)+1
            ELSE
              IC1 = I2
              IC3 = I1
              ICONF(MSPR,2) = ICONF(MSPR,2)+1
            ENDIF
          ELSE
            IF(IP3.GT.0) THEN
              IC1 = MAX(ICA1,ICB1)
              IC3 = MIN(ICA1,ICB1)
              ICONF(MSPR,3) = ICONF(MSPR,3)+1
            ELSE
              IC1 = MIN(ICA1,ICB1)
              IC3 = MAX(ICA1,ICB1)
              ICONF(MSPR,4) = ICONF(MSPR,4)+1
            ENDIF
          ENDIF
C  q q --> q q
        ELSE IF((MSPR.EQ.7).OR.(MSPR.EQ.8)) THEN
          IC2 = 0
          IC4 = 0
          PC(1) = (ONE+U**2)/V**2
          PC(2) = (ONE+V**2)/U**2
          XI = (PC(1)+PC(2))*RNDM(U)
          IF(XI.LT.PC(1)) THEN
            IC1 = ICB1
            IC3 = ICA1
            ICONF(MSPR,1) = ICONF(MSPR,1)+1
          ELSE
            IC1 = ICA1
            IC3 = ICB1
            ICONF(MSPR,2) = ICONF(MSPR,2)+1
          ENDIF
C  gam q --> q g
        ELSE IF(MSPR.EQ.10) THEN
          CALL SELCOL(ICB1,ICB2,IC1,IC2,IC3,IC4,2)
          IF(IP3.EQ.0) THEN
            CALL SWAPI(IC1,IC3)
            CALL SWAPI(IC2,IC4)
          ENDIF
C  gam g --> q q
        ELSE IF(MSPR.EQ.11) THEN
          IC1 = ICB1
          IC2 = 0
          IC3 = ICB2
          IC4 = 0
          IF(IP3.LT.0) CALL SWAPI(IC1,IC3)
C  q gam --> q g
        ELSE IF(MSPR.EQ.12) THEN
          CALL SELCOL(ICA1,ICA2,IC1,IC2,IC3,IC4,2)
          IF(IP3.EQ.0) THEN
            CALL SWAPI(IC1,IC3)
            CALL SWAPI(IC2,IC4)
          ENDIF
C  g gam --> q q
        ELSE IF(MSPR.EQ.13) THEN
          IC1 = ICA1
          IC2 = 0
          IC3 = ICA2
          IC4 = 0
          IF(IP3.LT.0) CALL SWAPI(IC1,IC3)
        ELSE IF(MSPR.EQ.14) THEN
          IF(ABS(IP3).GT.12) THEN
            IC1 = 0
            IC2 = 0
            IC3 = 0
            IC4 = 0
          ELSE
            CALL SELCOL(ICA1,ICA2,IC1,IC2,IC3,IC4,1)
            IF(IP3.LT.0) CALL SWAPI(IC1,IC3)
          ENDIF
C  unknown process
        ELSE
          WRITE(6,'(/1X,A,I3)')
     &      'POHCOL:ERROR:UNSUPPORTED PROCESS',MSPR
          CALL POABRT
        ENDIF
      ENDIF
C
C  debug output
      IF(IDEB(26).GE.10) THEN
        WRITE(6,'(1X,A,I4,/,5X,A,3I5,2X,3I5)') 'POHCOL:DEBUG:PROCESS',
     &    MSPR,'INITIAL PARTONS AND COLORS',IP1,ICA1,ICA2,IP2,ICB1,ICB2
        WRITE(6,'(5X,A,3I5,2X,3I5)')
     &    'FINAL PARTONS AND COLORS',IP3,IC1,IC2,IP4,IC3,IC4
      ENDIF
      ICC1 = IC1
      ICC2 = IC2
      ICD1 = IC3
      ICD2 = IC4
      END
