C
C
      SUBROUTINE POHDIR(II,IVAL1,IVAL2,MSPAR1,MSPAR2,MHPAR1,MHPAR2,
     &                  IREJ)
C**********************************************************************
C
C     parton orientated formulation of direct scattering processes
C
C     input:
C
C     output:   II        particle combination (1..4)
C               IVAL1,2   0 no valence quarks engaged
C                         1 valence quarks engaged
C               MSPAR1,2  number of realized soft partons
C               MHPAR1,2  number of realized hard partons
C               IREJ      1 failure
C                         0 success
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER ( MAXPRO = 16 , MLINE = 400 , MSCAHD = 50 )
      COMMON /HAPARA/ ALPHAS,Q0SQR,ALASQR,BQCD,NPD,NF,NHA,NHB
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /HAEVNT/ PT1,PT2,NHARD,NTRY,IHARD,ITRY,IREJEV
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
      COMMON /HAEVTR/ LINE,LIN,LREC1(MLINE),LREC2(MLINE),PREC(4,MLINE)
      COMMON /DGLAPP/ Q2MISR(2),PMISR(2),ZMISR(2),AL2ISR(2),NFSISR
      COMMON /ABRHRD/ XH1(50),XH2(50),IJHI1(50),IJHI2(50),
     &                IJHF1(50),IJHF2(50),PHARD1(4,50),PHARD2(4,50),IPTM
      COMMON /ABRSOF/ XS1(50),XS2(50),IJSI1(50),IJSI2(50),
     &                PSOFT1(4,50),PSOFT2(4,50)
      INTEGER MXSECT
      PARAMETER ( MAXTAB = 20 )
      COMMON /HAXSEC/ XSECTA(4,-1:MAXPRO,4,MAXTAB),XSECT(6,-1:MAXPRO),
     &                MXSECT(0:4,-1:MAXPRO,4),ECMSH(4,MAXTAB),ISTTAB
      COMMON /HARSLT/ LSCAHD,LSC1HD,
     &                ETAHD(MSCAHD,2) ,PTHD(MSCAHD), Q2SCA(MSCAHD,2),
     &                XHD(MSCAHD,2)   ,VHD(MSCAHD) ,X0HD(MSCAHD,2),
     &                NINHD(MSCAHD,2) ,NOUTHD(MSCAHD,2),
     &                N0INHD(MSCAHD,2),NBRAHD(MSCAHD,2),NPROHD(MSCAHD)
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      DIMENSION P1(4),P2(4)
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
      ITYPE(L) = MOD(LREC1(L),100)-50
C
      ITRY = 0
      LSC1HD = 0
      MSOFT = 2
      MHARD = 1
      PT1 = PTCUT(II)
C
      IF(ECMP.LT.(2.D0*PT1+2.1*CUTMU(II))) THEN
        IFAIL(18) = IFAIL(18)+1
        IREJ = 5
        GOTO 450
      ENDIF
      AS     = (CUTMU(II)/ECMP)**2
      AH     = (2.D0*PT1/ECMP)**2
      ALNS   = LOG(AS)
      ALNH   = LOG(AH)
C
C  main loop to select hard and soft parton kinematics
C -----------------------------------------------------
 120  CONTINUE
        IREJ = 0
        ITRY   = ITRY+1
        LSC1HD = LSC1HD+1
        IF(ITRY.GT.1) THEN
          IFAIL(17) = IFAIL(17)+1
          IF(ITRY.GE.NTRY) THEN
            IREJ = 1
            GOTO 450
          ENDIF
        ENDIF
        LINE   = 0
        LSCAHD = 0
        XSS1   = ZERO
        XSS2   = ZERO
        MSPAR1 = 0
        MSPAR2 = 0
        Z1MAX    = LOG(MAX(TINY,ONE-MSOFT*AS))
        Z1DIF    = Z1MAX-ALNH
        XMAXX    = ONE - MSOFT*AS
C
C  select hard V,X
        CALL POHSCA(1,II)
        XSS1   = XSS1+X1
        XSS2   = XSS2+X2
        XH1(1) = X1
        XH2(1) = X2
C  debug output
        IF(IDEB(25).GE.20) THEN
          WRITE(6,'(1X,A,2E12.4,2I5)')
     &      'POHDIR:DEBUG:AS,XMAX,PROCESS NUMBER,ITRY',
     &      AS,XMAXX,MSPR,ITRY
          WRITE(6,'(1X,A,4E12.4)') 'HARD X1,2  SUM X1,2',
     &      X1,X2,XSS1,XSS2
        ENDIF
C
      IF(MSPR.LE.11) THEN
        IF((XSS2.GT.XMAXX).OR.((ONE-XSS2).LT.AS)) GOTO 120
      ELSE IF(MSPR.LE.13) THEN
        IF((XSS1.GT.XMAXX).OR.((ONE-XSS1).LT.AS)) GOTO 120
      ENDIF
C
C  fill COMMON HARSLT
      LSCAHD     = 1
      XHD(1,1)   = X1
      XHD(1,2)   = X2
      VHD(1)     = V
      ETAHD(1,1) = ETAC
      ETAHD(1,2) = ETAD
      PTHD(1)    = PT
      Q2SCA(1,1) = QQPD
      Q2SCA(1,2) = QQPD
      NPROHD(1)  = MSPR
      NBRAHD(1,1)= IDPDG1
      NBRAHD(1,2)= IDPDG2
C  valence quarks?
      IF(MSPR.LE.11) THEN
        NINHD(1,1) = IDPDG1
        NINHD(1,2) = ITYPE(2)
        IF(ABS(NINHD(1,2)).GT.6) THEN
          IVAL2 = 1
        ELSE
          IVAL2 = 0
        ENDIF
        KHDIR = 1
      ELSE IF(MSPR.LE.13) THEN
        NINHD(1,1) = ITYPE(1)
        IF(ABS(NINHD(1,1)).GT.6) THEN
          IVAL1 = 1
        ELSE
          IVAL1 = 0
        ENDIF
        NINHD(1,2) = IDPDG2
        KHDIR = 2
      ELSE
        NINHD(1,1) = IDPDG1
        NINHD(1,2) = IDPDG2
        KHDIR = 3
      ENDIF
C  reweight according to photon virtuality
      IF((IPAMDL(115).EQ.1).AND.(MSPR.NE.14)) THEN
        WGX = 1.D0
        IF((MSPR.LE.11).AND.(IDPDG2.EQ.22)) THEN
          WGX = LOG(QQPD/(PVIRTP(2)+PARMDL(31)))/LOG(QQPD/PARMDL(31))
          IF(NINHD(1,2).EQ.0) WGX = WGX*WGX
        ELSE IF((MSPR.LE.13).AND.(IDPDG1.EQ.22)) THEN
          WGX = LOG(QQPD/(PVIRTP(1)+PARMDL(31)))/LOG(QQPD/PARMDL(31))
          IF(NINHD(1,1).EQ.0) WGX = WGX*WGX
        ENDIF
        IF(WGX.LT.RNDM(WGX)) THEN
          IREJ = 50
          RETURN
        ENDIF
      ENDIF
C  copy for parton showering
      DO 111 K=1,2
        NOUTHD(1,K) = ITYPE(K+2)
        N0INHD(1,K) = NINHD(1,K)
        X0HD(1,K)   = XHD(1,K)
111   CONTINUE
C  generate ISR
      IF((MSPR.NE.14).AND.(ISWMDL(8).GE.2)) THEN
C  ISR cutoffs
        Q2MISR(1) = MIN(PT1**2,PARMDL(125+II))
        Q2MISR(2) = Q2MISR(1)
        IF(IPAMDL(109).EQ.1) THEN
          Q2H = PARMDL(93)*PT**2
        ELSE
          Q2H = -PARMDL(93)*VHD(1)*XHD(1,1)*XHD(1,2)*ECMP*ECMP
        ENDIF
        XHMAX1 =  ONE - XSS1 - MSOFT*AS + XHD(1,1)
        XHMAX2 =  ONE - XSS2 - MSOFT*AS + XHD(1,2)
        DO 42 J=1,4
          P1(J) = PREC(J,3)
          P2(J) = PREC(J,4)
 42     CONTINUE
        CALL POHISR(1,P1,P2,NOUTHD(1,1),NOUTHD(1,2),NINHD(1,1),
     &    NINHD(1,2),Q2H,XHD(1,1),XHD(1,2),XHMAX1,XHMAX2,IFL1,IFL2,
     &    XISR1,XISR2,IREJ)
        XSS1 = XSS1+XISR1-XHD(1,1)
        XSS2 = XSS2+XISR2-XHD(1,2)
        NINHD(1,1) = IFL1
        NINHD(1,2) = IFL2
        XHD(1,1) = XISR1
        XHD(1,2) = XISR2
      ELSE
        IFL1 = NINHD(1,1)
        IFL2 = NINHD(1,2)
      ENDIF
C  add photon/hadron remnant
      Z1MAX = LOG(MAX(TINY,ONE-MHARD*AH))
      Z2MAX = LOG(MAX(TINY,ONE-MHARD*AH))
      Z1DIF = Z1MAX+Z2MAX-ALNS
      Z2DIF = Z1DIF
C
C  incoming gluon
      IF(IFL2.EQ.0) THEN
        XMAXX    = ONE - XSS2 - AS
        XMAXH    = MIN(XMAXX,PARMDL(44))
        CALL HADSP2(IDBAM2,XSS2,XMAXH,XS2,IREJ)
        IVAL2 = 1
        MSPAR1 = 0
        MSPAR2 = 2
        MHPAR1 = 1
        MHPAR2 = 1
      ELSE IF(IFL1.EQ.0) THEN
        XMAXX    = ONE - XSS1 - AS
        XMAXH    = MIN(XMAXX,PARMDL(44))
        CALL HADSP2(IDBAM1,XSS1,XMAXH,XS1,IREJ)
        IVAL1 = 1
        MSPAR1 = 2
        MSPAR2 = 0
        MHPAR1 = 1
        MHPAR2 = 1
C
C  incoming quark
      ELSE IF(ABS(IFL2).LE.12) THEN
        IF(IVAL2.EQ.1) THEN
          XS2(1) = ONE - XSS2
          MSPAR1 = 0
          MSPAR2 = 1
          MHPAR1 = 1
          MHPAR2 = 1
        ELSE
          XMAXX    = ONE - XSS2 - AS
          XMAXH    = MIN(XMAXX,PARMDL(44))
          CALL HADSP3(IDBAM2,XSS2,XMAXH,XS2,IREJ)
          MSPAR1 = 0
          MSPAR2 = 3
          MHPAR1 = 1
          MHPAR2 = 1
        ENDIF
      ELSE IF(ABS(IFL1).LE.12) THEN
        IF(IVAL1.EQ.1) THEN
          XS1(1) = ONE - XSS1
          MSPAR1 = 1
          MSPAR2 = 0
          MHPAR1 = 1
          MHPAR2 = 1
        ELSE
          XMAXX    = ONE - XSS1 - AS
          XMAXH    = MIN(XMAXX,PARMDL(44))
          CALL HADSP3(IDBAM1,XSS1,XMAXH,XS1,IREJ)
          MSPAR1 = 3
          MSPAR2 = 0
          MHPAR1 = 1
          MHPAR2 = 1
        ENDIF
C
C  double direct process
      ELSE IF(MSPR.EQ.14) THEN
        MSPAR1 = 0
        MSPAR2 = 0
        MHPAR1 = 1
        MHPAR2 = 1
C
C  unknown process
      ELSE
        WRITE(6,'(/1X,A,I3/)') 'POHDIR:ERROR:UNSUPPORTED MSPR',MSPR
        CALL POABRT
      ENDIF
      IF(IREJ.NE.0) THEN
        IF(IDEB(25).GE.3) THEN
          WRITE(6,'(1X,A,3I5)')
     &      'POHDIR:WARNING:INT.REJ.(MSPR,ITRY,NTRY)',MSPR,ITRY,NTRY
        ENDIF
        GOTO 120
      ENDIF
C
C  select information from event-record
C
C  flavors
      IF(ABS(NINHD(1,1)).GT.6)
     &  NINHD(1,1)=SIGN(ABS(NINHD(1,1))-6,NINHD(1,1))
      IJHI1(1) = NINHD(1,1)
      IF(ABS(NINHD(1,2)).GT.6)
     &  NINHD(1,2)=SIGN(ABS(NINHD(1,2))-6,NINHD(1,2))
      IJHI2(1) = NINHD(1,2)
C  final partons
C  flavors
      IJHF1(1) = NOUTHD(1,1)
      IJHF2(1) = NOUTHD(1,2)
C  four momenta
      DO 140 J=1,4
        PHARD1(J,1) = PREC(J,3)
        PHARD2(J,1) = PREC(J,4)
140   CONTINUE
C
C  soft particle momenta
      IF(MSPAR1.GT.0) THEN
        DO 50 I=1,MSPAR1
          PSOFT1(1,I) = ZERO
          PSOFT1(2,I) = ZERO
          PSOFT1(3,I) = XS1(I)*ECMP/TWO
          PSOFT1(4,I) = XS1(I)*ECMP/TWO
 50     CONTINUE
      ENDIF
      IF(MSPAR2.GT.0) THEN
        DO 55 I=1,MSPAR2
          PSOFT2(1,I) = ZERO
          PSOFT2(2,I) = ZERO
          PSOFT2(3,I) = -XS2(I)*ECMP/TWO
          PSOFT2(4,I) = XS2(I)*ECMP/TWO
 55     CONTINUE
      ENDIF
C  process counting
      MXSECT(3,MSPR,II) = MXSECT(3,MSPR,II)+1
      KSOFT = MAX(MSPAR1,MSPAR2)
      KHARD = MAX(MHPAR1,MHPAR2)
C  debug output
      IF(IDEB(25).GE.10) THEN
        WRITE(6,'(/1X,A,2I3,3I5)')
     &    'POHDIR:DEBUG:(ACCEPTED) IVAL1,IVAL2,MSPR,ITRY,NTRY',
     &     IVAL1,IVAL2,MSPR,ITRY,NTRY
        IF(MSPAR1.GT.0) THEN
          WRITE(6,'(5X,A,I4)') 'SOFT X PARTICLE1:',MSPAR1
          DO 105 I=1,MSPAR1
            WRITE(6,'(10X,I3,E12.3)') I,XS1(I)
 105      CONTINUE
        ENDIF
        IF(MSPAR2.GT.0) THEN
          WRITE(6,'(5X,A,I4)') 'SOFT X PARTICLE2:',MSPAR2
          DO 106 I=1,MSPAR2
            WRITE(6,'(10X,I3,E12.3)') I,XS2(I)
 106      CONTINUE
        ENDIF
        IF(MHPAR1.GT.0) THEN
          WRITE(6,'(5X,A,I4)') 'INI.HARD X/FLAVOR PARTICLE1:',MHPAR1
          DO 107 I=1,MHPAR1
            WRITE(6,'(10X,I3,E12.3,I5)') I,XH1(I),IJHI1(I)
 107      CONTINUE
          WRITE(6,'(5X,A,I4)') 'FIN.HARD MOMENTA  PARTICLE1:',MHPAR1
          DO 108 I=1,MHPAR1
            WRITE(6,'(10X,I3,4E12.3,I5)') I,(PHARD1(K,I),K=1,4),
     &        IJHF1(I)
 108      CONTINUE
        ENDIF
        IF(MHPAR2.GT.0) THEN
          WRITE(6,'(5X,A,I4)') 'INI.HARD X/FLAVOUR PARTICLE2:',MHPAR2
          DO 109 I=1,MHPAR2
            WRITE(6,'(10X,I3,E12.3,I5)') I,XH2(I),IJHI2(I)
 109      CONTINUE
          WRITE(6,'(5X,A,I4)') 'FIN.HARD MOMENTA  PARTICLE2:',MHPAR2
          DO 110 I=1,MHPAR2
            WRITE(6,'(10X,I3,4E12.3,I5)') I,(PHARD2(K,I),K=1,4),
     &        IJHF2(I)
 110      CONTINUE
        ENDIF
      ENDIF
      RETURN
C
 450  CONTINUE
      IFAIL(16) = IFAIL(16)+1
      IF(IDEB(25).GE.2) THEN
        WRITE(6,'(1X,A,3I5)')
     &    'POHDIR:WARNING:REJECTION (ITRY,NTRY,IREJ)',ITRY,NTRY,IREJ
       WRITE(6,'(5X,A,E12.4)') 'AVAILABLE ENERGY:',ECMP
       IF(IDEB(25).GE.5) THEN
         CALL POPREV(0)
       ELSE
         CALL POPREV(-1)
       ENDIF
      ENDIF
      RETURN
      END
