C
C
      SUBROUTINE REGFLA(JM1,JM2,IFLR1,IFLR2,IREJ)
C**********************************************************************
C
C     selection of reggeon flavours
C
C     input:    JM1,JM2      position index of mother hadrons
C
C     output:   IFLR1,IFLR2  valence flavours according to
C                            PDG conventions and JM1,JM2
C               IREJ         0  reggeon possible
C                            1  reggeon impossible
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           OHALF  =  0.5D0,
     &           EPS    =  0.1D0,
     &           DEPS   =  1.D-40)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      IF(JM1.GT.0) THEN
        IREJ = 0
        ITER = 0
C  invariant mass
        CMASS = SQRT((PHEP(4,JM1)+PHEP(4,JM2))**2
     &              -(PHEP(1,JM1)+PHEP(1,JM2))**2
     &              -(PHEP(2,JM1)+PHEP(2,JM2))**2
     &              -(PHEP(3,JM1)+PHEP(3,JM2))**2)
 50     CONTINUE
        ITER = ITER+1
        IF(ITER.GT.10) THEN
          IREJ = 1
C  debug output
          IF(IDEB(41).GE.2) WRITE(6,'(/1X,A,2I5)')
     &      'REGFLA:WARNING:REJECTION JM1,JM2',JM1,JM2
          RETURN
        ENDIF
C  selection of particle 1
        IF(RNDM(CMASS).GT.OHALF) THEN
          IM1 = JM1
          IM2 = JM2
        ELSE
          IM1 = JM2
          IM2 = JM1
        ENDIF
        CALL VALFLA(IM1,IFL1,IFL2,CMASS)
C  check if remainder of particle 2 exists
        CALL PARTRE(IM2,-IFL1,IREM1,IREJ1)
        CALL PARTRE(IM2,-IFL2,IREM2,IREJ2)
C  reggeon exchange possible?
        IF(IREJ1*IREJ2.NE.0) THEN
          IV1 = 1
          IV2 = 1
          IF(IDHEP(JM1).EQ.777) THEN
            IV1 = IHFLS(1)
          ELSE IF(IDHEP(JM1).EQ.888) THEN
            IV1 = IHFLS(2)
          ENDIF
          IF(IDHEP(JM2).EQ.777) THEN
            IV2 = IHFLS(1)
          ELSE IF(IDHEP(JM2).EQ.888) THEN
            IV2 = IHFLS(2)
          ENDIF
C  particle remnant
          IF(IV1.EQ.0) THEN
            IF(IV2.EQ.0) THEN
              CALL SEAFLA(JM1,IFL1,IFL2,CMASS)
              IFLR1 = IFL1
              IFLR2 = -IFL1
            ELSE
              CALL VALFLA(JM2,IFL1,IFL2,CMASS)
              IFLR1 = IFL1
              IFLR2 = IFL2
            ENDIF
          ELSE IF(IV2.EQ.0) THEN
            CALL VALFLA(JM1,IFL1,IFL2,CMASS)
            IFLR1 = IFL2
            IFLR2 = IFL1
          ELSE
C  debug output
            IF(IDEB(41).GE.15) WRITE(6,'(/1X,A,3I4)')
     &        'REGFLA:WARNING:INT.REJECTION JM1,JM2,ITRY',JM1,JM2,ITER
            GOTO 50
          ENDIF
        ELSE
C  reggeon exchange
          IF(IREJ1+IREJ2.EQ.0) THEN
            IF(RNDM(CMASS).GT.OHALF) THEN
              IFLR1 = IFL2
              IFLR2 = IREM1
            ELSE
              IFLR1 = IFL1
              IFLR2 = IREM2
            ENDIF
          ELSE IF(IREJ1.EQ.0) THEN
            IFLR1 = IFL2
            IFLR2 = IREM1
          ELSE
            IFLR1 = IFL1
            IFLR2 = IREM2
          ENDIF
        ENDIF
C  debug output
        IF(IDEB(41).GE.10) THEN
          WRITE(6,'(1X,A,4I5,E12.4)') 'REGFLA:JM1,JM2,FLR1,FLR2,MASS',
     &      JM1,JM2,IFLR1,IFLR2,CMASS
        ENDIF
      ELSE IF(JM1.EQ.-1) THEN
C  initialization
      ELSE IF(JM1.EQ.-2) THEN
C  output of statistics
      ELSE
        WRITE(6,'(1X,A,I10)') 'REGFLA:ERROR:INVALID JM1',JM1
        CALL POABRT
      ENDIF
      END
