C
C
      SUBROUTINE SELCOL(ICO1,ICO2,ICOA1,ICOA2,ICOB1,ICOB2,IMODE)
C********************************************************************
C
C    selection of color combinatorics
C
C    input:         ICO1,2   colors of incoming particle
C                   IMODE    -2  output of initialization status
C                            -1  initialization
C                                   ICINP(1) selection mode
C                                            0   QCD
C                                            1   large N_c expansion
C                                   ICINP(2) max. allowed color
C                            0   clear internal color counter
C                            1   hadron into two colored objects
C                            2   quark into quark gluon
C                            3   gluon into gluon gluon
C                            4   gluon into quark antiquark
C
C    output:        ICOA1,2  colors of first outgoing particle
C                   ICOB1,2  colors of second outgoing particle
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (OHALF = 0.5D0)
      DATA METHOD /0/, II /0/
C
      ICI1 = ICO1
      ICI2 = ICO2
      IF(METHOD.EQ.0) THEN
C
        IF(IMODE.EQ.1) THEN
          II = II+1
          IF(II.GT.MAXCOL)
     &      II = MIN(RNDM(XI)*MAXCOL+1.00001,DBLE(MAXCOL))
          ICOA1 = II
          ICOA2 = 0
          ICOB1 = -II
          ICOB2 = 0
        ELSE IF(IMODE.EQ.2) THEN
          II = II+1
          IF(II.GT.MAXCOL)
     &      II = MIN(RNDM(XI)*MAXCOL+1.00001,DBLE(MAXCOL))
          ICOA2 = 0
          IF(ICI1.GT.0) THEN
            ICOA1 = II
            ICOB1 = ICI1
            ICOB2 = -II
          ELSE
            ICOA1 = -II
            ICOB1 = II
            ICOB2 = ICI1
          ENDIF
        ELSE IF(IMODE.EQ.3) THEN
          II = II+1
          IF(II.GT.MAXCOL)
     &      II = MIN(RNDM(XI)*MAXCOL+1.00001,DBLE(MAXCOL))
          IF(RNDM(YI).GT.OHALF) THEN
            ICOA1 = ICI1
            ICOA2 = -II
            ICOB1 = II
            ICOB2 = ICI2
          ELSE
            ICOB1 = ICI1
            ICOB2 = -II
            ICOA1 = II
            ICOA2 = ICI2
          ENDIF
        ELSE IF(IMODE.EQ.4) THEN
          ICOA1 = ICI1
          ICOA2 = 0
          ICOB1 = ICI2
          ICOB2 = 0
        ELSE IF(IMODE.EQ.0) THEN
          II = 0
        ELSE IF(IMODE.EQ.-1) THEN
          METHOD = ICI1
          MAXCOL = ICI2
        ELSE IF(IMODE.EQ.-2) THEN
          WRITE(6,'(1X,A,2I5)') 'SELCOL:PARAMETERS:METHOD,MAXCOL ',
     &      METHOD,MAXCOL
        ELSE
          WRITE(6,'(1X,A,I5)') 'SELCOL:ERROR:UNSUPPORTED MODE ',
     &      IMODE
          CALL POABRT
        ENDIF
C
      ELSE
        WRITE(6,'(1X,A,I5)')
     &    'SELCOL:ERROR:UNSUPPORTED METHOD SELECTED ',METHOD
        CALL POABRT
      ENDIF
C
      II = ABS(II)
      IF(IDEB(75).GE.10) THEN
        WRITE(6,'(1X,A,I5,I12,I5)') 'SELCOL:DEBUG:IMODE,MAXCOL,II ',
     &    IMODE,MAXCOL,II
        WRITE(6,'(10X,A,2I5)') 'INPUT  COLORS ',ICI1,ICI2
        WRITE(6,'(10X,A,4I5)') 'OUTPUT COLORS ',
     &    ICOA1,ICOA2,ICOB1,ICOB2
      ENDIF
      END
