C
C
      SUBROUTINE SELSXI(MSOFT,MSMIN,XPOT1,XPOT2,XS1,XS2,XMAX1,XMAX2,
     &                  XSOFT1,XSOFT2,IREJ)
C***********************************************************************
C
C    select x values of soft chain ends (sea independent from valence)
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION XPOT1(50),XPOT2(50),XSOFT1(50),XSOFT2(50)
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
C
      DIMENSION XLDIF(2,50),XLMIN(2,50),REVP(2,50),POT(2,50)
C
      IREJ = 0
C
      XMIN = MAX(PSOMIN/ECM*TWO,XSOMIN)
      XMIN1 = MAX(AS/XMAX2,XMIN)
      XMIN2 = MAX(AS/XMAX1,XMIN)
      IF((XMIN1.GE.XMAX1).OR.(XMIN2.GE.XMAX2)) THEN
        IF(IDEB(31).GE.1) THEN
          WRITE (6,'(1X,A,4E12.3)')
     &      'SELSXI:WARNING:XMIN>XMAX (XMIN1,2/XMAX1,2)',
     &      XMIN1,XMIN2,XMAX1,XMAX2
          CALL POPREV(-1)
        ENDIF
        IREJ = 1
        RETURN
      ENDIF
C
 10   CONTINUE
C
      DO 50 I=1,MSOFT
        POT(1,I) = XPOT1(I)+ONE
        POT(2,I) = XPOT2(I)+ONE
        REVP(1,I) = ONE/POT(1,I)
        REVP(2,I) = ONE/POT(2,I)
        XLMIN(1,I) = XMIN1**POT(1,I)
        XLMAX = XMAX1**POT(1,I)
        XLDIF(1,I) = XLMAX-XLMIN(1,I)
        XLMIN(2,I) = XMIN2**POT(2,I)
        XLMAX = XMAX2**POT(2,I)
        XLDIF(2,I) = XLMAX-XLMIN(2,I)
 50   CONTINUE
C
C  selection of sea
      IITRY = 0
 5    CONTINUE
      IITRY = IITRY + 1
      IF(IITRY.GE.50) THEN
        IF(MSOFT-MSMIN.GE.4) THEN
          MSOFT = MSMIN
          GOTO 10
        ENDIF
        IF(IDEB(31).GT.2) THEN
          WRITE(6,'(1X,A,I4)') 'SELSXI:TOO MANY ITERATIONS:',IITRY
          WRITE(6,'(5X,A,I4,3E11.3)') 'MSOFT,XMAX1,2,AS:',
     &      MSOFT,XMAX1,XMAX2,AS
        ENDIF
        IREJ = 1
        RETURN
      ENDIF
      XSUM1 = XS1
      XSUM2 = XS2
      DO 100 I=3,MSOFT
 20     CONTINUE
        Z1 = XLDIF(1,I)*RNDM(XS1)+XLMIN(1,I)
        Z2 = XLDIF(2,I)*RNDM(XS2)+XLMIN(2,I)
        XSOFT1(I) = Z1**REVP(1,I)
        XSOFT2(I) = Z2**REVP(2,I)
        IF( (XSOFT1(I)*XSOFT2(I)).LT.AS ) GOTO 20
        XSUM1 = XSUM1+XSOFT1(I)
        XSUM2 = XSUM2+XSOFT2(I)
 100  CONTINUE
      IF(XSUM1.GT.XMAX1) GOTO 5
      IF(XSUM2.GT.XMAX2) GOTO 5
C
C  selection of valence
      CALL SELSX2(XPOT1,XPOT2,XSUM1,XSUM2,XMAX1,XMAX2,
     &  XSOFT1,XSOFT2,IREJ)
      IF(IREJ.NE.0) THEN
        IF(MSOFT-MSMIN.GE.4) THEN
          MSOFT = MSMIN
          GOTO 10
        ENDIF
        IF(IDEB(31).GE.1) THEN
          WRITE(6,'(1X,A)') 'SELSXI:WARNING:REJECTION BY SELSX2'
          CALL POPREV(-1)
        ENDIF
        RETURN
      ENDIF
C
      XS1 = ONE-XSOFT1(1)
      XS2 = ONE-XSOFT2(1)
C  debug output
      IF(IDEB(31).GE.10) THEN
        WRITE(6,'(1X,A,2E12.4)') 'SELSXI:DEBUG:XSUM 1,2:',XS1,XS2
        DO 30 I=1,MSOFT
          WRITE(6,'(5X,A,I4,2E12.3)') 'XSOFT',I,XSOFT1(I),XSOFT2(I)
 30     CONTINUE
      ENDIF
      END
