C
C
      SUBROUTINE VECRES(IVEC,RMASS,IDPDG,IDBAM)
C**********************************************************************
C
C     sampling of vector meson resonance in diffractive processes
C
C     input:   common QEVECM   VDMFAC factors
C
C     output:  IVEC         1   incoming hadron
C                           2   rho 0
C                           3   omega
C                           4   phi
C                           5   pi+/pi- background
C              RMASS        mass of vector meson (GeV)
C              IDPDG        particle ID according to PDG
C              IDBAM        particle ID according to BAMJET
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER(EPS  = 1.D-10,
     &          IONE = 1,
     &          PI   = 3.14159265359D0,
     &          PI2  = 6.28318530718D0,
     &          ZERO = 0.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
      COMMON /QEVECM/ VMAS(4),GAMM(4),RMIN(4),RMAX(4),VMSL(4),VMFA(4),
     &                TMIN(4),TMAX(4)
C  particle code translation
      DIMENSION ITRANS(4),IPOS(4)
C                  rho0,omega,phi,pi+/pi-
      DATA ITRANS /113, 223, 333, 6666 /
      DATA IPOS   / 33,  35,  96,   33 /
C
      IDPDO = IDPDG
      IF(IDPDG.EQ.22) THEN
        XI = RNDM(RMASS)*(VMFA(1)+VMFA(2)+VMFA(3)+VMFA(4))
        SUM = ZERO
        DO 55 K=1,4
          SUM = SUM + VMFA(K)
          IF(XI.LE.SUM) GOTO 65
 55     CONTINUE
 65     CONTINUE
C
        IDPDG = ITRANS(K)
        IDBAM = IPOS(K)
        IVEC  = K+1
C  sample mass of vector meson
        CALL SAMASS(IDPDG,RMASS)
      ELSE IF(IDPDG.EQ.777) THEN
        IF(IHFLD(1,1).EQ.0) THEN
          CALL SEAFLA(1,IFL1,IFL2,RMASS)
          CALL HACODE(IFL1,IFL2,IDBA1,IDBA2)
        ELSE
          CALL HACODE(IHFLD(1,1),IHFLD(1,2),IDBA1,IDBA2)
        ENDIF
        RMAS1 = POPAMA(IDBA1,0)
        RMAS2 = POPAMA(IDBA2,0)
        IF((IDBA2.NE.0).AND.
     &    (RNDM(RMAS1).LT.(RMAS1/(RMAS1+RMAS2)))) THEN
          IDBAM = IDBA2
          RMASS = RMAS2
        ELSE
          IDBAM = IDBA1
          RMASS = RMAS1
        ENDIF
        IDPDG = MPDGHA(IDBAM)
        IVEC = 1
      ELSE IF(IDPDG.EQ.888) THEN
        IF(IHFLD(2,1).EQ.0) THEN
          CALL SEAFLA(2,IFL1,IFL2,RMASS)
          CALL HACODE(IFL1,IFL2,IDBA1,IDBA2)
        ELSE
          CALL HACODE(IHFLD(2,1),IHFLD(2,2),IDBA1,IDBA2)
        ENDIF
        RMAS1 = POPAMA(IDBA1,0)
        RMAS2 = POPAMA(IDBA2,0)
        IF((IDBA2.NE.0).AND.
     &    (RNDM(RMAS1).LT.(RMAS1/(RMAS1+RMAS2)))) THEN
          IDBAM = IDBA2
          RMASS = RMAS2
        ELSE
          IDBAM = IDBA1
          RMASS = RMAS1
        ENDIF
        IDPDG = MPDGHA(IDBAM)
        IVEC = 1
      ENDIF
C  debug output
      IF(IDEB(47).GE.5) THEN
        WRITE(6,'(1X,A,/10X,3I7,E12.4)')
     &    'VECRES:DEBUG:IDPDG-OLD,IDPDG,IDBAM,MASS',
     &    IDPDO,IDPDG,IDBAM,RMASS
      ENDIF
      END
