  
      SUBROUTINE PYFSCR(IP)
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYINT1/MINT(400),VINT(400)
C...The common block of colour tags.
      COMMON/PYCTAG/NCT,MCT(4000,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYINT1/,/PYCTAG/,
     &/PYPARS/
C...Local variables
C...MCN: Temporary storage of new colour tags
      DOUBLE PRECISION MCN(4000,2)

C...Function to give four-product.
      FOUR(I,J)=P(I,4)*P(J,4)-P(I,1)*P(J,1)-P(I,2)*P(J,2)-P(I,3)*P(J,3)

C...Only works with colour tags.
      IF (MINT(33).EQ.0) GOTO 9999
C...For MSTP(95)=2, only apply to hadron-hadron
      IF (MSTP(95).EQ.2) THEN
         KA1=IABS(MINT(11))
         KA2=IABS(MINT(12))
         IF (KA1.LT.100.OR.KA2.LT.100) GOTO 9999
      ENDIF

C...Initialize new tag array (but do not delete old yet)
      LCT=NCT
      DO 100 I=MAX(1,IP),N
         MCN(I,1)=0
         MCN(I,2)=0
 100  CONTINUE

C...Loop over event record, starting from IP
C...(Ignore junctions for now.)
      NLOOP=0
 150  NLOOP=NLOOP+1
      MCIMAX=0
      MCJMAX=0
      RLMAX=0D0
      ILMAX=0
      JLMAX=0
      DO 500 I=MAX(1,IP),N
         IF (K(I,1).NE.3) GOTO 500
C...Check colour charge
         MCI=KCHG(PYCOMP(K(I,2)),2)*ISIGN(1,K(I,2))
         IF (MCI.EQ.0) GOTO 500
C...  Find optimal partner
         JLOPT=0
         MCJOPT=0
         MBROPT=0
         RLOPT=1D19
C...Loop over I colour/anticolour, check whether already connected
 180     DO 400 ICL=1,2
            IF (MCN(I,ICL).NE.0) GOTO 400
            IF (ICL.EQ.1.AND.MCI.EQ.-1) GOTO 400
            IF (ICL.EQ.2.AND.MCI.EQ.1) GOTO 400
C...Check whether this is a dangling colour tag (ie to junction!)
            IFOUND=0
            DO 190 J=MAX(1,IP),N
               IF (K(J,1).EQ.3.AND.MCT(J,3-ICL).EQ.MCT(I,ICL)) IFOUND=1
 190        CONTINUE
            IF (IFOUND.EQ.0) GOTO 400
            DO 300 J=MAX(1,IP),N
               IF (K(J,1).NE.3.OR.I.EQ.J) GOTO 300
C...Do not make direct connections between partons in same Beam Remnant
               MBRSTR=0
               IF (K(I,3).LE.2.AND.K(J,3).LE.2.AND.K(I,3).EQ.K(J,3)) 
     &              MBRSTR=1
C...Check colour charge 
               MCJ=KCHG(PYCOMP(K(J,2)),2)*ISIGN(1,K(J,2))
               IF (MCJ.EQ.0.OR.(MCJ.EQ.MCI.AND.MCI.NE.2)) GOTO 300
C...Loop over J colour/anticolour, check whether already connected
               DO 200 JCL=1,2
                  IF (MCN(J,JCL).NE.0) GOTO 200
                  IF (JCL.EQ.ICL) GOTO 200
                  IF (JCL.EQ.1.AND.MCJ.EQ.-1) GOTO 200
                  IF (JCL.EQ.2.AND.MCJ.EQ.1) GOTO 200
C...Check whether this is a dangling colour tag (ie to junction!)
                  IFOUND=0
                  DO 195 J2=MAX(1,IP),N
                     IF (K(J2,1).EQ.3.AND.MCT(J2,3-JCL).EQ.MCT(J,JCL)) 
     &                    IFOUND=1
 195              CONTINUE
                  IF (IFOUND.EQ.0) GOTO 200
C...Save connection with smallest lambda measure
                  RL=FOUR(I,J)
                  IF (RL.LT.RLOPT.OR.(RL.EQ.RLOPT.AND.PYR(0).LE.0.5D0)
     &              .OR.(MBROPT.EQ.1.AND.MBRSTR.EQ.0)) THEN
                     RLOPT=RL
                     JLOPT=J
                     ICOPT=ICL
                     JCOPT=JCL
                     MCJOPT=MCJ
                     MBROPT=MBRSTR
                  ENDIF
 200           CONTINUE
 300        CONTINUE
 400     CONTINUE
         IF (JLOPT.NE.0) THEN
C...Prioritize glue-glue over glue-quark over quark-quark
C            IF (MCIMAX.NE.2.AND.MCJMAX.NE.2) THEN
C               IF (MCI.EQ.2.OR.MCJOPT.EQ.2) RLOPT=MAX(1.1D0*RLMAX,RLOPT)
C            ELSEIF (MCIMAX.NE.2.OR.MCJMAX.NE.2) THEN
C               IF(MCI.EQ.2.AND.MCJOPT.EQ.2) RLOPT=MAX(1.1D0*RLMAX,RLOPT)
C            ELSEIF (MCIMAX.EQ.2.AND.MCJMAX.EQ.2) THEN
C               IF (MCI.NE.2.OR.MCJOPT.NE.2) RLOPT=0D0
C            ENDIF
C...Save pair with largest RLOPT so far
            IF (RLOPT.GE.RLMAX) THEN
               RLMAX=RLOPT
               ILMAX=I
               JLMAX=JLOPT
               ICMAX=ICOPT
               JCMAX=JCOPT
               MCJMAX=MCJOPT
               MCIMAX=MCI
            ENDIF
         ENDIF
 500  CONTINUE
C...Save and iterate
      IF (ILMAX.GT.0) THEN
         LCT=LCT+1
         MCN(ILMAX,ICMAX)=LCT
         MCN(JLMAX,JCMAX)=LCT
         IF (NLOOP.LE.2*(N-IP)) THEN
            GOTO 150
         ELSE
            PRINT*, 'infinite loop!'
            STOP
         ENDIF
      ELSE
C...Save and exit. First check for leftover gluon
         DO 600 I=MAX(1,IP),N
C...Check colour charge
            MCI=KCHG(PYCOMP(K(I,2)),2)*ISIGN(1,K(I,2))
            IF (K(I,1).NE.3.OR.MCI.NE.2) GOTO 600
            IF(MCN(I,1).EQ.0.AND.MCN(I,2).EQ.0) THEN
C...Decide where to put left-over gluon (minimal insertion)
               ILMAX=0
               RLMAX=1D19
               DO 480 KCT=NCT+1,LCT
                  DO 470 IT=MAX(1,IP),N
                     IF (IT.EQ.I.OR.K(IT,1).NE.3) GOTO 470
                     IF (MCN(IT,1).EQ.KCT) IC=IT
                     IF (MCN(IT,2).EQ.KCT) IA=IT
 470              CONTINUE
                  RL=FOUR(IC,I)*FOUR(IA,I)
                  IF (RL.LT.RLMAX) THEN
                     RLMAX=RL
                     ICMAX=IC
                     IAMAX=IA
                  ENDIF
 480           CONTINUE
               LCT=LCT+1
               MCN(I,1)=MCN(ICMAX,1)
               MCN(I,2)=LCT
               MCN(ICMAX,1)=LCT
            ENDIF
 600     CONTINUE
         DO 800 I=MAX(1,IP),N
C...Do not erase parton shower colour history
            IF (K(I,1).NE.3) GOTO 800
C...Check colour charge
            MCI=KCHG(PYCOMP(K(I,2)),2)*ISIGN(1,K(I,2))
            IF (MCI.EQ.0) GOTO 800
            IF (MCN(I,1).NE.0) MCT(I,1)=MCN(I,1)
            IF (MCN(I,2).NE.0) MCT(I,2)=MCN(I,2)
 800     CONTINUE
      ENDIF
         
 9999 RETURN
      END
