#!/bin/bash
#
# make project for RunMC v3.0 
# created by S.Chekanov 
# 
MYDIR=`pwd`

# ###################################
PROJNAME=$RUNMC"/proj"; 
cd $PROJNAME;

rm -f *.log
rm -f *.err
rm -f *.root
rm -f *.o
rm -f *~
rm -f *bak
rm -f *.rtup
rm -f *.htup
# user cleaning 
make clean > /dev/null


TMP=$RUNMC"/main/tmp/fmc.tmp"

# if does not exist - set 1 and create
if [ -x  "$TMP" ]
then
 rm -f $TMP
fi

# if does not exist - set 1 and create
if [ -x  "$RUNMC/main/tmp/project0.tmp" ]
then
 rm -f $RUNMC"/main/tmp/project0.tmp"
fi


# if does not exist - set 1 and create
if [ -x  "$RUNMC/main/tmp/project1.tmp" ]
then
 rm -f $RUNMC"/main/tmp/project1.tmp" 
fi


# if does not exist - set 1 and create
if [ -x  "$RUNMC/main/tmp/project2.tmp" ]
then
 rm -f $RUNMC"/main/tmp/project2.tmp"
fi

# if does not exist - set 1 and create
if [ -x  "$RUNMC/main/tmp/project.tmp" ]
then
 rm -f $RUNMC"/main/tmp/project.tmp"
fi



cd $PROJNAME;
# current check file
# list one file per line.
# last file uis the first one
FILENAME=`ls -1t *.mc`

# list all project times odered in tyme
ls -1t *.mc > $TMP;
#
# get the first one 
FILENAME=`head --lines=1 $TMP`
 
#
# look at the line with S-PROJECT 
grep -i 'S-PROJECT' $FILENAME > $RUNMC"/main/tmp/project1.tmp"

# 
# remove S-PROJECT word 
sed 's/S-PROJECT//g' $RUNMC"/main/tmp/project1.tmp" > $RUNMC"/main/tmp/project2.tmp"


# delete BOTH leading and trailing whitespace from each line
sed 's/^[ ^t]*//;s/[ ^]*$//' $RUNMC"/main/tmp/project2.tmp" > $RUNMC"/main/tmp/project.tmp"

 
GETNAME=`head --lines=1 $RUNMC"/main/tmp/project.tmp"`
# rm -f $RUNMC"/main/tmp/project.tmp";
# rm -f $RUNMC"/main/tmp/project1.tmp";
# rm -f $RUNMC"/main/tmp/project2.tmp";
# rm -f $TMP;


# echo "project name $GETNAME"
 
cd $RUNMC  
zip -rq $GETNAME proj  -x \*.o
wait $!;
mv -f $GETNAME".zip" $RUNMC"/archive/"$GETNAME".rmc"
echo $RUNMC"/archive/"$GETNAME".rmc  created" 
cd $MYDIR
exit 0
