#!/bin/bash
#
# view RMC project file with snavigator 
# created by S.Chekanov 
# 
MYDIR=`pwd`

# assume linux by default
VIEWPROGRAM="snavigator"

# is this windows or linux ?
OSYSTEM=`uname -s`
if [ "$OSYSTEM" != "Linux" ]
then
echo "operating system=$OSYSTEM ";
  VIEWPROGRAM="C:\Program Files\Snavigator\sourcenav-52b2\bin\snavigator";
  echo "call to $VIEWPROGRAM"; 
  echo "if nothing shows up then edit:"
  echo "\"$RUNMC/main/runmc/proj_view.sh\" file!" 
fi  


# main file
VIEWSOURCE=".snavigator.proj"


cd $RUNMC/proj
# if does not exist - set 1 and create
if [ -f  "$VIEWSOURCE" ]
then
  "$VIEWPROGRAM"  $VIEWSOURCE 
else
  echo "Snavigator cannot load  $RUNMC/proj/.snavigator.proj file"
  echo "This project was not set up correctly to view with Snavigator"
  echo " "
  echo "To fix this problem, do:"
  echo "cd $RUNMC/proj; snavigator&"
  echo "select new project and name it as .snavigator.proj (not proj.proj.!)"  
  echo "This will scan your source files .."
fi

cd $MYDIR
exit 0
