      subroutine breit_matrix_e (pe,ee,Llb,Lbl)
* This routine computes the matrix to make the boost from the laboratory into
* the Breit (Llb) and viceversa (Lbl).
* In fact it calculates the fourmomentum of the boson and calls breit_matrix

      implicit none

* Written by Oscar Gonzalez (Feb. 10th, 2002)

      double precision Llb(4,4),Lbl(4,4)
      double precision pe(4),ee

* The arguments of the routine are (note the double precision!!!)
*
* Input
*          pe is the four momentum of the scattered e (4 is the 
*            temporal component, that is the energy)
*
*          ee is the energy of the INITIAL e.
*
* Output
*          Llb is the matrix for the boost from the lab into the Breit
*              To boost a vector vl(4) use 
*                         do i=1,4
*                            vb(i)=0
*                            do j=1,4
*                               vb(i)=vb(i) + Llb(i,j)*vl(j)
*                            enddo
*                         enddo 
*
*         Lbl is the matrix for the boost from the Breit into the lab (the
*             way to boost a vector is the same but changing always l <-> b
*
*
      double precision q(4)

      integer i,j
*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

* Computing q of the boson from the e:

      q(1)=-pe(1)
      q(2)=-pe(2)

      q(3)=-ee-pe(3)
      q(4)=ee-pe(4)

      call breit_matrix (q,Llb,Lbl)

      end
*=======================================================================


