/* ss.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b3 = (float)0.;
static integer c__4 = 4;

/* Subroutine */ int brtini_0_(n__, pbeam, pgam, ierr, p, pnew)
int n__;
real *pbeam, *pgam;
integer *ierr;
real *p, *pnew;
{
    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double sqrt(), atan2();

    /* Local variables */
    static integer ivec;
    static real phcm[4], robo[3], theta;
    extern /* Subroutine */ int boost_(), ucopy_();
    static real xb, gammas;
    extern /* Subroutine */ int phmrot_();
    static real phi;

/* #***************************************************************** */
/* #      Subroutine BRTINI(pbeam,pgam,Ierr) */
/* #      Entry BRT(p,pnew,Ierr) */
/* # */
/* @# BRTINI/BRT (entry point) : Lorentz boost to Breit frame */
/* # PURPOSE : Lorentz boost to Breit frame */
/* # */
/* # INPUT : */
/* #   PBEAM    =  the 4 vector of the proton beam */
/* #   PGAM     =  the 4 vector of the virtual exchanged boson */
/* #   P        =   the vector to be acted upon */
/* # OUTPUT : */
/* #   PNEW     =  the boosted vector */
/* #   IERR     =  an error flag (1 = failed) */
/* # */
/* # BRTINI - called once an event to set up boost and rotation */
/* #          variables */
/* # BRT    - perform the actual boost of particles */
/* # */
/* # Author: N Brook */
/* # */
/* #***************************************************************** */


    /* Parameter adjustments */
    if (pbeam) {
	--pbeam;
	}
    if (pgam) {
	--pgam;
	}
    if (p) {
	--p;
	}
    if (pnew) {
	--pnew;
	}

    /* Function Body */
    switch(n__) {
	case 1: goto L_brt;
	}

    *ierr = 1;
/* Computing 2nd power */
    r__1 = pgam[4];
/* Computing 2nd power */
    r__2 = pgam[3];
/* Computing 2nd power */
    r__3 = pgam[2];
/* Computing 2nd power */
    r__4 = pgam[1];
    gammas = r__1 * r__1 - r__2 * r__2 - r__3 * r__3 - r__4 * r__4;
    if (gammas >= (float)0.) {
	return 0;
    }
    xb = -gammas / (float)2. / (pgam[4] * pbeam[4] - pgam[3] * pbeam[3]);
    if (xb > (float)1. || xb < (float)0.) {
	return 0;
    }
/* set up boost parameters */
    for (ivec = 1; ivec <= 3; ++ivec) {
/* L5: */
	robo[ivec - 1] = (pgam[ivec] + xb * (float)2. * pbeam[ivec]) / (pgam[
		4] + xb * (float)2. * pbeam[4]);
    }

/*     chksq = vdot(robo,robo,3) */
/*     If(chksq.gt.1.) Return */
/* ... and necessary rotation angles */
    r__1 = -robo[0];
    r__2 = -robo[1];
    r__3 = -robo[2];
    boost_(&r__1, &r__2, &r__3, &pgam[1], phcm);
/* Computing 2nd power */
    r__1 = phcm[1];
/* Computing 2nd power */
    r__2 = phcm[0];
    theta = atan2(phcm[2], sqrt(r__1 * r__1 + r__2 * r__2));
    phi = atan2(phcm[0], phcm[1]);

    *ierr = 0;
    return 0;


L_brt:

    *ierr = 1;
/* Boost and rotate particle to Breit frame */
    r__1 = -robo[0];
    r__2 = -robo[1];
    r__3 = -robo[2];
    boost_(&r__1, &r__2, &r__3, &p[1], phcm);
    r__1 = -phi;
    phmrot_(&r__1, &c_b3, phcm, phcm);
    r__1 = (float)3.141592654 - theta;
    phmrot_(&c_b3, &r__1, phcm, phcm);
    ucopy_(phcm, &pnew[1], &c__4);

    *ierr = 0;
    return 0;
} /* brtini_ */

/* Subroutine */ int brtini_(pbeam, pgam, ierr)
real *pbeam, *pgam;
integer *ierr;
{
    return brtini_0_(0, pbeam, pgam, ierr, (real *)0, (real *)0);
    }

/* Subroutine */ int brt_(p, pnew, ierr)
real *p, *pnew;
integer *ierr;
{
    return brtini_0_(1, (real *)0, (real *)0, ierr, p, pnew);
    }

