      Subroutine ZUANAL(IWant)
*     ************************
* version 1.1 S.Chekanov, March 4 
* version 1.2 L.Zawiejski, March 6
* version 1.3 S.Chekanov: 2D calculated in current and target March 10  
* version 1.4 S.Chekanov/L.Zawiejski : electron/positon removed from tracks, March 17
* version 1.5 small bug fixed (no pi defintion), March 18
*             CTDcor is added for data
* version 1.6 : change 2D bins (K.0). Bug in calculation of energy of tracks
*               March 20   
* 
* version 1.7 March 25. Now includes weights for MC sample 
* version 1.8, March 26: bug in phi + 2D bug 
* version 1.9, April 1: Krystina has found a bug in Breit-frame calculations
*----------------------------------------------------------------
*
*    Zeus User event ANALysis program. 
*
*  The flag IWant is used to control the output of events. 
*  If IWant = 1 the event is written out; if IWant = 0 it is not.
*
*----------------------------------------------------------------
*
      Implicit NONE

#include "partap.inc"
#include "zdskey.inc"
#include "vctpar.inc"
#include "orangentp.inc"
#include "ctrlcm.inc"

* mc stuff
#include "usgevt.inc"
#include "fmckin.inc"
#include "fmcevt.inc"
#include "fmcpcd.inc"
#include "fmcprt.inc"

*** common block with Q2 bins
      Integer IMAX,Nsys,JMAX
      PARAMETER (IMAX=9, JMAX=8)
      REAL  Q2bin(IMAX)
      REAL qmin(1000),qmax(1000), weight(1000)
      COMMON/MYCOMM/Nsys,Q2bin,weight,qmin,qmax

      Real pio, pi, pi2, pio2
      Parameter ( pio=0.1395699, pio2=0.1395699 **2)
      Parameter ( pi=3.141592, pi2=2*3.141592  )


      integer jbit
      external jbit

      INTEGER TLT4(32),DIS01,DIS03, IEL   
      Integer ISEL(0:20), I1,I2,I,J,M,IMC,nn,ncc,ntt,NTOT,Ierr,Iwant 
      real ppt(100),px(100),py(100),pz(100),pe(100),pc(100),pet(100)
      real pxb(100),pyb(100),pzb(100),peb(100)
      real xppt,px1,py1,pz1,pe1,pc1,px2,py2,pz2,pe2,pc2,xthe 
      real ch,ctdc,pbb(100),pbb1(100)
      real Eene,Ecor,Epz,Ethe,Ephi,vtxpos(3),Q12, ASWQ
      real Yel,Q2el,Xel,Q2da,Yda,Xda,Q2jb,Yjb,Xjb
      real Q2jb_cell,Yjb_cell,Xjb_cell,Eda_cell,Eda_zufo
      real Q2da_cell,Yda_cell,Xda_cell,PEL(4),pgam(4)
      real Q2r,Yr,Xr ! current values  
      real year,ebeam(4),pbeam(4),sinv,MPROTON 
      real xeta,xphi,plab(4),pbreit(4)
      real ccoul,pl12,e12,beta,gamma,ql,qt_2,qt,qunlike,wc,wc1
      real wgt, txx, tyy, tzz

      PARAMETER (MPROTON=0.938272)
    
      Logical First
      save    First
      Data    First / .TRUE. /
*************************************************************************
*     By default do not write out the event
*     -------------------------------------

      ctdc=1.0 ! CTDCOR value, default for MC. For data, use 1.003 
      iwant = 0
      ierr = 0
      NTOT=0
      ccoul = 1./137.*0.13957*2.*3.141592 ! for 2D calculations
      wgt=1.0 ! default weigths for all histograms

      call hf1(980,1.0,1.) ! debag program, count events !
C***********************************************
C REJECT IF THE RECORD IS NOT AN EVENT (eg. BOR)
C***********************************************

      Call Fettab(ZDSkey,id,1)
      IF (ZDSKEY_GAFTyp(1:3) .NE. 'EVT') THEN
        RETURN
      ENDIF

C *******************************************
C data or MC ?
      IMC=0  ! default is data
      if (coutab(FMCKIN).gt.0) IMC=1
** CTDCOR
      IF (IMC.eq.0) ctdc=1.003  ! correct tracks for data
*********************************************


C*******************************************
C DO FIRST EVENT INITIALISATION AND PRINTOUT
C*******************************************

      If (First) then
          First = .false.
          write(*,*)'This is ZUANAL, first event'
          IF (IMC.eq.1) THEN
          write(6,*) 'This is MC, with weights='
          do i=1, 1000
          write(6,*)'range=',qmin(i),' ',qmax(i),' MC weight=',weight(i)
          enddo
          ENDIF 
      Endif


C*******************************************
C Select DIS03 or DIS 01 
C*******************************************

** take only DIS01 and DIS03 trigger
        call uzero(TLT4,1,32)

        DO i=1, 32
        TLT4(i)=JBIT(Ora_TLTW(4),i)
        ENDDO
        DIS03=0
        DIS01=0
        IF (TLT4(3).eq.1) DIS03=1
        IF (TLT4(1).eq.1) DIS01=1
        IF (DIS03.eq.0.and.DIS01.eq.0) goto 999 
        call hf1(980,2.0,1.) ! debag program, count events !

C *******************************************
C get year and type of collisions  
      Call GetBeam(Ora_RunNr,IMC,year,IEL)
*     write(6,*) Ora_RunNr,IMC,year,IEL
* IEL=1=e-, IEL=2=e+ 
*********************************************


** vertex    
      vtxpos(1) = Ora_Xvtx
      vtxpos(2) = Ora_Yvtx  
      vtxpos(3) = Ora_Zvtx 
      IF (abs(vtxpos(3)).gt.55) GOTO 999   ! regect 

*** Sira candidae
      IF (SiNcand.eq.0)   GOTO 999   ! regect
      call hf1(980,3.0,1.) ! debag program, count events !

*** for best candidate----------------------------------- 
      ebeam(1)=0.
      ebeam(2)=0.
      ebeam(3)=-EBeam_Energy
      ebeam(4)=EBeam_Energy

      pbeam(1)=0.
      pbeam(2)=0.
      pbeam(3)=PBeam_Energy
      pbeam(4)=PBeam_Energy
      sinv = 4.*ebeam(4)*pbeam(4) + MPROTON**2 ! cm energy 
      Eene=SiCalEne(1)   !Electron calorimeter energy 
      Ecor=Siecorr(3,1)  !Corrected energy from EM subroutine 
      Ephi=SiCalPh(1)    ! thet and phi 
      Ethe=SiCalTh(1)
      Epz =Ora_CAL_Empz   ! E-pz 
      Yel=Siyel(1)        !yel
      Xel=Sixel(1)        !xel
      Q2el=Siq2el(1)      !q2el
      Yda=Siyda(1)        !yda from ZUFOs
      Q2da=SiQ2da(1)      !Q2da from ZUFOs
      Xda=Sixda(1)            !xda from Zufos
      Xda_cell=Sixda_cell(1)  !xda from Cells
      Q2da_cell=SiQ2da_cell(1)!Q2da from Cells
      Yda_cell=Siyda_cell(1)  !yda from Cells
      Xjb=Sixjb(1)            !xjb from Zufos
      Xjb_cell=Sixjb_cell(1)  !xjb from Cells
      Q2jb=SiQ2jb(1)          !q2jb from ZUFOS
      Q2jb_cell=SiQ2jb_cell(1)!q2jb from Cells
      Yjb=Siyjb(1)            !yjb from ZUFOs
      Yjb_cell=Siyjb_cell(1)  !yjb from Cells
      Eda_cell=SiQ2da_cell(1)/    ! DA enery of electrons  
     +         (2*EBeam_Energy*(1+cos(SiCalTh(1))))
      Eda_zufo=SiQ2da(1)/
     +         (2*EBeam_Energy*(1+cos(SiCalTh(1))))


*** set default values for kinematic variables

      Q2r=Q2el
      Yr=Yel
      Xr=Xel  
      
** regect low Q2
      IF (Q2r.le.3)    GOTO 999   ! regect
      IF (Ecor.le.10)  GOTO 999   ! regect 
      call hf1(980,4.0,1.) ! debag program, count events !


*** if it is MC, set weigths
      IF (IMC.eq.1) THEN
        wgt=1.0 ! default weigth
        DO I=1,1000
        IF (Q2r.ge.qmin(I).and.Q2r.le.qmax(I)) wgt=weight(I)
        ENDDO  
      ENDIF

** get 4-momenta of electrons
       PEL(1) =Ecor * SIN(Ethe) * COS(Ephi)
       PEL(2) =Ecor * SIN(Ethe) * SIN(Ephi)
       PEL(3) =Ecor * COS(Ethe)
       PEL(4) =Ecor

*-- gamma boost to BF
       do I=1, 4
       pgam(I) = ebeam(I)-PEL(I)
       enddo  
       Ierr=0
       Call brtini(pbeam,pgam,Ierr) ! find boost to the Breit frame

      Iwant=1

** specify selection variables
      do j=0,19
      ISEL(j)=0
      enddo 

** this is defalt the  selection
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     + Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(0)=1

** this is system 1: E-pz
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.58.and.Epz.gt.42.and.
     + Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(1)=1

** this is syst 2: Ye 
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     + Yel.lt.0.90.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(2)=1

** this is syst 3: Yjb
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     + Yel.lt.0.95.and.Yjb.gt.0.05.and.abs(vtxpos(3)).lt.50) ISEL(3)=1

** this is syst 4: Ee  
      IF (Q2r.gt.4.and.Ecor.gt.11.and.Epz.lt.60.and.Epz.gt.40.and.
     + Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(4)=1

** this is DA 4: DA
      IF (Q2da.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     +Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(5)=1

** electron energy scale
      IF (IMC.eq.0) then 
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     +Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(6)=1
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     +Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(7)=1
        else
      IF (Q2r.gt.4.and.Ecor*1.02.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     + Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(6)=1
      IF (Q2r.gt.4.and.Ecor*0.98.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     + Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.50) ISEL(7)=1
      endif  

** this is DA 4: DA
      IF (Q2r.gt.4.and.Ecor.gt.10.and.Epz.lt.60.and.Epz.gt.40.and.
     +Yel.lt.0.95.and.Yjb.gt.0.04.and.abs(vtxpos(3)).lt.45) ISEL(8)=1



** track systematics is below in the loop

*********** analyse the BEC effect 

** fill primary tracks 
      nn=0
      ncc=0
      ntt=0
      do i=1,trk_ntracks

** Apply CTDcor: data  is multiplied by 0.3%, not MC ! 
      txx=ctdc*trk_px(i)
      tyy=ctdc*trk_py(i)
      tzz=ctdc*trk_pz(i)


*** first, remove electron/positron 
      xphi = atan2(tyy,txx)
      if (xphi.lt.0.) xphi = xphi+pi2

      do j = 1, SiNcand
       if (int(sitrkmtch(j)).eq.i) then
       if (abs(sitrkph(j)-xphi).lt.0.05) then
        IF (trk_charge(i).lt.0.and.IEL.eq.1) goto 77 ! electron
        IF (trk_charge(i).gt.0.and.IEL.eq.2) goto 77 ! positron    
       endif
       endif
      enddo

      IF (trk_prim_vtx(i)) then                      ! only vertex fitted  
      IF (trk_layouter(i)-trk_layinner(i).ge.4) then ! more than 3 supp 


      xppt=sqrt(txx**2+tyy**2 )          ! get Pt 
      xthe=atan2(xppt,tzz)
      xeta=-log(tan(xthe/2.0)) 
      IF (xppt.ge.0.15.and.abs(xeta).lt.1.75)  then 
         nn=nn+1
      if (nn.gt.100) goto 999           ! too many tracks  
      px(nn)=txx 
      py(nn)=tyy
      pz(nn)=tzz
      pe(nn)=sqrt(txx**2+tyy**2+tzz**2+pio2)
      pc(nn)=trk_charge(i)
      ppt(nn)=xppt       ! pt 
      pet(nn)=xeta       ! eta  

** move to the Breit frame
       pbb(nn)=0 ! label track: current or target region ? 
       plab(1) = px(nn)
       plab(2) = py(nn)
       plab(3) = pz(nn)
       plab(4) = pe(nn)
       ierr=0
       Call brt(plab,pbreit,ierr) 
       If(ierr.ne.0) goto 300
         pxb(nn)=pbreit(1) 
         pyb(nn)=pbreit(2) 
         pzb(nn)=pbreit(3) 
         peb(nn)=pbreit(4)  
       if (pbreit(3).lt.0)  then
          pbb(nn)=1 ! current region     
          ncc=ncc+1 ! count multiplicity
       endif
       if (pbreit(3).ge.0)  then
          pbb(nn)=2 ! target region
          ntt=ntt+1 ! count multiplicity
       endif
300   continue 
      ENDIF 
      ENDIF 
      ENDIF 

 77   continue 
      enddo 
      NTOT=nn
      if (NTOT.le.1) goto 999
      call hf1(980,5.0,1.)  ! debug program, count events 



***** Reconstruct the Breif frame using the DA method  
** get 4-momenta of electrons
       PEL(1) =Eda_cell * SIN(Ethe) * COS(Ephi)
       PEL(2) =Eda_cell * SIN(Ethe) * SIN(Ephi)
       PEL(3) =Eda_cell * COS(Ethe)
       PEL(4) =Eda_cell
*-- gamma boost to BF
       do I=1, 4
       pgam(I) = ebeam(I)-PEL(I)
       enddo
       Ierr=0
       Call brtini(pbeam,pgam,Ierr) ! find boost to the Breit frame
       do i=1,NTOT
** move to the Breit frame
       pbb1(i)=0 ! label track: current or target region ?
       plab(1) = px(i)
       plab(2) = py(i)
       plab(3) = pz(i)
       plab(4) = pe(i)
       ierr=0
       Call brt(plab,pbreit,ierr)
       If(ierr.ne.0) goto 301
       if (pbreit(3).lt.0)  then
          pbb1(i)=1 ! current region
       endif
       if (pbreit(3).ge.0)  then
          pbb1(i)=2 ! target region
       endif
301   continue
       enddo 
       

*** fill control histograms for default parameters
      IF (ISEL(0).eq.1) THEN
      call hf1(10,Q2r,wgt)
      call hf1(50,Ecor,wgt)
      call hf1(51,Epz,wgt) 
      call hf1(52,vtxpos(3),wgt)
      call hf1(53,Ethe,wgt)   
      call hf1(54,Q2el,wgt)
      call hf1(55,Yel,wgt)
      call hf1(56,Xel,wgt)
      call hf1(57,Yjb,wgt)
      call hf1(58,Q2el,1.0) ! Q2 without reweigthins  
      call hf1(59,wgt,1.0)  ! weights for MC (to check)
 
** look at Q2 distribution (to get mean values of the bins)
*** and calculate mean charge multiplicity ineach bin of Q2 
        DO J=1,JMAX
        IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
        m=10+J 
        call hf1(m,Q2r,wgt)
        m=20+J
        call hf1(m,real(NTOT),wgt)
        m=30+J
        call hf1(m,real(ncc),wgt)  ! current region  
        m=40+J
        call hf1(m,real(ntt),wgt)  ! target region  
        ENDIF   
        ENDDO
       ENDIF  


************* BEC analysis ***********************

       DO I1=1, NTOT-1 
        px1=px(I1)
        py1=py(I1)
        pz1=pz(I1)
        pe1=pe(I1) 
        pc1=pc(I1)
        
        DO I2=I1+1, NTOT  
        px2=px(I2)
        py2=py(I2)
        pz2=pz(I2)
        pe2=pe(I2)
        pc2=pc(I2)

***     define charge combinations
        ch=pc1*pc2 ! positive -like charge,    negative - unlike charge 



** for systematc checks: cut on Pt
        ISEL(9)=0   
        if (ISEL(0).eq.1.and.ppt(I1).gt.0.20.and.
     +  ppt(I2).gt.0.20) ISEL(9)=1

** for systematc checks: cut on eta
        ISEL(10)=0
        if (ISEL(0).eq.1.and.abs(pet(I1)).lt.1.50.and.
     +  abs(pet(I2)).lt.1.50) ISEL(10)=1

** calculate Q12
       ASWQ=-((pe1-pe2)**2 -(px1-px2)**2-(py1-py2)**2-(pz1-pz2)**2) 
       Q12=0 
       IF (ASWQ.ge.0)  Q12=sqrt(ASWQ)


** note, I=0 - default parameters, I=1..NSYS - systematic check
       DO I=0, NSYS
        IF (ISEL(I).eq.1) THEN  

        IF (I.ne.5) THEN ! all but not DA! 
** for Q2>4 
        IF (ch.ge.0) call hf1(1000+I,Q12,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf1(2000+I,Q12,wgt)  ! r(+,-)  
** for Q2>100        
        IF (Q2r.ge.100.) then
          IF (ch.ge.0) call hf1(1100+I,Q12,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf1(2100+I,Q12,wgt)  ! r(+,-)
        ENDIF 
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf1(1000+m,Q12,wgt)
          IF (ch.lt.0) call hf1(2000+m,Q12,wgt)
          ENDIF
          ENDDO 
        ENDIF

*** Do DA systematics--------------------------------------
        IF (I.eq.5) THEN 
** for Q2>4
        IF (ch.ge.0) call hf1(1000+I,Q12,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf1(2000+I,Q12,wgt)  ! r(+,-)

        IF (Q2da.ge.100.) then
          IF (ch.ge.0) call hf1(1100+I,Q12,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf1(2100+I,Q12,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2da.gt.Q2bin(J).and.Q2da.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf1(1000+m,Q12,wgt)
          IF (ch.lt.0) call hf1(2000+m,Q12,wgt)
          ENDIF
         ENDDO
         ENDIF  



******************* Current region ***************************
        IF (I.ne.5) then ! all but not DA ! 
        IF (pbb(I1)*pbb(I2).eq.1) then  ! current region 
** for Q2>4
        IF (ch.ge.0) call hf1(3000+I,Q12,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf1(4000+I,Q12,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2r.ge.100.) then
          IF (ch.ge.0) call hf1(3100+I,Q12,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf1(4100+I,Q12,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf1(3000+m,Q12,wgt)
          IF (ch.lt.0) call hf1(4000+m,Q12,wgt)
          ENDIF
          ENDDO
        ENDIF
        ENDIF

*** for DA systematics  
        IF (I.eq.5) then
        IF (pbb1(I1)*pbb1(I2).eq.1) then  ! current region
** for Q2>4
        IF (ch.ge.0) call hf1(3000+I,Q12,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf1(4000+I,Q12,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2da.ge.100.) then
          IF (ch.ge.0) call hf1(3100+I,Q12,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf1(4100+I,Q12,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2da.gt.Q2bin(J).and.Q2da.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf1(3000+m,Q12,wgt)
          IF (ch.lt.0) call hf1(4000+m,Q12,wgt)
          ENDIF
          ENDDO
        ENDIF
        ENDIF  

******************** Target region **************************** 
        IF (I.ne.5) then ! all but not DA 
        IF (pbb(I1)*pbb(I2).ge.4) then  ! target  region
** for Q2>4
        IF (ch.ge.0) call hf1(5000+I,Q12,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf1(6000+I,Q12,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2r.ge.100.) then
          IF (ch.ge.0) call hf1(5100+I,Q12,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf1(6100+I,Q12,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf1(5000+m,Q12,wgt)
          IF (ch.lt.0) call hf1(6000+m,Q12,wgt)
          ENDIF
          ENDDO
         ENDIF 
        ENDIF

*** for DA systematics 
        IF (I.eq.5) then 
        IF (pbb1(I1)*pbb1(I2).ge.4) then  ! target  region
** for Q2>4
        IF (ch.ge.0) call hf1(5000+I,Q12,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf1(6000+I,Q12,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2da.ge.100.) then
          IF (ch.ge.0) call hf1(5100+I,Q12,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf1(6100+I,Q12,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2da.gt.Q2bin(J).and.Q2da.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf1(5000+m,Q12,wgt)
          IF (ch.lt.0) call hf1(6000+m,Q12,wgt)
          ENDIF
          ENDDO
         ENDIF
        endif 
***- stop Breit frame



******************* Now, 2D BEC calculations ***************************  
** All tracks now are in the Breit frame

** Leszek's stuff
       pl12 =pzb(I1)+pzb(I2)
       e12 = peb(I1)+peb(I2)
       beta = pl12/e12
       gamma = 1./sqrt(1.-beta**2)
       ql = 2.*abs(-gamma*beta*peb(I1)+gamma*pzb(I1))
       qt_2 = (pxb(I1)-pxb(I2))**2+(pyb(I1)-pyb(I2))**2 
       qt = sqrt(qt_2)

        IF (I.ne.5) THEN ! all but not DA 
** for Q2>4
        IF (ch.ge.0) call hf2(7000+I,ql,qt,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf2(8000+I,ql,qt,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2r.ge.100.) then
          IF (ch.ge.0) call hf2(7100+I,ql,qt,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf2(8100+I,ql,qt,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf2(7000+m,ql,qt,wgt)
          IF (ch.lt.0) call hf2(8000+m,ql,qt,wgt)
          ENDIF
          ENDDO
        ENDIF
 
*** Do DA systematics--------------------------------------
        IF (I.eq.5) THEN
** for Q2>4
        IF (ch.ge.0) call hf2(7000+I,ql,qt,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf2(8000+I,ql,qt,wgt)  ! r(+,-)
**for Q2>100
        IF (Q2da.ge.100.) then
          IF (ch.ge.0) call hf2(7100+I,ql,qt,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf2(8100+I,ql,qt,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2da.gt.Q2bin(J).and.Q2da.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf2(7000+m,ql,qt,wgt)
          IF (ch.lt.0) call hf2(8000+m,ql,qt,wgt)
          ENDIF
         ENDDO
         ENDIF

**************---------------------------------
************** 2D effect in the current region 
**************---------------------------------
** for Q2>4
        IF (I.ne.5) THEN ! all but not DA 
        IF (pbb(I1)*pbb(I2).eq.1) then  ! current region 
        IF (ch.ge.0) call hf2(10000+I,ql,qt,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf2(11000+I,ql,qt,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2r.ge.100.) then
          IF (ch.ge.0) call hf2(10100+I,ql,qt,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf2(11100+I,ql,qt,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf2(10000+m,ql,qt,wgt)
          IF (ch.lt.0) call hf2(11000+m,ql,qt,wgt)
          ENDIF
          ENDDO
        ENDIF
 
*** Do DA systematics--------------------------------------
        IF (I.eq.5) THEN
        IF (ch.ge.0) call hf2(10000+I,ql,qt,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf2(11000+I,ql,qt,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2da.ge.100.) then
          IF (ch.ge.0) call hf2(10100+I,ql,qt,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf2(11100+I,ql,qt,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2da.gt.Q2bin(J).and.Q2da.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf2(10000+m,ql,qt,wgt)
          IF (ch.lt.0) call hf2(11000+m,ql,qt,wgt)
          ENDIF
         ENDDO
         ENDIF

         ENDIF  ! end current region ...........

**************---------------------------------
************** 2D effect in the target region
**************---------------------------------
** for Q2>4
        IF (I.ne.5) THEN ! all but not DA  
        IF (pbb(I1)*pbb(I2).ge.4) then  ! target region
        IF (ch.ge.0) call hf2(12000+I,ql,qt,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf2(13000+I,ql,qt,wgt)  ! r(+,-)
** for Q2>100
        IF (Q2r.ge.100.) then
          IF (ch.ge.0) call hf2(12100+I,ql,qt,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf2(13100+I,ql,qt,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2r.gt.Q2bin(J).and.Q2r.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf2(12000+m,ql,qt,wgt)
          IF (ch.lt.0) call hf2(13000+m,ql,qt,wgt)
          ENDIF
          ENDDO
        ENDIF
*** Do DA systematics--------------------------------------
        IF (I.eq.5) THEN
        IF (ch.ge.0) call hf2(12000+I,ql,qt,wgt)  ! r(++,--)
        IF (ch.lt.0) call hf2(13000+I,ql,qt,wgt)  ! r(+,-)
        IF (Q2da.ge.100.) then
          IF (ch.ge.0) call hf2(12100+I,ql,qt,wgt)  ! r(++,--)
          IF (ch.lt.0) call hf2(13100+I,ql,qt,wgt)  ! r(+,-)
        ENDIF
** for bins in Q2
          DO J=1,JMAX
          m=100+100*J+I
          IF (Q2da.gt.Q2bin(J).and.Q2da.lt.Q2bin(J+1)) THEN
          IF (ch.ge.0) call hf2(12000+m,ql,qt,wgt)
          IF (ch.lt.0) call hf2(13000+m,ql,qt,wgt)
          ENDIF
         ENDDO
         ENDIF
 
         ENDIF  ! end target region ...........



 
        ENDIF  
       ENDDO  ! end run over systematics   


        ENDDO
       ENDDO 
******* end loop over all pairs

 999   CONTINUE
       End 




